/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function (Vue, uikitUtil, _yooessentials, $fields) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
    var $fields__default = /*#__PURE__*/_interopDefaultLegacy($fields);

    var script$5 = {
      name: 'AuthModal',
      "extends": _yooessentials.ModalForm,
      props: {
        scopes: {
          type: Array
        }
      },
      events: {
        'yooessentials-prerequest': function yooessentialsPrerequest(e) {
          e.params[0]['requiredScopes'] = this.scopes;
        }
      },
      methods: {
        connect: function connect() {
          var _this = this;
          var scopes = this.draft.scopes;
          _yooessentials.AuthModel.oauth(this.draft.driver, this.scopes).then(function (oauth) {
            for (var prop in oauth) {
              var value = oauth[prop];

              // merge scopes
              if (prop === 'scopes') {
                value = _yooessentials.unique([].concat(scopes != null ? scopes : [], value));
              }
              _yooessentials.set(_this.draft, prop, value);
            }

            // auto save the auth giving some time to the ui
            setTimeout(function () {
              _this.save(_this.draft);
            }, 500);
          });
        }
      }
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    /* script */
    var __vue_script__$5 = script$5;

    /* template */

    /* style */
    var __vue_inject_styles__$5 = undefined;
    /* scoped */
    var __vue_scope_id__$5 = undefined;
    /* module identifier */
    var __vue_module_identifier__$5 = undefined;
    /* functional template */
    var __vue_is_functional_template__$5 = undefined;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$5 = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);

    function _extends() {
      _extends = Object.assign ? Object.assign.bind() : function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }

    function toInteger(dirtyNumber) {
      if (dirtyNumber === null || dirtyNumber === true || dirtyNumber === false) {
        return NaN;
      }
      var number = Number(dirtyNumber);
      if (isNaN(number)) {
        return number;
      }
      return number < 0 ? Math.ceil(number) : Math.floor(number);
    }

    function requiredArgs(required, args) {
      if (args.length < required) {
        throw new TypeError(required + ' argument' + (required > 1 ? 's' : '') + ' required, but only ' + args.length + ' present');
      }
    }

    /**
     * @name toDate
     * @category Common Helpers
     * @summary Convert the given argument to an instance of Date.
     *
     * @description
     * Convert the given argument to an instance of Date.
     *
     * If the argument is an instance of Date, the function returns its clone.
     *
     * If the argument is a number, it is treated as a timestamp.
     *
     * If the argument is none of the above, the function returns Invalid Date.
     *
     * **Note**: *all* Date arguments passed to any *date-fns* function is processed by `toDate`.
     *
     * @param {Date|Number} argument - the value to convert
     * @returns {Date} the parsed date in the local time zone
     * @throws {TypeError} 1 argument required
     *
     * @example
     * // Clone the date:
     * const result = toDate(new Date(2014, 1, 11, 11, 30, 30))
     * //=> Tue Feb 11 2014 11:30:30
     *
     * @example
     * // Convert the timestamp to date:
     * const result = toDate(1392098430000)
     * //=> Tue Feb 11 2014 11:30:30
     */

    function toDate(argument) {
      requiredArgs(1, arguments);
      var argStr = Object.prototype.toString.call(argument); // Clone the date

      if (argument instanceof Date || typeof argument === 'object' && argStr === '[object Date]') {
        // Prevent the date to lose the milliseconds when passed to new Date() in IE10
        return new Date(argument.getTime());
      } else if (typeof argument === 'number' || argStr === '[object Number]') {
        return new Date(argument);
      } else {
        if ((typeof argument === 'string' || argStr === '[object String]') && typeof console !== 'undefined') {
          // eslint-disable-next-line no-console
          console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://git.io/fjule"); // eslint-disable-next-line no-console

          console.warn(new Error().stack);
        }
        return new Date(NaN);
      }
    }

    /**
     * @name addDays
     * @category Day Helpers
     * @summary Add the specified number of days to the given date.
     *
     * @description
     * Add the specified number of days to the given date.
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * @param {Date|Number} date - the date to be changed
     * @param {Number} amount - the amount of days to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
     * @returns {Date} - the new date with the days added
     * @throws {TypeError} - 2 arguments required
     *
     * @example
     * // Add 10 days to 1 September 2014:
     * const result = addDays(new Date(2014, 8, 1), 10)
     * //=> Thu Sep 11 2014 00:00:00
     */

    function addDays(dirtyDate, dirtyAmount) {
      requiredArgs(2, arguments);
      var date = toDate(dirtyDate);
      var amount = toInteger(dirtyAmount);
      if (isNaN(amount)) {
        return new Date(NaN);
      }
      if (!amount) {
        // If 0 days, no-op to avoid changing times in the hour before end of DST
        return date;
      }
      date.setDate(date.getDate() + amount);
      return date;
    }

    /**
     * @name addMonths
     * @category Month Helpers
     * @summary Add the specified number of months to the given date.
     *
     * @description
     * Add the specified number of months to the given date.
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * @param {Date|Number} date - the date to be changed
     * @param {Number} amount - the amount of months to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
     * @returns {Date} the new date with the months added
     * @throws {TypeError} 2 arguments required
     *
     * @example
     * // Add 5 months to 1 September 2014:
     * const result = addMonths(new Date(2014, 8, 1), 5)
     * //=> Sun Feb 01 2015 00:00:00
     */

    function addMonths(dirtyDate, dirtyAmount) {
      requiredArgs(2, arguments);
      var date = toDate(dirtyDate);
      var amount = toInteger(dirtyAmount);
      if (isNaN(amount)) {
        return new Date(NaN);
      }
      if (!amount) {
        // If 0 months, no-op to avoid changing times in the hour before end of DST
        return date;
      }
      var dayOfMonth = date.getDate(); // The JS Date object supports date math by accepting out-of-bounds values for
      // month, day, etc. For example, new Date(2020, 0, 0) returns 31 Dec 2019 and
      // new Date(2020, 13, 1) returns 1 Feb 2021.  This is *almost* the behavior we
      // want except that dates will wrap around the end of a month, meaning that
      // new Date(2020, 13, 31) will return 3 Mar 2021 not 28 Feb 2021 as desired. So
      // we'll default to the end of the desired month by adding 1 to the desired
      // month and using a date of 0 to back up one day to the end of the desired
      // month.

      var endOfDesiredMonth = new Date(date.getTime());
      endOfDesiredMonth.setMonth(date.getMonth() + amount + 1, 0);
      var daysInMonth = endOfDesiredMonth.getDate();
      if (dayOfMonth >= daysInMonth) {
        // If we're already at the end of the month, then this is the correct date
        // and we're done.
        return endOfDesiredMonth;
      } else {
        // Otherwise, we now know that setting the original day-of-month value won't
        // cause an overflow, so set the desired day-of-month. Note that we can't
        // just set the date of `endOfDesiredMonth` because that object may have had
        // its time changed in the unusual case where where a DST transition was on
        // the last day of the month and its local time was in the hour skipped or
        // repeated next to a DST transition.  So we use `date` instead which is
        // guaranteed to still have the original time.
        date.setFullYear(endOfDesiredMonth.getFullYear(), endOfDesiredMonth.getMonth(), dayOfMonth);
        return date;
      }
    }

    /**
     * @name add
     * @category Common Helpers
     * @summary Add the specified years, months, weeks, days, hours, minutes and seconds to the given date.
     *
     * @description
     * Add the specified years, months, weeks, days, hours, minutes and seconds to the given date.
     *
     * @param {Date|Number} date - the date to be changed
     * @param {Duration} duration - the object with years, months, weeks, days, hours, minutes and seconds to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
     *
     * | Key            | Description                        |
     * |----------------|------------------------------------|
     * | years          | Amount of years to be added        |
     * | months         | Amount of months to be added       |
     * | weeks          | Amount of weeks to be added        |
     * | days           | Amount of days to be added         |
     * | hours          | Amount of hours to be added        |
     * | minutes        | Amount of minutes to be added      |
     * | seconds        | Amount of seconds to be added      |
     *
     * All values default to 0
     *
     * @returns {Date} the new date with the seconds added
     * @throws {TypeError} 2 arguments required
     *
     * @example
     * // Add the following duration to 1 September 2014, 10:19:50
     * const result = add(new Date(2014, 8, 1, 10, 19, 50), {
     *   years: 2,
     *   months: 9,
     *   weeks: 1,
     *   days: 7,
     *   hours: 5,
     *   minutes: 9,
     *   seconds: 30,
     * })
     * //=> Thu Jun 15 2017 15:29:20
     */
    function add(dirtyDate, duration) {
      requiredArgs(2, arguments);
      if (!duration || typeof duration !== 'object') return new Date(NaN);
      var years = duration.years ? toInteger(duration.years) : 0;
      var months = duration.months ? toInteger(duration.months) : 0;
      var weeks = duration.weeks ? toInteger(duration.weeks) : 0;
      var days = duration.days ? toInteger(duration.days) : 0;
      var hours = duration.hours ? toInteger(duration.hours) : 0;
      var minutes = duration.minutes ? toInteger(duration.minutes) : 0;
      var seconds = duration.seconds ? toInteger(duration.seconds) : 0; // Add years and months

      var date = toDate(dirtyDate);
      var dateWithMonths = months || years ? addMonths(date, months + years * 12) : date; // Add weeks and days

      var dateWithDays = days || weeks ? addDays(dateWithMonths, days + weeks * 7) : dateWithMonths; // Add days, hours, minutes and seconds

      var minutesToAdd = minutes + hours * 60;
      var secondsToAdd = seconds + minutesToAdd * 60;
      var msToAdd = secondsToAdd * 1000;
      var finalDate = new Date(dateWithDays.getTime() + msToAdd);
      return finalDate;
    }

    var script$4 = {
      name: 'AuthSection',
      components: {
        ResourceListItem: _yooessentials.ResourceListItem
      },
      computed: {
        drivers: function drivers() {
          return _yooessentials.AuthModel.drivers;
        },
        auths: function auths() {
          var _this = this;
          return _yooessentials.AuthModel.auths.map(function (auth) {
            var _this$drivers;
            var res = {
              auth: auth,
              driver: driver
            };
            var driver = res.driver = (_this$drivers = _this.drivers) == null ? void 0 : _this$drivers[auth.driver];
            if (!driver) {
              return _extends({}, res, {
                error: 'Auth Driver Not Found'
              });
            }
            if (driver.type === 'oauth' && !auth.scopes) {
              return {
                auth: auth,
                driver: driver,
                warning: 'Missing Authorization'
              };
            }
            if (driver.accessTokenThreshold && auth.expiresAt) {
              var _auth$expiresAt, _add;
              var expiresAt = new Date(((_auth$expiresAt = auth.expiresAt) == null ? void 0 : _auth$expiresAt.date) || auth.expiresAt * 1000);
              var expiresIn = expiresAt.valueOf() - new Date().valueOf();
              var formated = expiresAt.toLocaleString().split(',')[0];
              if (expiresIn <= 0) {
                return _extends({}, res, {
                  warning: 'Expired ' + formated
                });
              }
              var _driver$accessTokenTh = driver.accessTokenThreshold.split(' '),
                num = _driver$accessTokenTh[0],
                unit = _driver$accessTokenTh[1];

              // pluralize
              if (unit[unit.length + 1] !== 's') {
                unit = unit + "s";
              }
              var threshold = add(new Date(), (_add = {}, _add[unit] = num, _add));
              var thresholdIn = threshold.valueOf() - new Date().valueOf();
              res.expiresSoon = expiresIn < thresholdIn;
              res.meta = 'Expires ' + formated;
            }
            return res;
          });
        }
      },
      methods: {
        edit: function edit(auth) {
          var driver = _yooessentials.AuthModel.drivers[auth.driver];
          return this.$modal(__vue_component__$5, {
            values: auth,
            panel: driver,
            scopes: Object.keys(driver.scopes)
          }).show().then(function (auth) {
            auth && _yooessentials.AuthModel.save(auth);
          });
        },
        trash: function trash(auth) {
          _yooessentials.AuthModel.remove(auth);
        }
      }
    };

    /* script */
    var __vue_script__$4 = script$4;

    /* template */
    var __vue_render__$4 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        staticClass: "uk-margin-remove-first-child"
      }, [_vm.auths.length ? _c('div', [_c('ul', {
        staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-iconnav"
      }, _vm._l(_vm.auths, function (ref) {
        var auth = ref.auth;
        var driver = ref.driver;
        var meta = ref.meta;
        var error = ref.error;
        var warning = ref.warning;
        var expiresSoon = ref.expiresSoon;
        return _c('ResourceListItem', {
          key: auth.id,
          attrs: {
            "title": auth.name || auth.account || auth.username || driver && driver.title || _vm.$t('Unknown'),
            "icon": driver && driver.icon,
            "error": error || warning,
            "meta": meta,
            "actions": ['delete', expiresSoon && {
              title: _vm.$t('Requires Re-Authentication'),
              emit: 'edit',
              icon: 'warning',
              "class": 'uk-text-danger',
              stack: true
            }].filter(Boolean),
            "editable": !error
          },
          on: {
            "edit": function edit($event) {
              return _vm.edit(auth);
            },
            "delete": function _delete($event) {
              return _vm.trash(auth);
            }
          },
          scopedSlots: _vm._u([!driver ? {
            key: "icon",
            fn: function fn() {
              return [_c('span', {
                attrs: {
                  "uk-icon": "question",
                  "ratio": "1.2"
                }
              })];
            },
            proxy: true
          } : driver.type !== 'oauth' ? {
            key: "icon",
            fn: function fn() {
              return [_c('span', {
                attrs: {
                  "uk-icon": "lock",
                  "ratio": "1.2"
                }
              })];
            },
            proxy: true
          } : null], null, true)
        });
      }), 1), _vm._v(" "), _c('p', {
        staticClass: "uk-text-muted"
      }, [_vm._v(_vm._s(_vm.$t('Connected Accounts and other authentication-related keys used with Sources, Storages or Form Actions.')))])]) : _c('div', {
        staticClass: "uk-text-center"
      }, [_c('p', [_vm._v(_vm._s(_vm.$t('Connected Accounts and other authentication-related keys used with Sources, Storages or Form Actions will appear here.')))])])]);
    };
    var __vue_staticRenderFns__$4 = [];

    /* style */
    var __vue_inject_styles__$4 = undefined;
    /* scoped */
    var __vue_scope_id__$4 = undefined;
    /* module identifier */
    var __vue_module_identifier__$4 = undefined;
    /* functional template */
    var __vue_is_functional_template__$4 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$4 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$4,
      staticRenderFns: __vue_staticRenderFns__$4
    }, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);

    var script$3 = {
      name: 'AuthDropdown',
      filters: {
        date: function date(timestamp) {
          return new Date(timestamp).toLocaleString().split(',')[0];
        }
      },
      props: {
        drivers: {
          type: Object,
          required: true
        },
        auths: {
          type: Array,
          required: true
        },
        connections: {
          type: Object,
          "default": function _default() {
            return {};
          }
        }
      },
      computed: {
        $auths: function $auths() {
          var _this = this;
          return this.auths.map(function (auth) {
            var _this$drivers;
            var scopes = _this.connections[auth.driver] || [];
            var driver = _extends({
              services: []
            }, (_this$drivers = _this.drivers) == null ? void 0 : _this$drivers[auth.driver]);
            var granted = _this.validateScopes(auth, scopes);
            return {
              auth: auth,
              driver: driver,
              granted: granted
            };
          });
        },
        $connections: function $connections() {
          var _this2 = this;
          return Object.keys(this.connections).filter(function (d) {
            var _this2$drivers;
            return (_this2$drivers = _this2.drivers) == null ? void 0 : _this2$drivers[d];
          }).map(function (d) {
            var scopes = _this2.connections[d];
            var driver = _extends({
              services: []
            }, _this2.drivers[d]);
            return {
              driver: driver,
              scopes: scopes
            };
          });
        }
      },
      methods: {
        validateScopes: function validateScopes(auth, scopes) {
          return scopes.every(function (scope) {
            return uikitUtil.includes(auth.scopes, scope);
          });
        }
      }
    };

    /* script */
    var __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$3 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('div', {
        staticClass: "yo-dropdown-body uk-overflow-auto uk-height-max-large"
      }, [_c('ul', {
        staticClass: "uk-nav uk-dropdown-nav"
      }, [_vm._l(_vm.$auths, function (ref) {
        var auth = ref.auth;
        var driver = ref.driver;
        return _c('li', {
          key: auth.id,
          staticClass: "uk-visible-toggle uk-text-truncate uk-position-relative"
        }, [_c('a', {
          attrs: {
            "href": ""
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('resolve', auth);
            }
          }
        }, [driver.icon ? _c('img', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "alt": driver.title,
            "src": driver.icon,
            "uk-svg": "",
            "width": "20",
            "height": "20"
          }
        }) : _c('span', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "uk-icon": "lock"
          }
        }), _vm._v(" "), _c('div', {
          staticClass: "uk-text-baseline"
        }, [_c('span', {
          staticClass: "uk-text-emphasis"
        }, [_vm._v(_vm._s(auth.name || auth.account || auth.username || driver.name))]), _vm._v(" "), _c('span', {
          staticClass: "uk-display-block uk-text-meta"
        }, [_c('span', {
          staticClass: "uk-text-meta"
        }, [_vm._v(_vm._s(driver.title))]), _vm._v(" "), auth.timestamp ? _c('span', [_vm._v(_vm._s(_vm._f("date")(auth.timestamp)))]) : _vm._e()])])]), _vm._v(" "), _c('div', {
          staticClass: "uk-invisible-hover uk-position-center-right uk-position-medium uk-margin-small-right"
        }, [_c('ul', {
          staticClass: "uk-iconnav uk-flex-nowrap"
        }, [_c('li', [_c('a', {
          staticClass: "uk-icon-link uk-preserve-width",
          attrs: {
            "title": _vm.$t('Edit'),
            "uk-icon": "pencil",
            "uk-tooltip": "delay: 500"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('edit', auth);
            }
          }
        })]), _vm._v(" "), _c('li', [_c('a', {
          staticClass: "uk-icon-link uk-preserve-width",
          attrs: {
            "title": _vm.$t('Delete'),
            "uk-icon": "trash",
            "uk-tooltip": "delay: 500"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('remove', auth);
            }
          }
        })])])])]);
      }), _vm._v(" "), _vm.auths.length ? _c('li', {
        staticClass: "uk-nav-divider"
      }) : _vm._e(), _vm._v(" "), _vm._l(_vm.$connections, function (ref) {
        var driver = ref.driver;
        return [driver ? _c('li', {
          key: driver.name
        }, [_c('a', {
          attrs: {
            "href": ""
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('add', driver.name);
            }
          }
        }, [_c('span', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "uk-icon": "plus-circle"
          }
        }), _vm._v("\n                        " + _vm._s(driver.title) + "\n                        "), _c('span', {
          staticClass: "uk-text-meta"
        }, [_vm._v(_vm._s(driver.description))])])]) : _vm._e()];
      })], 2)])]);
    };
    var __vue_staticRenderFns__$3 = [];

    /* style */
    var __vue_inject_styles__$3 = undefined;
    /* scoped */
    var __vue_scope_id__$3 = undefined;
    /* module identifier */
    var __vue_module_identifier__$3 = undefined;
    /* functional template */
    var __vue_is_functional_template__$3 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$3,
      staticRenderFns: __vue_staticRenderFns__$3
    }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);

    //
    var script$2 = {
      name: 'AuthOAuthField',
      filters: {
        date: function date(timestamp) {
          var date = new Date(timestamp).toLocaleString();
          return date.split(',')[0];
        }
      },
      "extends": $fields__default["default"].FieldText,
      computed: {
        selectedAuth: function selectedAuth() {
          var _this = this;
          return _yooessentials.AuthModel.auths.find(function (auth) {
            return auth.id === _this.value;
          });
        },
        authorizationRequired: function authorizationRequired() {
          var _this$driver, _this$connections;
          if (((_this$driver = this.driver) == null ? void 0 : _this$driver.type) !== 'oauth') {
            return false;
          }
          var auth = this.selectedAuth;
          var scopes = (_this$connections = this.connections) == null ? void 0 : _this$connections[auth == null ? void 0 : auth.driver];
          if (!auth) {
            return false;
          }
          return !_yooessentials.AuthModel.validateScopes(auth, scopes);
        },
        empty: function empty() {
          return this.drivers.length === 1 && uikitUtil.isEmpty(this.auths);
        },
        driver: function driver() {
          var _AuthModel$drivers, _this$selectedAuth;
          return (_AuthModel$drivers = _yooessentials.AuthModel.drivers) == null ? void 0 : _AuthModel$drivers[(_this$selectedAuth = this.selectedAuth) == null ? void 0 : _this$selectedAuth.driver];
        },
        drivers: function drivers() {
          var _this$connections2;
          return Object.keys((_this$connections2 = this.connections) != null ? _this$connections2 : {}).map(function (driver) {
            var _AuthModel$drivers2, _AuthModel$drivers2$d;
            return (_AuthModel$drivers2 = _yooessentials.AuthModel.drivers) == null ? void 0 : (_AuthModel$drivers2$d = _AuthModel$drivers2[driver]) == null ? void 0 : _AuthModel$drivers2$d.name;
          }).filter(Boolean);
        },
        auths: function auths() {
          var _this2 = this;
          return _yooessentials.AuthModel.auths.filter(function (auth) {
            return uikitUtil.includes(_this2.drivers, auth.driver);
          });
        }
      },
      mounted: function mounted() {
        // reset value if selected auth is not valid
        if (!this.selectedAuth) {
          this.value = '';
        }
      },
      methods: {
        isEmpty: uikitUtil.isEmpty,
        add: function add(driver) {
          var _this3 = this;
          driver = driver || this.drivers[0];
          return this.edit({
            driver: driver
          }).then(function (auth) {
            if (auth) {
              _this3.value = auth.id;
            }
          });
        },
        edit: function edit(auth) {
          var _this4 = this;
          if (auth === void 0) {
            auth = this.selectedAuth;
          }
          var driver = _yooessentials.AuthModel.drivers[auth.driver];
          var scopes = this.connections[auth.driver];
          return this.$modal(__vue_component__$5, {
            panel: driver,
            scopes: scopes,
            values: auth
          }).show().then(function (auth) {
            if (auth) {
              auth = _yooessentials.AuthModel.save(auth);
            }
            _this4.$forceUpdate();
            return auth;
          });
        },
        select: function select() {
          var _this5 = this;
          var drop = this.$dropdown({
            functional: true,
            render: function render(h) {
              return h(__vue_component__$3, {
                props: {
                  auths: _this5.auths,
                  drivers: _yooessentials.AuthModel.drivers,
                  connections: _this5.connections
                },
                on: {
                  add: function add(driver) {
                    drop.hide();
                    _this5.add(driver).then(function () {
                      drop.$forceUpdate();
                    });
                  },
                  edit: function edit(auth) {
                    drop.hide();
                    _this5.edit(auth).then(function () {
                      drop.$forceUpdate();
                    });
                  },
                  remove: function remove(auth) {
                    _yooessentials.AuthModel.remove(auth);
                    drop.$forceUpdate();
                    if (auth.id === _this5.value) {
                      _this5.value = '';
                    }
                    if (uikitUtil.isEmpty(_this5.auths)) {
                      drop.hide();
                    }
                  },
                  resolve: function resolve(auth) {
                    drop.hide();
                    _this5.value = auth.id;
                    drop.$forceUpdate();
                  }
                }
              });
            }
          });
          drop.show(this.$el, {
            classes: 'yo-dropdown'
          });
        }
      }
    };

    /* script */
    var __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$2 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _vm.isEmpty(_vm.drivers) ? _c('div', [_vm._v("\n    No valid drivers.\n")]) : _vm.isEmpty(_vm.connections) ? _c('div', [_vm._v("\n    No valid connections.\n")]) : _c('div', {
        staticClass: "uk-inline uk-width-1-1"
      }, [_c('div', {
        staticClass: "uk-position-center-right uk-position-small"
      }, [_c('ul', {
        staticClass: "uk-iconnav uk-flex-nowrap"
      }, [_vm.authorizationRequired ? _c('li', [_c('a', {
        staticClass: "uk-icon-link uk-preserve-width uk-text-danger",
        attrs: {
          "tabindex": "-1",
          "title": _vm.$t('Insufficient Scope Access'),
          "uk-icon": "warning",
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.edit();
          }
        }
      })]) : _vm.value ? _c('li', [_c('a', {
        staticClass: "uk-icon-link uk-preserve-width",
        attrs: {
          "tabindex": "-1",
          "title": _vm.$t('Edit'),
          "uk-icon": "pencil",
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.edit();
          }
        }
      })]) : _vm._e(), _vm._v(" "), _c('li', [_c('a', {
        staticClass: "uk-icon-link uk-preserve-width",
        attrs: {
          "tabindex": "-1",
          "title": _vm.$t('Pick'),
          "uk-icon": "album",
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            _vm.empty ? _vm.add() : _vm.select();
          }
        }
      })])])]), _vm._v(" "), _c('span', {
        staticClass: "uk-input uk-disabled",
        "class": [_vm.attributes["class"], {
          'uk-form-danger': _vm.authorizationRequired
        }],
        attrs: {
          "title": _vm.attributes.title
        }
      }, [_vm.selectedAuth && _vm.driver ? [_vm.driver.icon ? _c('img', {
        attrs: {
          "alt": _vm.driver.title,
          "src": _vm.driver.icon,
          "uk-svg": "",
          "width": "20",
          "height": "20"
        }
      }) : _c('span', {
        attrs: {
          "uk-icon": "lock"
        }
      }), _vm._v(" "), _c('span', {
        staticClass: "uk-text-emphasis uk-margin-small-left uk-text-baseline"
      }, [_vm._v(_vm._s(_vm.selectedAuth.name || _vm.selectedAuth.account || _vm.selectedAuth.username || _vm.driver.name))]), _vm._v(" "), _c('span', {
        staticClass: "uk-text-meta uk-margin-small-left uk-text-baseline"
      }, [_vm._v(_vm._s(_vm.driver.title))])] : _vm._e()], 2)]);
    };
    var __vue_staticRenderFns__$2 = [];

    /* style */
    var __vue_inject_styles__$2 = undefined;
    /* scoped */
    var __vue_scope_id__$2 = undefined;
    /* module identifier */
    var __vue_module_identifier__$2 = undefined;
    /* functional template */
    var __vue_is_functional_template__$2 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$2,
      staticRenderFns: __vue_staticRenderFns__$2
    }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

    //
    var script$1 = {
      "extends": $fields__default["default"].FieldText,
      inject: ['ModalForm'],
      computed: {
        connected: function connected() {
          var _this$values$scopes;
          return (_this$values$scopes = this.values.scopes) == null ? void 0 : _this$values$scopes.length;
        }
      },
      methods: {
        connect: function connect() {
          this.ModalForm.connect();
        }
      }
    };

    /* script */
    var __vue_script__$1 = script$1;

    /* template */
    var __vue_render__$1 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('button', _vm._b({
        staticClass: "uk-button yo-button-panel uk-width-1-1",
        "class": {
          'yo-button-medium': _vm.attributes["class"] === 'yo-form-medium'
        },
        attrs: {
          "type": "button"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.connect.apply(null, arguments);
          }
        }
      }, 'button', _vm.attributes, false), [_c('span', [_vm._v(_vm._s(_vm.$t(_vm.connected ? 'Re-Authenticate' : 'Authenticate')))])]);
    };
    var __vue_staticRenderFns__$1 = [];

    /* style */
    var __vue_inject_styles__$1 = undefined;
    /* scoped */
    var __vue_scope_id__$1 = undefined;
    /* module identifier */
    var __vue_module_identifier__$1 = undefined;
    /* functional template */
    var __vue_is_functional_template__$1 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$1,
      staticRenderFns: __vue_staticRenderFns__$1
    }, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

    //
    var script = {
      "extends": $fields__default["default"].FieldText,
      inject: ['ModalForm'],
      computed: {
        scopes: function scopes() {
          var _this$values$scopes,
            _this$values,
            _this = this;
          var scopes = [].concat((_this$values$scopes = (_this$values = this.values) == null ? void 0 : _this$values.scopes) != null ? _this$values$scopes : [], this.ModalForm.scopes);
          return _yooessentials.unique(scopes).filter(function (scope) {
            var _this$ModalForm$panel, _this$ModalForm$panel2;
            return (_this$ModalForm$panel = _this.ModalForm.panel) == null ? void 0 : (_this$ModalForm$panel2 = _this$ModalForm$panel.scopes) == null ? void 0 : _this$ModalForm$panel2[scope];
          }).map(function (scope) {
            return {
              name: scope,
              title: _this.ModalForm.panel.scopes[scope]
            };
          });
        },
        isOauth: function isOauth() {
          var _this$ModalForm$panel3;
          return ((_this$ModalForm$panel3 = this.ModalForm.panel) == null ? void 0 : _this$ModalForm$panel3.type) === 'oauth';
        }
      },
      methods: {
        validates: function validates(scope) {
          return uikitUtil.includes(this.values.scopes, scope);
        }
      }
    };

    /* script */
    var __vue_script__ = script;

    /* template */
    var __vue_render__ = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return !_vm.scopes.length ? _c('div', [_vm._v("\n    " + _vm._s(_vm.$t('None')) + "\n")]) : _c('ul', {
        staticClass: "uk-list"
      }, _vm._l(_vm.scopes, function (scope) {
        return _c('li', {
          key: scope.name,
          staticClass: "uk-flex uk-flex-between"
        }, [_c('span', [_vm._v(_vm._s(scope.title))]), _vm._v(" "), _vm.isOauth ? [_vm.validates(scope.name) ? _c('span', {
          attrs: {
            "uk-icon": "check"
          }
        }) : _c('span', {
          attrs: {
            "uk-icon": "ban"
          }
        })] : _vm._e()], 2);
      }), 0);
    };
    var __vue_staticRenderFns__ = [];

    /* style */
    var __vue_inject_styles__ = undefined;
    /* scoped */
    var __vue_scope_id__ = undefined;
    /* module identifier */
    var __vue_module_identifier__ = undefined;
    /* functional template */
    var __vue_is_functional_template__ = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__ = /*#__PURE__*/normalizeComponent({
      render: __vue_render__,
      staticRenderFns: __vue_staticRenderFns__
    }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

    var fields = /*#__PURE__*/Object.freeze({
        __proto__: null,
        FieldYooessentialsConnectedAuth: __vue_component__$2,
        FieldYooessentialsOauthGrant: __vue_component__$1,
        FieldYooessentialsOauthScopes: __vue_component__
    });

    var AuthModel$1 = {
      name: 'AuthModel',
      data: function data() {
        return {
          drivers: _yooessentials.get(window, '$customizer.yooessentials.auth_drivers', {})
        };
      },
      computed: {
        auths: {
          get: function get() {
            return _yooessentials.Config.get('auth.auths', []);
          },
          set: function set(values) {
            _yooessentials.Config.set('auth.auths', values);
          },
          cache: false
        }
      },
      methods: {
        save: function save(auth) {
          var driver = this.drivers[auth.driver];
          if (!driver) {
            throw Error("Unknown Driver: " + auth.driver);
          }
          var auths = [].concat(this.auths);
          var index = auths.findIndex(function (a) {
            return a.id === auth.id;
          });
          if (index >= 0) {
            // update
            auths[index] = auth;
          } else {
            // add new
            auth = _extends({
              id: _yooessentials.uuid(),
              timestamp: Date.now()
            }, auth);
            auths.push(auth);
          }
          this.auths = auths;
          return auth;
        },
        remove: function remove(values) {
          var auths = [].concat(this.auths);
          var index = auths.findIndex(function (a) {
            return a.id === values.id;
          });
          auths.splice(index, 1);
          this.auths = auths;
        },
        oauth: function oauth(driver, scopes) {
          var _this = this;
          return new Promise(function (resolve, reject) {
            var _$driver$endpoints;
            var $driver = _this.drivers[driver];
            if (!$driver) {
              reject("Unknown Driver: " + driver);
              return;
            }
            if (!scopes) {
              reject('Scopes must be specified.');
              return;
            }
            var oauthEndpoint = $driver == null ? void 0 : (_$driver$endpoints = $driver.endpoints) == null ? void 0 : _$driver$endpoints.oauth;
            if (!oauthEndpoint) {
              reject('Driver is missing oauth endpoint.');
              return;
            }
            if ($driver.poll) {
              var _$driver$endpoints2;
              var idEndpoint = $driver == null ? void 0 : (_$driver$endpoints2 = $driver.endpoints) == null ? void 0 : _$driver$endpoints2.id;
              if (!idEndpoint) {
                reject('Driver is missing id endpoint.');
                return;
              }
              _this.$http.post(idEndpoint.toString()).then(function (response) {
                var id = response.body.id;
                if (!id) {
                  reject('Driver id endpoint not resolved.');
                  return;
                }
                var oauthEndpointUrl = getOauthEndpoint(oauthEndpoint, scopes, id);
                var pollEndpointUrl = getOauthEndpoint(oauthEndpoint + "/poll", scopes, id);
                var win = window.open(oauthEndpointUrl, '');
                onWinClose(win, function () {
                  var count = 0;
                  var interval = setInterval(function () {
                    if (count > 10) {
                      clearInterval(interval);
                      reject('Sorry, something went wrong.');
                    }
                    _this.$http.get(pollEndpointUrl).then(function (response) {
                      if (!uikitUtil.isEmpty(response.body)) {
                        clearInterval(interval);
                        resolve(response.body);
                      }
                    });
                    count++;
                  }, 500);
                });
              });
            } else {
              var endpointUrl = getOauthEndpoint(oauthEndpoint, scopes);
              window.open(endpointUrl, '');
              window.addEventListener('message', function (e) {
                if (!endpointUrl.match(new RegExp(e.origin))) {
                  return;
                }
                resolve(uikitUtil.isObject(e.data) ? e.data : {});
              }, false);
            }
          }).then(function (data) {
            var _data$scopes;
            // if unknown granted scopes, assume all granted
            if (!((_data$scopes = data.scopes) != null && _data$scopes.length)) {
              data.scopes = scopes;
            }
            return data;
          });
        },
        validateScopes: function validateScopes(auth, scopes) {
          return scopes.every(function (scope) {
            return uikitUtil.includes(auth.scopes, scope);
          });
        }
      }
    };
    function onWinClose(win, cb) {
      var interval = setInterval(function () {
        if (win.closed) {
          clearInterval(interval);
          cb();
        }
      }, 400);
    }
    function getOauthEndpoint(endpoint, scopes, id) {
      var url = new URL(endpoint);
      var params = url.searchParams;
      params.set('scopes', scopes);
      params.set('yooessentialsVersion', window.$customizer.yooessentials.version);
      id && params.set('id', id);
      url.search = '?' + params.toString();
      return url.toString();
    }

    uikitUtil.assign(window.$fields, fields);
    Vue__default["default"].component('yooessentials-auths', __vue_component__$4);
    var AuthModel = new Vue__default["default"](AuthModel$1);

    // expose globally
    window.$yooess.AuthModel = AuthModel;

})(Vue, UIkit.util, $yooessentials, $fields);
