/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function (Vue, _yooessentials, uikitUtil, UIkit, $fields) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
    var UIkit__default = /*#__PURE__*/_interopDefaultLegacy(UIkit);
    var $fields__default = /*#__PURE__*/_interopDefaultLegacy($fields);

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    //
    var script$7 = {
      inject: ['Builder'],
      props: {
        selectable: {
          type: Boolean,
          "default": false
        },
        filter: {
          type: String
        }
      },
      computed: {
        fields: function fields() {
          var _this = this;
          var nodes = _yooessentials.flattenChildren(_yooessentials.FormModel.currentFormNode).filter(function (node) {
            return node.type.match(/yooessentials_form_/);
          }).filter(function (node) {
            return node.props.control_name;
          });
          if (this.filter) {
            return nodes.filter(function (node) {
              return node.type.match(new RegExp(_this.filter));
            });
          }
          return nodes;
        }
      }
    };

    /* script */
    var __vue_script__$7 = script$7;

    /* template */
    var __vue_render__$6 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        attrs: {
          "id": "yooessentials-form-fields-modal"
        }
      }, [_c('div', {
        staticClass: "uk-modal-header"
      }, [_vm._v("\n        " + _vm._s(_vm.$t('Form Fields')) + "\n    ")]), _vm._v(" "), _c('div', {
        staticClass: "uk-modal-body"
      }, [Object.keys(_vm.fields).length ? _c('table', {
        staticClass: "uk-table uk-table-divider",
        "class": {
          'uk-table-hover': _vm.selectable
        }
      }, [_c('thead', [_c('tr', [_c('th', [_vm._v(_vm._s(_vm.$t('Name')))]), _vm._v(" "), _c('th', [_vm._v(_vm._s(_vm.$t('Type')))])])]), _vm._v(" "), _c('tbody', _vm._l(_vm.fields, function (node) {
        return _c('tr', {
          key: _vm.Builder.key(node)
        }, [_vm.selectable ? _c('td', {
          staticClass: "uk-text-bold uk-table-link"
        }, [_c('a', {
          staticClass: "uk-link-reset",
          attrs: {
            "href": ""
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('resolve', node);
            }
          }
        }, [_vm._v(_vm._s(node.props.control_name))])]) : _c('td', {
          staticClass: "uk-text-bold"
        }, [_vm._v(_vm._s(node.props.control_name))]), _vm._v(" "), _c('td', [_vm._v(_vm._s(_vm.Builder.type(node).title))])]);
      }), 0)]) : [_vm._v("\n\n            " + _vm._s(_vm.$t('This Form Area has no assigned fields yet or those have not been associated with a name.')) + "\n\n        ")]], 2)]);
    };
    var __vue_staticRenderFns__$6 = [];

    /* style */
    var __vue_inject_styles__$7 = undefined;
    /* scoped */
    var __vue_scope_id__$7 = undefined;
    /* module identifier */
    var __vue_module_identifier__$7 = undefined;
    /* functional template */
    var __vue_is_functional_template__$7 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$7 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$6,
      staticRenderFns: __vue_staticRenderFns__$6
    }, __vue_inject_styles__$7, __vue_script__$7, __vue_scope_id__$7, __vue_is_functional_template__$7, __vue_module_identifier__$7, false, undefined, undefined, undefined);

    function _extends() {
      _extends = Object.assign ? Object.assign.bind() : function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }

    var script$6 = {
      name: 'FormAreaNodeStatus',
      inject: ['Builder', 'Sidebar'],
      props: {
        node: {
          type: Object,
          required: true
        },
        formAreaNode: {
          type: Object
        },
        error: String
      },
      computed: {
        position: function position() {
          var _this$node, _this$node$type;
          var positions = {
            section: 'top',
            row: 'left'
          };
          return positions[(_this$node = this.node) == null ? void 0 : (_this$node$type = _this$node.type) == null ? void 0 : _this$node$type.name] || 'bottom';
        }
      },
      methods: {
        edit: function edit() {
          var _this$formAreaNode;
          this.$trigger('openPanel', _extends({}, this.Sidebar.panels['yooessentials-form-settings'], {
            props: {
              node: this.formAreaNode,
              builder: this.Builder,
              values: (_this$formAreaNode = this.formAreaNode) == null ? void 0 : _this$formAreaNode.props
            },
            component: _yooessentials.BuilderPanel
          }));
        }
      }
    };

    /* script */
    var __vue_script__$6 = script$6;

    /* template */
    var __vue_render__$5 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _vm.error ? _c('span', {
        staticClass: "ye-builder-icon-form-error",
        attrs: {
          "title": _vm.$t(_vm.error),
          "uk-tooltip": "pos: " + _vm.position
        }
      }) : _vm.formAreaNode ? _c('a', {
        staticClass: "ye-builder-icon-form",
        attrs: {
          "href": "#",
          "title": _vm.$t('Form Area'),
          "uk-tooltip": "pos: " + _vm.position
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            _vm.formAreaNode && _vm.edit();
          }
        }
      }) : _c('span', {
        staticClass: "ye-builder-icon-form",
        attrs: {
          "title": _vm.$t('Form Area'),
          "uk-tooltip": "pos: " + _vm.position
        }
      });
    };
    var __vue_staticRenderFns__$5 = [];

    /* style */
    var __vue_inject_styles__$6 = undefined;
    /* scoped */
    var __vue_scope_id__$6 = undefined;
    /* module identifier */
    var __vue_module_identifier__$6 = undefined;
    /* functional template */
    var __vue_is_functional_template__$6 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$6 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$5,
      staticRenderFns: __vue_staticRenderFns__$5
    }, __vue_inject_styles__$6, __vue_script__$6, __vue_scope_id__$6, __vue_is_functional_template__$6, __vue_module_identifier__$6, false, undefined, undefined, undefined);

    //
    //
    //
    //
    //
    //

    var script$5 = {
      name: 'FormFieldNodeStatus',
      props: {
        node: {
          type: Object,
          required: true
        },
        error: String
      }
    };

    /* script */
    var __vue_script__$5 = script$5;

    /* template */
    var __vue_render__$4 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('span', {
        staticClass: "ye-builder-icon-form-error",
        attrs: {
          "title": _vm.$t(_vm.error),
          "uk-tooltip": "pos: bottom"
        }
      });
    };
    var __vue_staticRenderFns__$4 = [];

    /* style */
    var __vue_inject_styles__$5 = undefined;
    /* scoped */
    var __vue_scope_id__$5 = undefined;
    /* module identifier */
    var __vue_module_identifier__$5 = undefined;
    /* functional template */
    var __vue_is_functional_template__$5 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$5 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$4,
      staticRenderFns: __vue_staticRenderFns__$4
    }, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);

    var script$4 = {
      name: 'FormPlaceholderDrop',
      components: {
        DropdownList: _yooessentials.DropdownList
      },
      props: {
        entries: Array
      },
      computed: {
        entriesList: function entriesList() {
          return this.entries.map(function (ctrl) {
            return _extends({}, ctrl, {
              group: 'Form'
            });
          });
        }
      }
    };

    /* script */
    var __vue_script__$4 = script$4;

    /* template */
    var __vue_render__$3 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('DropdownList', {
        attrs: {
          "entries": _vm.entriesList
        },
        scopedSlots: _vm._u([{
          key: "entry",
          fn: function fn(ref) {
            var entry = ref.entry;
            return [_c('li', {
              staticClass: "uk-visible-toggle uk-position-relative",
              on: {
                "click": function click($event) {
                  $event.preventDefault();
                  return _vm.$emit('resolve', entry);
                }
              }
            }, [_c('a', {
              staticStyle: {
                "cursor": "default !important"
              }
            }, [_vm._v("\n                    " + _vm._s(entry.text) + "\n                    "), entry.meta ? _c('span', {
              staticClass: "uk-text-meta uk-margin-small-left"
            }, [_vm._v(_vm._s(entry.meta))]) : _vm._e()])])];
          }
        }])
      })], 1);
    };
    var __vue_staticRenderFns__$3 = [];

    /* style */
    var __vue_inject_styles__$4 = undefined;
    /* scoped */
    var __vue_scope_id__$4 = undefined;
    /* module identifier */
    var __vue_module_identifier__$4 = undefined;
    /* functional template */
    var __vue_is_functional_template__$4 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$4 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$3,
      staticRenderFns: __vue_staticRenderFns__$3
    }, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);

    var Status = (function (_ref, node) {
      var origin = _ref.origin,
        _ref$result = _ref.result,
        result = _ref$result === void 0 ? [] : _ref$result;
      if (node.type.match(/section|row/)) {
        var _evaluateFormArea = evaluateFormArea(node),
          _evaluateFormArea$for = _evaluateFormArea.formAreas,
          formAreas = _evaluateFormArea$for === void 0 ? [] : _evaluateFormArea$for,
          error = _evaluateFormArea.error;
        if (error) {
          return [].concat(result, [{
            component: __vue_component__$6,
            error: error
          }]);
        }
        if (!formAreas.length) {
          return result;
        }
        if (formAreas.length === 1) {
          result.push({
            component: __vue_component__$6,
            formAreaNode: formAreas[0]
          });
        } else {
          result.push({
            component: __vue_component__$6
          });
        }
        return result;
      } else {
        var _evaluateFormField = evaluateFormField(node, origin.Builder),
          _error = _evaluateFormField.error;
        if (_error) {
          result.push({
            component: __vue_component__$5,
            node: node,
            error: _error
          });
        }
      }
      return result;
    });
    function evaluateFormArea(node) {
      var _node$props, _node$props$yooessent;
      var children = _yooessentials.flattenChildren(node);
      var isFormArea = Boolean((_node$props = node.props) == null ? void 0 : (_node$props$yooessent = _node$props.yooessentials_form) == null ? void 0 : _node$props$yooessent.state);
      var formAreas = children.filter(function (n) {
        var _n$props, _n$props$yooessential;
        return (_n$props = n.props) == null ? void 0 : (_n$props$yooessential = _n$props.yooessentials_form) == null ? void 0 : _n$props$yooessential.state;
      });
      if (node.type === 'section') {
        if (isFormArea && formAreas.length) {
          return {
            error: 'Duplicated Form Area'
          };
        }
        if (isFormArea) {
          return {
            formAreas: [node]
          };
        }
        return {};
      }
      if (formAreas.length) {
        return {
          formAreas: formAreas
        };
      }
      return {};
    }
    function evaluateFormField(node, Builder) {
      var _node$props2;
      if (!node.type.match('^yooessentials_form_')) {
        return {};
      }
      var formArea = closestFormArea(node, Builder);
      if (!formArea) {
        return {
          error: 'Not In A Form Area'
        };
      }
      var errors = [];
      var siblings = _yooessentials.flattenChildren(formArea);
      var controlName = (_node$props2 = node.props) == null ? void 0 : _node$props2.control_name;
      var controlNames = siblings.filter(function (n) {
        return n.type.match(/^yooessentials_form_/);
      }).map(function (n) {
        var _n$props2;
        return (_n$props2 = n.props) == null ? void 0 : _n$props2.control_name;
      }).filter(Boolean);
      errors['Duplicated Control Name'] = controlNames.filter(function (name) {
        return name === controlName;
      }).length > 1;
      if (node.type.match(/^yooessentials_form_recaptcha$/)) {
        var _recaptchas$0$props, _recaptchas$0$props2;
        var recaptchas = siblings.filter(function (n) {
          return n.type.match(/^yooessentials_form_recaptcha$/);
        });
        errors['No Site or Secret key set'] = recaptchas.length && !((_recaptchas$0$props = recaptchas[0].props) != null && _recaptchas$0$props.control_site_key && (_recaptchas$0$props2 = recaptchas[0].props) != null && _recaptchas$0$props2.control_secret_key);
        errors['Duplicated Google reCaptcha element'] = recaptchas.length > 1;
      }
      var error = Object.keys(errors).reduce(function (carry, error) {
        return [].concat(carry, [errors[error] ? error : false]);
      }, []).filter(Boolean).pop();
      return {
        error: error
      };
    }
    function closestFormArea(node, Builder) {
      while (node && !((_node$props3 = node.props) != null && (_node$props3$yooessen = _node$props3.yooessentials_form) != null && _node$props3$yooessen.state)) {
        var _node$props3, _node$props3$yooessen;
        node = Builder.parent(node);
      }
      return node;
    }

    Vue__default["default"].events.on('yooessentialsDynamicOptions', function (_ref, _ref2) {
      var _ref$result = _ref.result,
        result = _ref$result === void 0 ? [] : _ref$result;
      var node = _ref2.node,
        field = _ref2.field;
      var form = _yooessentials.FormModel.$currentForm;
      if (!form) {
        return result;
      }
      var origin = 'yooessentials.form';
      var currentOrigin = _yooessentials.SourceExtended.getQueryOrigin(node, field.name);
      var matched = origin === currentOrigin;
      var query = {
        name: 'yooessentials_form_query'
      };
      result.push({
        query: query,
        group: 'Submission',
        name: origin,
        title: 'Form',
        // meta: SourceExtended.getSourceField(query)?.metadata.label,
        fields: function fields() {
          return _yooessentials.SourceExtended.getFieldsList(query);
        },
        match: function match() {
          return matched;
        },
        resolve: function resolve(_ref3) {
          var mappedTo = _ref3.mappedTo;
          _yooessentials.SourceExtended.setExtendedProp(node, field.name, {
            name: mappedTo,
            query: query
          }, query);
        }
      });
      return result;
    });
    Vue__default["default"].events.on('yooessentialsSourceQueryOrigin', function (_ref4, _ref5) {
      var _prop, _prop$query;
      var result = _ref4.result;
      var node = _ref5.node,
        prop = _ref5.prop;
      if (result) {
        return result;
      }
      prop = _yooessentials.SourceExtended.getProp(node, prop);
      if (((_prop = prop) == null ? void 0 : (_prop$query = _prop.query) == null ? void 0 : _prop$query.name) === 'yooessentials_form_query') {
        return 'yooessentials.form';
      }
    });
    Vue__default["default"].events.on('yooessentialsPickFormPlaceholder', function (_ref6, field, _ref7) {
      var origin = _ref6.origin;
      var target = _ref7.target;
      var entries = _yooessentials.FormModel.getFields().filter(function (e) {
        var _e$props;
        return (_e$props = e.props) == null ? void 0 : _e$props.control_name;
      }).map(function (e) {
        var _e$props2;
        var value = e.props.control_name;
        return {
          value: value,
          text: ((_e$props2 = e.props) == null ? void 0 : _e$props2.control_label) || value,
          meta: "{" + value + "}"
        };
      });
      origin.$dropdown(__vue_component__$4, {
        entries: entries
      }).show(target, {
        classes: 'yo-dropdown',
        boundaryX: uikitUtil.closest(target, '.yo-sidebar-fields > *') || target
      }).then(function (sel) {
        if (!(sel != null && sel.meta)) {
          return;
        }
        if (!navigator.clipboard) {
          return;
        }
        navigator.clipboard.writeText(sel.meta);
        UIkit__default["default"].notification({
          message: 'Copied to clipboard!',
          status: 'success',
          timeout: 500
        });

        // const fieldWrapper = parent(target);
        // const field = $('div.uk-margin-small > input', fieldWrapper) || $('div.uk-margin-small > textarea', fieldWrapper);

        // if (sel.meta) {
        //     field.value = `${field.value}${sel.meta}`;
        // }
      });
    });

    Vue__default["default"].events.on('yooessentialsBuilderPrepareField', function (e, _ref8) {
      _ref8.node;
        var field = _ref8.field;
      if (!field.formPlaceholder || !_yooessentials.FormModel.$currentForm) {
        return;
      }

      // if (!isString(field.component) || !field.component.startsWith('field-text')) {
      //     return;
      // }

      field.buttons = [{
        label: Vue__default["default"].i18n.t('Placeholder'),
        action: 'yooessentialsPickFormPlaceholder'
      }].concat(field.buttons || []);
    }, -50);

    //
    var script$3 = {
      "extends": $fields__default["default"].FieldText,
      mounted: function mounted() {
        var _this = this;
        uikitUtil.$$('#yooessentials-form-show-control-names', this.$parent.$el).forEach(function (n) {
          uikitUtil.on(n, 'click', function (e) {
            e.preventDefault();
            _this.showTags();
          });
        });
      },
      methods: {
        showTags: function showTags() {
          this.$modal(__vue_component__$7).show();
        }
      }
    };

    /* script */
    var __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$2 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        staticClass: "uk-hidden"
      });
    };
    var __vue_staticRenderFns__$2 = [];

    /* style */
    var __vue_inject_styles__$3 = undefined;
    /* scoped */
    var __vue_scope_id__$3 = undefined;
    /* module identifier */
    var __vue_module_identifier__$3 = undefined;
    /* functional template */
    var __vue_is_functional_template__$3 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$2,
      staticRenderFns: __vue_staticRenderFns__$2
    }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);

    //
    var script$2 = {
      "extends": $fields__default["default"].FieldText,
      inject: ['$node'],
      computed: {
        closestForm: function closestForm() {
          return _yooessentials.FormModel.closestForm(this.$node);
        },
        controls: function controls() {
          return this.closestForm ? _yooessentials.FormModel.controls(this.closestForm) : [];
        },
        inUse: function inUse() {
          var _this = this;
          return this.controls.filter(function (v) {
            return v === _this.value;
          }).length > 1;
        }
      },
      methods: {
        set: function set(value) {
          var _this2 = this;
          // remove unsupported characters and double spaces
          this.value = value.replace(/[^a-zA-Z0-9_ ]|^\s|\s{2,}/, '');

          // trim after last input
          clearTimeout(this.timeout);
          this.timeout = setTimeout(function () {
            _this2.value = _this2.value.trim();
          }, 1000);
        }
      }
    };

    /* script */
    var __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$1 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('input', {
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        staticClass: "uk-input",
        "class": {
          'uk-form-danger': _vm.inUse
        },
        attrs: {
          "type": "text"
        },
        domProps: {
          "value": _vm.value
        },
        on: {
          "input": [function ($event) {
            if ($event.target.composing) {
              return;
            }
            _vm.value = $event.target.value;
          }, function ($event) {
            return _vm.set($event.target.value);
          }]
        }
      }), _vm._v(" "), _vm.inUse ? _c('span', {
        staticClass: "uk-text-meta"
      }, [_vm._v(_vm._s(_vm.$t('Name already assigned to another field.')))]) : _vm._e()]);
    };
    var __vue_staticRenderFns__$1 = [];

    /* style */
    var __vue_inject_styles__$2 = undefined;
    /* scoped */
    var __vue_scope_id__$2 = undefined;
    /* module identifier */
    var __vue_module_identifier__$2 = undefined;
    /* functional template */
    var __vue_is_functional_template__$2 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$1,
      staticRenderFns: __vue_staticRenderFns__$1
    }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

    var script$1 = {
      name: 'FormControlSelect',
      "extends": _yooessentials.FieldYooessentialsSelectDrop,
      inject: {
        $node: {
          "default": null
        }
      },
      computed: {
        status: function status() {
          var _this = this;
          return !this.value || this.fields.some(function (f) {
            var _f$props;
            return ((_f$props = f.props) == null ? void 0 : _f$props.control_name) === _this.value;
          });
        },
        fields: function fields() {
          var _this2 = this;
          return _yooessentials.FormModel.getFields().filter(function (field) {
            var _this2$field;
            return field == null ? void 0 : field.type.name.match((_this2$field = _this2.field) == null ? void 0 : _this2$field.filterType);
          }).filter(function (field) {
            return field == null ? void 0 : field.props.control_name;
          });
        }
      },
      created: function created() {
        this.items = this.fields.map(function (field) {
          return {
            id: field.props.control_name,
            name: field.type.title
          };
        });
      }
    };

    /* script */
    var __vue_script__$1 = script$1;

    /* template */

    /* style */
    var __vue_inject_styles__$1 = undefined;
    /* scoped */
    var __vue_scope_id__$1 = undefined;
    /* module identifier */
    var __vue_module_identifier__$1 = undefined;
    /* functional template */
    var __vue_is_functional_template__$1 = undefined;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$1 = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

    //
    var script = {
      "extends": $fields__default["default"].FieldText,
      inject: ['Builder'],
      data: function data() {
        return {
          status: 200,
          statusText: ''
        };
      },
      computed: {
        formAreaNode: function formAreaNode() {
          var node = this.$parent.node;
          while (node && !((_node$props = node.props) != null && (_node$props$yooessent = _node$props.yooessentials_form) != null && _node$props$yooessent.state)) {
            var _node$props, _node$props$yooessent;
            node = this.Builder.parent(node);
          }
          return node;
        }
      },
      methods: {
        test: function test() {
          var _this$formAreaNode,
            _this = this;
          var formid = (_this$formAreaNode = this.formAreaNode) == null ? void 0 : _this$formAreaNode.formid;
          var action = this.$parent.node.id;
          if (!formid) {
            this.statusText = this.$t('No form ID found');
            return;
          }
          this.statusText = '';
          this.$http.post('yooessentials/form-send-test-email', {
            formid: formid,
            action: action
          }).then(function (response) {
            _this.status = response.status;
            _this.statusText = _this.$t('Email succesfully sent!');
          })["catch"](function (response) {
            _this.status = response.status;
            _this.statusText = response.statusText;
          });
        }
      }
    };

    /* script */
    var __vue_script__ = script;

    /* template */
    var __vue_render__ = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('button', {
        staticClass: "uk-button uk-button-default",
        attrs: {
          "type": "button"
        },
        on: {
          "click": _vm.test
        }
      }, [_vm._v(_vm._s(_vm.$t('Test')))]), _vm._v(" "), _vm.statusText ? _c('span', {
        "class": {
          'uk-text-danger': _vm.status === 400
        }
      }, [_vm._v("\n        " + _vm._s(_vm.statusText) + "\n    ")]) : _vm._e()]);
    };
    var __vue_staticRenderFns__ = [];

    /* style */
    var __vue_inject_styles__ = undefined;
    /* scoped */
    var __vue_scope_id__ = undefined;
    /* module identifier */
    var __vue_module_identifier__ = undefined;
    /* functional template */
    var __vue_is_functional_template__ = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__ = /*#__PURE__*/normalizeComponent({
      render: __vue_render__,
      staticRenderFns: __vue_staticRenderFns__
    }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

    var fields = /*#__PURE__*/Object.freeze({
        __proto__: null,
        FieldYooessentialsFormTags: __vue_component__$3,
        FieldYooessentialsFormControl: __vue_component__$2,
        FieldYooessentialsFormControlSelect: __vue_component__$1,
        FieldYooessentialsFormTestEmail: __vue_component__
    });

    var FormModel = {
      name: 'FormModel',
      events: {
        initBuilder: function initBuilder(e) {
          this.Builder = e.origin;
        },
        openPanel: function openPanel(_ref, payload) {
          var _payload$props, _sidebar$stack, _window$$yooess$yoocu, _node$props, _node$props$yooessent;
          var sidebar = _ref.sidebar;
          var node = payload == null ? void 0 : (_payload$props = payload.props) == null ? void 0 : _payload$props.node;
          var insideFormSettings = sidebar == null ? void 0 : (_sidebar$stack = sidebar.stack) == null ? void 0 : _sidebar$stack.some(function (s) {
            return s.name === 'yooessentials-form-settings';
          });
          var schema = (_window$$yooess$yoocu = window.$yooess.yoocustomizer) == null ? void 0 : _window$$yooess$yoocu.schema;
          if (node != null && (_node$props = node.props) != null && (_node$props$yooessent = _node$props.yooessentials_form) != null && _node$props$yooessent.state) {
            this.setCurrentForm({
              node: node
            });
          } else if (!insideFormSettings && schema) {
            this.$currentForm = null;

            // reset schema
            _yooessentials.SourceExtended.setSchema(schema);
          }
        }
      },
      methods: {
        setCurrentForm: function setCurrentForm(_ref2) {
          var node = _ref2.node,
            _ref2$schema = _ref2.schema,
            schema = _ref2$schema === void 0 ? null : _ref2$schema;
          var id = node.formid;
          this.$currentForm = {
            id: id,
            node: node,
            schema: schema
          };
          if (schema) {
            _yooessentials.SourceExtended.setSchema(schema);
          } else {
            var controls = this.getFields(node).map(function (field) {
              var _field$props, _field$props2, _field$type;
              return {
                name: field == null ? void 0 : (_field$props = field.props) == null ? void 0 : _field$props.control_name,
                label: field == null ? void 0 : (_field$props2 = field.props) == null ? void 0 : _field$props2.control_label,
                type: field == null ? void 0 : (_field$type = field.type) == null ? void 0 : _field$type.name
              };
            });
            controls.length && _yooessentials.yooessRequest('yooessentials/form/schema', {
              controls: controls
            }).then(function (_ref3) {
              var schema = _ref3.body;
              _yooessentials.SourceExtended.setSchema(schema);
            });
          }
        },
        closestForm: function closestForm(node) {
          if (!node) {
            throw new Error('Not Valid Node');
          }
          while (node && !((_node$props2 = node.props) != null && (_node$props2$yooessen = _node$props2.yooessentials_form) != null && _node$props2$yooessen.state)) {
            var _node$props2, _node$props2$yooessen, _this$Builder;
            node = (_this$Builder = this.Builder) == null ? void 0 : _this$Builder.parent(node);
          }
          return node;
        },
        controls: function controls(node) {
          if (node === void 0) {
            node = this.$currentForm.node;
          }
          return this.getFields(node).map(function (field) {
            var _field$props3;
            return (_field$props3 = field.props) == null ? void 0 : _field$props3.control_name;
          });
        },
        getFields: function getFields(node) {
          var _this = this;
          if (node === void 0) {
            node = this.$currentForm.node;
          }
          if (!node) {
            throw new Error('Not Valid Node');
          }
          return _yooessentials.flattenChildren(this.closestForm(node) || {}).filter(function (node) {
            var _node$props3;
            return node.type.match(/yooessentials_form_/) && (node == null ? void 0 : (_node$props3 = node.props) == null ? void 0 : _node$props3.control_name);
          }).map(function (node) {
            return _extends({}, node, {
              type: _this.Builder.type(node)
            });
          }).filter(function (node) {
            return node.type.submittable;
          });
        }
      }
    };

    uikitUtil.assign(window.$fields, fields);
    Vue__default["default"].events.on('statusNode', Status);

    // init forms model and expose it globally
    window.$yooess.FormModel = new Vue__default["default"](FormModel);

})(Vue, $yooessentials, UIkit.util, UIkit, $fields);
