/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function () {
  'use strict';

  function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends.apply(this, arguments);
  }

  var formComponent = (function (_ref) {
    var _ref$util = _ref.util,
      $ = _ref$util.$,
      $$ = _ref$util.$$,
      trigger = _ref$util.trigger,
      removeAttr = _ref$util.removeAttr,
      addClass = _ref$util.addClass,
      removeClass = _ref$util.removeClass,
      empty = _ref$util.empty,
      html = _ref$util.html,
      ajax = _ref$util.ajax,
      each = _ref$util.each;
    return {
      connected: function connected() {
        this.$submit = $$('button[type="submit"]', this.$el);
        this.$errors = $('[data-yooessentials-form-errors]', this.$el);
        this.$fields = $$('[data-yooessentials-form-field]', this.$el).reduce(function (carry, el) {
          var _extends2;
          return _extends({}, carry, (_extends2 = {}, _extends2[el.dataset.yooessentialsFormField] = el, _extends2));
        }, {});

        // enable submit btn
        removeAttr(this.$submit, 'disabled');
      },
      props: {
        errors: Array,
        action: String,
        validateAction: String,
        validationErrors: Array
      },
      data: function data() {
        return {
          action: '',
          errors: [],
          submitting: false,
          validateAction: '',
          validationErrors: []
        };
      },
      events: {
        submit: function submit(e) {
          e.preventDefault();
          this.submit();
        }
      },
      methods: {
        submit: function submit() {
          var prevented = false;
          prevented = !trigger(this.$el, 'form:submit');
          prevented = prevented || !trigger(document, 'yooessentials-form:submit', [{
            form: this.$el
          }]);
          if (prevented) {
            return;
          }
          this.doSubmit();
        },
        enableSpinner: function enableSpinner() {
          each(this.$submit, function (btn) {
            var content = $('.ye-form--btn-content', btn);
            var spinner = $('.ye-form--btn-spinner', btn);
            addClass(content, 'uk-invisible');
            removeClass(spinner, 'uk-hidden');
          });
        },
        disableSpinner: function disableSpinner() {
          each(this.$submit, function (btn) {
            var content = $('.ye-form--btn-content', btn);
            var spinner = $('.ye-form--btn-spinner', btn);
            removeClass(content, 'uk-invisible');
            addClass(spinner, 'uk-hidden');
          });
        },
        doSubmit: function doSubmit(data) {
          var _this = this;
          if (data === void 0) {
            data = {};
          }
          this.submitting = true;

          // set spinner with delay
          setTimeout(function () {
            if (_this.submitting === true) {
              _this.enableSpinner();
            }
          }, 200);
          var $data = new FormData(this.$el);
          for (var key in data) {
            $data.append(key, data[key]);
          }
          ajax(this.validateAction || this.action, {
            method: 'POST',
            data: $data,
            responseType: 'json',
            headers: {
              'X-Requested-With': 'XMLHttpRequest'
            }
          }).then(function (_ref2) {
            var response = _ref2.response;
            if (!response.success) {
              _this.processErrors({
                response: response
              });
              return;
            }
            trigger(_this.$el, 'form:submitted', [{
              response: response
            }]);
            trigger(document, 'yooessentials-form:submitted', [{
              form: _this.$el,
              response: response
            }]);
            if (_this.validateAction) {
              _this.$el.submit();
            }
            _this.resetForm();
          })["catch"](function (error) {
            var _error$xhr, _error$xhr2, _error$xhr3;
            var status = (error == null ? void 0 : (_error$xhr = error.xhr) == null ? void 0 : _error$xhr.status) || 500;
            var statusText = (error == null ? void 0 : (_error$xhr2 = error.xhr) == null ? void 0 : _error$xhr2.statusText) || 'Internal Server Error';
            if (status === 301 || status === 404) {
              statusText = 'Submission endpoint not found.';
            }
            _this.processErrors({
              status: status,
              statusText: statusText,
              response: error == null ? void 0 : (_error$xhr3 = error.xhr) == null ? void 0 : _error$xhr3.response
            });
          });
        },
        processErrors: function processErrors(_ref3) {
          var _response$validation, _response$errors;
          var response = _ref3.response,
            statusText = _ref3.statusText;
          this.submitting = false;
          this.disableSpinner();
          this.resetErrorsDisplay();
          this.resetValidationErrorsDisplay();
          var validation = this.validationErrors = (_response$validation = response == null ? void 0 : response.validation) != null ? _response$validation : [];
          var errors = this.errors = (_response$errors = response == null ? void 0 : response.errors) != null ? _response$errors : ['Submission failed, please try again or contact us about this issue.', statusText];
          this.displayValidationErrors();
          this.displayErrors();
          var payload = {
            errors: errors,
            validation: validation
          };
          trigger(this.$el, 'form:submission-error', [payload]);
          trigger(document, 'yooessentials-form:submission-error', [_extends({
            form: this.$el
          }, payload)]);
        },
        displayErrors: function displayErrors() {
          this.resetErrorsDisplay();
          if (!this.errors.length) {
            return;
          }
          var list = this.errors.map(function (e) {
            return "<li>" + e + "</li>";
          }).join('');
          html(this.$errors, "<div class=\"uk-alert-warning uk-margin-top\" uk-alert>\n                <a class=\"uk-alert-close\" uk-close></a>\n                <ul class=\"uk-list\">" + list + "</ul>\n            </div>");
        },
        displayValidationErrors: function displayValidationErrors() {
          this.resetValidationErrorsDisplay();
          var errors = this.validationErrors;
          for (var name in errors) {
            var field = this.$fields[name];
            var fieldErrors = errors[name];
            if (!field) {
              this.errors.push(errors[name]);
              return;
            }
            var $controls = $$('[name]', field);
            var $errors = $$('[data-yooessentials-form-field-errors]', field);
            addClass($controls, 'uk-form-danger');
            html($errors, '<ul class="uk-list">' + fieldErrors.map(function (e) {
              return "<li>" + e + "</li>";
            }) + '</ul>');
          }
        },
        resetForm: function resetForm() {
          this.errors = [];
          this.validationErrors = [];
          this.submitting = false;
          this.$el.reset();
          this.disableSpinner();
          this.resetErrorsDisplay();
          this.resetValidationErrorsDisplay();
        },
        resetErrorsDisplay: function resetErrorsDisplay() {
          empty(this.$errors);
        },
        resetValidationErrorsDisplay: function resetValidationErrorsDisplay() {
          for (var name in this.$fields) {
            var field = this.$fields[name];
            var $controls = $$('[name]', field);
            var $errors = $$('[data-yooessentials-form-field-errors]', field);
            removeClass($controls, 'uk-form-danger');
            empty($errors);
          }
        }
      }
    };
  });

  var downloadAction = (function (_ref) {
    var on = _ref.util.on;
    on(document, 'yooessentials-form:submitted', function (e, _ref2) {
      _ref2.form;
        var response = _ref2.response;
      if (response != null && response.download) {
        window.location = response.download;
      }
    });
  });

  var messageAction = (function (_ref) {
    var on = _ref.util.on,
      modal = _ref.modal;
    on(document, 'yooessentials-form:submitted', function (e, _ref2) {
      var form = _ref2.form,
        response = _ref2.response;
      if (response != null && response.message) {
        try {
          var alert = modal.alert(response.message);
          on(alert.$el, 'hidden', function () {
            form.reset();
          });
        } catch (_unused) {}
      }
    });
  });

  var redirectAction = (function (_ref) {
    var on = _ref.util.on;
    on(document, 'yooessentials-form:submitted', function (e, _ref2) {
      var response = _ref2.response;
      var redirect = (response == null ? void 0 : response.redirect) || {};
      if (redirect.to) {
        var timeout = redirect.timeout || 0;
        setTimeout(function () {
          window.open(redirect.to, redirect.blank ? '_blank' : '_self');
        }, timeout * 1000);
      }
    });
  });

  onDomReady(function () {
    var _UIkit$version;
    var UIkit = window.UIkit;
    if (!UIkit || !(UIkit != null && (_UIkit$version = UIkit.version) != null && _UIkit$version.match(/^3\./))) {
      throw new Error('YOOessentials Form Init Error: UIkit v3.x is required.');
    }
    UIkit.component('yooessentials-form', formComponent(UIkit));
    downloadAction(UIkit);
    messageAction(UIkit);
    redirectAction(UIkit);
  });
  function onDomReady(fn) {
    if (window.document.readyState !== 'loading') {
      fn();
      return;
    }
    window.document.addEventListener('DOMContentLoaded', function () {
      fn();
    }, {
      once: true
    });
  }

})();
