<?php
/**
 * @package   Essentials YOOtheme Pro 1.9.2 build 0113.0249
 * @author    ZOOlanders https://www.zoolanders.com
 * @copyright Copyright (C) Joolanders, SL
 * @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 */

use function YOOtheme\App;
use YOOtheme\Metadata;

/** @var Metadata $metadata */
$metadata = app(Metadata::class);

$id = 'h-captcha' . str_replace(['#', '-'], '', $node->id);
$callback = 'yooessentialsHcaptchaOnload';

$metadata->set('script:yooessentials-hcaptcha-callback', ['src' => '~yooessentials_url/modules/form/elements/form_hcaptcha/assets/hcaptcha.js', 'defer' => true]);
$metadata->set('script:yooessentials-hcaptcha', ['src' => "https://js.hcaptcha.com/1/api.js?onload={$callback}&render=explicit&recaptchacompat=off", 'async' => true, 'defer' => true]);

$type = $node->control->props['type'];
$siteKey = $node->control->siteKey;
$size = $node->control->props['size'];
$theme = $node->control->props['theme'];
$compliance = $node->control->props['compliance'] ?? '';

if ($type === 'invisible') {
    $size = 'invisible';
}

$params = compact('id', 'callback', 'theme', 'size', 'siteKey');

$el = $this->el('div');

$control = $this['form']->controlFieldset(
    $node->control->name,
    $node->control->props['label'] ?? '',
    true
);

?>

<?= $el($props, $attrs) ?>
<?= $control() ?>

    <?php if ($type === 'invisible') : ?>
        <?= $compliance ?: 'This site is protected by hCaptcha and its <a href="https://hcaptcha.com/privacy">Privacy Policy</a> and <a href="https://hcaptcha.com/terms">Terms of Service</a> apply.' ?>
    <?php endif; ?>

    <div id="<?= $id ?>" class="h-captcha" data-theme="<?= $theme ?>" data-size="<?= $size ?>" data-sitekey="<?= $siteKey ?>"></div>

<?= $control->end() ?>
<?= $el->end() ?>

