<?php
/**
 * @package   Essentials YOOtheme Pro 1.9.2 build 0113.0249
 * @author    ZOOlanders https://www.zoolanders.com
 * @copyright Copyright (C) Joolanders, SL
 * @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 */

use function YOOtheme\App;
use YOOtheme\Metadata;

/** @var Metadata $metadata */
$metadata = app(Metadata::class);

$id = 'reCAPTCHA' . str_replace(['#', '-'], '', $node->id);
$action = $node->control->props['action'];

$metadata->set('script:yooessentials-recaptcha', ['src' => "https://www.google.com/recaptcha/api.js?render={$node->control->siteKey}", 'defer' => true]);

?>

<input type="hidden" id="<?= $id; ?>"/>

<script type="text/javascript">
(function () {

    const recaptchaEl = UIkit.util.$('#<?= $id; ?>');
    const formEl = recaptchaEl.closest('form');

    UIkit.util.on(formEl, 'form:submit', function(e) {
        e.preventDefault();

        const form = UIkit.yooessentialsForm(formEl);

        grecaptcha.ready(function() {
            grecaptcha.execute('<?= $node->control->siteKey ?>', {action: '<?= $action ?>'}).then(function(token) {
                form.doSubmit({
                    'g-recaptcha-response': token
                });
            });
        });
    });

})();
</script>
