/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function (Vue, UIkit, _yooessentials, uikitUtil) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
    var UIkit__default = /*#__PURE__*/_interopDefaultLegacy(UIkit);

    var $cache = {};
    var IconModel$1 = {
      name: 'IconModel',
      data: function data() {
        return {
          collections: _yooessentials.get(window, '$customizer.yooessentials.icon_collections', [])
        };
      },
      methods: {
        add: function add(icons) {
          UIkit__default["default"].icon.add(icons);
          return Object.keys(icons);
        },
        addCollection: function addCollection(collection) {
          var _this = this;
          return _yooessentials.yooessRequest('yooessentials/icon/collection/add', {
            collection: collection.name
          }).then(function (_ref) {
            var body = _ref.body;
            return body;
          }).then(function (response) {
            _this.collections = response.collections;
          })["catch"](function (e) {
            UIkit__default["default"].modal.alert("\n                        <div class=\"uk-text-lead\">Ups! The collection installation has failed.</div>\n                        <p>It could be the server blocking the download, in which case you could try <a href=\"" + collection["package"] + "\" target=\"_blank\">downloading</a> the collection and installing it manually following <a href=\"https://zoolanders.com/docs/essentials-for-yootheme-pro/icons/custom-collections\" target=\"_blank\">this guide</a>.</p>\n                    ");
          });
        },
        removeCollection: function removeCollection(collection) {
          var _this2 = this;
          return _yooessentials.yooessRequest('yooessentials/icon/collection/remove', {
            collection: collection.name
          }).then(function (_ref2) {
            var body = _ref2.body;
            return body;
          }).then(function (response) {
            _this2.collections = response.collections;
          });
        },
        fetch: function fetch(params, force) {
          var _this3 = this;
          if (params === void 0) {
            params = {};
          }
          if (force === void 0) {
            force = false;
          }
          var requestId = JSON.stringify(params);
          var cached = $cache[requestId];
          return new Promise(function (resolve, reject) {
            if (!force && cached) {
              resolve(cached);
              return;
            }
            _yooessentials.yooessRequest('yooessentials/icon/list', params).then(function (_ref3) {
              var body = _ref3.body;
              return body;
            }).then(function (response) {
              response.data = _this3.add(response.data);
              $cache[requestId] = response;
              resolve(response);
            })["catch"](function () {
              reject();
            });
          });
        }
      }
    };

    function _extends() {
      _extends = Object.assign ? Object.assign.bind() : function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //

    var script$6 = {
      props: {
        icons: {
          type: Array,
          required: true
        }
      }
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    /* script */
    var __vue_script__$6 = script$6;

    /* template */
    var __vue_render__$6 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('table', {
        staticClass: "uk-table uk-table-divider uk-table-hover uk-table-middle"
      }, [_c('thead', [_c('tr', [_c('th', {
        attrs: {
          "colspan": "2"
        }
      }, [_vm._v(_vm._s(_vm.$t('Icon')))]), _vm._v(" "), _c('th', {
        staticClass: "uk-table-shrink"
      }, [_vm._v(_vm._s(_vm.$t('Collection')))]), _vm._v(" "), _c('th', {
        staticClass: "uk-table-shrink"
      }, [_vm._v(_vm._s(_vm.$t('Group')))])])]), _vm._v(" "), _c('tbody', _vm._l(_vm.icons, function (ref) {
        var name = ref.name;
        var group = ref.group;
        var collection = ref.collection;
        var key = ref.key;
        return _c('tr', {
          key: key,
          staticClass: "uk-visible-hover",
          on: {
            "click": function click($event) {
              return _vm.$emit('resolve', key);
            }
          }
        }, [_c('td', {
          staticClass: "uk-table-shrink uk-text-center"
        }, [_c('span', {
          staticClass: "yo-finder-list-image uk-icon-image",
          attrs: {
            "uk-icon": key
          }
        })]), _vm._v(" "), _c('td', {
          staticClass: "uk-table-expand uk-text-nowrap"
        }, [_vm._v("\n                    " + _vm._s(name) + "\n                ")]), _vm._v(" "), _c('td', {
          staticClass: "uk-text-nowrap"
        }, [_vm._v("\n                    " + _vm._s(collection) + "\n                ")]), _vm._v(" "), _c('td', {
          staticClass: "uk-text-nowrap"
        }, [_vm._v("\n                    " + _vm._s(group) + "\n                ")])]);
      }), 0)])]);
    };
    var __vue_staticRenderFns__$6 = [];

    /* style */
    var __vue_inject_styles__$6 = undefined;
    /* scoped */
    var __vue_scope_id__$6 = undefined;
    /* module identifier */
    var __vue_module_identifier__$6 = undefined;
    /* functional template */
    var __vue_is_functional_template__$6 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$6 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$6,
      staticRenderFns: __vue_staticRenderFns__$6
    }, __vue_inject_styles__$6, __vue_script__$6, __vue_scope_id__$6, __vue_is_functional_template__$6, __vue_module_identifier__$6, false, undefined, undefined, undefined);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //

    var script$5 = {
      props: {
        icons: {
          type: Array,
          required: true
        }
      }
    };

    /* script */
    var __vue_script__$5 = script$5;

    /* template */
    var __vue_render__$5 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        staticClass: "uk-grid-collapse uk-child-width-auto",
        attrs: {
          "uk-grid": ""
        }
      }, _vm._l(_vm.icons, function (icon) {
        return _c('div', {
          key: icon.key
        }, [_c('div', {
          staticClass: "uk-card uk-card-small uk-card-body uk-card-hover yo-panel uk-inline",
          staticStyle: {
            "width": "80px",
            "height": "80px"
          }
        }, [_c('span', {
          attrs: {
            "icon": icon.key,
            "uk-icon": "",
            "width": "80",
            "height": "80"
          }
        }), _vm._v(" "), _c('a', {
          staticClass: "uk-position-cover",
          attrs: {
            "title": icon.key,
            "href": "",
            "uk-tooltip": "delay: 500; position: top"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('resolve', icon.key);
            }
          }
        })])]);
      }), 0);
    };
    var __vue_staticRenderFns__$5 = [];

    /* style */
    var __vue_inject_styles__$5 = undefined;
    /* scoped */
    var __vue_scope_id__$5 = undefined;
    /* module identifier */
    var __vue_module_identifier__$5 = undefined;
    /* functional template */
    var __vue_is_functional_template__$5 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$5 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$5,
      staticRenderFns: __vue_staticRenderFns__$5
    }, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //

    var script$4 = {
      filters: {
        groupname: function groupname(group) {
          return group === '__main' ? 'Main' : group;
        }
      },
      props: {
        collections: {
          type: Array,
          required: true
        },
        filter: {
          type: Object,
          "default": function _default() {
            return {
              search: '',
              collection: '',
              group: ''
            };
          }
        }
      },
      computed: {
        isFiltered: function isFiltered() {
          return this.filter.collection || this.filter.group;
        }
      },
      watch: {
        filter: {
          handler: function handler(filter) {
            var collection = this.collections.find(function (c) {
              return c.name === filter.collection;
            });
            if (collection && !collection.groups || filter.group || !filter.collection && !filter.group) {
              this.$emit('hide');
            }
          },
          deep: true
        }
      },
      methods: {
        applyFilter: function applyFilter(params) {
          // reset group is switching collection
          if (params.collection && this.filter.collection !== params.collection) {
            params.group = '';
          }
          this.$emit('update:filter', _extends({}, this.filter, params));
        },
        reset: function reset() {
          if (this.collections.length === 1) {
            this.applyFilter({
              group: ''
            });
          } else {
            this.applyFilter({
              collection: '',
              group: ''
            });
          }
        }
      }
    };

    /* script */
    var __vue_script__$4 = script$4;

    /* template */
    var __vue_render__$4 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('div', {
        staticClass: "yo-dropdown-body uk-overflow-auto uk-height-max-medium"
      }, [_c('ul', {
        staticClass: "uk-nav uk-dropdown-nav"
      }, [_vm.collections.length ? _c('li', {
        staticClass: "uk-nav-header uk-flex uk-position-relative"
      }, [_vm._v("\n                " + _vm._s(_vm.$t('Filter by')) + "\n                "), _vm.isFiltered ? _c('span', {
        staticClass: "uk-link uk-margin-small-right uk-position-center-right uk-position-medium",
        attrs: {
          "uk-icon": "close",
          "ratio": "0.7",
          "title": _vm.$t('Reset Filters'),
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.reset.apply(null, arguments);
          }
        }
      }) : _vm._e()]) : _vm._e(), _vm._v(" "), _vm._l(_vm.collections, function (ref) {
        var name = ref.name;
        var title = ref.title;
        var groups = ref.groups;
        if (groups === void 0) groups = [];
        return [_c('li', {
          key: name,
          "class": {
            'uk-active': _vm.filter.collection === name,
            'uk-parent': groups.length
          }
        }, [_vm.collections.length > 1 ? _c('a', {
          attrs: {
            "href": "#"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.applyFilter({
                collection: name
              });
            }
          }
        }, [_vm._v(_vm._s(title))]) : _c('a', {
          staticClass: "uk-disabled",
          attrs: {
            "href": "#"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
            }
          }
        }, [_vm._v(_vm._s(title))]), _vm._v(" "), groups.length && (_vm.filter.collection === name || _vm.collections.length === 1) ? _c('ul', {
          staticClass: "uk-nav-sub"
        }, _vm._l(groups, function (group) {
          return _c('li', {
            key: group,
            "class": {
              'uk-active': _vm.filter.group === group
            }
          }, [_c('a', {
            attrs: {
              "href": "#"
            },
            on: {
              "click": function click($event) {
                $event.preventDefault();
                return _vm.applyFilter({
                  group: group
                });
              }
            }
          }, [_vm._v(_vm._s(_vm._f("groupname")(group)))])]);
        }), 0) : _vm._e()])];
      })], 2)])]);
    };
    var __vue_staticRenderFns__$4 = [];

    /* style */
    var __vue_inject_styles__$4 = undefined;
    /* scoped */
    var __vue_scope_id__$4 = undefined;
    /* module identifier */
    var __vue_module_identifier__$4 = undefined;
    /* functional template */
    var __vue_is_functional_template__$4 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$4 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$4,
      staticRenderFns: __vue_staticRenderFns__$4
    }, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);

    var storageView = 'yooessentials.icons.view';
    var script$3 = {
      name: 'IconFinder',
      components: {
        List: __vue_component__$6,
        Thumbnail: __vue_component__$5,
        Finder: _yooessentials.Finder
      },
      props: {
        items: _yooessentials.Finder.props.items,
        total: _yooessentials.Finder.props.total,
        menu: {
          type: Boolean,
          "default": true
        },
        addCollection: {
          type: Boolean,
          "default": false
        },
        collections: {
          type: Array,
          "default": function _default() {
            return [];
          }
        },
        fetching: {
          type: Boolean,
          "default": false
        }
      },
      data: function data() {
        return {
          view: _yooessentials.storage[storageView] || 'thumbnail',
          filter: {
            search: '',
            collection: '',
            group: ''
          }
        };
      },
      computed: {
        icons: function icons() {
          return this.items.map(this.parse);
        }
      },
      watch: {
        view: function view(_view) {
          _yooessentials.storage[storageView] = _view;
        },
        filter: {
          handler: _yooessentials.debounce(function () {
            this.fetch(_extends({}, this.filter, {
              offset: 0
            }));
          }, 100),
          deep: true
        }
      },
      methods: {
        fetch: function fetch(params) {
          this.$emit('fetch', params);
        },
        fetchNext: function fetchNext() {
          if (this.items.length < this.total) {
            this.fetch(_extends({}, this.filter, {
              offset: this.items.length
            }));
          }
        },
        parse: function parse(key) {
          var _collections$collecti;
          var parsed = key.match(/^([^-]*)-?(.*)--(.*)$/);
          if (!parsed) {
            throw new Error("Bad Formated Icon Name: " + key);
          }
          var collections = _yooessentials.keyBy(this.collections, 'name');
          var collection = parsed[1],
            group = parsed[2],
            name = parsed[3];
          return {
            collection: ((_collections$collecti = collections[collection]) == null ? void 0 : _collections$collecti.title) || collection,
            group: group,
            name: name,
            key: key
          };
        },
        openCollectionsMenu: function openCollectionsMenu() {
          var _this = this;
          var dp = this.$dropdown({
            functional: true,
            render: function render(h) {
              return h(__vue_component__$4, {
                props: {
                  filter: _this.filter,
                  collections: _this.collections,
                  addCollection: _this.addCollection
                },
                on: {
                  hide: function hide() {
                    return dp.hide();
                  },
                  'update:filter': function updateFilter(filter) {
                    return _this.filter = filter;
                  },
                  'add:collection': function addCollection() {
                    return _this.$emit('add-collection');
                  }
                }
              });
            }
          });
          dp.show(this.$refs.menu, {
            pos: 'bottom-right',
            classes: 'yo-dropdown'
          });
        }
      }
    };

    /* script */
    var __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$3 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('Finder', {
        attrs: {
          "item-name": "Icon",
          "items": _vm.icons,
          "total": _vm.total,
          "filter": _vm.filter
        },
        on: {
          "update:filter": function updateFilter($event) {
            _vm.filter = $event;
          }
        },
        scopedSlots: _vm._u([{
          key: "count",
          fn: function fn() {
            return [_c('h2', {
              staticClass: "uk-modal-title uk-margin-remove"
            }, [_vm._v("\n            " + _vm._s(_vm.$t("%smart_count% Icon |||| %smart_count% Icons", _vm.total)) + "\n            "), _vm.collections.length > 1 ? _c('span', {
              staticClass: "uk-text-meta uk-display-block"
            }, [_vm._v(_vm._s(_vm.$t("%smart_count% Collection |||| %smart_count% Collections", _vm.collections.length)))]) : _vm._e()])];
          },
          proxy: true
        }, {
          key: "right",
          fn: function fn() {
            return [_c('ul', {
              staticClass: "uk-grid-small uk-child-width-auto",
              attrs: {
                "uk-grid": ""
              }
            }, [_c('li', {
              "class": {
                'uk-active': _vm.view === 'list'
              }
            }, [_c('a', {
              staticClass: "uk-icon-link",
              attrs: {
                "href": "",
                "title": _vm.$t('List'),
                "uk-icon": "table",
                "uk-tooltip": "delay: 500"
              },
              on: {
                "click": function click($event) {
                  $event.preventDefault();
                  _vm.view = 'list';
                }
              }
            })]), _vm._v(" "), _c('li', {
              "class": {
                'uk-active': _vm.view === 'thumbnail'
              }
            }, [_c('a', {
              staticClass: "uk-icon-link",
              attrs: {
                "href": "",
                "title": _vm.$t('Thumbnails'),
                "uk-icon": "thumbnails",
                "uk-tooltip": "delay: 500"
              },
              on: {
                "click": function click($event) {
                  $event.preventDefault();
                  _vm.view = 'thumbnail';
                }
              }
            })]), _vm._v(" "), _vm.menu ? _c('li', {
              ref: "menu"
            }, [_c('a', {
              staticClass: "uk-icon-link",
              attrs: {
                "href": "",
                "uk-icon": "more-vertical"
              },
              on: {
                "click": function click($event) {
                  $event.preventDefault();
                  return _vm.openCollectionsMenu.apply(null, arguments);
                }
              }
            })]) : _vm._e()])];
          },
          proxy: true
        }, {
          key: "items",
          fn: function fn() {
            return [_c(_vm.view, {
              tag: "component",
              attrs: {
                "icons": _vm.icons
              },
              on: {
                "resolve": function resolve($event) {
                  return _vm.$emit('resolve', $event);
                }
              }
            }), _vm._v(" "), _vm.fetching ? _c('div', {
              staticClass: "uk-flex uk-flex-center uk-padding-small"
            }, [_c('span', {
              attrs: {
                "uk-spinner": "",
                "ratio": "0.9"
              }
            })]) : _vm.total > _vm.icons.length ? _c('div', {
              staticClass: "uk-text-center"
            }, [_c('a', {
              staticClass: "uk-icon-link",
              attrs: {
                "uk-icon": "more",
                "ratio": "2",
                "title": _vm.$t('Load More'),
                "href": "",
                "uk-tooltip": "delay: 500"
              },
              on: {
                "click": function click($event) {
                  $event.preventDefault();
                  return _vm.fetchNext();
                }
              }
            })]) : _vm._e()];
          },
          proxy: true
        }])
      });
    };
    var __vue_staticRenderFns__$3 = [];

    /* style */
    var __vue_inject_styles__$3 = undefined;
    /* scoped */
    var __vue_scope_id__$3 = undefined;
    /* module identifier */
    var __vue_module_identifier__$3 = undefined;
    /* functional template */
    var __vue_is_functional_template__$3 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$3,
      staticRenderFns: __vue_staticRenderFns__$3
    }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);

    var script$2 = {
      name: 'Collections',
      components: {
        IconFinder: __vue_component__$3
      },
      data: function data() {
        return {
          icons: [],
          total: 0,
          batch: 500,
          fetching: false,
          query: {}
        };
      },
      computed: {
        installedCollections: function installedCollections() {
          return _yooessentials.IconModel.collections.filter(function (c) {
            return c.installed;
          });
        }
      },
      created: function created() {
        this.total = this.installedCollections.reduce(function (carry, _ref) {
          var _ref$icons = _ref.icons,
            icons = _ref$icons === void 0 ? 0 : _ref$icons;
          return carry + icons;
        }, 0);
        this.fetch();
      },
      methods: {
        addCollection: function addCollection() {
          var _this = this;
          return this.$modal(_yooessentials.ItemsFinderModal, {
            items: _yooessentials.IconModel.collections.filter(function (c) {
              return !c.installed && c.name !== 'myicons';
            })
          }).show().then(function (collection) {
            collection && _yooessentials.IconModel.addCollection(collection).then(function () {
              _this.fetch({}, true);
            });
          });
        },
        fetch: function fetch(params, force) {
          var _this2 = this;
          if (params === void 0) {
            params = {};
          }
          if (force === void 0) {
            force = false;
          }
          this.fetching = true;
          params = _extends({
            offset: 0,
            length: this.batch
          }, params);
          return _yooessentials.IconModel.fetch(params, force).then(function (response) {
            var total = response.total,
              data = response.data;
            if (params.offset === 0) {
              _this2.total = total;
              _this2.icons = data;
            } else {
              _this2.icons = [].concat(_this2.icons, data);
            }
            _this2.fetching = false;
          });
        }
      }
    };

    /* script */
    var __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$2 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return !_vm.installedCollections.length ? _c('div', {
        staticClass: "uk-height-medium uk-flex"
      }, [_c('div', {
        staticClass: "uk-margin-auto uk-margin-auto-vertical uk-text-center"
      }, [_c('p', {
        staticClass: "uk-text-lead uk-text-center"
      }, [_vm._v(_vm._s(_vm.$t('Start by adding your first Icon Collection')))]), _vm._v(" "), _c('button', {
        staticClass: "uk-button uk-button-primary",
        on: {
          "click": _vm.addCollection
        }
      }, [_vm._v(_vm._s(_vm.$t('Add Collection')))]), _vm._v(" "), _c('p', {
        staticClass: "uk-text-meta uk-text-center"
      }, [_vm._v(_vm._s(_vm.$t('Or manage all collections in the Essentials Section.')))])])]) : _c('IconFinder', {
        attrs: {
          "items": _vm.icons,
          "total": _vm.total,
          "fetching": _vm.fetching,
          "collections": _vm.installedCollections
        },
        on: {
          "fetch": _vm.fetch,
          "resolve": function resolve($event) {
            return _vm.$emit('select', $event);
          }
        }
      });
    };
    var __vue_staticRenderFns__$2 = [];

    /* style */
    var __vue_inject_styles__$2 = undefined;
    /* scoped */
    var __vue_scope_id__$2 = undefined;
    /* module identifier */
    var __vue_module_identifier__$2 = undefined;
    /* functional template */
    var __vue_is_functional_template__$2 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$2,
      staticRenderFns: __vue_staticRenderFns__$2
    }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

    var script$1 = {
      name: 'MyIcons',
      components: {
        IconFinder: __vue_component__$3
      },
      "extends": __vue_component__$2,
      computed: {
        collection: function collection() {
          return _yooessentials.IconModel.collections.find(function (c) {
            return c.name === 'myicons';
          }) || {};
        },
        totalGroups: function totalGroups() {
          var _this$collection$grou;
          return ((_this$collection$grou = this.collection.groups) == null ? void 0 : _this$collection$grou.length) || 0;
        }
      },
      created: function created() {
        this.total = this.collection.icons || 0;
        this.fetch();
      },
      methods: {
        fetch: function fetch(params, force) {
          if (params === void 0) {
            params = {};
          }
          if (force === void 0) {
            force = false;
          }
          __vue_component__$2.methods.fetch.call(this, _extends({}, params, {
            collection: 'myicons'
          }), force);
        }
      }
    };

    /* script */
    var __vue_script__$1 = script$1;

    /* template */
    var __vue_render__$1 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return !_vm.fetching && !_vm.query.search && !_vm.query.group && _vm.total === 0 ? _c('div', {
        staticClass: "uk-height-medium uk-flex"
      }, [_c('div', {
        staticClass: "uk-margin-auto uk-margin-auto-vertical uk-text-center"
      }, [_c('p', {
        staticClass: "uk-text-lead uk-text-center"
      }, [_vm._v(_vm._s(_vm.$t('MyIcons is your Icon Collection')))]), _vm._v(" "), _c('p', {
        staticClass: "uk-text-muted uk-text-center"
      }, [_vm._v(_vm._s(_vm.$t('Start by placing icons into the "child_theme/myicons" folder.')))])])]) : _c('IconFinder', {
        attrs: {
          "menu": Boolean(_vm.totalGroups > 1),
          "items": _vm.icons,
          "total": _vm.total,
          "fetching": _vm.fetching,
          "collections": [_vm.collection]
        },
        on: {
          "fetch": _vm.fetch,
          "resolve": function resolve($event) {
            return _vm.$emit('select', $event);
          }
        }
      });
    };
    var __vue_staticRenderFns__$1 = [];

    /* style */
    var __vue_inject_styles__$1 = undefined;
    /* scoped */
    var __vue_scope_id__$1 = undefined;
    /* module identifier */
    var __vue_module_identifier__$1 = undefined;
    /* functional template */
    var __vue_is_functional_template__$1 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$1,
      staticRenderFns: __vue_staticRenderFns__$1
    }, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

    //
    var script = {
      name: 'CollectionsSection',
      components: {
        ResourceListItem: _yooessentials.ResourceListItem
      },
      inject: {
        Sidebar: {}
      },
      props: {
        panel: Object
      },
      computed: {
        collections: function collections() {
          return _yooessentials.IconModel.collections.filter(function (collection) {
            return collection.installed && collection.name !== 'myicons';
          }).map(function (collection) {
            return {
              collection: collection,
              title: collection == null ? void 0 : collection.title,
              meta: "v" + (collection == null ? void 0 : collection.installed),
              icon: collection == null ? void 0 : collection.icon,
              actions: ['delete']
            };
          });
        }
      },
      methods: {
        isEmpty: uikitUtil.isEmpty,
        remove: function remove(collection) {
          _yooessentials.IconModel.removeCollection(collection);
        },
        add: function add() {
          return this.$modal(_yooessentials.ResourcePicker, {
            items: _yooessentials.IconModel.collections.filter(function (c) {
              return !c.installed && c.name !== 'myicons';
            })
          }).show({
            container: true
          }).then(function (collection) {
            collection && _yooessentials.IconModel.addCollection(collection);
          });
        },
        isUpToDate: function isUpToDate(collection) {
          return _yooessentials.semverCompare(collection.installed, collection.version) >= 0;
        }
      }
    };

    /* script */
    var __vue_script__ = script;

    /* template */
    var __vue_render__ = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        staticClass: "uk-margin-remove-first-child"
      }, [!_vm.isEmpty(_vm.collections) ? _c('ul', {
        staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-iconnav uk-margin uk-margin-remove-bottom"
      }, _vm._l(_vm.collections, function (ref) {
        var collection = ref.collection;
        var title = ref.title;
        var icon = ref.icon;
        var meta = ref.meta;
        var actions = ref.actions;
        return _c('ResourceListItem', {
          key: collection.id,
          attrs: {
            "title": title,
            "icon": icon,
            "meta": meta,
            "actions": actions
          },
          on: {
            "delete": function _delete($event) {
              return _vm.remove(collection);
            }
          }
        });
      }), 1) : _vm._e(), _vm._v(" "), _c('button', {
        staticClass: "uk-button uk-button-default uk-width-1-1 uk-margin-medium-top",
        attrs: {
          "type": "button"
        },
        on: {
          "click": _vm.add
        }
      }, [_vm._v("\n        " + _vm._s(_vm.$t('Add Collection')) + "\n    ")]), _vm._v(" "), _c('p', {
        staticClass: "uk-text-muted"
      }, [_vm._v(_vm._s(_vm.$t('Add Icon Collections for the Builder Icon Picker.')))])]);
    };
    var __vue_staticRenderFns__ = [];

    /* style */
    var __vue_inject_styles__ = undefined;
    /* scoped */
    var __vue_scope_id__ = undefined;
    /* module identifier */
    var __vue_module_identifier__ = undefined;
    /* functional template */
    var __vue_is_functional_template__ = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__ = /*#__PURE__*/normalizeComponent({
      render: __vue_render__,
      staticRenderFns: __vue_staticRenderFns__
    }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

    var IconModel = new Vue__default["default"](IconModel$1);

    // expose globally
    window.$yooess.IconModel = IconModel;
    Vue__default["default"].component('yooessentials-icon-collections', __vue_component__);
    Vue__default["default"].events.on('iconsModalTabs', function (_ref) {
      var _window, _window$$customizer, _window2, _window2$wp, _window2$wp$customize, _window2$wp$customize2, _window2$wp$customize3, _window3, _window3$$customizer, _window3$$customizer$;
      var _ref$result = _ref.result,
        result = _ref$result === void 0 ? [] : _ref$result;
      var isChildTheme = ((_window = window) == null ? void 0 : (_window$$customizer = _window.$customizer) == null ? void 0 : _window$$customizer.yooessentials) && ((_window2 = window) == null ? void 0 : (_window2$wp = _window2.wp) == null ? void 0 : (_window2$wp$customize = _window2$wp.customize) == null ? void 0 : (_window2$wp$customize2 = _window2$wp$customize.settings) == null ? void 0 : (_window2$wp$customize3 = _window2$wp$customize2.theme) == null ? void 0 : _window2$wp$customize3.stylesheet) !== 'yootheme' || ( // wordpress
      (_window3 = window) == null ? void 0 : (_window3$$customizer = _window3.$customizer) == null ? void 0 : (_window3$$customizer$ = _window3$$customizer.config) == null ? void 0 : _window3$$customizer$.child_theme); // joomla

      isChildTheme && result.push({
        name: 'My Icons',
        component: __vue_component__$1
      });
      result.push({
        name: 'Collections',
        component: __vue_component__$2
      });
      return result;
    });

})(Vue, UIkit, $yooessentials, UIkit.util);
