/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function (Vue, uikitUtil, _yooessentials, $fields) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
    var $fields__default = /*#__PURE__*/_interopDefaultLegacy($fields);

    //
    var script$3 = {
      name: 'StorageModal',
      components: {
        ModalForm: _yooessentials.ModalForm,
        ResourcePicker: _yooessentials.ResourcePicker
      },
      props: {
        adapters: {
          type: Object,
          required: true
        },
        values: {
          type: Object,
          required: true
        }
      },
      computed: {
        adapter: function adapter() {
          var _this$adapters;
          return (_this$adapters = this.adapters) == null ? void 0 : _this$adapters[this.values.adapter];
        }
      },
      watch: {
        'values.adapter': function valuesAdapter() {
          var _this = this;
          this.$nextTick(function () {
            var focus = uikitUtil.$('[autofocus]', _this.$el);
            focus && focus.focus();
          });
        }
      },
      methods: {
        isEmpty: uikitUtil.isEmpty,
        save: function save(values) {
          this.$emit('resolve', values);
        },
        setAdapter: function setAdapter(adapter) {
          this.$set(this.values, 'adapter', adapter);
        }
      }
    };

    function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
        if (typeof shadowMode !== 'boolean') {
            createInjectorSSR = createInjector;
            createInjector = shadowMode;
            shadowMode = false;
        }
        // Vue.extend constructor export interop.
        const options = typeof script === 'function' ? script.options : script;
        // render functions
        if (template && template.render) {
            options.render = template.render;
            options.staticRenderFns = template.staticRenderFns;
            options._compiled = true;
            // functional template
            if (isFunctionalTemplate) {
                options.functional = true;
            }
        }
        // scopedId
        if (scopeId) {
            options._scopeId = scopeId;
        }
        let hook;
        if (moduleIdentifier) {
            // server build
            hook = function (context) {
                // 2.3 injection
                context =
                    context || // cached call
                        (this.$vnode && this.$vnode.ssrContext) || // stateful
                        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
                // 2.2 with runInNewContext: true
                if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                    context = __VUE_SSR_CONTEXT__;
                }
                // inject component styles
                if (style) {
                    style.call(this, createInjectorSSR(context));
                }
                // register component module identifier for async chunk inference
                if (context && context._registeredComponents) {
                    context._registeredComponents.add(moduleIdentifier);
                }
            };
            // used by ssr in case component is cached and beforeCreate
            // never gets called
            options._ssrRegister = hook;
        }
        else if (style) {
            hook = shadowMode
                ? function (context) {
                    style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
                }
                : function (context) {
                    style.call(this, createInjector(context));
                };
        }
        if (hook) {
            if (options.functional) {
                // register for functional component in vue file
                const originalRender = options.render;
                options.render = function renderWithStyleInjection(h, context) {
                    hook.call(context);
                    return originalRender(h, context);
                };
            }
            else {
                // inject component registration as beforeCreate hook
                const existing = options.beforeCreate;
                options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
            }
        }
        return script;
    }

    /* script */
    var __vue_script__$3 = script$3;

    /* template */
    var __vue_render__$3 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _vm.isEmpty(_vm.adapters) ? _c('div', {
        staticClass: "uk-modal-body uk-text-danger"
      }, [_vm._v("\n    No Storage Adapters Found\n")]) : _vm.values.adapter ? _c('ModalForm', {
        attrs: {
          "values": _vm.values,
          "panel": _vm.adapter
        },
        on: {
          "resolve": _vm.save
        }
      }) : _c('ResourcePicker', {
        attrs: {
          "items": Object.values(_vm.adapters)
        },
        on: {
          "resolve": function resolve(ref) {
            var name = ref.name;
            return _vm.setAdapter(name);
          }
        }
      });
    };
    var __vue_staticRenderFns__$3 = [];

    /* style */
    var __vue_inject_styles__$3 = undefined;
    /* scoped */
    var __vue_scope_id__$3 = undefined;
    /* module identifier */
    var __vue_module_identifier__$3 = undefined;
    /* functional template */
    var __vue_is_functional_template__$3 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$3,
      staticRenderFns: __vue_staticRenderFns__$3
    }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);

    function _extends() {
      _extends = Object.assign ? Object.assign.bind() : function (target) {
        for (var i = 1; i < arguments.length; i++) {
          var source = arguments[i];
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
        return target;
      };
      return _extends.apply(this, arguments);
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key, i;
      for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
      }
      return target;
    }

    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //
    //

    var script$2 = {
      name: 'StorageDropdown',
      filters: {
        date: function date(timestamp) {
          return new Date(timestamp).toLocaleString().split(',')[0];
        }
      },
      props: {
        storages: {
          type: Array,
          required: true
        },
        adapters: {
          type: Object,
          "default": function _default() {
            return {};
          }
        }
      },
      computed: {
        $storages: function $storages() {
          var _this = this;
          return this.storages.map(function (storage) {
            var _this$adapters;
            var adapter = _extends({
              services: []
            }, (_this$adapters = _this.adapters) == null ? void 0 : _this$adapters[storage.adapter]);
            return {
              storage: storage,
              adapter: adapter
            };
          });
        }
      }
    };

    /* script */
    var __vue_script__$2 = script$2;

    /* template */
    var __vue_render__$2 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_c('div', {
        staticClass: "yo-dropdown-body uk-overflow-auto uk-height-max-large"
      }, [_c('ul', {
        staticClass: "uk-nav uk-dropdown-nav"
      }, [_vm._l(_vm.$storages, function (ref) {
        var storage = ref.storage;
        var adapter = ref.adapter;
        return _c('li', {
          key: storage.id,
          staticClass: "uk-visible-toggle uk-text-truncate uk-position-relative"
        }, [_c('a', {
          attrs: {
            "href": ""
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('resolve', storage);
            }
          }
        }, [adapter.icon ? _c('img', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "alt": adapter.title,
            "src": adapter.icon,
            "uk-svg": "",
            "width": "20",
            "height": "20"
          }
        }) : _c('span', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "uk-icon": "lock"
          }
        }), _vm._v(" "), _c('span', {
          staticClass: "uk-text-emphasis uk-text-middle"
        }, [_vm._v(_vm._s(storage.name || adapter.name))]), _vm._v(" "), _c('span', {
          staticClass: "uk-text-middle uk-text-meta"
        }, [_vm._v(_vm._s(adapter.title) + " "), storage.timestamp ? _c('span', [_vm._v(_vm._s(_vm.$t('created on')) + " " + _vm._s(_vm._f("date")(storage.timestamp)))]) : _vm._e()])]), _vm._v(" "), _c('div', {
          staticClass: "uk-invisible-hover uk-position-center-right uk-position-medium uk-margin-small-right"
        }, [_c('ul', {
          staticClass: "uk-iconnav uk-flex-nowrap"
        }, [_c('li', [_c('a', {
          staticClass: "uk-icon-link uk-preserve-width",
          attrs: {
            "title": _vm.$t('Edit'),
            "uk-icon": "pencil",
            "uk-tooltip": "delay: 500"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('edit', storage);
            }
          }
        })]), _vm._v(" "), _c('li', [_c('a', {
          staticClass: "uk-icon-link uk-preserve-width",
          attrs: {
            "title": _vm.$t('Delete'),
            "uk-icon": "trash",
            "uk-tooltip": "delay: 500"
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('remove', storage);
            }
          }
        })])])])]);
      }), _vm._v(" "), _vm.storages.length ? _c('li', {
        staticClass: "uk-nav-divider"
      }) : _vm._e(), _vm._v(" "), _vm._l(_vm.adapters, function (adapter) {
        return [adapter ? _c('li', {
          key: adapter.name
        }, [_c('a', {
          attrs: {
            "href": ""
          },
          on: {
            "click": function click($event) {
              $event.preventDefault();
              return _vm.$emit('add', adapter.name);
            }
          }
        }, [_c('span', {
          staticClass: "uk-margin-small-right",
          attrs: {
            "uk-icon": "plus-circle"
          }
        }), _vm._v("\n                        " + _vm._s(adapter.title) + "\n                        "), _c('span', {
          staticClass: "uk-text-meta"
        }, [_vm._v(_vm._s(adapter.description))])])]) : _vm._e()];
      })], 2)])]);
    };
    var __vue_staticRenderFns__$2 = [];

    /* style */
    var __vue_inject_styles__$2 = undefined;
    /* scoped */
    var __vue_scope_id__$2 = undefined;
    /* module identifier */
    var __vue_module_identifier__$2 = undefined;
    /* functional template */
    var __vue_is_functional_template__$2 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$2,
      staticRenderFns: __vue_staticRenderFns__$2
    }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

    var _excluded = ["id"];
    var script$1 = {
      name: 'StoragesSection',
      components: {
        ResourceListItem: _yooessentials.ResourceListItem
      },
      props: {
        panel: Object
      },
      computed: {
        storages: function storages() {
          var _this = this;
          return _yooessentials.StorageModel.storages.map(function (storage) {
            var adapter = _yooessentials.StorageModel.adapters[storage == null ? void 0 : storage.adapter];
            var title = storage.name || (adapter == null ? void 0 : adapter.title) || storage.adapter || _this.$t('Unknown');
            var error = !adapter ? _this.$t('Invalid Adapter') : '';
            return {
              storage: storage,
              error: error,
              title: title,
              meta: !error ? adapter.title : '',
              icon: adapter == null ? void 0 : adapter.icon,
              actions: error ? ['delete'] : ['copy', 'delete']
            };
          });
        }
      },
      methods: {
        isEmpty: uikitUtil.isEmpty,
        add: function add() {
          var _this2 = this;
          this.$modal(_yooessentials.ResourcePicker, {
            items: Object.values(_yooessentials.StorageModel.adapters)
          }).show({
            container: true
          }).then(function (adapter) {
            if (adapter) {
              _this2.edit(Vue__default["default"].observable({
                adapter: adapter.name
              }));
            }
          });
        },
        edit: function edit(values) {
          var panel = _yooessentials.StorageModel.adapters[values.adapter];
          this.$modal(_yooessentials.ModalForm, {
            values: values,
            panel: panel
          }).show().then(function (values) {
            values && _yooessentials.StorageModel.save(values);
          });
        },
        remove: function remove(storage) {
          _yooessentials.StorageModel.remove(storage);
        },
        copy: function copy(_ref) {
          _ref.id;
            var storage = _objectWithoutPropertiesLoose(_ref, _excluded);
          storage.name = storage.name ? storage.name + " Copy" : '';
          _yooessentials.StorageModel.save(_yooessentials.deepCopy(storage));
        }
      }
    };

    /* script */
    var __vue_script__$1 = script$1;

    /* template */
    var __vue_render__$1 = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', {
        staticClass: "uk-margin-remove-first-child"
      }, [!_vm.isEmpty(_vm.storages) ? _c('ul', {
        staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-iconnav uk-margin uk-margin-remove-bottom"
      }, _vm._l(_vm.storages, function (ref) {
        var storage = ref.storage;
        var title = ref.title;
        var icon = ref.icon;
        var meta = ref.meta;
        var error = ref.error;
        var actions = ref.actions;
        return _c('ResourceListItem', {
          key: storage.id,
          attrs: {
            "title": title,
            "icon": icon,
            "meta": meta,
            "actions": actions,
            "error": error,
            "disabled": Boolean(error)
          },
          on: {
            "edit": function edit($event) {
              return _vm.edit(storage);
            },
            "copy": function copy($event) {
              return _vm.copy(storage);
            },
            "delete": function _delete($event) {
              return _vm.remove(storage);
            }
          },
          scopedSlots: _vm._u([error ? {
            key: "icon",
            fn: function fn() {
              return [_c('span', {
                attrs: {
                  "uk-icon": "question",
                  "ratio": "1.2"
                }
              })];
            },
            proxy: true
          } : null], null, true)
        });
      }), 1) : _vm._e(), _vm._v(" "), _c('button', {
        staticClass: "uk-button uk-button-default uk-width-1-1",
        "class": {
          'uk-margin-medium-top': !_vm.isEmpty(_vm.storages)
        },
        attrs: {
          "type": "button"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.add();
          }
        }
      }, [_vm._v(_vm._s(_vm.$t('New Storage')))]), _vm._v(" "), _c('p', {
        staticClass: "uk-text-muted"
      }, [_vm._v(_vm._s(_vm.$t('Create virtual storages from local and external locations, used by Shared Locations and others.')))])]);
    };
    var __vue_staticRenderFns__$1 = [];

    /* style */
    var __vue_inject_styles__$1 = undefined;
    /* scoped */
    var __vue_scope_id__$1 = undefined;
    /* module identifier */
    var __vue_module_identifier__$1 = undefined;
    /* functional template */
    var __vue_is_functional_template__$1 = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
      render: __vue_render__$1,
      staticRenderFns: __vue_staticRenderFns__$1
    }, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

    //
    var script = {
      name: 'ConnectedStorage',
      filters: {
        date: function date(timestamp) {
          var date = new Date(timestamp).toLocaleString();
          return date.split(',')[0];
        }
      },
      "extends": $fields__default["default"].FieldText,
      computed: {
        selectedStorage: function selectedStorage() {
          var _this = this;
          return _yooessentials.StorageModel.storages.find(function (storage) {
            return storage.id === _this.value;
          });
        },
        empty: function empty() {
          return this.adapters.length === 1 && uikitUtil.isEmpty(this.storages);
        },
        adapter: function adapter() {
          var _StorageModel$adapter, _this$selectedStorage;
          return (_StorageModel$adapter = _yooessentials.StorageModel.adapters) == null ? void 0 : _StorageModel$adapter[(_this$selectedStorage = this.selectedStorage) == null ? void 0 : _this$selectedStorage.adapter];
        },
        adapters: function adapters() {
          return Object.values(_yooessentials.StorageModel.adapters).map(function (adapter) {
            return adapter == null ? void 0 : adapter.name;
          });
        },
        storages: function storages() {
          var _this2 = this;
          return _yooessentials.StorageModel.storages.filter(function (storage) {
            return uikitUtil.includes(_this2.adapters, storage.adapter);
          });
        }
      },
      created: function created() {
        if (!this.selectedStorage) {
          this.value = '';
        }
      },
      methods: {
        isEmpty: uikitUtil.isEmpty,
        add: function add(adapter) {
          var _this3 = this;
          adapter = adapter || this.adapters[0];
          return this.edit({
            adapter: adapter
          }).then(function (storage) {
            if (storage) {
              _this3.value = storage.id;
            }
          });
        },
        edit: function edit(storage) {
          var _this4 = this;
          if (storage === void 0) {
            storage = this.selectedStorage;
          }
          var adapters = _yooessentials.StorageModel.adapters;
          return this.$modal(__vue_component__$3, {
            adapters: adapters,
            values: storage
          }).show().then(function (storage) {
            if (storage) {
              storage = _yooessentials.StorageModel.save(storage);
            }
            _this4.$forceUpdate();
            return storage;
          });
        },
        select: function select() {
          var _this5 = this;
          var drop = this.$dropdown({
            functional: true,
            render: function render(h) {
              return h(__vue_component__$2, {
                props: {
                  storages: _this5.storages,
                  adapters: _yooessentials.StorageModel.adapters
                },
                on: {
                  add: function add(adapter) {
                    drop.hide();
                    _this5.add(adapter).then(function () {
                      drop.$forceUpdate();
                    });
                  },
                  edit: function edit(storage) {
                    drop.hide();
                    _this5.edit(storage).then(function () {
                      drop.$forceUpdate();
                    });
                  },
                  remove: function remove(storage) {
                    _yooessentials.StorageModel.remove(storage);
                    drop.$forceUpdate();
                    if (storage.id === _this5.value) {
                      _this5.value = '';
                    }
                    if (uikitUtil.isEmpty(_this5.storages)) {
                      drop.hide();
                    }
                  },
                  resolve: function resolve(storage) {
                    drop.hide();
                    _this5.value = storage.id;
                    drop.$forceUpdate();
                  }
                }
              });
            }
          });
          drop.show(this.$el, {
            classes: 'yo-dropdown'
          });
        }
      }
    };

    /* script */
    var __vue_script__ = script;

    /* template */
    var __vue_render__ = function __vue_render__() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return !_vm.adapters.length ? _c('div', [_vm._v("\n    No valid adapters.\n")]) : _c('div', {
        staticClass: "uk-inline uk-width-1-1"
      }, [_c('div', {
        staticClass: "uk-position-center-right uk-position-small"
      }, [_c('ul', {
        staticClass: "uk-iconnav uk-flex-nowrap"
      }, [_vm.value ? _c('li', [_c('a', {
        staticClass: "uk-icon-link uk-preserve-width",
        attrs: {
          "tabindex": "-1",
          "title": _vm.$t('Edit'),
          "uk-icon": "pencil",
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.edit();
          }
        }
      })]) : _vm._e(), _vm._v(" "), _c('li', [_c('a', {
        staticClass: "uk-icon-link uk-preserve-width",
        attrs: {
          "tabindex": "-1",
          "title": _vm.$t('Pick'),
          "uk-icon": "album",
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            _vm.empty ? _vm.add() : _vm.select();
          }
        }
      })])])]), _vm._v(" "), _c('span', {
        staticClass: "uk-input uk-disabled",
        "class": [_vm.attributes["class"]],
        attrs: {
          "title": _vm.attributes.title
        }
      }, [_vm.selectedStorage && _vm.adapter ? [_vm.adapter.icon ? _c('img', {
        attrs: {
          "alt": _vm.adapter.title,
          "src": _vm.adapter.icon,
          "uk-svg": "",
          "width": "20",
          "height": "20"
        }
      }) : _c('span', {
        attrs: {
          "uk-icon": "lock"
        }
      }), _vm._v(" "), _c('span', {
        staticClass: "uk-text-emphasis uk-margin-small-left uk-text-baseline"
      }, [_vm._v(_vm._s(_vm.selectedStorage.name || _vm.adapter.name))]), _vm._v(" "), _c('span', {
        staticClass: "uk-text-meta uk-margin-small-left uk-text-baseline"
      }, [_vm._v(_vm._s(_vm.adapter.title))])] : _vm._e()], 2)]);
    };
    var __vue_staticRenderFns__ = [];

    /* style */
    var __vue_inject_styles__ = undefined;
    /* scoped */
    var __vue_scope_id__ = undefined;
    /* module identifier */
    var __vue_module_identifier__ = undefined;
    /* functional template */
    var __vue_is_functional_template__ = false;
    /* style inject */

    /* style inject SSR */

    /* style inject shadow dom */

    var __vue_component__ = /*#__PURE__*/normalizeComponent({
      render: __vue_render__,
      staticRenderFns: __vue_staticRenderFns__
    }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

    var fields = /*#__PURE__*/Object.freeze({
        __proto__: null,
        FieldYooessentialsConnectedStorage: __vue_component__
    });

    var StorageModel$1 = {
      name: 'StorageModel',
      data: function data() {
        return {
          adapters: _yooessentials.get(window, '$customizer.yooessentials.storage_adapters', {})
        };
      },
      computed: {
        storages: {
          get: function get() {
            return _yooessentials.Config.get('storages', []);
          },
          set: function set(values) {
            _yooessentials.Config.set('storages', values);
          },
          cache: false
        }
      },
      methods: {
        save: function save(values) {
          var storages = [].concat(this.storages);
          var adapter = this.adapters[values.adapter];
          if (!adapter) {
            throw Error("Unknown Adapter: " + values.adapter);
          }
          if (values.id) {
            storages[storages.findIndex(function (_ref) {
              var id = _ref.id;
              return id === values.id;
            })] = values;
          } else {
            values = _extends({}, values, {
              id: _yooessentials.uuid(),
              _meta: {
                created_at: Date.now(),
                created_on: _yooessentials.get(window, '$customizer.yooessentials.version')
              }
            });
            storages.push(values);
          }
          this.storages = storages;
          return values;
        },
        remove: function remove(storage) {
          var storages = [].concat(this.storages);
          storages.splice(storages.indexOf(storage), 1);
          this.storages = storages;
        }
      }
    };

    uikitUtil.assign(window.$fields, fields);
    Vue__default["default"].component('yooessentials-storages', __vue_component__$1);
    var StorageModel = new Vue__default["default"](StorageModel$1);

    // expose globally
    window.$yooess.StorageModel = StorageModel;

})(Vue, UIkit.util, $yooessentials, $fields);
