<?php

/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
namespace ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets;

class GridData extends \ZOOlanders\YOOessentials\Vendor\Google\Collection
{
    protected $collection_key = 'rowMetadata';
    protected $columnMetadataType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\DimensionProperties::class;
    protected $columnMetadataDataType = 'array';
    protected $rowDataType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\RowData::class;
    protected $rowDataDataType = 'array';
    protected $rowMetadataType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\DimensionProperties::class;
    protected $rowMetadataDataType = 'array';
    /**
     * @var int
     */
    public $startColumn;
    /**
     * @var int
     */
    public $startRow;
    /**
     * @param DimensionProperties[]
     */
    public function setColumnMetadata($columnMetadata)
    {
        $this->columnMetadata = $columnMetadata;
    }
    /**
     * @return DimensionProperties[]
     */
    public function getColumnMetadata()
    {
        return $this->columnMetadata;
    }
    /**
     * @param RowData[]
     */
    public function setRowData($rowData)
    {
        $this->rowData = $rowData;
    }
    /**
     * @return RowData[]
     */
    public function getRowData()
    {
        return $this->rowData;
    }
    /**
     * @param DimensionProperties[]
     */
    public function setRowMetadata($rowMetadata)
    {
        $this->rowMetadata = $rowMetadata;
    }
    /**
     * @return DimensionProperties[]
     */
    public function getRowMetadata()
    {
        return $this->rowMetadata;
    }
    /**
     * @param int
     */
    public function setStartColumn($startColumn)
    {
        $this->startColumn = $startColumn;
    }
    /**
     * @return int
     */
    public function getStartColumn()
    {
        return $this->startColumn;
    }
    /**
     * @param int
     */
    public function setStartRow($startRow)
    {
        $this->startRow = $startRow;
    }
    /**
     * @return int
     */
    public function getStartRow()
    {
        return $this->startRow;
    }
}
// Adding a class alias for backwards compatibility with the previous class name.
\class_alias(\ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\GridData::class, 'ZOOlanders\\YOOessentials\\Vendor\\Google_Service_Sheets_GridData');
