<?php

/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
namespace ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets;

class Spreadsheet extends \ZOOlanders\YOOessentials\Vendor\Google\Collection
{
    protected $collection_key = 'sheets';
    protected $dataSourceSchedulesType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\DataSourceRefreshSchedule::class;
    protected $dataSourceSchedulesDataType = 'array';
    protected $dataSourcesType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\DataSource::class;
    protected $dataSourcesDataType = 'array';
    protected $developerMetadataType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\DeveloperMetadata::class;
    protected $developerMetadataDataType = 'array';
    protected $namedRangesType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\NamedRange::class;
    protected $namedRangesDataType = 'array';
    protected $propertiesType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\SpreadsheetProperties::class;
    protected $propertiesDataType = '';
    protected $sheetsType = \ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\Sheet::class;
    protected $sheetsDataType = 'array';
    /**
     * @var string
     */
    public $spreadsheetId;
    /**
     * @var string
     */
    public $spreadsheetUrl;
    /**
     * @param DataSourceRefreshSchedule[]
     */
    public function setDataSourceSchedules($dataSourceSchedules)
    {
        $this->dataSourceSchedules = $dataSourceSchedules;
    }
    /**
     * @return DataSourceRefreshSchedule[]
     */
    public function getDataSourceSchedules()
    {
        return $this->dataSourceSchedules;
    }
    /**
     * @param DataSource[]
     */
    public function setDataSources($dataSources)
    {
        $this->dataSources = $dataSources;
    }
    /**
     * @return DataSource[]
     */
    public function getDataSources()
    {
        return $this->dataSources;
    }
    /**
     * @param DeveloperMetadata[]
     */
    public function setDeveloperMetadata($developerMetadata)
    {
        $this->developerMetadata = $developerMetadata;
    }
    /**
     * @return DeveloperMetadata[]
     */
    public function getDeveloperMetadata()
    {
        return $this->developerMetadata;
    }
    /**
     * @param NamedRange[]
     */
    public function setNamedRanges($namedRanges)
    {
        $this->namedRanges = $namedRanges;
    }
    /**
     * @return NamedRange[]
     */
    public function getNamedRanges()
    {
        return $this->namedRanges;
    }
    /**
     * @param SpreadsheetProperties
     */
    public function setProperties(\ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\SpreadsheetProperties $properties)
    {
        $this->properties = $properties;
    }
    /**
     * @return SpreadsheetProperties
     */
    public function getProperties()
    {
        return $this->properties;
    }
    /**
     * @param Sheet[]
     */
    public function setSheets($sheets)
    {
        $this->sheets = $sheets;
    }
    /**
     * @return Sheet[]
     */
    public function getSheets()
    {
        return $this->sheets;
    }
    /**
     * @param string
     */
    public function setSpreadsheetId($spreadsheetId)
    {
        $this->spreadsheetId = $spreadsheetId;
    }
    /**
     * @return string
     */
    public function getSpreadsheetId()
    {
        return $this->spreadsheetId;
    }
    /**
     * @param string
     */
    public function setSpreadsheetUrl($spreadsheetUrl)
    {
        $this->spreadsheetUrl = $spreadsheetUrl;
    }
    /**
     * @return string
     */
    public function getSpreadsheetUrl()
    {
        return $this->spreadsheetUrl;
    }
}
// Adding a class alias for backwards compatibility with the previous class name.
\class_alias(\ZOOlanders\YOOessentials\Vendor\Google\Service\Sheets\Spreadsheet::class, 'ZOOlanders\\YOOessentials\\Vendor\\Google_Service_Sheets_Spreadsheet');
