<?php

/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
namespace ZOOlanders\YOOessentials\Vendor\Google\Service\YouTube;

class ChannelSectionSnippet extends \ZOOlanders\YOOessentials\Vendor\Google\Model
{
    /**
     * @var string
     */
    public $channelId;
    /**
     * @var string
     */
    public $defaultLanguage;
    protected $localizedType = \ZOOlanders\YOOessentials\Vendor\Google\Service\YouTube\ChannelSectionLocalization::class;
    protected $localizedDataType = '';
    /**
     * @var string
     */
    public $position;
    /**
     * @var string
     */
    public $style;
    /**
     * @var string
     */
    public $title;
    /**
     * @var string
     */
    public $type;
    /**
     * @param string
     */
    public function setChannelId($channelId)
    {
        $this->channelId = $channelId;
    }
    /**
     * @return string
     */
    public function getChannelId()
    {
        return $this->channelId;
    }
    /**
     * @param string
     */
    public function setDefaultLanguage($defaultLanguage)
    {
        $this->defaultLanguage = $defaultLanguage;
    }
    /**
     * @return string
     */
    public function getDefaultLanguage()
    {
        return $this->defaultLanguage;
    }
    /**
     * @param ChannelSectionLocalization
     */
    public function setLocalized(\ZOOlanders\YOOessentials\Vendor\Google\Service\YouTube\ChannelSectionLocalization $localized)
    {
        $this->localized = $localized;
    }
    /**
     * @return ChannelSectionLocalization
     */
    public function getLocalized()
    {
        return $this->localized;
    }
    /**
     * @param string
     */
    public function setPosition($position)
    {
        $this->position = $position;
    }
    /**
     * @return string
     */
    public function getPosition()
    {
        return $this->position;
    }
    /**
     * @param string
     */
    public function setStyle($style)
    {
        $this->style = $style;
    }
    /**
     * @return string
     */
    public function getStyle()
    {
        return $this->style;
    }
    /**
     * @param string
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }
    /**
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }
    /**
     * @param string
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
}
// Adding a class alias for backwards compatibility with the previous class name.
\class_alias(\ZOOlanders\YOOessentials\Vendor\Google\Service\YouTube\ChannelSectionSnippet::class, 'ZOOlanders\\YOOessentials\\Vendor\\Google_Service_YouTube_ChannelSectionSnippet');
