<?php

/*
 * This file is part of the league/commonmark package.
 *
 * (c) Colin O'Dell <colinodell@gmail.com>
 *
 * Original code based on the CommonMark JS reference parser (https://bitly.com/commonmark-js)
 *  - (c) John MacFarlane
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace ZOOlanders\YOOessentials\Vendor\League\CommonMark\Inline\Element;

abstract class AbstractWebResource extends \ZOOlanders\YOOessentials\Vendor\League\CommonMark\Inline\Element\AbstractInline
{
    /**
     * @var string
     */
    protected $url;
    public function __construct(string $url)
    {
        $this->url = $url;
    }
    /**
     * @return string
     */
    public function getUrl() : string
    {
        return $this->url;
    }
    /**
     * @param string $url
     *
     * @return $this
     */
    public function setUrl(string $url)
    {
        $this->url = $url;
        return $this;
    }
    public function isContainer() : bool
    {
        return \true;
    }
}
