<?php

/*
 * This file is part of Respect/Validation.
 *
 * (c) Alexandre Gomes Gaigalas <alexandre@gaigalas.net>
 *
 * For the full copyright and license information, please view the LICENSE file
 * that was distributed with this source code.
 */
declare (strict_types=1);
namespace ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions;

use ZOOlanders\YOOessentials\Vendor\Respect\Validation\Rules\CreditCard;
/**
 * @author Henrique Moody <henriquemoody@gmail.com>
 * @author Jean Pimentel <jeanfap@gmail.com>
 * @author William Espindola <oi@williamespindola.com.br>
 */
final class CreditCardException extends \ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions\ValidationException
{
    public const BRANDED = 'branded';
    /**
     * {@inheritDoc}
     */
    protected $defaultTemplates = [self::MODE_DEFAULT => [self::STANDARD => '{{name}} must be a valid Credit Card number', self::BRANDED => '{{name}} must be a valid {{brand}} Credit Card number'], self::MODE_NEGATIVE => [self::STANDARD => '{{name}} must not be a valid Credit Card number', self::BRANDED => '{{name}} must not be a valid {{brand}} Credit Card number']];
    /**
     * {@inheritDoc}
     */
    protected function chooseTemplate() : string
    {
        if ($this->getParam('brand') === \ZOOlanders\YOOessentials\Vendor\Respect\Validation\Rules\CreditCard::ANY) {
            return self::STANDARD;
        }
        return self::BRANDED;
    }
}
