<?php

/*
 * This file is part of Respect/Validation.
 *
 * (c) Alexandre Gomes Gaigalas <alexandre@gaigalas.net>
 *
 * For the full copyright and license information, please view the LICENSE file
 * that was distributed with this source code.
 */
declare (strict_types=1);
namespace ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions;

/**
 * @author Danilo Correa <danilosilva87@gmail.com>
 * @author Henrique Moody <henriquemoody@gmail.com>
 */
final class NotBlankException extends \ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions\ValidationException
{
    public const NAMED = 'named';
    /**
     * {@inheritDoc}
     */
    protected $defaultTemplates = [self::MODE_DEFAULT => [self::STANDARD => 'The value must not be blank', self::NAMED => '{{name}} must not be blank'], self::MODE_NEGATIVE => [self::STANDARD => 'The value must be blank', self::NAMED => '{{name}} must be blank']];
    /**
     * {@inheritDoc}
     */
    protected function chooseTemplate() : string
    {
        if ($this->getParam('input') || $this->getParam('name')) {
            return self::NAMED;
        }
        return self::STANDARD;
    }
}
