<?php

/*
 * This file is part of Respect/Validation.
 *
 * (c) Alexandre Gomes Gaigalas <alexandre@gaigalas.net>
 *
 * For the full copyright and license information, please view the LICENSE file
 * that was distributed with this source code.
 */
declare (strict_types=1);
namespace ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions;

use ZOOlanders\YOOessentials\Vendor\Respect\Validation\Rules\Sorted;
/**
 * @author Henrique Moody <henriquemoody@gmail.com>
 * @author Mikhail Vyrtsev <reeywhaar@gmail.com>
 */
final class SortedException extends \ZOOlanders\YOOessentials\Vendor\Respect\Validation\Exceptions\ValidationException
{
    public const ASCENDING = 'ascending';
    public const DESCENDING = 'descending';
    /**
     * {@inheritDoc}
     */
    protected $defaultTemplates = [self::MODE_DEFAULT => [self::ASCENDING => '{{name}} must be sorted in ascending order', self::DESCENDING => '{{name}} must be sorted in descending order'], self::MODE_NEGATIVE => [self::ASCENDING => '{{name}} must not be sorted in ascending order', self::DESCENDING => '{{name}} must not be sorted in descending order']];
    /**
     * {@inheritDoc}
     */
    protected function chooseTemplate() : string
    {
        return $this->getParam('direction') === \ZOOlanders\YOOessentials\Vendor\Respect\Validation\Rules\Sorted::ASCENDING ? self::ASCENDING : self::DESCENDING;
    }
}
