/* Essentials YOOtheme Pro 1.9.2 build 0113.0249; ZOOlanders https://www.zoolanders.com; Copyright (C) Joolanders, SL; http://www.gnu.org/licenses/gpl.html GNU/GPL */

(function (Vue, UIkit, uikitUtil, $fields) {
  'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var Vue__default = /*#__PURE__*/_interopDefaultLegacy(Vue);
  var UIkit__default = /*#__PURE__*/_interopDefaultLegacy(UIkit);
  var $fields__default = /*#__PURE__*/_interopDefaultLegacy($fields);

  function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];
        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }
      return target;
    };
    return _extends.apply(this, arguments);
  }
  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }
    return target;
  }
  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }
  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
    return arr2;
  }
  function _createForOfIteratorHelperLoose(o, allowArrayLike) {
    var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
    if (it) return (it = it.call(o)).next.bind(it);
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var _set$1;
  var _storage;
  function Util$1 (_ref) {
    var set = _ref.set;
    _set$1 = set;
  }

  /**
   * Simple array reindexing
   */
  function reindex(array, from, to) {
    var node = array[from];
    if (to < from && to >= 0) {
      array.splice(from, 1);
      array.splice(to, 0, node);
    } else if (to > from && to < array.length) {
      array.splice(to + 1, 0, node);
      array.splice(from, 1);
    }
  }

  /**
   * Flatten node children recursively
   */
  function flattenChildren(node) {
    return (node.children || []).reduce(function (carry, child) {
      return [].concat(carry, [child], flattenChildren(child));
    }, []);
  }

  /**
   * Resolve component mixins
   */
  function resolveMixins(component) {
    return (component.mixins || []).reduce(function (carry, child) {
      return _extends({}, carry, resolveMixins(child));
    }, _extends({}, component));
  }

  /**
   * Resolve component extends
   */
  function resolveExtends(component) {
    while ((_component = component) != null && _component["extends"]) {
      var _component, _component2;
      component = _extends({}, (_component2 = component) == null ? void 0 : _component2["extends"], component);
      delete component["extends"];
    }
    return component;
  }

  /**
   * Finds Vue closeset parent instance with a custom filter
   */
  function vueClosestParent(instance, filter) {
    do {
      var _instance;
      instance = (_instance = instance) == null ? void 0 : _instance.$parent;
    } while (instance && !filter(instance));
    return instance;
  }

  // Returns a function, that, as long as it continues to be invoked, will not
  // be triggered. The function will be called after it stops being called for
  // N milliseconds. If `immediate` is passed, trigger the function on the
  // leading edge, instead of the trailing.
  function debounce(func, wait, immediate) {
    var timeout;
    return function () {
      var context = this;
      var args = arguments;
      var later = function later() {
        timeout = null;
        if (!immediate) func.apply(context, args);
      };
      var callNow = immediate && !timeout;
      clearTimeout(timeout);
      timeout = setTimeout(later, wait);
      if (callNow) func.apply(context, args);
    };
  }

  /**
   * Get a value from object with deep path
   */
  function get$1(obj, key, def) {
    var parts = uikitUtil.isArray(key) ? key : key.split('.');
    for (var i = 0; i < parts.length; i++) {
      if (uikitUtil.isObject(obj) && !uikitUtil.isUndefined(obj[parts[i]])) {
        obj = obj[parts[i]];
      } else {
        return def;
      }
    }
    return obj;
  }

  /**
   * Set a value into an object with deep path
   */
  function set$2(obj, key, val) {
    var parts = uikitUtil.isArray(key) ? key : key.split('.');
    while (parts.length > 1) {
      var part = parts.shift();
      if (!uikitUtil.isObject(obj[part])) {
        _set$1(obj, part, {});
      }
      obj = obj[part];
    }
    _set$1(obj, parts.shift(), val);
  }

  /**
   * Key an array of objects
   */
  function keyBy(obj, key) {
    return obj.reduce(function (carry, item) {
      var _extends2;
      return _extends({}, carry, (_extends2 = {}, _extends2[get$1(item, key)] = item, _extends2));
    }, {});
  }

  /**
   * Unkey
   */
  function unkeyWith(obj, key) {
    return Object.keys(obj).map(function (k) {
      var _extends3;
      return _extends((_extends3 = {}, _extends3[key] = k, _extends3), obj[k]);
    });
  }

  /**
   * Group an array of objects
   */
  function groupBy(obj, key) {
    return obj.reduce(function (carry, item) {
      var _extends4;
      return _extends({}, carry, (_extends4 = {}, _extends4[item[key]] = [].concat(carry[item[key]] || [], [item]), _extends4));
    }, {});
  }

  /**
   * UIIG generator adapted from Math.uuid.js (v1.4)
   * http://www.broofa.com
   * Copyright (c) 2010 Robert Kieffer
   * Dual licensed under the MIT and GPL licenses.
   */
  function uuid(len) {
    if (len === void 0) {
      len = 6;
    }
    var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
    var uuid = new Array(len);
    var rnd = 0;
    var r;
    for (var i = 0; i < len; i++) {
      if (i === 8 || i === 13 || i === 18 || i === 23) {
        uuid[i] = '-';
      } else if (i === 14) {
        uuid[i] = '4';
      } else {
        if (rnd <= 0x02) rnd = 0x2000000 + Math.random() * 0x1000000 | 0;
        r = rnd & 0xf;
        rnd = rnd >> 4;
        uuid[i] = chars[i === 19 ? r & 0x3 | 0x8 : r];
      }
    }
    return uuid.join('');
  }

  /*
   * Session storage, with workaround for Safari's private
   * browsing mode and accessing sessionStorage in Blink
   */
  try {
    var key = '__test__';
    _storage = window.sessionStorage || {};
    _storage[key] = 1;
    delete _storage[key];
  } catch (e) {
    _storage = {};
  }
  var storage = _storage;

  /**
   * Semversion comparison
   * @returns -1 (a < b), 0 (a = 0), 1 (a > b)
   */
  function semverCompare(a, b) {
    if (!a || !b) {
      return 0;
    }
    var regExStrip0 = /(\.0+)+$/;
    var segmentsA = a.replace(regExStrip0, '').split('.');
    var segmentsB = b.replace(regExStrip0, '').split('.');
    var l = Math.min(segmentsA.length, segmentsB.length);
    var diff;
    for (var i = 0; i < l; i++) {
      diff = parseInt(segmentsA[i], 10) - parseInt(segmentsB[i], 10);
      if (diff) {
        return diff < 0 ? -1 : 1;
      }
    }
    return segmentsA.length - segmentsB.length;
  }

  /**
   * Deep copy of an object
   */
  function deepCopy(obj) {
    return JSON.parse(JSON.stringify(obj));
  }

  /**
   * Get unique values of array
   */
  function unique(arr) {
    return arr.filter(function (value, index, self) {
      return self.indexOf(value) === index;
    });
  }

  /**
   * Download file
   */
  function download(filename, text) {
    var url = URL.createObjectURL(new Blob([new TextEncoder().encode(text).buffer], {
      type: 'application/octet-stream'
    }));
    var element = document.createElement('a');
    element.setAttribute('href', url);
    element.setAttribute('download', filename);
    element.click();
    URL.revokeObjectURL(url);
  }
  function downloadUrl(filename, url) {
    var element = document.createElement('a');
    element.setAttribute('href', url);
    element.setAttribute('download', filename);
    element.click();
    URL.revokeObjectURL(url);
  }

  /**
   * Read files contents
   */
  function readFile(file) {
    return new Promise(function (resolve, reject) {
      var reader = new FileReader();
      reader.onload = resolve;
      reader.onerror = reject;
      reader.readAsText(file);
    });
  }

  /**
   * Make sure obj is an array
   */
  function arrify(obj) {
    return uikitUtil.isArray(obj) ? obj : [obj];
  }

  var util = /*#__PURE__*/Object.freeze({
    __proto__: null,
    'default': Util$1,
    reindex: reindex,
    flattenChildren: flattenChildren,
    resolveMixins: resolveMixins,
    resolveExtends: resolveExtends,
    vueClosestParent: vueClosestParent,
    debounce: debounce,
    get: get$1,
    set: set$2,
    keyBy: keyBy,
    unkeyWith: unkeyWith,
    groupBy: groupBy,
    uuid: uuid,
    storage: storage,
    semverCompare: semverCompare,
    deepCopy: deepCopy,
    unique: unique,
    download: download,
    downloadUrl: downloadUrl,
    readFile: readFile,
    arrify: arrify
  });

  /**
   * Removes all key-value entries from the list cache.
   *
   * @private
   * @name clear
   * @memberOf ListCache
   */
  function listCacheClear() {
    this.__data__ = [];
    this.size = 0;
  }

  /**
   * Performs a
   * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * comparison between two values to determine if they are equivalent.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   * @example
   *
   * var object = { 'a': 1 };
   * var other = { 'a': 1 };
   *
   * _.eq(object, object);
   * // => true
   *
   * _.eq(object, other);
   * // => false
   *
   * _.eq('a', 'a');
   * // => true
   *
   * _.eq('a', Object('a'));
   * // => false
   *
   * _.eq(NaN, NaN);
   * // => true
   */
  function eq(value, other) {
    return value === other || value !== value && other !== other;
  }

  /**
   * Gets the index at which the `key` is found in `array` of key-value pairs.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} key The key to search for.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function assocIndexOf(array, key) {
    var length = array.length;
    while (length--) {
      if (eq(array[length][0], key)) {
        return length;
      }
    }
    return -1;
  }

  /** Used for built-in method references. */
  var arrayProto = Array.prototype;

  /** Built-in value references. */
  var splice = arrayProto.splice;

  /**
   * Removes `key` and its value from the list cache.
   *
   * @private
   * @name delete
   * @memberOf ListCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function listCacheDelete(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      return false;
    }
    var lastIndex = data.length - 1;
    if (index == lastIndex) {
      data.pop();
    } else {
      splice.call(data, index, 1);
    }
    --this.size;
    return true;
  }

  /**
   * Gets the list cache value for `key`.
   *
   * @private
   * @name get
   * @memberOf ListCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function listCacheGet(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    return index < 0 ? undefined : data[index][1];
  }

  /**
   * Checks if a list cache value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf ListCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
  }

  /**
   * Sets the list cache `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf ListCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the list cache instance.
   */
  function listCacheSet(key, value) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      ++this.size;
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }
    return this;
  }

  /**
   * Creates an list cache object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function ListCache(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  // Add methods to `ListCache`.
  ListCache.prototype.clear = listCacheClear;
  ListCache.prototype['delete'] = listCacheDelete;
  ListCache.prototype.get = listCacheGet;
  ListCache.prototype.has = listCacheHas;
  ListCache.prototype.set = listCacheSet;

  /**
   * Removes all key-value entries from the stack.
   *
   * @private
   * @name clear
   * @memberOf Stack
   */
  function stackClear() {
    this.__data__ = new ListCache();
    this.size = 0;
  }

  /**
   * Removes `key` and its value from the stack.
   *
   * @private
   * @name delete
   * @memberOf Stack
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function stackDelete(key) {
    var data = this.__data__,
      result = data['delete'](key);
    this.size = data.size;
    return result;
  }

  /**
   * Gets the stack value for `key`.
   *
   * @private
   * @name get
   * @memberOf Stack
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function stackGet(key) {
    return this.__data__.get(key);
  }

  /**
   * Checks if a stack value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Stack
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function stackHas(key) {
    return this.__data__.has(key);
  }

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof global == 'object' && global && global.Object === Object && global;
  var freeGlobal$1 = freeGlobal;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal$1 || freeSelf || Function('return this')();
  var root$1 = root;

  /** Built-in value references. */
  var Symbol$1 = root$1.Symbol;
  var Symbol$2 = Symbol$1;

  /** Used for built-in method references. */
  var objectProto$a = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$8 = objectProto$a.hasOwnProperty;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString$1 = objectProto$a.toString;

  /** Built-in value references. */
  var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : undefined;

  /**
   * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the raw `toStringTag`.
   */
  function getRawTag(value) {
    var isOwn = hasOwnProperty$8.call(value, symToStringTag$1),
      tag = value[symToStringTag$1];
    try {
      value[symToStringTag$1] = undefined;
      var unmasked = true;
    } catch (e) {}
    var result = nativeObjectToString$1.call(value);
    if (unmasked) {
      if (isOwn) {
        value[symToStringTag$1] = tag;
      } else {
        delete value[symToStringTag$1];
      }
    }
    return result;
  }

  /** Used for built-in method references. */
  var objectProto$9 = Object.prototype;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var nativeObjectToString = objectProto$9.toString;

  /**
   * Converts `value` to a string using `Object.prototype.toString`.
   *
   * @private
   * @param {*} value The value to convert.
   * @returns {string} Returns the converted string.
   */
  function objectToString(value) {
    return nativeObjectToString.call(value);
  }

  /** `Object#toString` result references. */
  var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

  /** Built-in value references. */
  var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : undefined;

  /**
   * The base implementation of `getTag` without fallbacks for buggy environments.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
  function baseGetTag(value) {
    if (value == null) {
      return value === undefined ? undefinedTag : nullTag;
    }
    return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
  }

  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */
  function isObject$1(value) {
    var type = typeof value;
    return value != null && (type == 'object' || type == 'function');
  }

  /** `Object#toString` result references. */
  var asyncTag = '[object AsyncFunction]',
    funcTag$1 = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

  /**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */
  function isFunction$1(value) {
    if (!isObject$1(value)) {
      return false;
    }
    // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 9 which returns 'object' for typed arrays and other constructors.
    var tag = baseGetTag(value);
    return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
  }

  /** Used to detect overreaching core-js shims. */
  var coreJsData = root$1['__core-js_shared__'];
  var coreJsData$1 = coreJsData;

  /** Used to detect methods masquerading as native. */
  var maskSrcKey = function () {
    var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || '');
    return uid ? 'Symbol(src)_1.' + uid : '';
  }();

  /**
   * Checks if `func` has its source masked.
   *
   * @private
   * @param {Function} func The function to check.
   * @returns {boolean} Returns `true` if `func` is masked, else `false`.
   */
  function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
  }

  /** Used for built-in method references. */
  var funcProto$2 = Function.prototype;

  /** Used to resolve the decompiled source of functions. */
  var funcToString$2 = funcProto$2.toString;

  /**
   * Converts `func` to its source code.
   *
   * @private
   * @param {Function} func The function to convert.
   * @returns {string} Returns the source code.
   */
  function toSource(func) {
    if (func != null) {
      try {
        return funcToString$2.call(func);
      } catch (e) {}
      try {
        return func + '';
      } catch (e) {}
    }
    return '';
  }

  /**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

  /** Used to detect host constructors (Safari). */
  var reIsHostCtor = /^\[object .+?Constructor\]$/;

  /** Used for built-in method references. */
  var funcProto$1 = Function.prototype,
    objectProto$8 = Object.prototype;

  /** Used to resolve the decompiled source of functions. */
  var funcToString$1 = funcProto$1.toString;

  /** Used to check objects for own properties. */
  var hasOwnProperty$7 = objectProto$8.hasOwnProperty;

  /** Used to detect if a method is native. */
  var reIsNative = RegExp('^' + funcToString$1.call(hasOwnProperty$7).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');

  /**
   * The base implementation of `_.isNative` without bad shim checks.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a native function,
   *  else `false`.
   */
  function baseIsNative(value) {
    if (!isObject$1(value) || isMasked(value)) {
      return false;
    }
    var pattern = isFunction$1(value) ? reIsNative : reIsHostCtor;
    return pattern.test(toSource(value));
  }

  /**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */
  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }

  /**
   * Gets the native function at `key` of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the method to get.
   * @returns {*} Returns the function if it's native, else `undefined`.
   */
  function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : undefined;
  }

  /* Built-in method references that are verified to be native. */
  var Map = getNative(root$1, 'Map');
  var Map$1 = Map;

  /* Built-in method references that are verified to be native. */
  var nativeCreate = getNative(Object, 'create');
  var nativeCreate$1 = nativeCreate;

  /**
   * Removes all key-value entries from the hash.
   *
   * @private
   * @name clear
   * @memberOf Hash
   */
  function hashClear() {
    this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
    this.size = 0;
  }

  /**
   * Removes `key` and its value from the hash.
   *
   * @private
   * @name delete
   * @memberOf Hash
   * @param {Object} hash The hash to modify.
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function hashDelete(key) {
    var result = this.has(key) && delete this.__data__[key];
    this.size -= result ? 1 : 0;
    return result;
  }

  /** Used to stand-in for `undefined` hash values. */
  var HASH_UNDEFINED$1 = '__lodash_hash_undefined__';

  /** Used for built-in method references. */
  var objectProto$7 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$6 = objectProto$7.hasOwnProperty;

  /**
   * Gets the hash value for `key`.
   *
   * @private
   * @name get
   * @memberOf Hash
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function hashGet(key) {
    var data = this.__data__;
    if (nativeCreate$1) {
      var result = data[key];
      return result === HASH_UNDEFINED$1 ? undefined : result;
    }
    return hasOwnProperty$6.call(data, key) ? data[key] : undefined;
  }

  /** Used for built-in method references. */
  var objectProto$6 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$5 = objectProto$6.hasOwnProperty;

  /**
   * Checks if a hash value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Hash
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function hashHas(key) {
    var data = this.__data__;
    return nativeCreate$1 ? data[key] !== undefined : hasOwnProperty$5.call(data, key);
  }

  /** Used to stand-in for `undefined` hash values. */
  var HASH_UNDEFINED = '__lodash_hash_undefined__';

  /**
   * Sets the hash `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Hash
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the hash instance.
   */
  function hashSet(key, value) {
    var data = this.__data__;
    this.size += this.has(key) ? 0 : 1;
    data[key] = nativeCreate$1 && value === undefined ? HASH_UNDEFINED : value;
    return this;
  }

  /**
   * Creates a hash object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function Hash(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  // Add methods to `Hash`.
  Hash.prototype.clear = hashClear;
  Hash.prototype['delete'] = hashDelete;
  Hash.prototype.get = hashGet;
  Hash.prototype.has = hashHas;
  Hash.prototype.set = hashSet;

  /**
   * Removes all key-value entries from the map.
   *
   * @private
   * @name clear
   * @memberOf MapCache
   */
  function mapCacheClear() {
    this.size = 0;
    this.__data__ = {
      'hash': new Hash(),
      'map': new (Map$1 || ListCache)(),
      'string': new Hash()
    };
  }

  /**
   * Checks if `value` is suitable for use as unique object key.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
   */
  function isKeyable(value) {
    var type = typeof value;
    return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
  }

  /**
   * Gets the data for `map`.
   *
   * @private
   * @param {Object} map The map to query.
   * @param {string} key The reference key.
   * @returns {*} Returns the map data.
   */
  function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key) ? data[typeof key == 'string' ? 'string' : 'hash'] : data.map;
  }

  /**
   * Removes `key` and its value from the map.
   *
   * @private
   * @name delete
   * @memberOf MapCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function mapCacheDelete(key) {
    var result = getMapData(this, key)['delete'](key);
    this.size -= result ? 1 : 0;
    return result;
  }

  /**
   * Gets the map value for `key`.
   *
   * @private
   * @name get
   * @memberOf MapCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function mapCacheGet(key) {
    return getMapData(this, key).get(key);
  }

  /**
   * Checks if a map value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf MapCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function mapCacheHas(key) {
    return getMapData(this, key).has(key);
  }

  /**
   * Sets the map `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf MapCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the map cache instance.
   */
  function mapCacheSet(key, value) {
    var data = getMapData(this, key),
      size = data.size;
    data.set(key, value);
    this.size += data.size == size ? 0 : 1;
    return this;
  }

  /**
   * Creates a map cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function MapCache(entries) {
    var index = -1,
      length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  // Add methods to `MapCache`.
  MapCache.prototype.clear = mapCacheClear;
  MapCache.prototype['delete'] = mapCacheDelete;
  MapCache.prototype.get = mapCacheGet;
  MapCache.prototype.has = mapCacheHas;
  MapCache.prototype.set = mapCacheSet;

  /** Used as the size to enable large array optimizations. */
  var LARGE_ARRAY_SIZE = 200;

  /**
   * Sets the stack `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Stack
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the stack cache instance.
   */
  function stackSet(key, value) {
    var data = this.__data__;
    if (data instanceof ListCache) {
      var pairs = data.__data__;
      if (!Map$1 || pairs.length < LARGE_ARRAY_SIZE - 1) {
        pairs.push([key, value]);
        this.size = ++data.size;
        return this;
      }
      data = this.__data__ = new MapCache(pairs);
    }
    data.set(key, value);
    this.size = data.size;
    return this;
  }

  /**
   * Creates a stack cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function Stack(entries) {
    var data = this.__data__ = new ListCache(entries);
    this.size = data.size;
  }

  // Add methods to `Stack`.
  Stack.prototype.clear = stackClear;
  Stack.prototype['delete'] = stackDelete;
  Stack.prototype.get = stackGet;
  Stack.prototype.has = stackHas;
  Stack.prototype.set = stackSet;

  var defineProperty = function () {
    try {
      var func = getNative(Object, 'defineProperty');
      func({}, '', {});
      return func;
    } catch (e) {}
  }();
  var defineProperty$1 = defineProperty;

  /**
   * The base implementation of `assignValue` and `assignMergeValue` without
   * value checks.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
  function baseAssignValue(object, key, value) {
    if (key == '__proto__' && defineProperty$1) {
      defineProperty$1(object, key, {
        'configurable': true,
        'enumerable': true,
        'value': value,
        'writable': true
      });
    } else {
      object[key] = value;
    }
  }

  /**
   * This function is like `assignValue` except that it doesn't assign
   * `undefined` values.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
  function assignMergeValue(object, key, value) {
    if (value !== undefined && !eq(object[key], value) || value === undefined && !(key in object)) {
      baseAssignValue(object, key, value);
    }
  }

  /**
   * Creates a base function for methods like `_.forIn` and `_.forOwn`.
   *
   * @private
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */
  function createBaseFor(fromRight) {
    return function (object, iteratee, keysFunc) {
      var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;
      while (length--) {
        var key = props[fromRight ? length : ++index];
        if (iteratee(iterable[key], key, iterable) === false) {
          break;
        }
      }
      return object;
    };
  }

  /**
   * The base implementation of `baseForOwn` which iterates over `object`
   * properties returned by `keysFunc` and invokes `iteratee` for each property.
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @returns {Object} Returns `object`.
   */
  var baseFor = createBaseFor();
  var baseFor$1 = baseFor;

  /** Detect free variable `exports`. */
  var freeExports$2 = typeof exports == 'object' && exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule$2 = freeExports$2 && typeof module == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports$2 = freeModule$2 && freeModule$2.exports === freeExports$2;

  /** Built-in value references. */
  var Buffer$1 = moduleExports$2 ? root$1.Buffer : undefined,
    allocUnsafe = Buffer$1 ? Buffer$1.allocUnsafe : undefined;

  /**
   * Creates a clone of  `buffer`.
   *
   * @private
   * @param {Buffer} buffer The buffer to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Buffer} Returns the cloned buffer.
   */
  function cloneBuffer(buffer, isDeep) {
    if (isDeep) {
      return buffer.slice();
    }
    var length = buffer.length,
      result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
    buffer.copy(result);
    return result;
  }

  /** Built-in value references. */
  var Uint8Array = root$1.Uint8Array;
  var Uint8Array$1 = Uint8Array;

  /**
   * Creates a clone of `arrayBuffer`.
   *
   * @private
   * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
   * @returns {ArrayBuffer} Returns the cloned array buffer.
   */
  function cloneArrayBuffer(arrayBuffer) {
    var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
    new Uint8Array$1(result).set(new Uint8Array$1(arrayBuffer));
    return result;
  }

  /**
   * Creates a clone of `typedArray`.
   *
   * @private
   * @param {Object} typedArray The typed array to clone.
   * @param {boolean} [isDeep] Specify a deep clone.
   * @returns {Object} Returns the cloned typed array.
   */
  function cloneTypedArray(typedArray, isDeep) {
    var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
    return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
  }

  /**
   * Copies the values of `source` to `array`.
   *
   * @private
   * @param {Array} source The array to copy values from.
   * @param {Array} [array=[]] The array to copy values to.
   * @returns {Array} Returns `array`.
   */
  function copyArray(source, array) {
    var index = -1,
      length = source.length;
    array || (array = Array(length));
    while (++index < length) {
      array[index] = source[index];
    }
    return array;
  }

  /** Built-in value references. */
  var objectCreate = Object.create;

  /**
   * The base implementation of `_.create` without support for assigning
   * properties to the created object.
   *
   * @private
   * @param {Object} proto The object to inherit from.
   * @returns {Object} Returns the new object.
   */
  var baseCreate = function () {
    function object() {}
    return function (proto) {
      if (!isObject$1(proto)) {
        return {};
      }
      if (objectCreate) {
        return objectCreate(proto);
      }
      object.prototype = proto;
      var result = new object();
      object.prototype = undefined;
      return result;
    };
  }();
  var baseCreate$1 = baseCreate;

  /**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */
  function overArg(func, transform) {
    return function (arg) {
      return func(transform(arg));
    };
  }

  /** Built-in value references. */
  var getPrototype = overArg(Object.getPrototypeOf, Object);
  var getPrototype$1 = getPrototype;

  /** Used for built-in method references. */
  var objectProto$5 = Object.prototype;

  /**
   * Checks if `value` is likely a prototype object.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
   */
  function isPrototype(value) {
    var Ctor = value && value.constructor,
      proto = typeof Ctor == 'function' && Ctor.prototype || objectProto$5;
    return value === proto;
  }

  /**
   * Initializes an object clone.
   *
   * @private
   * @param {Object} object The object to clone.
   * @returns {Object} Returns the initialized clone.
   */
  function initCloneObject(object) {
    return typeof object.constructor == 'function' && !isPrototype(object) ? baseCreate$1(getPrototype$1(object)) : {};
  }

  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */
  function isObjectLike(value) {
    return value != null && typeof value == 'object';
  }

  /** `Object#toString` result references. */
  var argsTag$1 = '[object Arguments]';

  /**
   * The base implementation of `_.isArguments`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   */
  function baseIsArguments(value) {
    return isObjectLike(value) && baseGetTag(value) == argsTag$1;
  }

  /** Used for built-in method references. */
  var objectProto$4 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$4 = objectProto$4.hasOwnProperty;

  /** Built-in value references. */
  var propertyIsEnumerable = objectProto$4.propertyIsEnumerable;

  /**
   * Checks if `value` is likely an `arguments` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   *  else `false`.
   * @example
   *
   * _.isArguments(function() { return arguments; }());
   * // => true
   *
   * _.isArguments([1, 2, 3]);
   * // => false
   */
  var isArguments = baseIsArguments(function () {
    return arguments;
  }()) ? baseIsArguments : function (value) {
    return isObjectLike(value) && hasOwnProperty$4.call(value, 'callee') && !propertyIsEnumerable.call(value, 'callee');
  };
  var isArguments$1 = isArguments;

  /**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */
  var isArray$1 = Array.isArray;
  var isArray$2 = isArray$1;

  /** Used as references for various `Number` constants. */
  var MAX_SAFE_INTEGER$1 = 9007199254740991;

  /**
   * Checks if `value` is a valid array-like length.
   *
   * **Note:** This method is loosely based on
   * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
   * @example
   *
   * _.isLength(3);
   * // => true
   *
   * _.isLength(Number.MIN_VALUE);
   * // => false
   *
   * _.isLength(Infinity);
   * // => false
   *
   * _.isLength('3');
   * // => false
   */
  function isLength(value) {
    return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER$1;
  }

  /**
   * Checks if `value` is array-like. A value is considered array-like if it's
   * not a function and has a `value.length` that's an integer greater than or
   * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
   * @example
   *
   * _.isArrayLike([1, 2, 3]);
   * // => true
   *
   * _.isArrayLike(document.body.children);
   * // => true
   *
   * _.isArrayLike('abc');
   * // => true
   *
   * _.isArrayLike(_.noop);
   * // => false
   */
  function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction$1(value);
  }

  /**
   * This method is like `_.isArrayLike` except that it also checks if `value`
   * is an object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array-like object,
   *  else `false`.
   * @example
   *
   * _.isArrayLikeObject([1, 2, 3]);
   * // => true
   *
   * _.isArrayLikeObject(document.body.children);
   * // => true
   *
   * _.isArrayLikeObject('abc');
   * // => false
   *
   * _.isArrayLikeObject(_.noop);
   * // => false
   */
  function isArrayLikeObject(value) {
    return isObjectLike(value) && isArrayLike(value);
  }

  /**
   * This method returns `false`.
   *
   * @static
   * @memberOf _
   * @since 4.13.0
   * @category Util
   * @returns {boolean} Returns `false`.
   * @example
   *
   * _.times(2, _.stubFalse);
   * // => [false, false]
   */
  function stubFalse() {
    return false;
  }

  /** Detect free variable `exports`. */
  var freeExports$1 = typeof exports == 'object' && exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule$1 = freeExports$1 && typeof module == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;

  /** Built-in value references. */
  var Buffer = moduleExports$1 ? root$1.Buffer : undefined;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

  /**
   * Checks if `value` is a buffer.
   *
   * @static
   * @memberOf _
   * @since 4.3.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
   * @example
   *
   * _.isBuffer(new Buffer(2));
   * // => true
   *
   * _.isBuffer(new Uint8Array(2));
   * // => false
   */
  var isBuffer = nativeIsBuffer || stubFalse;
  var isBuffer$1 = isBuffer;

  /** `Object#toString` result references. */
  var objectTag$1 = '[object Object]';

  /** Used for built-in method references. */
  var funcProto = Function.prototype,
    objectProto$3 = Object.prototype;

  /** Used to resolve the decompiled source of functions. */
  var funcToString = funcProto.toString;

  /** Used to check objects for own properties. */
  var hasOwnProperty$3 = objectProto$3.hasOwnProperty;

  /** Used to infer the `Object` constructor. */
  var objectCtorString = funcToString.call(Object);

  /**
   * Checks if `value` is a plain object, that is, an object created by the
   * `Object` constructor or one with a `[[Prototype]]` of `null`.
   *
   * @static
   * @memberOf _
   * @since 0.8.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   * }
   *
   * _.isPlainObject(new Foo);
   * // => false
   *
   * _.isPlainObject([1, 2, 3]);
   * // => false
   *
   * _.isPlainObject({ 'x': 0, 'y': 0 });
   * // => true
   *
   * _.isPlainObject(Object.create(null));
   * // => true
   */
  function isPlainObject(value) {
    if (!isObjectLike(value) || baseGetTag(value) != objectTag$1) {
      return false;
    }
    var proto = getPrototype$1(value);
    if (proto === null) {
      return true;
    }
    var Ctor = hasOwnProperty$3.call(proto, 'constructor') && proto.constructor;
    return typeof Ctor == 'function' && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
  }

  /** `Object#toString` result references. */
  var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

  /** Used to identify `toStringTag` values of typed arrays. */
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;

  /**
   * The base implementation of `_.isTypedArray` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   */
  function baseIsTypedArray(value) {
    return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
  }

  /**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */
  function baseUnary(func) {
    return function (value) {
      return func(value);
    };
  }

  /** Detect free variable `exports`. */
  var freeExports = typeof exports == 'object' && exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && typeof module == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Detect free variable `process` from Node.js. */
  var freeProcess = moduleExports && freeGlobal$1.process;

  /** Used to access faster Node.js helpers. */
  var nodeUtil = function () {
    try {
      // Use `util.types` for Node.js 10+.
      var types = freeModule && freeModule.require && freeModule.require('util').types;
      if (types) {
        return types;
      }

      // Legacy `process.binding('util')` for Node.js < 10.
      return freeProcess && freeProcess.binding && freeProcess.binding('util');
    } catch (e) {}
  }();
  var nodeUtil$1 = nodeUtil;

  /* Node.js helper references. */
  var nodeIsTypedArray = nodeUtil$1 && nodeUtil$1.isTypedArray;

  /**
   * Checks if `value` is classified as a typed array.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   * @example
   *
   * _.isTypedArray(new Uint8Array);
   * // => true
   *
   * _.isTypedArray([]);
   * // => false
   */
  var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
  var isTypedArray$1 = isTypedArray;

  /**
   * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */
  function safeGet(object, key) {
    if (key === 'constructor' && typeof object[key] === 'function') {
      return;
    }
    if (key == '__proto__') {
      return;
    }
    return object[key];
  }

  /** Used for built-in method references. */
  var objectProto$2 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$2 = objectProto$2.hasOwnProperty;

  /**
   * Assigns `value` to `key` of `object` if the existing value is not equivalent
   * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * for equality comparisons.
   *
   * @private
   * @param {Object} object The object to modify.
   * @param {string} key The key of the property to assign.
   * @param {*} value The value to assign.
   */
  function assignValue(object, key, value) {
    var objValue = object[key];
    if (!(hasOwnProperty$2.call(object, key) && eq(objValue, value)) || value === undefined && !(key in object)) {
      baseAssignValue(object, key, value);
    }
  }

  /**
   * Copies properties of `source` to `object`.
   *
   * @private
   * @param {Object} source The object to copy properties from.
   * @param {Array} props The property identifiers to copy.
   * @param {Object} [object={}] The object to copy properties to.
   * @param {Function} [customizer] The function to customize copied values.
   * @returns {Object} Returns `object`.
   */
  function copyObject(source, props, object, customizer) {
    var isNew = !object;
    object || (object = {});
    var index = -1,
      length = props.length;
    while (++index < length) {
      var key = props[index];
      var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined;
      if (newValue === undefined) {
        newValue = source[key];
      }
      if (isNew) {
        baseAssignValue(object, key, newValue);
      } else {
        assignValue(object, key, newValue);
      }
    }
    return object;
  }

  /**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
  function baseTimes(n, iteratee) {
    var index = -1,
      result = Array(n);
    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }

  /** Used as references for various `Number` constants. */
  var MAX_SAFE_INTEGER = 9007199254740991;

  /** Used to detect unsigned integer values. */
  var reIsUint = /^(?:0|[1-9]\d*)$/;

  /**
   * Checks if `value` is a valid array-like index.
   *
   * @private
   * @param {*} value The value to check.
   * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
   * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
   */
  function isIndex(value, length) {
    var type = typeof value;
    length = length == null ? MAX_SAFE_INTEGER : length;
    return !!length && (type == 'number' || type != 'symbol' && reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
  }

  /** Used for built-in method references. */
  var objectProto$1 = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty$1 = objectProto$1.hasOwnProperty;

  /**
   * Creates an array of the enumerable property names of the array-like `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @param {boolean} inherited Specify returning inherited property names.
   * @returns {Array} Returns the array of property names.
   */
  function arrayLikeKeys(value, inherited) {
    var isArr = isArray$2(value),
      isArg = !isArr && isArguments$1(value),
      isBuff = !isArr && !isArg && isBuffer$1(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray$1(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;
    for (var key in value) {
      if ((inherited || hasOwnProperty$1.call(value, key)) && !(skipIndexes && (
      // Safari 9 has enumerable `arguments.length` in strict mode.
      key == 'length' ||
      // Node.js 0.10 has enumerable non-index properties on buffers.
      isBuff && (key == 'offset' || key == 'parent') ||
      // PhantomJS 2 has enumerable non-index properties on typed arrays.
      isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset') ||
      // Skip index properties.
      isIndex(key, length)))) {
        result.push(key);
      }
    }
    return result;
  }

  /**
   * This function is like
   * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * except that it includes inherited enumerable properties.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
  function nativeKeysIn(object) {
    var result = [];
    if (object != null) {
      for (var key in Object(object)) {
        result.push(key);
      }
    }
    return result;
  }

  /** Used for built-in method references. */
  var objectProto = Object.prototype;

  /** Used to check objects for own properties. */
  var hasOwnProperty = objectProto.hasOwnProperty;

  /**
   * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
  function baseKeysIn(object) {
    if (!isObject$1(object)) {
      return nativeKeysIn(object);
    }
    var isProto = isPrototype(object),
      result = [];
    for (var key in object) {
      if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
        result.push(key);
      }
    }
    return result;
  }

  /**
   * Creates an array of the own and inherited enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keysIn(new Foo);
   * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
   */
  function keysIn(object) {
    return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
  }

  /**
   * Converts `value` to a plain object flattening inherited enumerable string
   * keyed properties of `value` to own properties of the plain object.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {Object} Returns the converted plain object.
   * @example
   *
   * function Foo() {
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.assign({ 'a': 1 }, new Foo);
   * // => { 'a': 1, 'b': 2 }
   *
   * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
   * // => { 'a': 1, 'b': 2, 'c': 3 }
   */
  function toPlainObject(value) {
    return copyObject(value, keysIn(value));
  }

  /**
   * A specialized version of `baseMerge` for arrays and objects which performs
   * deep merges and tracks traversed objects enabling objects with circular
   * references to be merged.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @param {string} key The key of the value to merge.
   * @param {number} srcIndex The index of `source`.
   * @param {Function} mergeFunc The function to merge values.
   * @param {Function} [customizer] The function to customize assigned values.
   * @param {Object} [stack] Tracks traversed source values and their merged
   *  counterparts.
   */
  function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
    var objValue = safeGet(object, key),
      srcValue = safeGet(source, key),
      stacked = stack.get(srcValue);
    if (stacked) {
      assignMergeValue(object, key, stacked);
      return;
    }
    var newValue = customizer ? customizer(objValue, srcValue, key + '', object, source, stack) : undefined;
    var isCommon = newValue === undefined;
    if (isCommon) {
      var isArr = isArray$2(srcValue),
        isBuff = !isArr && isBuffer$1(srcValue),
        isTyped = !isArr && !isBuff && isTypedArray$1(srcValue);
      newValue = srcValue;
      if (isArr || isBuff || isTyped) {
        if (isArray$2(objValue)) {
          newValue = objValue;
        } else if (isArrayLikeObject(objValue)) {
          newValue = copyArray(objValue);
        } else if (isBuff) {
          isCommon = false;
          newValue = cloneBuffer(srcValue, true);
        } else if (isTyped) {
          isCommon = false;
          newValue = cloneTypedArray(srcValue, true);
        } else {
          newValue = [];
        }
      } else if (isPlainObject(srcValue) || isArguments$1(srcValue)) {
        newValue = objValue;
        if (isArguments$1(objValue)) {
          newValue = toPlainObject(objValue);
        } else if (!isObject$1(objValue) || isFunction$1(objValue)) {
          newValue = initCloneObject(srcValue);
        }
      } else {
        isCommon = false;
      }
    }
    if (isCommon) {
      // Recursively merge objects and arrays (susceptible to call stack limits).
      stack.set(srcValue, newValue);
      mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
      stack['delete'](srcValue);
    }
    assignMergeValue(object, key, newValue);
  }

  /**
   * The base implementation of `_.merge` without support for multiple sources.
   *
   * @private
   * @param {Object} object The destination object.
   * @param {Object} source The source object.
   * @param {number} srcIndex The index of `source`.
   * @param {Function} [customizer] The function to customize merged values.
   * @param {Object} [stack] Tracks traversed source values and their merged
   *  counterparts.
   */
  function baseMerge(object, source, srcIndex, customizer, stack) {
    if (object === source) {
      return;
    }
    baseFor$1(source, function (srcValue, key) {
      stack || (stack = new Stack());
      if (isObject$1(srcValue)) {
        baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
      } else {
        var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + '', object, source, stack) : undefined;
        if (newValue === undefined) {
          newValue = srcValue;
        }
        assignMergeValue(object, key, newValue);
      }
    }, keysIn);
  }

  /**
   * This method returns the first argument it receives.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Util
   * @param {*} value Any value.
   * @returns {*} Returns `value`.
   * @example
   *
   * var object = { 'a': 1 };
   *
   * console.log(_.identity(object) === object);
   * // => true
   */
  function identity(value) {
    return value;
  }

  /**
   * A faster alternative to `Function#apply`, this function invokes `func`
   * with the `this` binding of `thisArg` and the arguments of `args`.
   *
   * @private
   * @param {Function} func The function to invoke.
   * @param {*} thisArg The `this` binding of `func`.
   * @param {Array} args The arguments to invoke `func` with.
   * @returns {*} Returns the result of `func`.
   */
  function apply(func, thisArg, args) {
    switch (args.length) {
      case 0:
        return func.call(thisArg);
      case 1:
        return func.call(thisArg, args[0]);
      case 2:
        return func.call(thisArg, args[0], args[1]);
      case 3:
        return func.call(thisArg, args[0], args[1], args[2]);
    }
    return func.apply(thisArg, args);
  }

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeMax$1 = Math.max;

  /**
   * A specialized version of `baseRest` which transforms the rest array.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @param {Function} transform The rest array transform.
   * @returns {Function} Returns the new function.
   */
  function overRest(func, start, transform) {
    start = nativeMax$1(start === undefined ? func.length - 1 : start, 0);
    return function () {
      var args = arguments,
        index = -1,
        length = nativeMax$1(args.length - start, 0),
        array = Array(length);
      while (++index < length) {
        array[index] = args[start + index];
      }
      index = -1;
      var otherArgs = Array(start + 1);
      while (++index < start) {
        otherArgs[index] = args[index];
      }
      otherArgs[start] = transform(array);
      return apply(func, this, otherArgs);
    };
  }

  /**
   * Creates a function that returns `value`.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {*} value The value to return from the new function.
   * @returns {Function} Returns the new constant function.
   * @example
   *
   * var objects = _.times(2, _.constant({ 'a': 1 }));
   *
   * console.log(objects);
   * // => [{ 'a': 1 }, { 'a': 1 }]
   *
   * console.log(objects[0] === objects[1]);
   * // => true
   */
  function constant(value) {
    return function () {
      return value;
    };
  }

  /**
   * The base implementation of `setToString` without support for hot loop shorting.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */
  var baseSetToString = !defineProperty$1 ? identity : function (func, string) {
    return defineProperty$1(func, 'toString', {
      'configurable': true,
      'enumerable': false,
      'value': constant(string),
      'writable': true
    });
  };
  var baseSetToString$1 = baseSetToString;

  /** Used to detect hot functions by number of calls within a span of milliseconds. */
  var HOT_COUNT = 800,
    HOT_SPAN = 16;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeNow = Date.now;

  /**
   * Creates a function that'll short out and invoke `identity` instead
   * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
   * milliseconds.
   *
   * @private
   * @param {Function} func The function to restrict.
   * @returns {Function} Returns the new shortable function.
   */
  function shortOut(func) {
    var count = 0,
      lastCalled = 0;
    return function () {
      var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);
      lastCalled = stamp;
      if (remaining > 0) {
        if (++count >= HOT_COUNT) {
          return arguments[0];
        }
      } else {
        count = 0;
      }
      return func.apply(undefined, arguments);
    };
  }

  /**
   * Sets the `toString` method of `func` to return `string`.
   *
   * @private
   * @param {Function} func The function to modify.
   * @param {Function} string The `toString` result.
   * @returns {Function} Returns `func`.
   */
  var setToString = shortOut(baseSetToString$1);
  var setToString$1 = setToString;

  /**
   * The base implementation of `_.rest` which doesn't validate or coerce arguments.
   *
   * @private
   * @param {Function} func The function to apply a rest parameter to.
   * @param {number} [start=func.length-1] The start position of the rest parameter.
   * @returns {Function} Returns the new function.
   */
  function baseRest(func, start) {
    return setToString$1(overRest(func, start, identity), func + '');
  }

  /**
   * Checks if the given arguments are from an iteratee call.
   *
   * @private
   * @param {*} value The potential iteratee value argument.
   * @param {*} index The potential iteratee index or key argument.
   * @param {*} object The potential iteratee object argument.
   * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
   *  else `false`.
   */
  function isIterateeCall(value, index, object) {
    if (!isObject$1(object)) {
      return false;
    }
    var type = typeof index;
    if (type == 'number' ? isArrayLike(object) && isIndex(index, object.length) : type == 'string' && index in object) {
      return eq(object[index], value);
    }
    return false;
  }

  /**
   * Creates a function like `_.assign`.
   *
   * @private
   * @param {Function} assigner The function to assign values.
   * @returns {Function} Returns the new assigner function.
   */
  function createAssigner(assigner) {
    return baseRest(function (object, sources) {
      var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;
      customizer = assigner.length > 3 && typeof customizer == 'function' ? (length--, customizer) : undefined;
      if (guard && isIterateeCall(sources[0], sources[1], guard)) {
        customizer = length < 3 ? undefined : customizer;
        length = 1;
      }
      object = Object(object);
      while (++index < length) {
        var source = sources[index];
        if (source) {
          assigner(object, source, index, customizer);
        }
      }
      return object;
    });
  }

  /**
   * This method is like `_.assign` except that it recursively merges own and
   * inherited enumerable string keyed properties of source objects into the
   * destination object. Source properties that resolve to `undefined` are
   * skipped if a destination value exists. Array and plain object properties
   * are merged recursively. Other objects and value types are overridden by
   * assignment. Source objects are applied from left to right. Subsequent
   * sources overwrite property assignments of previous sources.
   *
   * **Note:** This method mutates `object`.
   *
   * @static
   * @memberOf _
   * @since 0.5.0
   * @category Object
   * @param {Object} object The destination object.
   * @param {...Object} [sources] The source objects.
   * @returns {Object} Returns `object`.
   * @example
   *
   * var object = {
   *   'a': [{ 'b': 2 }, { 'd': 4 }]
   * };
   *
   * var other = {
   *   'a': [{ 'c': 3 }, { 'e': 5 }]
   * };
   *
   * _.merge(object, other);
   * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
   */
  var merge = createAssigner(function (object, source, srcIndex) {
    baseMerge(object, source, srcIndex);
  });
  var _merge = merge;

  var copy = {};
  var draft = false;
  var Config = new Vue__default["default"]({
    data: function data() {
      return {
        ready: false,
        values: deepCopy(get$1(window, '$customizer.yooessentials.config', {}))
      };
    },
    computed: {
      yooconfig: {
        get: function get() {
          return window.$yooess.yooconfig || {};
        },
        cache: false
      }
    },
    watch: {
      values: {
        handler: function handler(values) {
          if (!this.ready) {
            return;
          }

          // is being reseted?
          if (JSON.stringify(values) === JSON.stringify(copy)) {
            this.yooconfig.dirty = draft = false;
          } else {
            this.yooconfig.dirty = draft = true;
          }

          // this.$trigger('loadPreview', {config: this.yooconfig.values});
        },

        deep: true,
        immediate: true
      }
    },
    events: {
      initBuilder: {
        handler: function handler() {
          copy = deepCopy(this.values);
          this.ready = true;

          // a hint if the config has been updated within a php script
          if (this.values.updated) {
            var values = deepCopy(this.values);
            delete values.updated;
            this.values = values;
          }
        },
        priority: -50
      },
      loadPreview: {
        handler: function handler(e, values) {
          // it is being cancelled?
          if (!this.yooconfig.dirty) {
            if (draft) {
              this.cancel();
            }
            return;
          }
          var config = deepCopy(this.values);

          // joomla
          if (e != null && e.params[0]) {
            e.params[0].yooessentials = config;
          }

          // wp
          if (values != null && values.config) {
            values.config.yooessentials = config;
          }
        },
        priority: 50
      },
      saveConfig: function saveConfig() {
        this.persist();
        copy = deepCopy(this.values);
        draft = false;
      },
      'yooessentials-prerequest': function yooessentialsPrerequest(e) {
        if (!draft) {
          return;
        }
        e.params[0].config = deepCopy(this.values);
      }
    },
    methods: {
      get: function get(index, _default) {
        return get$1(this.values, index, _default);
      },
      set: function set(index, value) {
        set$2(this.values, index, value);
      },
      add: function add(_values) {
        _merge(this.values, deepCopy(_values));
      },
      replace: function replace(_values) {
        this.values = deepCopy(_values);
      },
      cancel: function cancel() {
        this.replace(copy);
      },
      persist: function persist() {
        var config = deepCopy(this.values);
        this.$trigger('saveYooessentialsConfig', config);
        return this.$http.post('yooessentials/config/save', {
          config: config
        });
      }
    }
  });

  // import UIkit from 'uikit';

  function yooessRequest (endpoint, params) {
    if (params === void 0) {
      params = {};
    }
    Vue__default["default"].events.trigger('yooessentials-prerequest', params);
    return new Promise(function (resolve, reject) {
      Vue__default["default"].http.post(endpoint, params).then(function (res) {
        resolve(res);
      })["catch"](function (e) {
        reject(e);
      });
      // .catch(e => {
      //     const error = window.$yooessRequestError = JSON.stringify(e, null, 2);

      //     UIkit.modal.alert(`
      //         <p class="uk-text-lead">There was an error processing this request.</p>
      //         <div class="uk-overflow-auto">
      //             <pre class="uk-height-medium" style="background-color: white;">${error}</pre>
      //         </div>

      //         <div class="uk-text-right">
      //             <a class="uk-link-muted" onclick="navigator.clipboard.writeText(window.$yooessRequestError)">Copy to Clipboard</a>
      //         </div>
      //     `);
      // });
    });
  }

  var script$R = {
    name: 'YooessentialsCheckbox',
    "extends": $fields__default["default"].FieldCheckbox,
    mounted: function mounted() {
      var _this = this;
      if (this.field.reliesOn) {
        this.$watch("values." + this.field.reliesOn, function (checked) {
          _this.value = checked ? _this.trueValue : _this.falseValue;
        });
      }
    }
  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
      if (typeof shadowMode !== 'boolean') {
          createInjectorSSR = createInjector;
          createInjector = shadowMode;
          shadowMode = false;
      }
      // Vue.extend constructor export interop.
      const options = typeof script === 'function' ? script.options : script;
      // render functions
      if (template && template.render) {
          options.render = template.render;
          options.staticRenderFns = template.staticRenderFns;
          options._compiled = true;
          // functional template
          if (isFunctionalTemplate) {
              options.functional = true;
          }
      }
      // scopedId
      if (scopeId) {
          options._scopeId = scopeId;
      }
      let hook;
      if (moduleIdentifier) {
          // server build
          hook = function (context) {
              // 2.3 injection
              context =
                  context || // cached call
                      (this.$vnode && this.$vnode.ssrContext) || // stateful
                      (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
              // 2.2 with runInNewContext: true
              if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                  context = __VUE_SSR_CONTEXT__;
              }
              // inject component styles
              if (style) {
                  style.call(this, createInjectorSSR(context));
              }
              // register component module identifier for async chunk inference
              if (context && context._registeredComponents) {
                  context._registeredComponents.add(moduleIdentifier);
              }
          };
          // used by ssr in case component is cached and beforeCreate
          // never gets called
          options._ssrRegister = hook;
      }
      else if (style) {
          hook = shadowMode
              ? function (context) {
                  style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
              }
              : function (context) {
                  style.call(this, createInjector(context));
              };
      }
      if (hook) {
          if (options.functional) {
              // register for functional component in vue file
              const originalRender = options.render;
              options.render = function renderWithStyleInjection(h, context) {
                  hook.call(context);
                  return originalRender(h, context);
              };
          }
          else {
              // inject component registration as beforeCreate hook
              const existing = options.beforeCreate;
              options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
          }
      }
      return script;
  }

  /* script */
  var __vue_script__$R = script$R;

  /* template */

  /* style */
  var __vue_inject_styles__$U = undefined;
  /* scoped */
  var __vue_scope_id__$U = undefined;
  /* module identifier */
  var __vue_module_identifier__$U = undefined;
  /* functional template */
  var __vue_is_functional_template__$U = undefined;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$U = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$U, __vue_script__$R, __vue_scope_id__$U, __vue_is_functional_template__$U, __vue_module_identifier__$U, false, undefined, undefined, undefined);

  //
  var script$Q = {
    name: 'Info',
    "extends": $fields__default["default"].FieldText
  };

  /* script */
  var __vue_script__$Q = script$Q;

  /* template */
  var __vue_render__$P = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      domProps: {
        "innerHTML": _vm._s(_vm.field.content)
      }
    });
  };
  var __vue_staticRenderFns__$P = [];

  /* style */
  var __vue_inject_styles__$T = undefined;
  /* scoped */
  var __vue_scope_id__$T = undefined;
  /* module identifier */
  var __vue_module_identifier__$T = undefined;
  /* functional template */
  var __vue_is_functional_template__$T = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$T = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$P,
    staticRenderFns: __vue_staticRenderFns__$P
  }, __vue_inject_styles__$T, __vue_script__$Q, __vue_scope_id__$T, __vue_is_functional_template__$T, __vue_module_identifier__$T, false, undefined, undefined, undefined);

  //
  var script$P = {
    name: 'File',
    "extends": $fields__default["default"].FieldText,
    methods: {
      open: function open() {
        this.$trigger('openFilePicker', true).then(this.select);
      },
      select: function select(value) {
        if (uikitUtil.isPlainObject(value)) {
          value = value.src;
        }
        if (this.field.mode === 'folder' && !isFolder(value)) {
          return;
        }
        if (this.field.mode === 'file' && isFolder(value)) {
          return;
        }
        this.value = value;
      }
    }
  };
  function isFolder(value) {
    return value && value.match(/\/[^.]+$/);
  }

  /* script */
  var __vue_script__$P = script$P;

  /* template */
  var __vue_render__$O = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [_c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Pick'),
        "href": "",
        "uk-icon": "album",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    })])])]), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.value,
        expression: "value"
      }],
      staticClass: "uk-input yo-input-iconnav-right",
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.value
      },
      on: {
        "input": function input($event) {
          if ($event.target.composing) {
            return;
          }
          _vm.value = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))]);
  };
  var __vue_staticRenderFns__$O = [];

  /* style */
  var __vue_inject_styles__$S = undefined;
  /* scoped */
  var __vue_scope_id__$S = undefined;
  /* module identifier */
  var __vue_module_identifier__$S = undefined;
  /* functional template */
  var __vue_is_functional_template__$S = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$S = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$O,
    staticRenderFns: __vue_staticRenderFns__$O
  }, __vue_inject_styles__$S, __vue_script__$P, __vue_scope_id__$S, __vue_is_functional_template__$S, __vue_module_identifier__$S, false, undefined, undefined, undefined);

  //
  var script$O = {
    "extends": $fields__default["default"].FieldText,
    computed: {
      mod: function mod() {
        return uikitUtil.toFloat(this.field.modifier || 0);
      },
      val: {
        get: function get() {
          return uikitUtil.isNumeric(this.value) ? uikitUtil.toFloat(this.value) + this.mod : this.value;
        },
        set: function set(value) {
          this.value = uikitUtil.isNumeric(value) ? uikitUtil.toFloat(value) - this.mod : undefined;
        }
      }
    }
  };

  /* script */
  var __vue_script__$O = script$O;

  /* template */
  var __vue_render__$N = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.val,
        expression: "val"
      }],
      staticClass: "uk-input",
      attrs: {
        "type": "number"
      },
      domProps: {
        "value": _vm.val
      },
      on: {
        "input": function input($event) {
          if ($event.target.composing) {
            return;
          }
          _vm.val = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false));
  };
  var __vue_staticRenderFns__$N = [];

  /* style */
  var __vue_inject_styles__$R = undefined;
  /* scoped */
  var __vue_scope_id__$R = undefined;
  /* module identifier */
  var __vue_module_identifier__$R = undefined;
  /* functional template */
  var __vue_is_functional_template__$R = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$R = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$N,
    staticRenderFns: __vue_staticRenderFns__$N
  }, __vue_inject_styles__$R, __vue_script__$O, __vue_scope_id__$R, __vue_is_functional_template__$R, __vue_module_identifier__$R, false, undefined, undefined, undefined);

  //
  var script$N = {
    name: 'Password',
    "extends": $fields__default["default"].FieldText,
    data: function data() {
      return {
        visible: false
      };
    },
    computed: {
      empty: function empty() {
        return !this.value;
      },
      val: {
        get: function get() {
          if (!this.visible) {
            var _this$value;
            return '*'.repeat((_this$value = this.value) == null ? void 0 : _this$value.length);
          }
          return this.value;
        },
        set: function set(value) {
          this.show();
          this.value = value;
        }
      }
    },
    methods: {
      show: function show() {
        this.visible = true;
      }
    }
  };

  /* script */
  var __vue_script__$N = script$N;

  /* template */
  var __vue_render__$M = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      }
    }) : _c('div', [_c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [!_vm.visible && !_vm.empty ? _c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "ye-builder-icon-eye uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Show'),
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.show.apply(null, arguments);
        }
      }
    })])])]) : _vm._e(), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.val,
        expression: "val"
      }],
      staticClass: "uk-input",
      "class": {
        'ye-input-iconnav-right': !_vm.visible
      },
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.val
      },
      on: {
        "input": function input($event) {
          if ($event.target.composing) {
            return;
          }
          _vm.val = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))])]);
  };
  var __vue_staticRenderFns__$M = [];

  /* style */
  var __vue_inject_styles__$Q = undefined;
  /* scoped */
  var __vue_scope_id__$Q = undefined;
  /* module identifier */
  var __vue_module_identifier__$Q = undefined;
  /* functional template */
  var __vue_is_functional_template__$Q = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$Q = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$M,
    staticRenderFns: __vue_staticRenderFns__$M
  }, __vue_inject_styles__$Q, __vue_script__$N, __vue_scope_id__$Q, __vue_is_functional_template__$Q, __vue_module_identifier__$Q, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$M = {
    inject: {
      $node: {
        "default": {}
      }
    },
    props: {
      title: String,
      error: String,
      statusIcons: Array,
      icon: String,
      uikitIcon: String,
      editable: {
        type: Boolean,
        "default": true
      },
      copyable: {
        type: Boolean,
        "default": true
      },
      removable: {
        type: Boolean,
        "default": true
      }
    },
    computed: {
      statusError: function statusError() {
        var _this$statusIcons;
        return (_this$statusIcons = this.statusIcons) == null ? void 0 : _this$statusIcons.some(function (_ref) {
          var error = _ref.error;
          return error;
        });
      }
    }
  };

  /* script */
  var __vue_script__$M = script$M;

  /* template */
  function objectWithoutProperties$2(obj, exclude) {
    var target = {};
    for (var k in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) target[k] = obj[k];
    }
    return target;
  }
  var __vue_render__$L = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('li', {
      staticClass: "uk-visible-toggle",
      attrs: {
        "tabindex": "-1"
      }
    }, [_c('a', {
      staticClass: "uk-display-block",
      "class": {
        'uk-disabled': !_vm.editable
      },
      attrs: {
        "href": ""
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('edit');
        }
      }
    }, [_vm._t("default", function () {
      return [_vm.statusIcons && _vm.statusIcons.length ? _c('ul', {
        staticClass: "uk-grid uk-grid-collapse uk-flex-inline uk-text-bottom"
      }, _vm._l(_vm.statusIcons, function (ref) {
        var component = ref.component;
        var rest = objectWithoutProperties$2(ref, ["component"]);
        var props = rest;
        return _c('li', {
          key: component.name
        }, [_c(component, _vm._b({
          tag: "component",
          attrs: {
            "node": _vm.$node
          }
        }, 'component', props, false))], 1);
      }), 0) : _vm.icon ? _c('img', {
        staticClass: "uk-svg uk-margin-small-right",
        attrs: {
          "alt": _vm.$t(_vm.title),
          "src": _vm.icon,
          "width": "20",
          "height": "20",
          "uk-svg": ""
        }
      }) : _vm.uikitIcon ? _c('span', {
        staticClass: "uk-margin-small-right",
        attrs: {
          "uk-icon": _vm.uikitIcon
        }
      }) : _vm._e(), _vm._v(" "), _c('span', {
        "class": ['uk-text-truncate uk-text-middle', {
          'uk-text-danger': _vm.statusError
        }]
      }, [_vm._v(_vm._s(_vm.$t(_vm.title || 'Item')))]), _vm._v(" "), _vm.$slots.meta ? _c('span', {
        staticClass: "uk-text-middle uk-text-meta uk-margin-small-left"
      }, [_vm._t("meta")], 2) : _vm._e(), _vm._v(" "), _vm.error ? _c('div', {
        staticClass: "uk-flex uk-flex-middle uk-margin-small-top"
      }, [_c('span', {
        staticClass: "ye-builder-icon-error"
      }), _vm._v(" "), _c('span', {
        staticClass: "uk-text-small uk-text-danger uk-margin-small-left uk-text-break"
      }, [_vm._v(_vm._s(_vm.error))])]) : _vm._e()];
    })], 2), _vm._v(" "), _c('div', {
      staticClass: "uk-invisible-hover uk-position-center-right uk-position-medium"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_vm.copyable ? _c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "href": "",
        "uk-icon": "copy"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('copy');
        }
      }
    })]) : _vm._e(), _vm._v(" "), _vm.removable ? _c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "href": "",
        "uk-icon": "trash"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('remove');
        }
      }
    })]) : _vm._e()])])]);
  };
  var __vue_staticRenderFns__$L = [];

  /* style */
  var __vue_inject_styles__$P = undefined;
  /* scoped */
  var __vue_scope_id__$P = undefined;
  /* module identifier */
  var __vue_module_identifier__$P = undefined;
  /* functional template */
  var __vue_is_functional_template__$P = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$P = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$L,
    staticRenderFns: __vue_staticRenderFns__$L
  }, __vue_inject_styles__$P, __vue_script__$M, __vue_scope_id__$P, __vue_is_functional_template__$P, __vue_module_identifier__$P, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$L = {
    name: 'ResourceListItem',
    props: {
      title: String,
      icon: String,
      status: Object,
      meta: String,
      error: [String, Boolean],
      disabled: Boolean,
      editable: {
        type: Boolean,
        "default": true
      },
      actions: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      indications: {
        type: Array,
        "default": function _default() {
          return [];
        }
      }
    },
    computed: {
      actionsList: function actionsList() {
        var actions = {
          copy: {
            title: 'Copy',
            emit: 'copy',
            icon: 'copy'
          },
          "delete": {
            title: 'Delete',
            emit: 'delete',
            icon: 'trash'
          }
        };
        return this.actions.map(function (action) {
          return actions[action] || action;
        }).filter(Boolean);
      }
    }
  };

  /* script */
  var __vue_script__$L = script$L;

  /* template */
  var __vue_render__$K = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('li', {
      staticClass: "uk-visible-toggle yooessentials-resource-item",
      attrs: {
        "tabindex": "-1"
      }
    }, [_c('a', {
      staticClass: "uk-flex uk-flex-middle uk-position-relative",
      "class": {
        'uk-disabled': _vm.disabled || !_vm.editable,
        'uk-text-muted': _vm.disabled || _vm.error && !_vm.editable
      },
      attrs: {
        "href": ""
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('edit');
        }
      }
    }, [_vm._t("icon", function () {
      return [_vm.icon ? _c('span', {
        staticClass: "uk-margin-small-right"
      }, [_c('img', {
        staticClass: "uk-svg",
        attrs: {
          "alt": _vm.$t(_vm.title || 'Item'),
          "src": _vm.icon,
          "width": "28",
          "height": "28",
          "uk-svg": ""
        }
      })]) : _vm._e()];
    }, null, _vm.$props), _vm._v(" "), _c('div', {
      staticClass: "uk-width-5-6"
    }, [_c('div', {
      staticClass: "uk-text-truncate"
    }, [_vm._v(_vm._s(_vm.$t(_vm.title || 'Item')))]), _vm._v(" "), _vm.error ? _c('div', {
      staticClass: "uk-text-meta uk-text-danger"
    }, [_vm._v("\n                " + _vm._s(_vm.error) + "\n            ")]) : _vm.meta || _vm.$slots.meta ? _c('div', {
      staticClass: "uk-text-meta"
    }, [_vm._t("meta", function () {
      return [_vm._v(_vm._s(_vm.meta))];
    }, {
      "meta": _vm.meta
    })], 2) : _vm._e()])], 2), _vm._v(" "), _c('div', {
      staticClass: "uk-position-center-right uk-position-medium",
      staticStyle: {
        "padding-right": "5px"
      }
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_vm._l(_vm.indications, function (indication) {
      return _c('li', {
        key: indication.title
      }, [_c('span', {
        "class": [indication["class"], 'uk-preserve-width'],
        attrs: {
          "title": _vm.$t(indication.title),
          "uk-icon": indication.icon,
          "uk-tooltip": "delay: 500"
        }
      })]);
    }), _vm._v(" "), _vm._l(_vm.actionsList, function (action, i) {
      return _c('li', {
        key: action.key || i,
        "class": {
          'uk-invisible-hover': !action.stack
        }
      }, [_c('span', {
        "class": [action["class"], 'uk-preserve-width', {
          'uk-link uk-icon-link': action.emit || action.callback
        }],
        attrs: {
          "uk-icon": action.icon,
          "title": _vm.$t(action.title),
          "uk-tooltip": "delay: 500"
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            action.emit && _vm.$emit(action.emit), action.callback && action.callback($event);
          }
        }
      })]);
    })], 2)])]);
  };
  var __vue_staticRenderFns__$K = [];

  /* style */
  var __vue_inject_styles__$O = undefined;
  /* scoped */
  var __vue_scope_id__$O = undefined;
  /* module identifier */
  var __vue_module_identifier__$O = undefined;
  /* functional template */
  var __vue_is_functional_template__$O = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$O = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$K,
    staticRenderFns: __vue_staticRenderFns__$K
  }, __vue_inject_styles__$O, __vue_script__$L, __vue_scope_id__$O, __vue_is_functional_template__$O, __vue_module_identifier__$O, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$K = {
    name: 'DatasetPickerItem',
    props: {
      title: String,
      icon: String,
      description: String,
      badge: [String, Number]
    }
  };

  /* script */
  var __vue_script__$K = script$K;

  /* template */
  var __vue_render__$J = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-card uk-card-body uk-card-hover yo-panel uk-padding-remove-horizontal uk-text-center"
    }, [_c('div', {
      staticClass: "uk-width-small uk-margin-auto"
    }, [_c('span', {
      staticClass: "uk-inline"
    }, [_c('img', {
      attrs: {
        "alt": _vm.title,
        "src": _vm.icon,
        "uk-svg": "",
        "width": "40",
        "height": "40"
      }
    }), _vm._v(" "), _vm.badge ? _c('span', {
      staticClass: "uk-badge uk-background-secondary uk-position-top-right uk-position-z-index",
      staticStyle: {
        "top": "-12px",
        "right": "-12px"
      }
    }, [_vm._v(_vm._s(_vm.badge))]) : _vm._e()])]), _vm._v(" "), _c('div', {
      staticClass: "uk-margin-top uk-padding-small uk-padding-remove-vertical uk-margin-remove-bottom uk-text-wrap"
    }, [_vm._v(_vm._s(_vm.title))]), _vm._v(" "), _vm.description ? _c('div', {
      staticClass: "uk-margin-small-top uk-padding-small uk-padding-remove-vertical uk-margin-remove-bottom uk-text-wrap uk-text-meta"
    }, [_vm._v(_vm._s(_vm.description))]) : _vm._e(), _vm._v(" "), _c('a', {
      staticClass: "uk-position-cover uk-position-z-index",
      attrs: {
        "href": ""
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('resolve');
        }
      }
    })]);
  };
  var __vue_staticRenderFns__$J = [];

  /* style */
  var __vue_inject_styles__$N = undefined;
  /* scoped */
  var __vue_scope_id__$N = undefined;
  /* module identifier */
  var __vue_module_identifier__$N = undefined;
  /* functional template */
  var __vue_is_functional_template__$N = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$N = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$J,
    staticRenderFns: __vue_staticRenderFns__$J
  }, __vue_inject_styles__$N, __vue_script__$K, __vue_scope_id__$N, __vue_is_functional_template__$N, __vue_module_identifier__$N, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$J = {
    name: 'FinderView',
    props: {
      itemName: {
        type: String,
        "default": 'Item'
      },
      items: {
        type: Array,
        required: true
      },
      total: {
        type: Number,
        "default": 0
      },
      selected: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      filter: {
        type: Object,
        "default": function _default() {
          return {
            search: ''
          };
        }
      }
    },
    computed: {
      totalItems: function totalItems() {
        return this.total || this.items.length;
      },
      countText: function countText() {
        return this.$t("%smart_count% " + this.itemName + " |||| %smart_count% " + this.itemName + "s", this.totalItems);
      },
      selectedText: function selectedText() {
        return this.$t('%smart_count% Selected', this.selected.length);
      },
      selectedAll: function selectedAll() {
        return this.selected.length === this.items.length;
      }
    },
    methods: {
      isSelected: function isSelected(_ref) {
        var id = _ref.id;
        return ~this.selected.indexOf(id);
      },
      toggleSelect: function toggleSelect(_ref2) {
        var id = _ref2.id;
        var selected = [].concat(this.selected);
        var index = this.selected.indexOf(id);
        ~index ? selected.splice(index, 1) : selected.push(id);
        this.$emit('update:selected', selected);
      },
      toggleSelectAll: function toggleSelectAll() {
        var selected = this.selectedAll ? [] : [].concat(this.items.map(function (_ref3) {
          var id = _ref3.id;
          return id;
        }));
        this.$emit('update:selected', selected);
      }
    }
  };

  /* script */
  var __vue_script__$J = script$J;

  /* template */
  var __vue_render__$I = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "yo-modal-subheader uk-margin-medium-bottom"
    }, [_c('div', {
      staticClass: "uk-grid-small uk-flex-middle uk-flex-between",
      attrs: {
        "uk-grid": ""
      }
    }, [_c('div', {
      staticClass: "uk-flex uk-flex-middle uk-flex-1"
    }, [_c('div', [_vm._t("count", function () {
      return [_c('h2', {
        staticClass: "uk-modal-title uk-margin-remove uk-text-nowrap"
      }, [_vm._v(_vm._s(_vm.selected.length ? _vm.selectedText : _vm.countText))])];
    }, {
      "countText": _vm.countText
    })], 2), _vm._v(" "), _vm.$slots.actions ? _c('div', {
      staticClass: "uk-margin-small-left"
    }, [_vm._t("actions")], 2) : _vm._e(), _vm._v(" "), _c('div', {
      staticClass: "yo-finder-search uk-flex uk-flex-between uk-flex-1"
    }, [_c('div', {
      staticClass: "uk-search uk-search-navbar uk-width-expand uk-width-small@s"
    }, [_c('span', {
      attrs: {
        "uk-search-icon": ""
      }
    }), _vm._v(" "), _c('input', {
      staticClass: "uk-search-input",
      attrs: {
        "type": "search",
        "autofocus": ""
      },
      domProps: {
        "value": _vm.filter.search
      },
      on: {
        "input": function input($event) {
          return _vm.$emit('update:filter', Object.assign({}, _vm.filter, {
            search: $event.target.value
          }));
        }
      }
    })])]), _vm._v(" "), _vm._t("filter"), _vm._v(" "), _vm.$slots.right ? _c('div', [_vm._t("right", null, {
      "items": _vm.items
    })], 2) : _vm._e()], 2)])]), _vm._v(" "), _c('div', {
      staticClass: "yo-finder-body",
      attrs: {
        "uk-overflow-auto": ""
      }
    }, [!_vm.items.length && _vm.filter.search ? _c('h3', {
      staticClass: "uk-h1 uk-text-muted uk-text-center"
    }, [_vm._v(_vm._s(_vm.$t('Not found. Try a different criteria.')))]) : _c('div', [_vm._t("items", null, {
      "items": _vm.items
    })], 2)])]);
  };
  var __vue_staticRenderFns__$I = [];

  /* style */
  var __vue_inject_styles__$M = undefined;
  /* scoped */
  var __vue_scope_id__$M = undefined;
  /* module identifier */
  var __vue_module_identifier__$M = undefined;
  /* functional template */
  var __vue_is_functional_template__$M = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$M = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$I,
    staticRenderFns: __vue_staticRenderFns__$I
  }, __vue_inject_styles__$M, __vue_script__$J, __vue_scope_id__$M, __vue_is_functional_template__$M, __vue_module_identifier__$M, false, undefined, undefined, undefined);

  var script$I = {
    name: 'DatasetPickerFinder',
    components: {
      Finder: __vue_component__$M
    },
    props: {
      items: {
        type: Array,
        required: true
      },
      itemGrid: {
        type: String,
        "default": '1-6'
      }
    },
    data: function data() {
      return {
        filter: {
          search: ''
        }
      };
    },
    computed: {
      list: function list() {
        var _this = this;
        return this.items.filter(function (item) {
          var _item$group;
          return ((_item$group = item.group) == null ? void 0 : _item$group.toLowerCase()) !== 'legacy';
        }) // hide legacy group
        .filter(function (_ref) {
          var name = _ref.name,
            title = _ref.title,
            group = _ref.group;
          var value = [name, title, group].map(function (v) {
            return v == null ? void 0 : v.toString().toLowerCase();
          }).join(' ');
          return !_this.filter.search || ~value.indexOf(_this.filter.search.toLowerCase());
        }).map(function (item) {
          return _extends({
            group: ''
          }, item);
        }).sort(function (a, b) {
          if (a.group === b.group) {
            return 0;
          }
          return a.group === '' ? -1 : 1;
        });
      },
      groups: function groups() {
        return groupBy(this.list, 'group');
      }
    },
    methods: {
      total: function total(obj) {
        return Object.keys(obj).length;
      }
    }
  };

  /* script */
  var __vue_script__$I = script$I;

  /* template */
  var __vue_render__$H = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('Finder', {
      attrs: {
        "items": _vm.items,
        "total": _vm.list.length,
        "filter": _vm.filter
      },
      on: {
        "update:filter": function updateFilter($event) {
          _vm.filter = $event;
        }
      },
      scopedSlots: _vm._u([_vm.list.length ? {
        key: "items",
        fn: function fn() {
          return _vm._l(_vm.groups, function (groupItems, group) {
            return _c('div', {
              key: group,
              "class": {
                'uk-margin': _vm.total(_vm.groups) > 1
              }
            }, [group && _vm.total(_vm.groups) > 1 ? _c('h3', {
              staticClass: "uk-heading-divider uk-margin-small"
            }, [_vm._v(_vm._s(group))]) : _vm._e(), _vm._v(" "), _c('div', {
              "class": ["uk-grid-collapse uk-child-width uk-child-width-" + _vm.itemGrid],
              attrs: {
                "uk-grid": "",
                "uk-height-match": "target: > div > .uk-card"
              }
            }, _vm._l(groupItems, function (item) {
              return _c('div', {
                key: item.name
              }, [_vm._t("item", null, {
                "item": item
              })], 2);
            }), 0)]);
          });
        },
        proxy: true
      } : null], null, true)
    });
  };
  var __vue_staticRenderFns__$H = [];

  /* style */
  var __vue_inject_styles__$L = undefined;
  /* scoped */
  var __vue_scope_id__$L = undefined;
  /* module identifier */
  var __vue_module_identifier__$L = undefined;
  /* functional template */
  var __vue_is_functional_template__$L = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$L = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$H,
    staticRenderFns: __vue_staticRenderFns__$H
  }, __vue_inject_styles__$L, __vue_script__$I, __vue_scope_id__$L, __vue_is_functional_template__$L, __vue_module_identifier__$L, false, undefined, undefined, undefined);

  var script$H = {
    name: 'ResourcePickerModal',
    components: {
      ResourcePickerItem: __vue_component__$N,
      ResourcePickerFinder: __vue_component__$L
    },
    props: {
      items: {
        type: Array,
        required: true
      }
    },
    data: function data() {
      return {
        openCollection: null
      };
    },
    computed: {
      list: function list() {
        var _this = this;
        if (this.openCollection) {
          return this.items.filter(function (item) {
            return item.collection === _this.openCollection;
          });
        }
        return this.items.reduce(function (items, item) {
          if (item.collection && items.find(function (i) {
            return i.collection === item.collection;
          })) {
            return items;
          }
          return [].concat(items, [_extends({}, item, {
            title: item.collection || item.title
          })]);
        }, []);
      },
      collections: function collections() {
        return groupBy(this.items, 'collection');
      }
    },
    methods: {
      total: function total(obj) {
        return Object.keys(obj).length;
      },
      getCollectionDescription: function getCollectionDescription(collection) {
        var _this$collections, _this$collections$col, _this$collections$col2;
        return (_this$collections = this.collections) == null ? void 0 : (_this$collections$col = _this$collections[collection]) == null ? void 0 : (_this$collections$col2 = _this$collections$col.find(function (i) {
          return i.collectionDescription;
        })) == null ? void 0 : _this$collections$col2.collectionDescription;
      }
    }
  };

  /* script */
  var __vue_script__$H = script$H;

  /* template */
  var __vue_render__$G = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-modal-body"
    }, [_c('ResourcePickerFinder', {
      attrs: {
        "items": _vm.list
      },
      scopedSlots: _vm._u([{
        key: "item",
        fn: function fn(ref) {
          var item = ref.item;
          return [!_vm.openCollection && item.collection ? _c('ResourcePickerItem', {
            attrs: {
              "title": item.title,
              "icon": item.icon,
              "description": _vm.getCollectionDescription(item.collection),
              "badge": _vm.total(_vm.collections[item.collection])
            },
            on: {
              "resolve": function resolve($event) {
                _vm.openCollection = item.collection;
              }
            }
          }) : _c('ResourcePickerItem', {
            attrs: {
              "title": item.title,
              "icon": item.icon,
              "description": item.description
            },
            on: {
              "resolve": function resolve($event) {
                return _vm.$emit('resolve', item);
              }
            }
          })];
        }
      }])
    })], 1);
  };
  var __vue_staticRenderFns__$G = [];

  /* style */
  var __vue_inject_styles__$K = undefined;
  /* scoped */
  var __vue_scope_id__$K = undefined;
  /* module identifier */
  var __vue_module_identifier__$K = undefined;
  /* functional template */
  var __vue_is_functional_template__$K = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$K = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$G,
    staticRenderFns: __vue_staticRenderFns__$G
  }, __vue_inject_styles__$K, __vue_script__$H, __vue_scope_id__$K, __vue_is_functional_template__$K, __vue_module_identifier__$K, false, undefined, undefined, undefined);

  //
  var script$G = {
    name: 'Switcher',
    props: {
      tabs: {
        type: Array,
        required: true
      },
      storage: String,
      active: {
        type: Number,
        "default": function _default() {
          return this.storage && toInteger$2(storage[this.storage]) || 0;
        }
      }
    },
    data: function data() {
      return {
        shown: []
      };
    },
    methods: {
      selectTab: function selectTab(tab, i) {
        var _this = this;
        if (this.storage) {
          storage[this.storage] = i;
        }
        this.shown.splice(this.shown.length, 0, i);
        this.$emit('show', tab, i);
        this.$nextTick(function () {
          var _this$$el$querySelect;
          return (_this$$el$querySelect = _this.$el.querySelector(".uk-switcher li:nth-child(" + (i + 1) + ") [autofocus]")) == null ? void 0 : _this$$el$querySelect.focus();
        });
      }
    }
  };
  function toInteger$2(val) {
  }

  /* script */
  var __vue_script__$G = script$G;

  /* template */
  var __vue_render__$F = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "uk-modal-header uk-flex uk-flex-middle uk-flex-between"
    }, [_c('ul', {
      staticClass: "uk-margin-remove-bottom",
      attrs: {
        "active": _vm.active,
        "uk-tab": "connect: !* +; animation: uk-animation-fade"
      }
    }, _vm._l(_vm.tabs, function (tab) {
      return _c('li', {
        key: tab
      }, [_c('a', {
        attrs: {
          "href": ""
        }
      }, [_vm._v(_vm._s(_vm.$t(tab)))])]);
    }), 0), _vm._v(" "), _vm._t("header-right")], 2), _vm._v(" "), _c('ul', {
      staticClass: "uk-switcher"
    }, _vm._l(_vm.tabs, function (tab, i) {
      return _c('li', {
        key: tab,
        on: {
          "beforeshow": function beforeshow($event) {
            if ($event.target !== $event.currentTarget) {
              return null;
            }
            return _vm.selectTab(tab, i);
          }
        }
      }, [~_vm.shown.indexOf(i) ? _vm._t(tab) : _vm._e()], 2);
    }), 0)]);
  };
  var __vue_staticRenderFns__$F = [];

  /* style */
  var __vue_inject_styles__$J = undefined;
  /* scoped */
  var __vue_scope_id__$J = undefined;
  /* module identifier */
  var __vue_module_identifier__$J = undefined;
  /* functional template */
  var __vue_is_functional_template__$J = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$J = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$F,
    staticRenderFns: __vue_staticRenderFns__$F
  }, __vue_inject_styles__$J, __vue_script__$G, __vue_scope_id__$J, __vue_is_functional_template__$J, __vue_module_identifier__$J, false, undefined, undefined, undefined);

  /* script */

  /* template */
  var __vue_render__$E = function __vue_render__(_h, _vm) {
    var _c = _vm._c;
    return _c('div', {
      staticClass: "yo-sidebar-fields",
      "class": _vm.data.staticClass,
      style: _vm.data.style
    }, _vm._l(_vm.parent.prepare(_vm.props.field.fields), function (field) {
      return _c('div', {
        directives: [{
          name: "show",
          rawName: "v-show",
          value: _vm.parent.evaluate(field.show),
          expression: "parent.evaluate(field.show)"
        }],
        key: field.name
      }, [field.buttons ? [_c('div', {
        staticClass: "uk-flex uk-flex-middle uk-flex-right"
      }, [field.label ? _c('div', {
        staticClass: "uk-width-expand"
      }, [_c('h3', {
        staticClass: "yo-sidebar-subheading uk-margin-remove"
      }, [_vm._v(_vm._s(_vm.parent.$t(field.label)))])]) : _vm._e(), _vm._v(" "), _c('div', {
        staticClass: "uk-width-auto"
      }, [_c('ul', {
        staticClass: "uk-subnav uk-margin-remove"
      }, _vm._l(field.buttons, function (ref) {
        var label = ref.label;
        var action = ref.action;
        var show = ref.show;
        return _c('li', {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.parent.evaluate(show),
            expression: "parent.evaluate(show)"
          }],
          key: action
        }, [_c('button', {
          staticClass: "uk-button uk-button-link",
          attrs: {
            "disabled": field.enable && !_vm.parent.evaluate(field.enable),
            "type": "button"
          },
          on: {
            "click": function click($event) {
              return _vm.parent.$trigger(action, [field, $event]);
            }
          }
        }, [_vm._v(_vm._s(label))])]);
      }), 0)])])] : field.label ? _c('h3', {
        staticClass: "yo-sidebar-subheading"
      }, [_vm._v(_vm._s(_vm.parent.$t(field.label)))]) : _vm._e(), _vm._v(" "), field.type !== 'description' ? [!~['grid', 'group'].indexOf(field.type) ? _c('div', {
        staticClass: "uk-margin-small"
      }, [_c(field.component, {
        tag: "component",
        attrs: {
          "field": field,
          "values": _vm.parent.values
        },
        on: {
          "change": _vm.parent.change
        }
      })], 1) : _c(field.component, {
        tag: "component",
        attrs: {
          "field": field,
          "values": _vm.parent.values
        },
        on: {
          "change": _vm.parent.change
        }
      })] : _vm._e(), _vm._v(" "), field.description ? _c('p', {
        staticClass: "uk-text-muted uk-margin-small",
        domProps: {
          "innerHTML": _vm._s(_vm.parent.$t(field.description))
        }
      }) : _vm._e(), _vm._v(" "), field.divider ? _c('hr') : _vm._e()], 2);
    }), 0);
  };
  var __vue_staticRenderFns__$E = [];

  /* style */
  var __vue_inject_styles__$I = undefined;
  /* scoped */
  var __vue_scope_id__$I = undefined;
  /* module identifier */
  var __vue_module_identifier__$I = undefined;
  /* functional template */
  var __vue_is_functional_template__$I = true;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$I = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$E,
    staticRenderFns: __vue_staticRenderFns__$E
  }, __vue_inject_styles__$I, {}, __vue_scope_id__$I, __vue_is_functional_template__$I, __vue_module_identifier__$I, false, undefined, undefined, undefined);

  /* script */

  /* template */
  var __vue_render__$D = function __vue_render__(_h, _vm) {
    var _c = _vm._c;
    return _c('div', {
      staticClass: "yo-sidebar-grid uk-grid uk-flex-nowrap",
      "class": {
        'uk-grid-small uk-margin-remove-bottom': _vm.parent.get(_vm.props.field.attrs, 'class') === 'yo-form-medium',
        'uk-grid-medium': _vm.parent.get(_vm.props.field.attrs, 'class') !== 'yo-form-medium'
      }
    }, _vm._l(_vm.parent.prepare(_vm.props.field.fields), function (field) {
      var _obj;
      return _c('div', {
        directives: [{
          name: "show",
          rawName: "v-show",
          value: _vm.parent.evaluate(field.show),
          expression: "parent.evaluate(field.show)"
        }],
        key: field.name,
        "class": (_obj = {}, _obj["uk-width-" + _vm.props.field.width] = _vm.props.field.width, _obj)
      }, [field.buttons ? [_c('div', {
        staticClass: "uk-flex uk-flex-middle uk-flex-right"
      }, [field.label ? _c('div', {
        staticClass: "uk-width-expand"
      }, [_c('h3', {
        staticClass: "yo-sidebar-subheading uk-margin-remove"
      }, [_vm._v(_vm._s(_vm.parent.$t(field.label)))])]) : _vm._e(), _vm._v(" "), _c('div', {
        staticClass: "uk-width-auto"
      }, [_c('ul', {
        staticClass: "uk-subnav uk-margin-remove"
      }, _vm._l(field.buttons, function (ref) {
        var label = ref.label;
        var action = ref.action;
        var show = ref.show;
        return _c('li', {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.parent.evaluate(show),
            expression: "parent.evaluate(show)"
          }],
          key: action
        }, [_c('button', {
          staticClass: "uk-button uk-button-link",
          attrs: {
            "disabled": field.enable && !_vm.parent.evaluate(field.enable),
            "type": "button"
          },
          on: {
            "click": function click($event) {
              return _vm.parent.$trigger(action, [field, $event]);
            }
          }
        }, [_vm._v(_vm._s(label))])]);
      }), 0)])])] : field.label ? _c('h3', {
        staticClass: "yo-sidebar-subheading"
      }, [_vm._v(_vm._s(_vm.parent.$t(field.label)))]) : _vm._e(), _vm._v(" "), field.type !== 'description' ? [!~['grid'].indexOf(field.type) ? _c('div', {
        staticClass: "uk-margin-small"
      }, [_c(field.component, {
        tag: "component",
        attrs: {
          "field": field,
          "values": _vm.props.values
        },
        on: {
          "change": _vm.parent.change
        }
      })], 1) : _c(field.component, {
        tag: "component",
        attrs: {
          "field": field,
          "values": _vm.props.values
        },
        on: {
          "change": _vm.parent.change
        }
      })] : _vm._e(), _vm._v(" "), field.description ? _c('p', {
        staticClass: "uk-text-muted uk-margin-small",
        domProps: {
          "innerHTML": _vm._s(_vm.parent.$t(field.description))
        }
      }) : _vm._e()], 2);
    }), 0);
  };
  var __vue_staticRenderFns__$D = [];

  /* style */
  var __vue_inject_styles__$H = undefined;
  /* scoped */
  var __vue_scope_id__$H = undefined;
  /* module identifier */
  var __vue_module_identifier__$H = undefined;
  /* functional template */
  var __vue_is_functional_template__$H = true;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$H = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$D,
    staticRenderFns: __vue_staticRenderFns__$D
  }, __vue_inject_styles__$H, {}, __vue_scope_id__$H, __vue_is_functional_template__$H, __vue_module_identifier__$H, false, undefined, undefined, undefined);

  /* script */

  /* template */
  var __vue_render__$C = function __vue_render__(_h, _vm) {
    var _c = _vm._c;
    return _c('div', {
      staticClass: "uk-margin-small"
    }, _vm._l(_vm.parent.prepare(_vm.props.field.fields), function (field) {
      return _c('div', {
        directives: [{
          name: "show",
          rawName: "v-show",
          value: _vm.parent.evaluate(field.show),
          expression: "parent.evaluate(field.show)"
        }],
        key: field.name,
        staticClass: "uk-flex uk-flex-middle uk-margin-small",
        "class": {
          'uk-flex-wrap': field.buttons
        }
      }, [field.buttons ? _c('div', {
        staticClass: "uk-width-1-1 uk-flex uk-flex-right uk-margin-small-bottom"
      }, [_c('ul', {
        staticClass: "uk-subnav uk-margin-remove"
      }, _vm._l(field.buttons, function (ref) {
        var label = ref.label;
        var action = ref.action;
        var show = ref.show;
        return _c('li', {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.parent.evaluate(show),
            expression: "parent.evaluate(show)"
          }],
          key: action
        }, [_c('button', {
          staticClass: "uk-button uk-button-link",
          attrs: {
            "disabled": field.enable && !_vm.parent.evaluate(field.enable),
            "type": "button"
          },
          on: {
            "click": function click($event) {
              return _vm.parent.$trigger(action, [field, $event]);
            }
          }
        }, [_vm._v(_vm._s(label))])]);
      }), 0)]) : _vm._e(), _vm._v(" "), _c('div', {
        staticClass: "uk-width-expand uk-text-truncate"
      }, [field.description ? _c('span', {
        attrs: {
          "title": field.description,
          "uk-tooltip": "delay: 300; pos: top-left"
        }
      }, [_vm._v(_vm._s(_vm.parent.$t(field.label || '')))]) : _c('span', [_vm._v(_vm._s(_vm.parent.$t(field.label || '')))])]), _vm._v(" "), _c('div', {
        staticClass: "uk-width-medium"
      }, [_c(field.component, {
        tag: "component",
        attrs: {
          "values": _vm.props.values,
          "field": _vm.parent.merge(field, {
            attrs: {
              "class": 'yo-form-medium'
            }
          })
        },
        on: {
          "change": _vm.parent.change
        }
      })], 1)]);
    }), 0);
  };
  var __vue_staticRenderFns__$C = [];

  /* style */
  var __vue_inject_styles__$G = undefined;
  /* scoped */
  var __vue_scope_id__$G = undefined;
  /* module identifier */
  var __vue_module_identifier__$G = undefined;
  /* functional template */
  var __vue_is_functional_template__$G = true;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$G = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$C,
    staticRenderFns: __vue_staticRenderFns__$C
  }, __vue_inject_styles__$G, {}, __vue_scope_id__$G, __vue_is_functional_template__$G, __vue_module_identifier__$G, false, undefined, undefined, undefined);

  /*!
   * vue-fields v1.1.3
   * https://github.com/pagekit/vue-fields
   * Released under the MIT License.
   */

  /**
   * Utility functions.
   */
  var _config = {},
    _set;
  var assign = Object.assign || _assign;
  var isArray = Array.isArray;
  function Util(_ref) {
    var set = _ref.set,
      config = _ref.config;
    _set = set;
    _config = config;
  }
  function log(message, color) {
    if (color === void 0) {
      color = '#41B883';
    }
    if (typeof console !== 'undefined' && _config.devtools) {
      console.log("%c vue-fields %c " + message + " ", 'color: #fff; background: #35495E; padding: 1px; border-radius: 3px 0 0 3px;', "color: #fff; background: " + color + "; padding: 1px; border-radius: 0 3px 3px 0;");
    }
  }
  function warn(message, color) {
    if (color === void 0) {
      color = '#DB6B00';
    }
    log(message, color);
  }
  function isObject(obj) {
    return obj !== null && typeof obj === 'object';
  }
  function isString(val) {
    return typeof val === 'string';
  }
  function isFunction(val) {
    return typeof val === 'function';
  }
  function isUndefined(val) {
    return typeof val === 'undefined';
  }
  function get(obj, key, def) {
    var parts = isArray(key) ? key : key.split('.');
    for (var i = 0; i < parts.length; i++) {
      if (isObject(obj) && !isUndefined(obj[parts[i]])) {
        obj = obj[parts[i]];
      } else {
        return def;
      }
    }
    return obj;
  }
  function set$1(obj, key, val) {
    var parts = isArray(key) ? key : key.split('.');
    while (parts.length > 1) {
      var part = parts.shift();
      if (!isObject(obj[part])) {
        _set(obj, part, {});
      }
      obj = obj[part];
    }
    _set(obj, parts.shift(), val);
  }
  var parsedFunc = {};
  var expressionRe = /((?:\d|true|false|null|undefined|(?:this\.|\$)[\w.$]+|\W)*)([\w][\w.-]*)?/g;
  var quotedStringRe = /([^"']+)((.)(?:[^\3\\]|\\.)*?\3|.)?/g;
  function parse(expr) {
    return parsedFunc[expr] = parsedFunc[expr] || Function('$values', '$context', "with($context){return " + expr.replace(quotedStringRe, function (match, unquoted, quoted) {
      if (quoted === void 0) {
        quoted = '';
      }
      return unquoted.replace(expressionRe, function (match, prefix, expression) {
        if (prefix === void 0) {
          prefix = '';
        }
        return match ? "" + prefix + (expression ? "$get('" + expression + "')" : '') : '';
      }) + quoted;
    }) + "}");
  }
  function each(obj, iterator) {
    var i, key;
    if (typeof obj.length == 'number') {
      for (i = 0; i < obj.length; i++) {
        iterator.call(obj[i], obj[i], i);
      }
    } else if (isObject(obj)) {
      for (key in obj) {
        if (obj.hasOwnProperty(key)) {
          iterator.call(obj[key], obj[key], key);
        }
      }
    }
    return obj;
  }
  /**
   * Object.assign() polyfill.
   */

  function _assign(target) {
    for (var _len = arguments.length, sources = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      sources[_key - 1] = arguments[_key];
    }
    sources.forEach(function (source) {
      Object.keys(source || {}).forEach(function (key) {
        return target[key] = source[key];
      });
    });
    return target;
  }
  var Field = {
    inject: ['Fields'],
    props: {
      field: {
        type: Object,
        required: true
      },
      values: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return assign({
        name: '',
        label: '',
        attrs: {},
        options: [],
        "default": undefined
      }, this.field);
    },
    computed: {
      value: {
        get: function get$$1() {
          return get(this.values, this.name);
        },
        set: function set$$1(value) {
          this.$emit('change', value, this);
        }
      },
      attributes: {
        get: function get$$1() {
          if (!this.Fields.evaluate(this.enable)) {
            return assign({
              disabled: 'true'
            }, this.attrs);
          }
          return this.attrs;
        }
      }
    },
    created: function created() {
      if (isUndefined(this.value) && !isUndefined(this["default"])) {
        this.value = this["default"];
      }
    },
    methods: {
      filterOptions: function filterOptions(options) {
        var _this = this;
        var opts = [];
        if (!options) {
          warn("Invalid options provided for " + this.name);
          return opts;
        }
        each(options, function (value, name) {
          if (isObject(value)) {
            opts.push({
              label: name,
              options: _this.filterOptions(value)
            });
          } else {
            opts.push({
              text: name,
              value: value
            });
          }
        });
        return opts;
      }
    }
  };
  var FieldText = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('input', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        attrs: {
          "type": "text"
        },
        domProps: {
          "value": _vm.value
        },
        on: {
          "input": function input($event) {
            if ($event.target.composing) {
              return;
            }
            _vm.value = $event.target.value;
          }
        }
      }, 'input', _vm.attributes, false));
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldTextarea = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('textarea', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        domProps: {
          "value": _vm.value
        },
        on: {
          "input": function input($event) {
            if ($event.target.composing) {
              return;
            }
            _vm.value = $event.target.value;
          }
        }
      }, 'textarea', _vm.attributes, false));
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldRadio = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', [_vm._l(_vm.filterOptions(_vm.options), function (option) {
        return [_c('input', _vm._b({
          directives: [{
            name: "model",
            rawName: "v-model",
            value: _vm.value,
            expression: "value"
          }],
          attrs: {
            "name": _vm.name,
            "type": "radio"
          },
          domProps: {
            "value": option.value,
            "checked": _vm._q(_vm.value, option.value)
          },
          on: {
            "change": function change($event) {
              _vm.value = option.value;
            }
          }
        }, 'input', _vm.attributes, false)), _vm._v(" "), _c('label', [_vm._v(_vm._s(option.text))])];
      })], 2);
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldCheckbox = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('input', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        attrs: {
          "type": "checkbox"
        },
        domProps: {
          "checked": Array.isArray(_vm.value) ? _vm._i(_vm.value, null) > -1 : _vm.value
        },
        on: {
          "change": function change($event) {
            var $$a = _vm.value,
              $$el = $event.target,
              $$c = $$el.checked ? true : false;
            if (Array.isArray($$a)) {
              var $$v = null,
                $$i = _vm._i($$a, $$v);
              if ($$el.checked) {
                $$i < 0 && (_vm.value = $$a.concat([$$v]));
              } else {
                $$i > -1 && (_vm.value = $$a.slice(0, $$i).concat($$a.slice($$i + 1)));
              }
            } else {
              _vm.value = $$c;
            }
          }
        }
      }, 'input', _vm.attributes, false));
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldSelect = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('select', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        on: {
          "change": function change($event) {
            var $$selectedVal = Array.prototype.filter.call($event.target.options, function (o) {
              return o.selected;
            }).map(function (o) {
              var val = "_value" in o ? o._value : o.value;
              return val;
            });
            _vm.value = $event.target.multiple ? $$selectedVal : $$selectedVal[0];
          }
        }
      }, 'select', _vm.attributes, false), [_vm._l(_vm.filterOptions(_vm.options), function (option) {
        return [option.label ? _c('optgroup', {
          attrs: {
            "label": option.label
          }
        }, _vm._l(option.options, function (opt) {
          return _c('option', {
            domProps: {
              "value": opt.value
            }
          }, [_vm._v(_vm._s(opt.text))]);
        }), 0) : _c('option', {
          domProps: {
            "value": option.value
          }
        }, [_vm._v(_vm._s(option.text))])];
      })], 2);
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldRange = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('input', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        attrs: {
          "type": "range"
        },
        domProps: {
          "value": _vm.value
        },
        on: {
          "__r": function __r($event) {
            _vm.value = $event.target.value;
          }
        }
      }, 'input', _vm.attributes, false));
    },
    staticRenderFns: [],
    "extends": Field
  };
  var FieldNumber = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('input', _vm._b({
        directives: [{
          name: "model",
          rawName: "v-model",
          value: _vm.value,
          expression: "value"
        }],
        attrs: {
          "type": "number"
        },
        domProps: {
          "value": _vm.value
        },
        on: {
          "input": function input($event) {
            if ($event.target.composing) {
              return;
            }
            _vm.value = $event.target.value;
          }
        }
      }, 'input', _vm.attributes, false));
    },
    staticRenderFns: [],
    "extends": Field
  };
  var Fields = {
    render: function render() {
      var _vm = this;
      var _h = _vm.$createElement;
      var _c = _vm._self._c || _h;
      return _c('div', _vm._l(_vm.fields, function (field) {
        return _c('div', {
          directives: [{
            name: "show",
            rawName: "v-show",
            value: _vm.evaluate(field.show),
            expression: "evaluate(field.show)"
          }],
          key: field.name
        }, [field.type != 'checkbox' ? _c('label', [_vm._v(_vm._s(field.label))]) : _vm._e(), _vm._v(" "), _c(field.component, {
          tag: "component",
          attrs: {
            "field": field,
            "values": _vm.values
          },
          on: {
            "change": _vm.change
          }
        })], 1);
      }), 0);
    },
    staticRenderFns: [],
    components: {
      FieldText: FieldText,
      FieldTextarea: FieldTextarea,
      FieldRadio: FieldRadio,
      FieldCheckbox: FieldCheckbox,
      FieldSelect: FieldSelect,
      FieldRange: FieldRange,
      FieldNumber: FieldNumber
    },
    provide: function provide() {
      return {
        Fields: this
      };
    },
    props: {
      config: {
        type: [Object, Array],
        "default": function _default() {
          return {};
        }
      },
      values: {
        type: Object,
        "default": function _default() {
          return {};
        }
      },
      prefix: {
        type: String,
        "default": 'field-'
      }
    },
    computed: {
      fields: function fields() {
        return this.prepare();
      }
    },
    methods: {
      change: function change(value, field) {
        set$1(this.values, field.name, value);
        this.$emit('change', value, field);
      },
      prepare: function prepare(config, prefix) {
        if (config === void 0) {
          config = this.config;
        }
        if (prefix === void 0) {
          prefix = this.prefix;
        }
        var arr = isArray(config),
          fields = [];
        each(config, function (field, key) {
          field = assign({}, field);
          if (!field.name && !arr) {
            field.name = key;
          }
          if (field.name) {
            if (!field.type) {
              field.type = 'text';
            }
            if (!field.component) {
              field.component = prefix + field.type;
            }
            fields.push(field);
          } else {
            warn("Field name missing " + JSON.stringify(field));
          }
        });
        return fields;
      },
      evaluate: function evaluate(expression, values) {
        if (values === void 0) {
          values = this.values;
        }
        try {
          if (isUndefined(expression)) {
            return true;
          }
          if (isString(expression)) {
            expression = parse(expression);
          }
          if (isFunction(expression)) {
            return expression.call(this, values, {
              $match: $match,
              $get: function $get(key) {
                return get(values, key);
              }
            });
          }
          return expression;
        } catch (e) {
          warn(e);
        }
        return true;
      }
    }
  };
  function $match(subject, pattern, flags) {
    return subject && new RegExp(pattern, flags).test(subject);
  }

  /**
   * Install plugin.
   */
  var Plugin = {
    Field: Field,
    Fields: Fields,
    install: function install(Vue) {
      if (this.installed) {
        return;
      }
      Util(Vue);
      log(this.version);
      Vue.component('field', Field);
      Vue.component('fields', Fields);
    },
    version: '1.1.3'
  };
  if (typeof window !== 'undefined' && window.Vue) {
    window.Vue.use(Plugin);
  }

  var _prepare = Fields.methods.prepare;
  var script$F = {
    name: 'FieldsPanel',
    // eslint-disable-next-line vue/no-unused-components
    components: {
      FieldGrid: __vue_component__$H,
      FieldGroup: __vue_component__$G,
      FieldFields: __vue_component__$I
    },
    "extends": {
      // required so the fields ref is kept
      components: $fields__default["default"],
      "extends": Fields
    },
    inject: {
      Config: {
        "default": {
          values: {}
        }
      }
    },
    props: {
      name: {
        type: String,
        "default": 'default'
      },
      panel: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        index: 0,
        transitionIndex: 0
      };
    },
    computed: {
      fieldlist: function fieldlist() {
        var _this$panel$fields,
          _this$panel,
          _this = this;
        var fields = this.prepare((_this$panel$fields = (_this$panel = this.panel) == null ? void 0 : _this$panel.fields) != null ? _this$panel$fields : {});
        fields.forEach(function (field) {
          if (field.fields) {
            fields = [].concat(fields, _this.prepare(field.fields));
          }
        });
        return fields;
      },
      fieldset: function fieldset() {
        var _this$panel2 = this.panel,
          _this$panel2$fieldset = _this$panel2.fieldset,
          fieldset = _this$panel2$fieldset === void 0 ? {} : _this$panel2$fieldset,
          fields = _this$panel2.fields;
        return fieldset[this.name] || {
          fields: fields
        };
      }
    },
    watch: {
      index: function index(_index, prev) {
        this.transitionIndex = prev;
      }
    },
    created: function created() {
      // hide panel heading
      this.panel.heading = this.fieldset.type !== 'tabs';
    },
    methods: {
      get: get$1,
      merge: _merge,
      prepare: function prepare(config, prefix) {
        var _this2 = this;
        if (config === void 0) {
          config = this.config;
        }
        if (prefix === void 0) {
          prefix = this.prefix;
        }
        var arr = uikitUtil.isArray(config);
        return _prepare.call(this, Object.keys(config).map(function (key) {
          var field = config[key];

          // if string, get field from panel?
          if (uikitUtil.isString(field)) {
            if (!(field in _this2.panel.fields)) {
              return;
            }
            field = uikitUtil.assign({
              name: field
            }, _this2.panel.fields[field]);
          } else {
            field = uikitUtil.assign({}, field);
          }

          // set name from key or label?
          if (!field.name && !arr) {
            field.name = key;
          } else if (!field.name && field.label) {
            field.name = field.label;
          }
          return field;
        }).filter(function (field) {
          return field;
        }), prefix);
      },
      tabStyle: function tabStyle(index) {
        return {
          width: '100%',
          left: index < this.index ? '-100%' : index === this.index ? '0' : '100%',
          visibility: uikitUtil.includes([this.index, this.transitionIndex], index) ? 'visible' : 'hidden'
        };
      }
    }
  };

  /* script */
  var __vue_script__$F = script$F;

  /* template */
  var __vue_render__$B = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.fieldset.type === 'tabs' ? _c('div', [_c('div', {
      staticClass: "uk-grid uk-grid-small uk-flex-middle yo-sidebar-tabs"
    }, [_c('div', {
      staticClass: "uk-width-expand"
    }, [_c('h2', {
      staticClass: "yo-sidebar-heading"
    }, [_vm._v(_vm._s(_vm.$t(_vm.panel.title)))])]), _vm._v(" "), _c('div', {
      staticClass: "uk-width-auto"
    }, [_c('ul', {
      staticClass: "uk-subnav"
    }, _vm._l(_vm.fieldset.fields, function (ref, i) {
      var title = ref.title;
      return _c('li', {
        key: i,
        "class": {
          'uk-active': _vm.index === i
        }
      }, [_c('a', {
        attrs: {
          "href": ""
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            _vm.index = i;
          }
        }
      }, [_vm._v(_vm._s(_vm.$t(title)))])]);
    }), 0)])]), _vm._v(" "), _c('div', {
      staticClass: "yo-sidebar-tabs-content"
    }, _vm._l(_vm.fieldset.fields, function (fields, i) {
      return _c('FieldFields', {
        key: i,
        staticClass: "yo-sidebar-tabs-section",
        style: _vm.tabStyle(i),
        attrs: {
          "field": fields
        },
        nativeOn: {
          "transitionend": function transitionend($event) {
            if ($event.target !== $event.currentTarget) {
              return null;
            }
            _vm.transitionIndex = _vm.index;
          }
        }
      });
    }), 1)]) : _c('FieldFields', {
      attrs: {
        "field": _vm.fieldset
      }
    });
  };
  var __vue_staticRenderFns__$B = [];

  /* style */
  var __vue_inject_styles__$F = undefined;
  /* scoped */
  var __vue_scope_id__$F = undefined;
  /* module identifier */
  var __vue_module_identifier__$F = undefined;
  /* functional template */
  var __vue_is_functional_template__$F = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$F = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$B,
    staticRenderFns: __vue_staticRenderFns__$B
  }, __vue_inject_styles__$F, __vue_script__$F, __vue_scope_id__$F, __vue_is_functional_template__$F, __vue_module_identifier__$F, false, undefined, undefined, undefined);

  var script$E = {
    name: 'ModalForm',
    components: {
      FieldsPanel: __vue_component__$F
    },
    provide: function provide() {
      return {
        ModalForm: this
      };
    },
    props: {
      panel: {
        type: Object,
        required: true
      },
      values: {
        type: Object,
        required: true
      }
    },
    data: function data() {
      return {
        draft: {},
        error: '',
        loading: false
      };
    },
    computed: {
      dirty: function dirty() {
        return JSON.stringify(this.values) !== JSON.stringify(this.draft);
      }
    },
    watch: {
      draft: {
        handler: function handler() {
          this.error = '';
        },
        deep: true
      }
    },
    events: {
      'yooessentials-prerequest': function yooessentialsPrerequest(e) {
        var _e$params, _e$params$;
        if (!((_e$params = e.params) != null && (_e$params$ = _e$params[0]) != null && _e$params$['form'])) {
          e.params[0]['form'] = this.draft;
        }
      },
      'yooessentials-resolve-field-argument': function yooessentialsResolveFieldArgument(e, params) {
        var values = this.draft;
        var regex = new RegExp('#__{values.(.*)}');
        for (var key in params) {
          var param = params[key];
          var matched = uikitUtil.isString(param) && param.match(regex);
          if (matched) {
            var _values$matched$;
            params[key] = param.replace(regex, (_values$matched$ = values[matched[1]]) != null ? _values$matched$ : '');
          }
        }
      }
    },
    created: function created() {
      this.draft = deepCopy(this.values);
    },
    methods: {
      save: function save() {
        var _this = this;
        return new Promise(function (resolve, reject) {
          var _this$panel, _this$panel$endpoints;
          var endpoint = (_this$panel = _this.panel) == null ? void 0 : (_this$panel$endpoints = _this$panel.endpoints) == null ? void 0 : _this$panel$endpoints.presave;
          if (!endpoint) {
            resolve(_this.draft);
            return;
          }
          _this.loading = true;
          yooessRequest(endpoint, {
            form: _this.draft
          }).then(function (res) {
            var data = uikitUtil.isObject(res.body) ? res.body : {};
            resolve(_extends({}, _this.draft, data));
          })["catch"](reject);
        }).then(function (values) {
          _this.loading = false;
          _this.$emit('resolve', values);
        })["catch"](function (response) {
          _this.loading = false;
          _this.error = "Ups, there was an error: " + response.statusText;
        });
      }
    }
  };

  /* script */
  var __vue_script__$E = script$E;

  /* template */
  var __vue_render__$A = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('form', {
      on: {
        "submit": function submit($event) {
          $event.preventDefault();
          return _vm.save.apply(null, arguments);
        }
      }
    }, [_vm._t("header", function () {
      return [_c('div', {
        staticClass: "uk-modal-header uk-flex uk-flex-middle uk-flex-between"
      }, [_vm.panel.title || _vm.panel.description ? _c('div', {
        staticClass: "uk-margin-large-right uk-flex-1"
      }, [_vm.panel.title ? _c('h3', {
        staticClass: "uk-margin-remove"
      }, [_vm._v(_vm._s(_vm.$t(_vm.panel.title)))]) : _vm._e(), _vm._v(" "), _vm.panel.description ? _c('div', {
        staticClass: "uk-margin-small-top"
      }, [_vm._v("\n                    " + _vm._s(_vm.$t(_vm.panel.description)) + "\n                    "), _vm.panel.docs ? _c('span', [_vm._v("\n                        Review the "), _c('a', {
        attrs: {
          "href": _vm.panel.docs,
          "target": "_blank"
        }
      }, [_vm._v("Documentation Guide")]), _vm._v(" for tips and best practices.\n                    ")]) : _vm._e()]) : _vm._e()]) : _vm._e(), _vm._v(" "), _vm.panel.icon ? _c('div', {
        staticClass: "uk-flex-middle uk-text-lead"
      }, [_c('img', {
        attrs: {
          "src": _vm.panel.icon,
          "uk-svg": "",
          "width": "60",
          "height": "60"
        }
      })]) : _vm._e()])];
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-modal-body"
    }, [_vm._t("prefields"), _vm._v(" "), _vm._t("panel", function () {
      return [_c('FieldsPanel', {
        attrs: {
          "panel": _vm.panel,
          "values": _vm.draft
        }
      })];
    }, {
      "draft": _vm.draft
    })], 2), _vm._v(" "), _c('div', {
      staticClass: "uk-modal-footer uk-flex uk-flex-middle uk-flex-between"
    }, [_vm.loading ? _c('span', {
      attrs: {
        "uk-spinner": ""
      }
    }) : _c('div', {
      staticClass: "uk-text-danger"
    }, [_vm._v(_vm._s(_vm.error))]), _vm._v(" "), _c('div', {
      staticClass: "uk-text-nowrap",
      "class": {
        'uk-disabled': _vm.loading
      }
    }, [_c('button', {
      staticClass: "uk-button uk-button-text uk-modal-close uk-margin-small-right",
      attrs: {
        "type": "button"
      }
    }, [_vm._v(_vm._s(_vm.$t('Cancel')))]), _vm._v(" "), _c('button', {
      "class": "uk-button uk-button-" + (_vm.error ? 'danger' : 'primary')
    }, [_vm._v(_vm._s(_vm.$t('Save')))])])])], 2);
  };
  var __vue_staticRenderFns__$A = [];

  /* style */
  var __vue_inject_styles__$E = undefined;
  /* scoped */
  var __vue_scope_id__$E = undefined;
  /* module identifier */
  var __vue_module_identifier__$E = undefined;
  /* functional template */
  var __vue_is_functional_template__$E = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$E = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$A,
    staticRenderFns: __vue_staticRenderFns__$A
  }, __vue_inject_styles__$E, __vue_script__$E, __vue_scope_id__$E, __vue_is_functional_template__$E, __vue_module_identifier__$E, false, undefined, undefined, undefined);

  //
  var script$D = {
    name: 'ModalFormTabs',
    props: {
      tabs: {
        type: Array,
        required: true
      },
      storage: String,
      active: {
        type: Number,
        "default": function _default() {
          return this.storage && parseInt(storage[this.storage], 10) || 0;
        }
      }
    },
    data: function data() {
      return {
        shown: []
      };
    },
    methods: {
      selectTab: function selectTab(tab, i) {
        var _this = this;
        if (this.storage) {
          storage[this.storage] = i;
        }
        this.shown.splice(this.shown.length, 0, i);
        this.$emit('show', tab, i);
        this.$nextTick(function () {
          var el = _this.$el.querySelector(".uk-switcher li:nth-child(" + (i + 1) + ") [autofocus]");
          el == null ? void 0 : el.focus();
        });
      }
    }
  };

  /* script */
  var __vue_script__$D = script$D;

  /* template */
  var __vue_render__$z = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "uk-flex uk-flex-middle uk-flex-right uk-margin-right uk-padding uk-padding-remove-bottom"
    }, [_c('ul', {
      staticClass: "uk-subnav uk-margin-remove-bottom",
      attrs: {
        "active": _vm.active,
        "uk-switcher": "connect: !* +; animation: uk-animation-fade"
      }
    }, _vm._l(_vm.tabs, function (tab) {
      return _c('li', {
        key: tab
      }, [_c('a', {
        attrs: {
          "href": ""
        }
      }, [_vm._v(_vm._s(_vm.$t(tab)))])]);
    }), 0)]), _vm._v(" "), _c('ul', {
      staticClass: "uk-switcher"
    }, _vm._l(_vm.tabs, function (tab, i) {
      return _c('li', {
        key: tab,
        on: {
          "beforeshow": function beforeshow($event) {
            if ($event.target !== $event.currentTarget) {
              return null;
            }
            return _vm.selectTab(tab, i);
          }
        }
      }, [~_vm.shown.indexOf(i) ? _vm._t(tab) : _vm._e()], 2);
    }), 0)]);
  };
  var __vue_staticRenderFns__$z = [];

  /* style */
  var __vue_inject_styles__$D = undefined;
  /* scoped */
  var __vue_scope_id__$D = undefined;
  /* module identifier */
  var __vue_module_identifier__$D = undefined;
  /* functional template */
  var __vue_is_functional_template__$D = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$D = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$z,
    staticRenderFns: __vue_staticRenderFns__$z
  }, __vue_inject_styles__$D, __vue_script__$D, __vue_scope_id__$D, __vue_is_functional_template__$D, __vue_module_identifier__$D, false, undefined, undefined, undefined);

  var script$C = {
    inject: ['Builder'],
    props: {
      node: {
        type: Object,
        required: true
      },
      editable: {
        type: Boolean,
        "default": true
      },
      copyable: {
        type: Boolean,
        "default": true
      },
      removable: {
        type: Boolean,
        "default": true
      },
      status: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      icon: String,
      title: String,
      uikitIcon: String
    },
    computed: {
      type: function type() {
        return {}; // fake for compatibility with the Builder
      },
      children: function children() {
        return this.node.children || [];
      },
      statusIcons: function statusIcons() {
        var statuses = [].concat(this.status, this.$trigger('statusNode', [this.node]));
        statuses = (statuses || []).map(function (status) {
          return status.component ? status : _extends({}, status, {
            component: {
              functional: true,
              name: uikitUtil.camelize(status.title).replace(/ /g, ''),
              render: function render(h) {
                return h('span', {
                  attrs: {
                    title: status.title
                  },
                  "class": status.classNames
                });
              }
            }
          });
        });
        return uikitUtil.isEmpty(statuses) ? null : statuses;
      },
      statusError: function statusError() {
        var _this$statusIcons;
        return (_this$statusIcons = this.statusIcons) == null ? void 0 : _this$statusIcons.some(function (_ref) {
          var error = _ref.error;
          return error;
        });
      },
      isDisabled: function isDisabled() {
        return get$1(this.node, 'props.status') === 'disabled';
      }
    }
  };

  /* script */
  var __vue_script__$C = script$C;

  /* template */
  function objectWithoutProperties$1(obj, exclude) {
    var target = {};
    for (var k in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) target[k] = obj[k];
    }
    return target;
  }
  var __vue_render__$y = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('li', {
      staticClass: "uk-visible-toggle",
      attrs: {
        "tabindex": "-1"
      }
    }, [_c('a', {
      staticClass: "uk-text-truncate",
      "class": {
        'uk-disabled': !_vm.editable
      },
      attrs: {
        "href": ""
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('edit');
        }
      }
    }, [_vm.statusError && _vm.statusIcons && _vm.statusIcons.length ? _c('ul', {
      staticClass: "uk-grid uk-grid-collapse uk-flex-inline uk-text-bottom"
    }, _vm._l(_vm.statusIcons, function (ref) {
      var component = ref.component;
      var rest = objectWithoutProperties$1(ref, ["component"]);
      var props = rest;
      return _c('li', {
        key: component.name
      }, [_c(component, _vm._b({
        tag: "component",
        attrs: {
          "node": _vm._self
        }
      }, 'component', props, false))], 1);
    }), 0) : _vm.icon ? _c('img', {
      staticClass: "uk-svg uk-margin-small-right",
      attrs: {
        "alt": _vm.$t(_vm.title),
        "src": _vm.icon,
        "width": "20",
        "height": "20",
        "uk-svg": ""
      }
    }) : _vm.uikitIcon ? _c('span', {
      staticClass: "uk-margin-small-right",
      attrs: {
        "uk-icon": _vm.uikitIcon
      }
    }) : _vm._e(), _vm._v(" "), _c('span', {
      "class": ['uk-text-middle', {
        'uk-text-danger': _vm.statusError
      }]
    }, [_vm._v(_vm._s(_vm.$t(_vm.title || 'Item')))]), _vm._v(" "), _vm.$slots.meta ? _c('span', {
      staticClass: "uk-text-middle uk-text-meta"
    }, [_vm._t("meta")], 2) : _vm._e()]), _vm._v(" "), _c('div', {
      staticClass: "uk-invisible-hover uk-position-center-right uk-position-medium"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_vm.copyable ? _c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "href": "",
        "title": _vm.$t('Copy'),
        "uk-icon": "copy",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('copy');
        }
      }
    })]) : _vm._e(), _vm._v(" "), _vm.removable ? _c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "href": "",
        "title": _vm.$t('Delete'),
        "uk-icon": "trash",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('remove');
        }
      }
    })]) : _vm._e()])])]);
  };
  var __vue_staticRenderFns__$y = [];

  /* style */
  var __vue_inject_styles__$C = undefined;
  /* scoped */
  var __vue_scope_id__$C = undefined;
  /* module identifier */
  var __vue_module_identifier__$C = undefined;
  /* functional template */
  var __vue_is_functional_template__$C = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$C = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$y,
    staticRenderFns: __vue_staticRenderFns__$y
  }, __vue_inject_styles__$C, __vue_script__$C, __vue_scope_id__$C, __vue_is_functional_template__$C, __vue_module_identifier__$C, false, undefined, undefined, undefined);

  var script$B = {
    name: 'DynamicPanel',
    "extends": __vue_component__$F,
    provide: function provide() {
      return {
        $node: this.node
      };
    },
    props: {
      node: Object
    },
    events: {
      'yooessentials-prerequest': function yooessentialsPrerequest(e) {
        var _e$params, _e$params$;
        if (!((_e$params = e.params) != null && (_e$params$ = _e$params[0]) != null && _e$params$['form'])) {
          e.params[0]['form'] = this.values;
        }
        e.params[0]['node'] = this.node;
      }
    },
    methods: {
      prepare: function prepare(config) {
        var _this = this;
        return __vue_component__$F.methods.prepare.call(this, config).map(function (field) {
          _this.$trigger('yooessentialsBuilderPrepareField', {
            node: _this.node,
            field: field
          });
          return field;
        });
      }
    }
  };

  /* script */
  var __vue_script__$B = script$B;

  /* template */

  /* style */
  var __vue_inject_styles__$B = undefined;
  /* scoped */
  var __vue_scope_id__$B = undefined;
  /* module identifier */
  var __vue_module_identifier__$B = undefined;
  /* functional template */
  var __vue_is_functional_template__$B = undefined;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$B = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$B, __vue_script__$B, __vue_scope_id__$B, __vue_is_functional_template__$B, __vue_module_identifier__$B, false, undefined, undefined, undefined);

  var script$A = {
    name: 'BuilderPanel',
    "extends": __vue_component__$F,
    provide: function provide() {
      return {
        $node: this.node,
        Builder: this.builder
      };
    },
    props: {
      node: Object,
      builder: Object
    },
    created: function created() {
      var _this = this;
      if (this.node.type === 'row') {
        // update column widths from row 'layout' preset
        this.$on('change', function (value, _ref) {
          var name = _ref.name;
          if (name === 'layout') {
            _this.$nextTick(function () {
              return _this.builder.columnWidths(_this.node, value);
            });
          }
        });
      }
    },
    events: {
      resetNode: function resetNode() {
        this.$trigger('closePanel');
      }
    }
  };

  /* script */
  var __vue_script__$A = script$A;

  /* template */

  /* style */
  var __vue_inject_styles__$A = undefined;
  /* scoped */
  var __vue_scope_id__$A = undefined;
  /* module identifier */
  var __vue_module_identifier__$A = undefined;
  /* functional template */
  var __vue_is_functional_template__$A = undefined;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$A = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$A, __vue_script__$A, __vue_scope_id__$A, __vue_is_functional_template__$A, __vue_module_identifier__$A, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //

  var script$z = {
    name: 'NodeStatus',
    props: {
      node: Object,
      error: String,
      icon: String
    },
    computed: {
      position: function position() {
        var _this$node, _this$node$type;
        var positions = {
          section: 'top',
          row: 'left'
        };
        return positions[(_this$node = this.node) == null ? void 0 : (_this$node$type = _this$node.type) == null ? void 0 : _this$node$type.name] || 'bottom';
      }
    }
  };

  /* script */
  var __vue_script__$z = script$z;

  /* template */
  var __vue_render__$x = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('span', {
      staticClass: "ye-builder-icon-error",
      attrs: {
        "title": _vm.$t(_vm.error),
        "uk-tooltip": "pos: " + _vm.position
      }
    });
  };
  var __vue_staticRenderFns__$x = [];

  /* style */
  var __vue_inject_styles__$z = undefined;
  /* scoped */
  var __vue_scope_id__$z = undefined;
  /* module identifier */
  var __vue_module_identifier__$z = undefined;
  /* functional template */
  var __vue_is_functional_template__$z = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$z = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$x,
    staticRenderFns: __vue_staticRenderFns__$x
  }, __vue_inject_styles__$z, __vue_script__$z, __vue_scope_id__$z, __vue_is_functional_template__$z, __vue_module_identifier__$z, false, undefined, undefined, undefined);

  var script$y = {
    name: 'ItemsFinderModal',
    components: {
      Finder: __vue_component__$M
    },
    props: {
      items: {
        type: Array,
        require: true
      }
    },
    data: function data() {
      return {
        filter: {
          search: ''
        }
      };
    },
    computed: {
      list: function list() {
        var _this = this;
        return this.items.filter(function (_ref) {
          var id = _ref.id,
            name = _ref.name,
            group = _ref.group;
          var value = [id, name, group].map(function (v) {
            return v == null ? void 0 : v.toString().toLowerCase();
          }).join(' ');
          return !_this.filter.search || ~value.indexOf(_this.filter.search.toLowerCase());
        }).map(function (item) {
          return _extends({
            group: 'custom'
          }, item);
        });
      },
      groups: function groups() {
        var groups = groupBy(this.list, 'group');
        for (var group in groups) {
          if (groups[group].length) {
            groups[group] = groups[group].sort(function (a, b) {
              var _a$name;
              return a == null ? void 0 : (_a$name = a.name) == null ? void 0 : _a$name.localeCompare(b.name);
            });
          }
        }
        return groups;
      },
      groupsTotal: function groupsTotal() {
        return Object.keys(this.groups).length;
      }
    }
  };

  /* script */
  var __vue_script__$y = script$y;

  /* template */
  var __vue_render__$w = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-modal-body"
    }, [_c('Finder', {
      attrs: {
        "items": _vm.items,
        "total": _vm.items.length,
        "filter": _vm.filter
      },
      on: {
        "update:filter": function updateFilter($event) {
          _vm.filter = $event;
        }
      },
      scopedSlots: _vm._u([_vm.list.length ? {
        key: "items",
        fn: function fn() {
          return _vm._l(_vm.groups, function ($items, group) {
            return _c('div', {
              key: group,
              staticClass: "uk-margin-medium"
            }, [_vm.groupsTotal > 1 ? _c('h3', {
              staticClass: "uk-heading-divider uk-margin-small"
            }, [_vm._v(_vm._s(group))]) : _vm._e(), _vm._v(" "), _c('div', {
              staticClass: "uk-grid-collapse uk-child-width uk-child-width-1-2 uk-child-width-1-4@s uk-child-width-1-5@m",
              attrs: {
                "uk-grid": "",
                "uk-height-match": "target: > div > .uk-card"
              }
            }, _vm._l($items, function (item) {
              return _c('div', {
                key: item.name,
                attrs: {
                  "title": item.description,
                  "uk-tooltip": "pos: bottom; delay: 300"
                }
              }, [_c('div', {
                staticClass: "uk-card uk-card-body uk-card-hover yo-panel uk-text-center"
              }, [item.icon ? _c('img', {
                attrs: {
                  "alt": item.title,
                  "src": item.icon,
                  "uk-svg": "",
                  "width": "40",
                  "height": "40"
                }
              }) : _vm._e(), _vm._v(" "), _c('p', {
                staticClass: "uk-margin-small-top uk-margin-remove-bottom uk-text-wrap"
              }, [_vm._v(_vm._s(item.title))]), _vm._v(" "), _c('a', {
                staticClass: "uk-position-cover",
                attrs: {
                  "href": ""
                },
                on: {
                  "click": function click($event) {
                    $event.preventDefault();
                    return _vm.$emit('resolve', item);
                  }
                }
              })])]);
            }), 0)]);
          });
        },
        proxy: true
      } : null], null, true)
    })], 1);
  };
  var __vue_staticRenderFns__$w = [];

  /* style */
  var __vue_inject_styles__$y = undefined;
  /* scoped */
  var __vue_scope_id__$y = undefined;
  /* module identifier */
  var __vue_module_identifier__$y = undefined;
  /* functional template */
  var __vue_is_functional_template__$y = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$y = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$w,
    staticRenderFns: __vue_staticRenderFns__$w
  }, __vue_inject_styles__$y, __vue_script__$y, __vue_scope_id__$y, __vue_is_functional_template__$y, __vue_module_identifier__$y, false, undefined, undefined, undefined);

  var script$x = {
    name: 'DropdownList',
    props: {
      entries: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      selected: {
        type: String
      },
      maxHeight: {
        type: String,
        "default": 'medium'
      }
    },
    data: function data() {
      return {
        search: ''
      };
    },
    computed: {
      entriesList: function entriesList() {
        return this.entries;
      },
      groups: function groups() {
        return groupBy(this.entriesList.map(function (entry) {
          return _extends({
            group: ''
          }, entry);
        }), 'group');
      }
    },
    methods: {
      isFirstGroup: function isFirstGroup(group) {
        return Object.keys(this.groups).indexOf(group) === 0;
      },
      prepareMeta: function prepareMeta(meta) {
        return !uikitUtil.isObject(meta) ? [{
          value: meta
        }] : Object.keys(meta).map(function (text) {
          return {
            text: text,
            value: meta[text]
          };
        });
      }
    }
  };

  /* script */
  var __vue_script__$x = script$x;

  /* template */
  var __vue_render__$v = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "yo-dropdown-header"
    }, [_c('div', {
      staticClass: "uk-flex uk-flex-middle"
    }, [_c('div', {
      staticClass: "uk-search uk-search-default uk-flex-1 uk-margin-large-right"
    }, [_c('input', {
      ref: "search",
      staticClass: "uk-search-input",
      attrs: {
        "placeholder": _vm.$t('Search'),
        "type": "search",
        "autofocus": ""
      },
      domProps: {
        "value": _vm.search
      },
      on: {
        "input": function input(e) {
          return _vm.$emit('search', e.target.value);
        }
      }
    })]), _vm._v(" "), _vm._t("nav")], 2)]), _vm._v(" "), _c('div', {
      "class": ['yo-dropdown-body uk-overflow-auto', "uk-height-max-" + _vm.maxHeight]
    }, [_vm.entriesList.length ? _c('ul', {
      staticClass: "uk-nav uk-dropdown-nav"
    }, [_vm._l(_vm.groups, function (group, label) {
      return [!_vm.isFirstGroup(label) ? _c('li', {
        key: label + "-divider",
        staticClass: "uk-nav-divider"
      }) : _vm._e(), _vm._v(" "), label ? _c('li', {
        key: label + "-label",
        staticClass: "uk-nav-header"
      }, [_vm._v(_vm._s(label))]) : _vm._e(), _vm._v(" "), _vm._l(group, function (entry) {
        return _vm._t("entry", function () {
          return [_c('li', {
            key: entry.value,
            "class": {
              'uk-active': entry.value === _vm.selected
            },
            on: {
              "click": function click($event) {
                $event.preventDefault();
                return _vm.$emit('resolve', entry);
              }
            }
          }, [_c('a', {
            staticClass: "uk-display-block",
            attrs: {
              "href": ""
            }
          }, [_c('div', {
            staticClass: "uk-text-nowrap uk-text-truncate"
          }, [_vm._v(_vm._s(entry.text))]), _vm._v(" "), entry.meta ? _c('div', {
            staticClass: "uk-text-meta uk-text-truncate"
          }, _vm._l(_vm.prepareMeta(entry.meta), function (meta) {
            return _c('span', {
              key: meta.value,
              staticClass: "uk-margin-small-right"
            }, [meta.text ? _c('b', [_vm._v(_vm._s(meta.text))]) : _vm._e(), _vm._v(" "), _c('span', [_vm._v(_vm._s(meta.value))])]);
          }), 0) : _vm._e()])])];
        }, {
          "entry": entry
        });
      })];
    })], 2) : _c('span', [_vm._v(_vm._s(_vm.$t('No entries found.')))])])]);
  };
  var __vue_staticRenderFns__$v = [];

  /* style */
  var __vue_inject_styles__$x = undefined;
  /* scoped */
  var __vue_scope_id__$x = undefined;
  /* module identifier */
  var __vue_module_identifier__$x = undefined;
  /* functional template */
  var __vue_is_functional_template__$x = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$x = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$v,
    staticRenderFns: __vue_staticRenderFns__$v
  }, __vue_inject_styles__$x, __vue_script__$x, __vue_scope_id__$x, __vue_is_functional_template__$x, __vue_module_identifier__$x, false, undefined, undefined, undefined);

  var script$w = {
    name: 'DropdownList',
    "extends": __vue_component__$x,
    computed: {
      entriesList: function entriesList() {
        var _this = this;
        return this.entries.filter(function (_ref) {
          var text = _ref.text;
          return !_this.search || uikitUtil.includes(text.toLowerCase(), _this.search.toLowerCase());
        });
      }
    },
    created: function created() {
      var _this2 = this;
      this.$on('search', function (val) {
        return _this2.search = val;
      });
    }
  };

  /* script */
  var __vue_script__$w = script$w;

  /* template */

  /* style */
  var __vue_inject_styles__$w = undefined;
  /* scoped */
  var __vue_scope_id__$w = undefined;
  /* module identifier */
  var __vue_module_identifier__$w = undefined;
  /* functional template */
  var __vue_is_functional_template__$w = undefined;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$w = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$w, __vue_script__$w, __vue_scope_id__$w, __vue_is_functional_template__$w, __vue_module_identifier__$w, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$v = {
    name: 'OptionsDropdownView',
    props: {
      searchable: {
        type: Boolean,
        "default": true
      },
      loading: {
        type: Boolean,
        "default": false
      },
      items: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      message: {
        type: String,
        "default": ''
      },
      search: {
        type: String,
        "default": ''
      },
      dropMaxSize: {
        type: String,
        "default": 'small'
      }
    }
  };

  /* script */
  var __vue_script__$v = script$v;

  /* template */
  var __vue_render__$u = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_vm.searchable ? _c('div', {
      staticClass: "yo-dropdown-header"
    }, [_c('div', {
      staticClass: "uk-search uk-search-default uk-width-1-1"
    }, [_vm.loading ? _c('span', {
      key: "spinner",
      staticClass: "uk-position-absolute uk-position-center-right uk-margin-small-right",
      attrs: {
        "uk-spinner": "ratio: 0.5"
      }
    }) : _c('span', {
      key: "search",
      staticClass: "uk-search-icon-flip",
      attrs: {
        "uk-search-icon": ""
      }
    }), _vm._v(" "), _c('input', {
      ref: "search",
      staticClass: "uk-search-input",
      attrs: {
        "autofocus": "",
        "placeholder": _vm.$t('Search'),
        "type": "search"
      },
      domProps: {
        "value": _vm.search
      },
      on: {
        "input": function input($event) {
          return _vm.$emit('update:search', $event.target.value);
        }
      }
    })])]) : _vm._e(), _vm._v(" "), _vm.items.length ? _c('div', {
      staticClass: "yo-dropdown-body uk-overflow-auto",
      "class": "uk-height-max-" + _vm.dropMaxSize
    }, [_c('ul', {
      staticClass: "uk-nav uk-dropdown-nav"
    }, _vm._l(_vm.items, function (item) {
      return _c('li', {
        key: item.id,
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.$emit('resolve', item.id);
          }
        }
      }, [_c('a', {
        staticClass: "uk-overflow-auto",
        attrs: {
          "href": ""
        }
      }, [item.icon ? _c('img', {
        staticClass: "uk-margin-small-right",
        attrs: {
          "alt": item.name,
          "src": item.icon,
          "uk-svg": "",
          "width": "20",
          "height": "20"
        }
      }) : _vm._e(), _vm._v(" "), _c('span', {
        staticClass: "uk-text-middle"
      }, [_vm._v(_vm._s(item.id))]), _vm._v(" "), item.name ? _c('span', {
        staticClass: "uk-text-middle uk-text-meta uk-margin-small-left"
      }, [_vm._v(_vm._s(item.name))]) : _vm._e(), _vm._v(" "), item.meta ? _c('div', {
        staticClass: "uk-text-middle uk-text-meta uk-margin-small-left"
      }, [_vm._v(_vm._s(item.meta))]) : _vm._e()])]);
    }), 0), _vm._v(" "), _vm._t("postitems")], 2) : !_vm.loading ? _c('div', {
      staticClass: "yo-dropdown-body"
    }, [_vm._t("empty")], 2) : _vm._e()]);
  };
  var __vue_staticRenderFns__$u = [];

  /* style */
  var __vue_inject_styles__$v = undefined;
  /* scoped */
  var __vue_scope_id__$v = undefined;
  /* module identifier */
  var __vue_module_identifier__$v = undefined;
  /* functional template */
  var __vue_is_functional_template__$v = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$v = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$u,
    staticRenderFns: __vue_staticRenderFns__$u
  }, __vue_inject_styles__$v, __vue_script__$v, __vue_scope_id__$v, __vue_is_functional_template__$v, __vue_module_identifier__$v, false, undefined, undefined, undefined);

  //
  var script$u = {
    name: 'OptionsDropdown',
    components: {
      OptionsDropdownView: __vue_component__$v
    },
    props: {
      searchable: {
        type: Boolean,
        "default": true
      },
      items: {
        type: Array,
        "default": function _default() {
          return [];
        }
      },
      dropMaxSize: __vue_component__$v.props.dropMaxSize
    },
    data: function data() {
      return {
        search: '',
        message: ''
      };
    },
    computed: {
      list: function list() {
        var _this = this;
        return this.items.filter(function (_ref) {
          var id = _ref.id,
            name = _ref.name;
          var value = [id, name].map(function (v) {
            return v == null ? void 0 : v.toString().toLowerCase();
          }).join(' ');
          return !_this.search || ~value.indexOf(_this.search.toLowerCase());
        });
      }
    },
    watch: {
      list: function list(items) {
        this.message = '';
        if (!items.length) {
          this.message = 'Not Found.';
        }
      }
    }
  };

  /* script */
  var __vue_script__$u = script$u;

  /* template */
  var __vue_render__$t = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('OptionsDropdownView', {
      attrs: {
        "items": _vm.list,
        "message": _vm.message,
        "searchable": _vm.searchable,
        "search": _vm.search,
        "drop-max-size": _vm.dropMaxSize
      },
      on: {
        "update:search": function updateSearch($event) {
          _vm.search = $event;
        },
        "resolve": function resolve($event) {
          return _vm.$emit('resolve', $event);
        }
      }
    }, [_c('template', {
      slot: "empty"
    }, [_vm.message ? _c('div', [_vm._v(_vm._s(_vm.$t(_vm.message)))]) : _vm._e()])], 2);
  };
  var __vue_staticRenderFns__$t = [];

  /* style */
  var __vue_inject_styles__$u = undefined;
  /* scoped */
  var __vue_scope_id__$u = undefined;
  /* module identifier */
  var __vue_module_identifier__$u = undefined;
  /* functional template */
  var __vue_is_functional_template__$u = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$u = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$t,
    staticRenderFns: __vue_staticRenderFns__$t
  }, __vue_inject_styles__$u, __vue_script__$u, __vue_scope_id__$u, __vue_is_functional_template__$u, __vue_module_identifier__$u, false, undefined, undefined, undefined);

  var script$t = {
    name: 'OptionsDropdownAsync',
    components: {
      OptionsDropdownView: __vue_component__$v
    },
    props: {
      endpoint: {
        type: String,
        required: true
      },
      params: {
        type: Object,
        "default": function _default() {
          return {};
        }
      },
      map: {
        type: Object,
        "default": function _default() {
          return {};
        }
      },
      dropMaxSize: __vue_component__$v.props.dropMaxSize
    },
    data: function data() {
      return {
        items: [],
        total: 0,
        search: '',
        message: '',
        error: '',
        loading: false
      };
    },
    computed: {
      mapList: function mapList() {
        return _extends({
          items: 'items',
          id: 'id',
          name: 'name',
          meta: 'meta',
          total: 'total'
        }, this.map);
      },
      list: function list() {
        var _this = this;
        return this.items.filter(function (_ref) {
          var id = _ref.id,
            name = _ref.name,
            meta = _ref.meta;
          var value = [id, name, meta].map(function (v) {
            return v == null ? void 0 : v.toString().toLowerCase();
          }).join(' ');
          return !_this.search || ~value.indexOf(_this.search.toLowerCase());
        });
      }
    },
    watch: {
      search: function search(value) {
        if (this.nextPage) {
          this.fetch({
            search: value
          });
        }
      },
      list: function list(items) {
        this.message = '';
        if (!items.length) {
          this.message = 'Not Found.';
        }
      }
    },
    created: function created() {
      this.fetch();
    },
    methods: {
      fetch: function fetch(params) {
        var _this2 = this;
        if (params === void 0) {
          params = {};
        }
        return new Promise(function (resolve, reject) {
          _this2.loading = true;
          yooessRequest(_this2.endpoint, _extends({}, params, _this2.params)).then(function (_ref2) {
            var body = _ref2.body;
            _this2.loading = false;
            resolve(body);
          })["catch"](function (res) {
            _this2.error = res.statusText;
            _this2.loading = false;
          });
        }).then(function (res) {
          _this2.items = get$1(res, _this2.mapList.items, []).map(function (item) {
            return {
              id: get$1(item, _this2.mapList.id),
              name: get$1(item, _this2.mapList.name),
              meta: get$1(item, _this2.mapList.meta)
            };
          });
          _this2.total = get$1(res, _this2.mapList.total);
        });
      }
    }
  };

  /* script */
  var __vue_script__$t = script$t;

  /* template */
  var __vue_render__$s = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('OptionsDropdownView', {
      attrs: {
        "items": _vm.list,
        "message": _vm.message,
        "loading": _vm.loading,
        "search": _vm.search,
        "drop-max-size": _vm.dropMaxSize
      },
      on: {
        "update:search": function updateSearch($event) {
          _vm.search = $event;
        },
        "resolve": function resolve($event) {
          return _vm.$emit('resolve', $event);
        }
      }
    }, [_c('template', {
      slot: "empty"
    }, [_vm.error ? _c('div', {
      staticClass: "uk-text-danger"
    }, [_vm._v(_vm._s(_vm.$t(_vm.error)))]) : _vm.message ? _c('div', [_vm._v(_vm._s(_vm.$t(_vm.message)))]) : _vm._e()]), _vm._v(" "), _c('template', {
      slot: "postitems"
    }, [_vm.total > _vm.items.length ? _c('div', {
      staticClass: "uk-text-muted uk-text-center uk-margin-top"
    }, [_c('span', {
      attrs: {
        "uk-icon": "more"
      }
    }), _vm._v(" "), _c('div', [_vm._v(_vm._s(_vm.$t('Narrow down the list with a query.')))])]) : _vm._e()])], 2);
  };
  var __vue_staticRenderFns__$s = [];

  /* style */
  var __vue_inject_styles__$t = undefined;
  /* scoped */
  var __vue_scope_id__$t = undefined;
  /* module identifier */
  var __vue_module_identifier__$t = undefined;
  /* functional template */
  var __vue_is_functional_template__$t = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$t = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$s,
    staticRenderFns: __vue_staticRenderFns__$s
  }, __vue_inject_styles__$t, __vue_script__$t, __vue_scope_id__$t, __vue_is_functional_template__$t, __vue_module_identifier__$t, false, undefined, undefined, undefined);

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeCeil = Math.ceil,
    nativeMax = Math.max;

  /**
   * The base implementation of `_.range` and `_.rangeRight` which doesn't
   * coerce arguments.
   *
   * @private
   * @param {number} start The start of the range.
   * @param {number} end The end of the range.
   * @param {number} step The value to increment or decrement by.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Array} Returns the range of numbers.
   */
  function baseRange(start, end, step, fromRight) {
    var index = -1,
      length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
      result = Array(length);
    while (length--) {
      result[fromRight ? length : ++index] = start;
      start += step;
    }
    return result;
  }

  /** Used to match a single whitespace character. */
  var reWhitespace = /\s/;

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
   * character of `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the index of the last non-whitespace character.
   */
  function trimmedEndIndex(string) {
    var index = string.length;
    while (index-- && reWhitespace.test(string.charAt(index))) {}
    return index;
  }

  /** Used to match leading whitespace. */
  var reTrimStart = /^\s+/;

  /**
   * The base implementation of `_.trim`.
   *
   * @private
   * @param {string} string The string to trim.
   * @returns {string} Returns the trimmed string.
   */
  function baseTrim(string) {
    return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '') : string;
  }

  /** `Object#toString` result references. */
  var symbolTag = '[object Symbol]';

  /**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
  function isSymbol(value) {
    return typeof value == 'symbol' || isObjectLike(value) && baseGetTag(value) == symbolTag;
  }

  /** Used as references for various `Number` constants. */
  var NAN = 0 / 0;

  /** Used to detect bad signed hexadecimal string values. */
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

  /** Used to detect binary string values. */
  var reIsBinary = /^0b[01]+$/i;

  /** Used to detect octal string values. */
  var reIsOctal = /^0o[0-7]+$/i;

  /** Built-in method references without a dependency on `root`. */
  var freeParseInt = parseInt;

  /**
   * Converts `value` to a number.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {number} Returns the number.
   * @example
   *
   * _.toNumber(3.2);
   * // => 3.2
   *
   * _.toNumber(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toNumber(Infinity);
   * // => Infinity
   *
   * _.toNumber('3.2');
   * // => 3.2
   */
  function toNumber(value) {
    if (typeof value == 'number') {
      return value;
    }
    if (isSymbol(value)) {
      return NAN;
    }
    if (isObject$1(value)) {
      var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
      value = isObject$1(other) ? other + '' : other;
    }
    if (typeof value != 'string') {
      return value === 0 ? value : +value;
    }
    value = baseTrim(value);
    var isBinary = reIsBinary.test(value);
    return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
  }

  /** Used as references for various `Number` constants. */
  var INFINITY = 1 / 0,
    MAX_INTEGER = 1.7976931348623157e+308;

  /**
   * Converts `value` to a finite number.
   *
   * @static
   * @memberOf _
   * @since 4.12.0
   * @category Lang
   * @param {*} value The value to convert.
   * @returns {number} Returns the converted number.
   * @example
   *
   * _.toFinite(3.2);
   * // => 3.2
   *
   * _.toFinite(Number.MIN_VALUE);
   * // => 5e-324
   *
   * _.toFinite(Infinity);
   * // => 1.7976931348623157e+308
   *
   * _.toFinite('3.2');
   * // => 3.2
   */
  function toFinite(value) {
    if (!value) {
      return value === 0 ? value : 0;
    }
    value = toNumber(value);
    if (value === INFINITY || value === -INFINITY) {
      var sign = value < 0 ? -1 : 1;
      return sign * MAX_INTEGER;
    }
    return value === value ? value : 0;
  }

  /**
   * Creates a `_.range` or `_.rangeRight` function.
   *
   * @private
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new range function.
   */
  function createRange(fromRight) {
    return function (start, end, step) {
      if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
        end = step = undefined;
      }
      // Ensure the sign of `-0` is preserved.
      start = toFinite(start);
      if (end === undefined) {
        end = start;
        start = 0;
      } else {
        end = toFinite(end);
      }
      step = step === undefined ? start < end ? 1 : -1 : toFinite(step);
      return baseRange(start, end, step, fromRight);
    };
  }

  /**
   * Creates an array of numbers (positive and/or negative) progressing from
   * `start` up to, but not including, `end`. A step of `-1` is used if a negative
   * `start` is specified without an `end` or `step`. If `end` is not specified,
   * it's set to `start` with `start` then set to `0`.
   *
   * **Note:** JavaScript follows the IEEE-754 standard for resolving
   * floating-point values which can produce unexpected results.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Util
   * @param {number} [start=0] The start of the range.
   * @param {number} end The end of the range.
   * @param {number} [step=1] The value to increment or decrement by.
   * @returns {Array} Returns the range of numbers.
   * @see _.inRange, _.rangeRight
   * @example
   *
   * _.range(4);
   * // => [0, 1, 2, 3]
   *
   * _.range(-4);
   * // => [0, -1, -2, -3]
   *
   * _.range(1, 5);
   * // => [1, 2, 3, 4]
   *
   * _.range(0, 20, 5);
   * // => [0, 5, 10, 15]
   *
   * _.range(0, -4, -1);
   * // => [0, -1, -2, -3]
   *
   * _.range(1, 4, 0);
   * // => [1, 1, 1]
   *
   * _.range(0);
   * // => []
   */
  var range = createRange();
  var _range = range;

  function toInteger$1(dirtyNumber) {
    if (dirtyNumber === null || dirtyNumber === true || dirtyNumber === false) {
      return NaN;
    }
    var number = Number(dirtyNumber);
    if (isNaN(number)) {
      return number;
    }
    return number < 0 ? Math.ceil(number) : Math.floor(number);
  }

  function requiredArgs(required, args) {
    if (args.length < required) {
      throw new TypeError(required + ' argument' + (required > 1 ? 's' : '') + ' required, but only ' + args.length + ' present');
    }
  }

  /**
   * @name toDate
   * @category Common Helpers
   * @summary Convert the given argument to an instance of Date.
   *
   * @description
   * Convert the given argument to an instance of Date.
   *
   * If the argument is an instance of Date, the function returns its clone.
   *
   * If the argument is a number, it is treated as a timestamp.
   *
   * If the argument is none of the above, the function returns Invalid Date.
   *
   * **Note**: *all* Date arguments passed to any *date-fns* function is processed by `toDate`.
   *
   * @param {Date|Number} argument - the value to convert
   * @returns {Date} the parsed date in the local time zone
   * @throws {TypeError} 1 argument required
   *
   * @example
   * // Clone the date:
   * const result = toDate(new Date(2014, 1, 11, 11, 30, 30))
   * //=> Tue Feb 11 2014 11:30:30
   *
   * @example
   * // Convert the timestamp to date:
   * const result = toDate(1392098430000)
   * //=> Tue Feb 11 2014 11:30:30
   */

  function toDate$1(argument) {
    requiredArgs(1, arguments);
    var argStr = Object.prototype.toString.call(argument); // Clone the date

    if (argument instanceof Date || typeof argument === 'object' && argStr === '[object Date]') {
      // Prevent the date to lose the milliseconds when passed to new Date() in IE10
      return new Date(argument.getTime());
    } else if (typeof argument === 'number' || argStr === '[object Number]') {
      return new Date(argument);
    } else {
      if ((typeof argument === 'string' || argStr === '[object String]') && typeof console !== 'undefined') {
        // eslint-disable-next-line no-console
        console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://git.io/fjule"); // eslint-disable-next-line no-console

        console.warn(new Error().stack);
      }
      return new Date(NaN);
    }
  }

  /**
   * @name addDays
   * @category Day Helpers
   * @summary Add the specified number of days to the given date.
   *
   * @description
   * Add the specified number of days to the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of days to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} - the new date with the days added
   * @throws {TypeError} - 2 arguments required
   *
   * @example
   * // Add 10 days to 1 September 2014:
   * const result = addDays(new Date(2014, 8, 1), 10)
   * //=> Thu Sep 11 2014 00:00:00
   */

  function addDays(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var date = toDate$1(dirtyDate);
    var amount = toInteger$1(dirtyAmount);
    if (isNaN(amount)) {
      return new Date(NaN);
    }
    if (!amount) {
      // If 0 days, no-op to avoid changing times in the hour before end of DST
      return date;
    }
    date.setDate(date.getDate() + amount);
    return date;
  }

  /**
   * @name addMonths
   * @category Month Helpers
   * @summary Add the specified number of months to the given date.
   *
   * @description
   * Add the specified number of months to the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of months to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} the new date with the months added
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Add 5 months to 1 September 2014:
   * const result = addMonths(new Date(2014, 8, 1), 5)
   * //=> Sun Feb 01 2015 00:00:00
   */

  function addMonths(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var date = toDate$1(dirtyDate);
    var amount = toInteger$1(dirtyAmount);
    if (isNaN(amount)) {
      return new Date(NaN);
    }
    if (!amount) {
      // If 0 months, no-op to avoid changing times in the hour before end of DST
      return date;
    }
    var dayOfMonth = date.getDate(); // The JS Date object supports date math by accepting out-of-bounds values for
    // month, day, etc. For example, new Date(2020, 0, 0) returns 31 Dec 2019 and
    // new Date(2020, 13, 1) returns 1 Feb 2021.  This is *almost* the behavior we
    // want except that dates will wrap around the end of a month, meaning that
    // new Date(2020, 13, 31) will return 3 Mar 2021 not 28 Feb 2021 as desired. So
    // we'll default to the end of the desired month by adding 1 to the desired
    // month and using a date of 0 to back up one day to the end of the desired
    // month.

    var endOfDesiredMonth = new Date(date.getTime());
    endOfDesiredMonth.setMonth(date.getMonth() + amount + 1, 0);
    var daysInMonth = endOfDesiredMonth.getDate();
    if (dayOfMonth >= daysInMonth) {
      // If we're already at the end of the month, then this is the correct date
      // and we're done.
      return endOfDesiredMonth;
    } else {
      // Otherwise, we now know that setting the original day-of-month value won't
      // cause an overflow, so set the desired day-of-month. Note that we can't
      // just set the date of `endOfDesiredMonth` because that object may have had
      // its time changed in the unusual case where where a DST transition was on
      // the last day of the month and its local time was in the hour skipped or
      // repeated next to a DST transition.  So we use `date` instead which is
      // guaranteed to still have the original time.
      date.setFullYear(endOfDesiredMonth.getFullYear(), endOfDesiredMonth.getMonth(), dayOfMonth);
      return date;
    }
  }

  /**
   * @name add
   * @category Common Helpers
   * @summary Add the specified years, months, weeks, days, hours, minutes and seconds to the given date.
   *
   * @description
   * Add the specified years, months, weeks, days, hours, minutes and seconds to the given date.
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Duration} duration - the object with years, months, weeks, days, hours, minutes and seconds to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   *
   * | Key            | Description                        |
   * |----------------|------------------------------------|
   * | years          | Amount of years to be added        |
   * | months         | Amount of months to be added       |
   * | weeks          | Amount of weeks to be added        |
   * | days           | Amount of days to be added         |
   * | hours          | Amount of hours to be added        |
   * | minutes        | Amount of minutes to be added      |
   * | seconds        | Amount of seconds to be added      |
   *
   * All values default to 0
   *
   * @returns {Date} the new date with the seconds added
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Add the following duration to 1 September 2014, 10:19:50
   * const result = add(new Date(2014, 8, 1, 10, 19, 50), {
   *   years: 2,
   *   months: 9,
   *   weeks: 1,
   *   days: 7,
   *   hours: 5,
   *   minutes: 9,
   *   seconds: 30,
   * })
   * //=> Thu Jun 15 2017 15:29:20
   */
  function add(dirtyDate, duration) {
    requiredArgs(2, arguments);
    if (!duration || typeof duration !== 'object') return new Date(NaN);
    var years = duration.years ? toInteger$1(duration.years) : 0;
    var months = duration.months ? toInteger$1(duration.months) : 0;
    var weeks = duration.weeks ? toInteger$1(duration.weeks) : 0;
    var days = duration.days ? toInteger$1(duration.days) : 0;
    var hours = duration.hours ? toInteger$1(duration.hours) : 0;
    var minutes = duration.minutes ? toInteger$1(duration.minutes) : 0;
    var seconds = duration.seconds ? toInteger$1(duration.seconds) : 0; // Add years and months

    var date = toDate$1(dirtyDate);
    var dateWithMonths = months || years ? addMonths(date, months + years * 12) : date; // Add weeks and days

    var dateWithDays = days || weeks ? addDays(dateWithMonths, days + weeks * 7) : dateWithMonths; // Add days, hours, minutes and seconds

    var minutesToAdd = minutes + hours * 60;
    var secondsToAdd = seconds + minutesToAdd * 60;
    var msToAdd = secondsToAdd * 1000;
    var finalDate = new Date(dateWithDays.getTime() + msToAdd);
    return finalDate;
  }

  /**
   * @name addMilliseconds
   * @category Millisecond Helpers
   * @summary Add the specified number of milliseconds to the given date.
   *
   * @description
   * Add the specified number of milliseconds to the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of milliseconds to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} the new date with the milliseconds added
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Add 750 milliseconds to 10 July 2014 12:45:30.000:
   * const result = addMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
   * //=> Thu Jul 10 2014 12:45:30.750
   */

  function addMilliseconds(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var timestamp = toDate$1(dirtyDate).getTime();
    var amount = toInteger$1(dirtyAmount);
    return new Date(timestamp + amount);
  }

  /**
   * @name startOfWeek
   * @category Week Helpers
   * @summary Return the start of a week for the given date.
   *
   * @description
   * Return the start of a week for the given date.
   * The result will be in the local timezone.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the original date
   * @param {Object} [options] - an object with options.
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @returns {Date} the start of a week
   * @throws {TypeError} 1 argument required
   * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
   *
   * @example
   * // The start of a week for 2 September 2014 11:55:00:
   * const result = startOfWeek(new Date(2014, 8, 2, 11, 55, 0))
   * //=> Sun Aug 31 2014 00:00:00
   *
   * @example
   * // If the week starts on Monday, the start of the week for 2 September 2014 11:55:00:
   * const result = startOfWeek(new Date(2014, 8, 2, 11, 55, 0), { weekStartsOn: 1 })
   * //=> Mon Sep 01 2014 00:00:00
   */

  function startOfWeek(dirtyDate, dirtyOptions) {
    requiredArgs(1, arguments);
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeWeekStartsOn = locale && locale.options && locale.options.weekStartsOn;
    var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : toInteger$1(localeWeekStartsOn);
    var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : toInteger$1(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

    if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
      throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
    }
    var date = toDate$1(dirtyDate);
    var day = date.getDay();
    var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
    date.setDate(date.getDate() - diff);
    date.setHours(0, 0, 0, 0);
    return date;
  }

  /**
   * Google Chrome as of 67.0.3396.87 introduced timezones with offset that includes seconds.
   * They usually appear for dates that denote time before the timezones were introduced
   * (e.g. for 'Europe/Prague' timezone the offset is GMT+00:57:44 before 1 October 1891
   * and GMT+01:00:00 after that date)
   *
   * Date#getTimezoneOffset returns the offset in minutes and would return 57 for the example above,
   * which would lead to incorrect calculations.
   *
   * This function returns the timezone offset in milliseconds that takes seconds in account.
   */
  function getTimezoneOffsetInMilliseconds$1(date) {
    var utcDate = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()));
    utcDate.setUTCFullYear(date.getFullYear());
    return date.getTime() - utcDate.getTime();
  }

  /**
   * @name startOfDay
   * @category Day Helpers
   * @summary Return the start of a day for the given date.
   *
   * @description
   * Return the start of a day for the given date.
   * The result will be in the local timezone.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the original date
   * @returns {Date} the start of a day
   * @throws {TypeError} 1 argument required
   *
   * @example
   * // The start of a day for 2 September 2014 11:55:00:
   * const result = startOfDay(new Date(2014, 8, 2, 11, 55, 0))
   * //=> Tue Sep 02 2014 00:00:00
   */

  function startOfDay(dirtyDate) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    date.setHours(0, 0, 0, 0);
    return date;
  }

  /**
   * @name isSameDay
   * @category Day Helpers
   * @summary Are the given dates in the same day (and year and month)?
   *
   * @description
   * Are the given dates in the same day (and year and month)?
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} dateLeft - the first date to check
   * @param {Date|Number} dateRight - the second date to check
   * @returns {Boolean} the dates are in the same day (and year and month)
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Are 4 September 06:00:00 and 4 September 18:00:00 in the same day?
   * var result = isSameDay(new Date(2014, 8, 4, 6, 0), new Date(2014, 8, 4, 18, 0))
   * //=> true
   * 
   * @example
   * // Are 4 September and 4 October in the same day?
   * var result = isSameDay(new Date(2014, 8, 4), new Date(2014, 9, 4))
   * //=> false
   * 
   * @example
   * // Are 4 September, 2014 and 4 September, 2015 in the same day?
   * var result = isSameDay(new Date(2014, 8, 4), new Date(2015, 8, 4))
   * //=> false
   */

  function isSameDay(dirtyDateLeft, dirtyDateRight) {
    requiredArgs(2, arguments);
    var dateLeftStartOfDay = startOfDay(dirtyDateLeft);
    var dateRightStartOfDay = startOfDay(dirtyDateRight);
    return dateLeftStartOfDay.getTime() === dateRightStartOfDay.getTime();
  }

  /**
   * @name isDate
   * @category Common Helpers
   * @summary Is the given value a date?
   *
   * @description
   * Returns true if the given value is an instance of Date. The function works for dates transferred across iframes.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {*} value - the value to check
   * @returns {boolean} true if the given value is a date
   * @throws {TypeError} 1 arguments required
   *
   * @example
   * // For a valid date:
   * const result = isDate(new Date())
   * //=> true
   *
   * @example
   * // For an invalid date:
   * const result = isDate(new Date(NaN))
   * //=> true
   *
   * @example
   * // For some value:
   * const result = isDate('2014-02-31')
   * //=> false
   *
   * @example
   * // For an object:
   * const result = isDate({})
   * //=> false
   */

  function isDate(value) {
    requiredArgs(1, arguments);
    return value instanceof Date || typeof value === 'object' && Object.prototype.toString.call(value) === '[object Date]';
  }

  /**
   * @name isValid
   * @category Common Helpers
   * @summary Is the given date valid?
   *
   * @description
   * Returns false if argument is Invalid Date and true otherwise.
   * Argument is converted to Date using `toDate`. See [toDate]{@link https://date-fns.org/docs/toDate}
   * Invalid Date is a Date, whose time value is NaN.
   *
   * Time value of Date: http://es5.github.io/#x15.9.1.1
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * - Now `isValid` doesn't throw an exception
   *   if the first argument is not an instance of Date.
   *   Instead, argument is converted beforehand using `toDate`.
   *
   *   Examples:
   *
   *   | `isValid` argument        | Before v2.0.0 | v2.0.0 onward |
   *   |---------------------------|---------------|---------------|
   *   | `new Date()`              | `true`        | `true`        |
   *   | `new Date('2016-01-01')`  | `true`        | `true`        |
   *   | `new Date('')`            | `false`       | `false`       |
   *   | `new Date(1488370835081)` | `true`        | `true`        |
   *   | `new Date(NaN)`           | `false`       | `false`       |
   *   | `'2016-01-01'`            | `TypeError`   | `false`       |
   *   | `''`                      | `TypeError`   | `false`       |
   *   | `1488370835081`           | `TypeError`   | `true`        |
   *   | `NaN`                     | `TypeError`   | `false`       |
   *
   *   We introduce this change to make *date-fns* consistent with ECMAScript behavior
   *   that try to coerce arguments to the expected type
   *   (which is also the case with other *date-fns* functions).
   *
   * @param {*} date - the date to check
   * @returns {Boolean} the date is valid
   * @throws {TypeError} 1 argument required
   *
   * @example
   * // For the valid date:
   * const result = isValid(new Date(2014, 1, 31))
   * //=> true
   *
   * @example
   * // For the value, convertable into a date:
   * const result = isValid(1393804800000)
   * //=> true
   *
   * @example
   * // For the invalid date:
   * const result = isValid(new Date(''))
   * //=> false
   */

  function isValid(dirtyDate) {
    requiredArgs(1, arguments);
    if (!isDate(dirtyDate) && typeof dirtyDate !== 'number') {
      return false;
    }
    var date = toDate$1(dirtyDate);
    return !isNaN(Number(date));
  }

  /**
   * @name eachDayOfInterval
   * @category Interval Helpers
   * @summary Return the array of dates within the specified time interval.
   *
   * @description
   * Return the array of dates within the specified time interval.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * - The function was renamed from `eachDay` to `eachDayOfInterval`.
   *   This change was made to mirror the use of the word "interval" in standard ISO 8601:2004 terminology:
   *
   *   ```
   *   2.1.3
   *   time interval
   *   part of the time axis limited by two instants
   *   ```
   *
   *   Also, this function now accepts an object with `start` and `end` properties
   *   instead of two arguments as an interval.
   *   This function now throws `RangeError` if the start of the interval is after its end
   *   or if any date in the interval is `Invalid Date`.
   *
   *   ```javascript
   *   // Before v2.0.0
   *
   *   eachDay(new Date(2014, 0, 10), new Date(2014, 0, 20))
   *
   *   // v2.0.0 onward
   *
   *   eachDayOfInterval(
   *     { start: new Date(2014, 0, 10), end: new Date(2014, 0, 20) }
   *   )
   *   ```
   *
   * @param {Interval} interval - the interval. See [Interval]{@link https://date-fns.org/docs/Interval}
   * @param {Object} [options] - an object with options.
   * @param {Number} [options.step=1] - the step to increment by. The value should be more than 1.
   * @returns {Date[]} the array with starts of days from the day of the interval start to the day of the interval end
   * @throws {TypeError} 1 argument required
   * @throws {RangeError} `options.step` must be a number greater than 1
   * @throws {RangeError} The start of an interval cannot be after its end
   * @throws {RangeError} Date in interval cannot be `Invalid Date`
   *
   * @example
   * // Each day between 6 October 2014 and 10 October 2014:
   * const result = eachDayOfInterval({
   *   start: new Date(2014, 9, 6),
   *   end: new Date(2014, 9, 10)
   * })
   * //=> [
   * //   Mon Oct 06 2014 00:00:00,
   * //   Tue Oct 07 2014 00:00:00,
   * //   Wed Oct 08 2014 00:00:00,
   * //   Thu Oct 09 2014 00:00:00,
   * //   Fri Oct 10 2014 00:00:00
   * // ]
   */

  function eachDayOfInterval(dirtyInterval, options) {
    requiredArgs(1, arguments);
    var interval = dirtyInterval || {};
    var startDate = toDate$1(interval.start);
    var endDate = toDate$1(interval.end);
    var endTime = endDate.getTime(); // Throw an exception if start date is after end date or if any date is `Invalid Date`

    if (!(startDate.getTime() <= endTime)) {
      throw new RangeError('Invalid interval');
    }
    var dates = [];
    var currentDate = startDate;
    currentDate.setHours(0, 0, 0, 0);
    var step = options && 'step' in options ? Number(options.step) : 1;
    if (step < 1 || isNaN(step)) throw new RangeError('`options.step` must be a number greater than 1');
    while (currentDate.getTime() <= endTime) {
      dates.push(toDate$1(currentDate));
      currentDate.setDate(currentDate.getDate() + step);
      currentDate.setHours(0, 0, 0, 0);
    }
    return dates;
  }

  /**
   * @name endOfWeek
   * @category Week Helpers
   * @summary Return the end of a week for the given date.
   *
   * @description
   * Return the end of a week for the given date.
   * The result will be in the local timezone.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the original date
   * @param {Object} [options] - an object with options.
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @returns {Date} the end of a week
   * @throws {TypeError} 1 argument required
   * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
   *
   * @example
   * // The end of a week for 2 September 2014 11:55:00:
   * const result = endOfWeek(new Date(2014, 8, 2, 11, 55, 0))
   * //=> Sat Sep 06 2014 23:59:59.999
   *
   * @example
   * // If the week starts on Monday, the end of the week for 2 September 2014 11:55:00:
   * const result = endOfWeek(new Date(2014, 8, 2, 11, 55, 0), { weekStartsOn: 1 })
   * //=> Sun Sep 07 2014 23:59:59.999
   */
  function endOfWeek(dirtyDate, dirtyOptions) {
    requiredArgs(1, arguments);
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeWeekStartsOn = locale && locale.options && locale.options.weekStartsOn;
    var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : toInteger$1(localeWeekStartsOn);
    var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : toInteger$1(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

    if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
      throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
    }
    var date = toDate$1(dirtyDate);
    var day = date.getDay();
    var diff = (day < weekStartsOn ? -7 : 0) + 6 - (day - weekStartsOn);
    date.setDate(date.getDate() + diff);
    date.setHours(23, 59, 59, 999);
    return date;
  }

  var formatDistanceLocale = {
    lessThanXSeconds: {
      one: 'less than a second',
      other: 'less than {{count}} seconds'
    },
    xSeconds: {
      one: '1 second',
      other: '{{count}} seconds'
    },
    halfAMinute: 'half a minute',
    lessThanXMinutes: {
      one: 'less than a minute',
      other: 'less than {{count}} minutes'
    },
    xMinutes: {
      one: '1 minute',
      other: '{{count}} minutes'
    },
    aboutXHours: {
      one: 'about 1 hour',
      other: 'about {{count}} hours'
    },
    xHours: {
      one: '1 hour',
      other: '{{count}} hours'
    },
    xDays: {
      one: '1 day',
      other: '{{count}} days'
    },
    aboutXWeeks: {
      one: 'about 1 week',
      other: 'about {{count}} weeks'
    },
    xWeeks: {
      one: '1 week',
      other: '{{count}} weeks'
    },
    aboutXMonths: {
      one: 'about 1 month',
      other: 'about {{count}} months'
    },
    xMonths: {
      one: '1 month',
      other: '{{count}} months'
    },
    aboutXYears: {
      one: 'about 1 year',
      other: 'about {{count}} years'
    },
    xYears: {
      one: '1 year',
      other: '{{count}} years'
    },
    overXYears: {
      one: 'over 1 year',
      other: 'over {{count}} years'
    },
    almostXYears: {
      one: 'almost 1 year',
      other: 'almost {{count}} years'
    }
  };
  var formatDistance = function formatDistance(token, count, options) {
    var result;
    var tokenValue = formatDistanceLocale[token];
    if (typeof tokenValue === 'string') {
      result = tokenValue;
    } else if (count === 1) {
      result = tokenValue.one;
    } else {
      result = tokenValue.other.replace('{{count}}', count.toString());
    }
    if (options !== null && options !== void 0 && options.addSuffix) {
      if (options.comparison && options.comparison > 0) {
        return 'in ' + result;
      } else {
        return result + ' ago';
      }
    }
    return result;
  };
  var formatDistance$1 = formatDistance;

  function buildFormatLongFn(args) {
    return function () {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      // TODO: Remove String()
      var width = options.width ? String(options.width) : args.defaultWidth;
      var format = args.formats[width] || args.formats[args.defaultWidth];
      return format;
    };
  }

  var dateFormats = {
    full: 'EEEE, MMMM do, y',
    "long": 'MMMM do, y',
    medium: 'MMM d, y',
    "short": 'MM/dd/yyyy'
  };
  var timeFormats = {
    full: 'h:mm:ss a zzzz',
    "long": 'h:mm:ss a z',
    medium: 'h:mm:ss a',
    "short": 'h:mm a'
  };
  var dateTimeFormats = {
    full: "{{date}} 'at' {{time}}",
    "long": "{{date}} 'at' {{time}}",
    medium: '{{date}}, {{time}}',
    "short": '{{date}}, {{time}}'
  };
  var formatLong = {
    date: buildFormatLongFn({
      formats: dateFormats,
      defaultWidth: 'full'
    }),
    time: buildFormatLongFn({
      formats: timeFormats,
      defaultWidth: 'full'
    }),
    dateTime: buildFormatLongFn({
      formats: dateTimeFormats,
      defaultWidth: 'full'
    })
  };
  var formatLong$1 = formatLong;

  var formatRelativeLocale = {
    lastWeek: "'last' eeee 'at' p",
    yesterday: "'yesterday at' p",
    today: "'today at' p",
    tomorrow: "'tomorrow at' p",
    nextWeek: "eeee 'at' p",
    other: 'P'
  };
  var formatRelative = function formatRelative(token, _date, _baseDate, _options) {
    return formatRelativeLocale[token];
  };
  var formatRelative$1 = formatRelative;

  function buildLocalizeFn(args) {
    return function (dirtyIndex, dirtyOptions) {
      var options = dirtyOptions || {};
      var context = options.context ? String(options.context) : 'standalone';
      var valuesArray;
      if (context === 'formatting' && args.formattingValues) {
        var defaultWidth = args.defaultFormattingWidth || args.defaultWidth;
        var width = options.width ? String(options.width) : defaultWidth;
        valuesArray = args.formattingValues[width] || args.formattingValues[defaultWidth];
      } else {
        var _defaultWidth = args.defaultWidth;
        var _width = options.width ? String(options.width) : args.defaultWidth;
        valuesArray = args.values[_width] || args.values[_defaultWidth];
      }
      var index = args.argumentCallback ? args.argumentCallback(dirtyIndex) : dirtyIndex; // @ts-ignore: For some reason TypeScript just don't want to match it, no matter how hard we try. I challenge you to try to remove it!

      return valuesArray[index];
    };
  }

  var eraValues = {
    narrow: ['B', 'A'],
    abbreviated: ['BC', 'AD'],
    wide: ['Before Christ', 'Anno Domini']
  };
  var quarterValues = {
    narrow: ['1', '2', '3', '4'],
    abbreviated: ['Q1', 'Q2', 'Q3', 'Q4'],
    wide: ['1st quarter', '2nd quarter', '3rd quarter', '4th quarter']
  }; // Note: in English, the names of days of the week and months are capitalized.
  // If you are making a new locale based on this one, check if the same is true for the language you're working on.
  // Generally, formatted dates should look like they are in the middle of a sentence,
  // e.g. in Spanish language the weekdays and months should be in the lowercase.

  var monthValues = {
    narrow: ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'],
    abbreviated: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    wide: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
  };
  var dayValues = {
    narrow: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
    "short": ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
    abbreviated: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
    wide: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
  };
  var dayPeriodValues = {
    narrow: {
      am: 'a',
      pm: 'p',
      midnight: 'mi',
      noon: 'n',
      morning: 'morning',
      afternoon: 'afternoon',
      evening: 'evening',
      night: 'night'
    },
    abbreviated: {
      am: 'AM',
      pm: 'PM',
      midnight: 'midnight',
      noon: 'noon',
      morning: 'morning',
      afternoon: 'afternoon',
      evening: 'evening',
      night: 'night'
    },
    wide: {
      am: 'a.m.',
      pm: 'p.m.',
      midnight: 'midnight',
      noon: 'noon',
      morning: 'morning',
      afternoon: 'afternoon',
      evening: 'evening',
      night: 'night'
    }
  };
  var formattingDayPeriodValues = {
    narrow: {
      am: 'a',
      pm: 'p',
      midnight: 'mi',
      noon: 'n',
      morning: 'in the morning',
      afternoon: 'in the afternoon',
      evening: 'in the evening',
      night: 'at night'
    },
    abbreviated: {
      am: 'AM',
      pm: 'PM',
      midnight: 'midnight',
      noon: 'noon',
      morning: 'in the morning',
      afternoon: 'in the afternoon',
      evening: 'in the evening',
      night: 'at night'
    },
    wide: {
      am: 'a.m.',
      pm: 'p.m.',
      midnight: 'midnight',
      noon: 'noon',
      morning: 'in the morning',
      afternoon: 'in the afternoon',
      evening: 'in the evening',
      night: 'at night'
    }
  };
  var ordinalNumber = function ordinalNumber(dirtyNumber, _options) {
    var number = Number(dirtyNumber); // If ordinal numbers depend on context, for example,
    // if they are different for different grammatical genders,
    // use `options.unit`.
    //
    // `unit` can be 'year', 'quarter', 'month', 'week', 'date', 'dayOfYear',
    // 'day', 'hour', 'minute', 'second'.

    var rem100 = number % 100;
    if (rem100 > 20 || rem100 < 10) {
      switch (rem100 % 10) {
        case 1:
          return number + 'st';
        case 2:
          return number + 'nd';
        case 3:
          return number + 'rd';
      }
    }
    return number + 'th';
  };
  var localize = {
    ordinalNumber: ordinalNumber,
    era: buildLocalizeFn({
      values: eraValues,
      defaultWidth: 'wide'
    }),
    quarter: buildLocalizeFn({
      values: quarterValues,
      defaultWidth: 'wide',
      argumentCallback: function argumentCallback(quarter) {
        return quarter - 1;
      }
    }),
    month: buildLocalizeFn({
      values: monthValues,
      defaultWidth: 'wide'
    }),
    day: buildLocalizeFn({
      values: dayValues,
      defaultWidth: 'wide'
    }),
    dayPeriod: buildLocalizeFn({
      values: dayPeriodValues,
      defaultWidth: 'wide',
      formattingValues: formattingDayPeriodValues,
      defaultFormattingWidth: 'wide'
    })
  };
  var localize$1 = localize;

  function buildMatchFn(args) {
    return function (string) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var width = options.width;
      var matchPattern = width && args.matchPatterns[width] || args.matchPatterns[args.defaultMatchWidth];
      var matchResult = string.match(matchPattern);
      if (!matchResult) {
        return null;
      }
      var matchedString = matchResult[0];
      var parsePatterns = width && args.parsePatterns[width] || args.parsePatterns[args.defaultParseWidth];
      var key = Array.isArray(parsePatterns) ? findIndex(parsePatterns, function (pattern) {
        return pattern.test(matchedString);
      }) : findKey(parsePatterns, function (pattern) {
        return pattern.test(matchedString);
      });
      var value;
      value = args.valueCallback ? args.valueCallback(key) : key;
      value = options.valueCallback ? options.valueCallback(value) : value;
      var rest = string.slice(matchedString.length);
      return {
        value: value,
        rest: rest
      };
    };
  }
  function findKey(object, predicate) {
    for (var key in object) {
      if (object.hasOwnProperty(key) && predicate(object[key])) {
        return key;
      }
    }
    return undefined;
  }
  function findIndex(array, predicate) {
    for (var key = 0; key < array.length; key++) {
      if (predicate(array[key])) {
        return key;
      }
    }
    return undefined;
  }

  function buildMatchPatternFn(args) {
    return function (string) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var matchResult = string.match(args.matchPattern);
      if (!matchResult) return null;
      var matchedString = matchResult[0];
      var parseResult = string.match(args.parsePattern);
      if (!parseResult) return null;
      var value = args.valueCallback ? args.valueCallback(parseResult[0]) : parseResult[0];
      value = options.valueCallback ? options.valueCallback(value) : value;
      var rest = string.slice(matchedString.length);
      return {
        value: value,
        rest: rest
      };
    };
  }

  var matchOrdinalNumberPattern = /^(\d+)(th|st|nd|rd)?/i;
  var parseOrdinalNumberPattern = /\d+/i;
  var matchEraPatterns = {
    narrow: /^(b|a)/i,
    abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
    wide: /^(before christ|before common era|anno domini|common era)/i
  };
  var parseEraPatterns = {
    any: [/^b/i, /^(a|c)/i]
  };
  var matchQuarterPatterns = {
    narrow: /^[1234]/i,
    abbreviated: /^q[1234]/i,
    wide: /^[1234](th|st|nd|rd)? quarter/i
  };
  var parseQuarterPatterns = {
    any: [/1/i, /2/i, /3/i, /4/i]
  };
  var matchMonthPatterns = {
    narrow: /^[jfmasond]/i,
    abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
    wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
  };
  var parseMonthPatterns = {
    narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
    any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
  };
  var matchDayPatterns = {
    narrow: /^[smtwf]/i,
    "short": /^(su|mo|tu|we|th|fr|sa)/i,
    abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
    wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
  };
  var parseDayPatterns = {
    narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
    any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
  };
  var matchDayPeriodPatterns = {
    narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
    any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
  };
  var parseDayPeriodPatterns = {
    any: {
      am: /^a/i,
      pm: /^p/i,
      midnight: /^mi/i,
      noon: /^no/i,
      morning: /morning/i,
      afternoon: /afternoon/i,
      evening: /evening/i,
      night: /night/i
    }
  };
  var match = {
    ordinalNumber: buildMatchPatternFn({
      matchPattern: matchOrdinalNumberPattern,
      parsePattern: parseOrdinalNumberPattern,
      valueCallback: function valueCallback(value) {
        return parseInt(value, 10);
      }
    }),
    era: buildMatchFn({
      matchPatterns: matchEraPatterns,
      defaultMatchWidth: 'wide',
      parsePatterns: parseEraPatterns,
      defaultParseWidth: 'any'
    }),
    quarter: buildMatchFn({
      matchPatterns: matchQuarterPatterns,
      defaultMatchWidth: 'wide',
      parsePatterns: parseQuarterPatterns,
      defaultParseWidth: 'any',
      valueCallback: function valueCallback(index) {
        return index + 1;
      }
    }),
    month: buildMatchFn({
      matchPatterns: matchMonthPatterns,
      defaultMatchWidth: 'wide',
      parsePatterns: parseMonthPatterns,
      defaultParseWidth: 'any'
    }),
    day: buildMatchFn({
      matchPatterns: matchDayPatterns,
      defaultMatchWidth: 'wide',
      parsePatterns: parseDayPatterns,
      defaultParseWidth: 'any'
    }),
    dayPeriod: buildMatchFn({
      matchPatterns: matchDayPeriodPatterns,
      defaultMatchWidth: 'any',
      parsePatterns: parseDayPeriodPatterns,
      defaultParseWidth: 'any'
    })
  };
  var match$1 = match;

  /**
   * @type {Locale}
   * @category Locales
   * @summary English locale (United States).
   * @language English
   * @iso-639-2 eng
   * @author Sasha Koss [@kossnocorp]{@link https://github.com/kossnocorp}
   * @author Lesha Koss [@leshakoss]{@link https://github.com/leshakoss}
   */
  var locale = {
    code: 'en-US',
    formatDistance: formatDistance$1,
    formatLong: formatLong$1,
    formatRelative: formatRelative$1,
    localize: localize$1,
    match: match$1,
    options: {
      weekStartsOn: 0
      /* Sunday */,

      firstWeekContainsDate: 1
    }
  };
  var defaultLocale = locale;

  /**
   * @name subMilliseconds
   * @category Millisecond Helpers
   * @summary Subtract the specified number of milliseconds from the given date.
   *
   * @description
   * Subtract the specified number of milliseconds from the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of milliseconds to be subtracted. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} the new date with the milliseconds subtracted
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Subtract 750 milliseconds from 10 July 2014 12:45:30.000:
   * const result = subMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
   * //=> Thu Jul 10 2014 12:45:29.250
   */

  function subMilliseconds(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var amount = toInteger$1(dirtyAmount);
    return addMilliseconds(dirtyDate, -amount);
  }

  var MILLISECONDS_IN_DAY = 86400000; // This function will be a part of public API when UTC function will be implemented.
  // See issue: https://github.com/date-fns/date-fns/issues/376

  function getUTCDayOfYear(dirtyDate) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var timestamp = date.getTime();
    date.setUTCMonth(0, 1);
    date.setUTCHours(0, 0, 0, 0);
    var startOfYearTimestamp = date.getTime();
    var difference = timestamp - startOfYearTimestamp;
    return Math.floor(difference / MILLISECONDS_IN_DAY) + 1;
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function startOfUTCISOWeek(dirtyDate) {
    requiredArgs(1, arguments);
    var weekStartsOn = 1;
    var date = toDate$1(dirtyDate);
    var day = date.getUTCDay();
    var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
    date.setUTCDate(date.getUTCDate() - diff);
    date.setUTCHours(0, 0, 0, 0);
    return date;
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function getUTCISOWeekYear(dirtyDate) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var year = date.getUTCFullYear();
    var fourthOfJanuaryOfNextYear = new Date(0);
    fourthOfJanuaryOfNextYear.setUTCFullYear(year + 1, 0, 4);
    fourthOfJanuaryOfNextYear.setUTCHours(0, 0, 0, 0);
    var startOfNextYear = startOfUTCISOWeek(fourthOfJanuaryOfNextYear);
    var fourthOfJanuaryOfThisYear = new Date(0);
    fourthOfJanuaryOfThisYear.setUTCFullYear(year, 0, 4);
    fourthOfJanuaryOfThisYear.setUTCHours(0, 0, 0, 0);
    var startOfThisYear = startOfUTCISOWeek(fourthOfJanuaryOfThisYear);
    if (date.getTime() >= startOfNextYear.getTime()) {
      return year + 1;
    } else if (date.getTime() >= startOfThisYear.getTime()) {
      return year;
    } else {
      return year - 1;
    }
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function startOfUTCISOWeekYear(dirtyDate) {
    requiredArgs(1, arguments);
    var year = getUTCISOWeekYear(dirtyDate);
    var fourthOfJanuary = new Date(0);
    fourthOfJanuary.setUTCFullYear(year, 0, 4);
    fourthOfJanuary.setUTCHours(0, 0, 0, 0);
    var date = startOfUTCISOWeek(fourthOfJanuary);
    return date;
  }

  var MILLISECONDS_IN_WEEK$1 = 604800000; // This function will be a part of public API when UTC function will be implemented.
  // See issue: https://github.com/date-fns/date-fns/issues/376

  function getUTCISOWeek(dirtyDate) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var diff = startOfUTCISOWeek(date).getTime() - startOfUTCISOWeekYear(date).getTime(); // Round the number of days to the nearest integer
    // because the number of milliseconds in a week is not constant
    // (e.g. it's different in the week of the daylight saving time clock shift)

    return Math.round(diff / MILLISECONDS_IN_WEEK$1) + 1;
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function startOfUTCWeek(dirtyDate, dirtyOptions) {
    requiredArgs(1, arguments);
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeWeekStartsOn = locale && locale.options && locale.options.weekStartsOn;
    var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : toInteger$1(localeWeekStartsOn);
    var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : toInteger$1(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

    if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
      throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
    }
    var date = toDate$1(dirtyDate);
    var day = date.getUTCDay();
    var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
    date.setUTCDate(date.getUTCDate() - diff);
    date.setUTCHours(0, 0, 0, 0);
    return date;
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function getUTCWeekYear(dirtyDate, dirtyOptions) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var year = date.getUTCFullYear();
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeFirstWeekContainsDate = locale && locale.options && locale.options.firstWeekContainsDate;
    var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : toInteger$1(localeFirstWeekContainsDate);
    var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : toInteger$1(options.firstWeekContainsDate); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

    if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
      throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
    }
    var firstWeekOfNextYear = new Date(0);
    firstWeekOfNextYear.setUTCFullYear(year + 1, 0, firstWeekContainsDate);
    firstWeekOfNextYear.setUTCHours(0, 0, 0, 0);
    var startOfNextYear = startOfUTCWeek(firstWeekOfNextYear, dirtyOptions);
    var firstWeekOfThisYear = new Date(0);
    firstWeekOfThisYear.setUTCFullYear(year, 0, firstWeekContainsDate);
    firstWeekOfThisYear.setUTCHours(0, 0, 0, 0);
    var startOfThisYear = startOfUTCWeek(firstWeekOfThisYear, dirtyOptions);
    if (date.getTime() >= startOfNextYear.getTime()) {
      return year + 1;
    } else if (date.getTime() >= startOfThisYear.getTime()) {
      return year;
    } else {
      return year - 1;
    }
  }

  // See issue: https://github.com/date-fns/date-fns/issues/376

  function startOfUTCWeekYear(dirtyDate, dirtyOptions) {
    requiredArgs(1, arguments);
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeFirstWeekContainsDate = locale && locale.options && locale.options.firstWeekContainsDate;
    var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : toInteger$1(localeFirstWeekContainsDate);
    var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : toInteger$1(options.firstWeekContainsDate);
    var year = getUTCWeekYear(dirtyDate, dirtyOptions);
    var firstWeek = new Date(0);
    firstWeek.setUTCFullYear(year, 0, firstWeekContainsDate);
    firstWeek.setUTCHours(0, 0, 0, 0);
    var date = startOfUTCWeek(firstWeek, dirtyOptions);
    return date;
  }

  var MILLISECONDS_IN_WEEK = 604800000; // This function will be a part of public API when UTC function will be implemented.
  // See issue: https://github.com/date-fns/date-fns/issues/376

  function getUTCWeek(dirtyDate, options) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var diff = startOfUTCWeek(date, options).getTime() - startOfUTCWeekYear(date, options).getTime(); // Round the number of days to the nearest integer
    // because the number of milliseconds in a week is not constant
    // (e.g. it's different in the week of the daylight saving time clock shift)

    return Math.round(diff / MILLISECONDS_IN_WEEK) + 1;
  }

  function addLeadingZeros$1(number, targetLength) {
    var sign = number < 0 ? '-' : '';
    var output = Math.abs(number).toString();
    while (output.length < targetLength) {
      output = '0' + output;
    }
    return sign + output;
  }

  /*
   * |     | Unit                           |     | Unit                           |
   * |-----|--------------------------------|-----|--------------------------------|
   * |  a  | AM, PM                         |  A* |                                |
   * |  d  | Day of month                   |  D  |                                |
   * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
   * |  m  | Minute                         |  M  | Month                          |
   * |  s  | Second                         |  S  | Fraction of second             |
   * |  y  | Year (abs)                     |  Y  |                                |
   *
   * Letters marked by * are not implemented but reserved by Unicode standard.
   */

  var formatters$4 = {
    // Year
    y: function y(date, token) {
      // From http://www.unicode.org/reports/tr35/tr35-31/tr35-dates.html#Date_Format_tokens
      // | Year     |     y | yy |   yyy |  yyyy | yyyyy |
      // |----------|-------|----|-------|-------|-------|
      // | AD 1     |     1 | 01 |   001 |  0001 | 00001 |
      // | AD 12    |    12 | 12 |   012 |  0012 | 00012 |
      // | AD 123   |   123 | 23 |   123 |  0123 | 00123 |
      // | AD 1234  |  1234 | 34 |  1234 |  1234 | 01234 |
      // | AD 12345 | 12345 | 45 | 12345 | 12345 | 12345 |
      var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

      var year = signedYear > 0 ? signedYear : 1 - signedYear;
      return addLeadingZeros$1(token === 'yy' ? year % 100 : year, token.length);
    },
    // Month
    M: function M(date, token) {
      var month = date.getUTCMonth();
      return token === 'M' ? String(month + 1) : addLeadingZeros$1(month + 1, 2);
    },
    // Day of the month
    d: function d(date, token) {
      return addLeadingZeros$1(date.getUTCDate(), token.length);
    },
    // AM or PM
    a: function a(date, token) {
      var dayPeriodEnumValue = date.getUTCHours() / 12 >= 1 ? 'pm' : 'am';
      switch (token) {
        case 'a':
        case 'aa':
          return dayPeriodEnumValue.toUpperCase();
        case 'aaa':
          return dayPeriodEnumValue;
        case 'aaaaa':
          return dayPeriodEnumValue[0];
        case 'aaaa':
        default:
          return dayPeriodEnumValue === 'am' ? 'a.m.' : 'p.m.';
      }
    },
    // Hour [1-12]
    h: function h(date, token) {
      return addLeadingZeros$1(date.getUTCHours() % 12 || 12, token.length);
    },
    // Hour [0-23]
    H: function H(date, token) {
      return addLeadingZeros$1(date.getUTCHours(), token.length);
    },
    // Minute
    m: function m(date, token) {
      return addLeadingZeros$1(date.getUTCMinutes(), token.length);
    },
    // Second
    s: function s(date, token) {
      return addLeadingZeros$1(date.getUTCSeconds(), token.length);
    },
    // Fraction of second
    S: function S(date, token) {
      var numberOfDigits = token.length;
      var milliseconds = date.getUTCMilliseconds();
      var fractionalSeconds = Math.floor(milliseconds * Math.pow(10, numberOfDigits - 3));
      return addLeadingZeros$1(fractionalSeconds, token.length);
    }
  };
  var formatters$5 = formatters$4;

  var dayPeriodEnum = {
    am: 'am',
    pm: 'pm',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  };
  /*
   * |     | Unit                           |     | Unit                           |
   * |-----|--------------------------------|-----|--------------------------------|
   * |  a  | AM, PM                         |  A* | Milliseconds in day            |
   * |  b  | AM, PM, noon, midnight         |  B  | Flexible day period            |
   * |  c  | Stand-alone local day of week  |  C* | Localized hour w/ day period   |
   * |  d  | Day of month                   |  D  | Day of year                    |
   * |  e  | Local day of week              |  E  | Day of week                    |
   * |  f  |                                |  F* | Day of week in month           |
   * |  g* | Modified Julian day            |  G  | Era                            |
   * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
   * |  i! | ISO day of week                |  I! | ISO week of year               |
   * |  j* | Localized hour w/ day period   |  J* | Localized hour w/o day period  |
   * |  k  | Hour [1-24]                    |  K  | Hour [0-11]                    |
   * |  l* | (deprecated)                   |  L  | Stand-alone month              |
   * |  m  | Minute                         |  M  | Month                          |
   * |  n  |                                |  N  |                                |
   * |  o! | Ordinal number modifier        |  O  | Timezone (GMT)                 |
   * |  p! | Long localized time            |  P! | Long localized date            |
   * |  q  | Stand-alone quarter            |  Q  | Quarter                        |
   * |  r* | Related Gregorian year         |  R! | ISO week-numbering year        |
   * |  s  | Second                         |  S  | Fraction of second             |
   * |  t! | Seconds timestamp              |  T! | Milliseconds timestamp         |
   * |  u  | Extended year                  |  U* | Cyclic year                    |
   * |  v* | Timezone (generic non-locat.)  |  V* | Timezone (location)            |
   * |  w  | Local week of year             |  W* | Week of month                  |
   * |  x  | Timezone (ISO-8601 w/o Z)      |  X  | Timezone (ISO-8601)            |
   * |  y  | Year (abs)                     |  Y  | Local week-numbering year      |
   * |  z  | Timezone (specific non-locat.) |  Z* | Timezone (aliases)             |
   *
   * Letters marked by * are not implemented but reserved by Unicode standard.
   *
   * Letters marked by ! are non-standard, but implemented by date-fns:
   * - `o` modifies the previous token to turn it into an ordinal (see `format` docs)
   * - `i` is ISO day of week. For `i` and `ii` is returns numeric ISO week days,
   *   i.e. 7 for Sunday, 1 for Monday, etc.
   * - `I` is ISO week of year, as opposed to `w` which is local week of year.
   * - `R` is ISO week-numbering year, as opposed to `Y` which is local week-numbering year.
   *   `R` is supposed to be used in conjunction with `I` and `i`
   *   for universal ISO week-numbering date, whereas
   *   `Y` is supposed to be used in conjunction with `w` and `e`
   *   for week-numbering date specific to the locale.
   * - `P` is long localized date format
   * - `p` is long localized time format
   */

  var formatters$2 = {
    // Era
    G: function G(date, token, localize) {
      var era = date.getUTCFullYear() > 0 ? 1 : 0;
      switch (token) {
        // AD, BC
        case 'G':
        case 'GG':
        case 'GGG':
          return localize.era(era, {
            width: 'abbreviated'
          });
        // A, B

        case 'GGGGG':
          return localize.era(era, {
            width: 'narrow'
          });
        // Anno Domini, Before Christ

        case 'GGGG':
        default:
          return localize.era(era, {
            width: 'wide'
          });
      }
    },
    // Year
    y: function y(date, token, localize) {
      // Ordinal number
      if (token === 'yo') {
        var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

        var year = signedYear > 0 ? signedYear : 1 - signedYear;
        return localize.ordinalNumber(year, {
          unit: 'year'
        });
      }
      return formatters$5.y(date, token);
    },
    // Local week-numbering year
    Y: function Y(date, token, localize, options) {
      var signedWeekYear = getUTCWeekYear(date, options); // Returns 1 for 1 BC (which is year 0 in JavaScript)

      var weekYear = signedWeekYear > 0 ? signedWeekYear : 1 - signedWeekYear; // Two digit year

      if (token === 'YY') {
        var twoDigitYear = weekYear % 100;
        return addLeadingZeros$1(twoDigitYear, 2);
      } // Ordinal number

      if (token === 'Yo') {
        return localize.ordinalNumber(weekYear, {
          unit: 'year'
        });
      } // Padding

      return addLeadingZeros$1(weekYear, token.length);
    },
    // ISO week-numbering year
    R: function R(date, token) {
      var isoWeekYear = getUTCISOWeekYear(date); // Padding

      return addLeadingZeros$1(isoWeekYear, token.length);
    },
    // Extended year. This is a single number designating the year of this calendar system.
    // The main difference between `y` and `u` localizers are B.C. years:
    // | Year | `y` | `u` |
    // |------|-----|-----|
    // | AC 1 |   1 |   1 |
    // | BC 1 |   1 |   0 |
    // | BC 2 |   2 |  -1 |
    // Also `yy` always returns the last two digits of a year,
    // while `uu` pads single digit years to 2 characters and returns other years unchanged.
    u: function u(date, token) {
      var year = date.getUTCFullYear();
      return addLeadingZeros$1(year, token.length);
    },
    // Quarter
    Q: function Q(date, token, localize) {
      var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);
      switch (token) {
        // 1, 2, 3, 4
        case 'Q':
          return String(quarter);
        // 01, 02, 03, 04

        case 'QQ':
          return addLeadingZeros$1(quarter, 2);
        // 1st, 2nd, 3rd, 4th

        case 'Qo':
          return localize.ordinalNumber(quarter, {
            unit: 'quarter'
          });
        // Q1, Q2, Q3, Q4

        case 'QQQ':
          return localize.quarter(quarter, {
            width: 'abbreviated',
            context: 'formatting'
          });
        // 1, 2, 3, 4 (narrow quarter; could be not numerical)

        case 'QQQQQ':
          return localize.quarter(quarter, {
            width: 'narrow',
            context: 'formatting'
          });
        // 1st quarter, 2nd quarter, ...

        case 'QQQQ':
        default:
          return localize.quarter(quarter, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // Stand-alone quarter
    q: function q(date, token, localize) {
      var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);
      switch (token) {
        // 1, 2, 3, 4
        case 'q':
          return String(quarter);
        // 01, 02, 03, 04

        case 'qq':
          return addLeadingZeros$1(quarter, 2);
        // 1st, 2nd, 3rd, 4th

        case 'qo':
          return localize.ordinalNumber(quarter, {
            unit: 'quarter'
          });
        // Q1, Q2, Q3, Q4

        case 'qqq':
          return localize.quarter(quarter, {
            width: 'abbreviated',
            context: 'standalone'
          });
        // 1, 2, 3, 4 (narrow quarter; could be not numerical)

        case 'qqqqq':
          return localize.quarter(quarter, {
            width: 'narrow',
            context: 'standalone'
          });
        // 1st quarter, 2nd quarter, ...

        case 'qqqq':
        default:
          return localize.quarter(quarter, {
            width: 'wide',
            context: 'standalone'
          });
      }
    },
    // Month
    M: function M(date, token, localize) {
      var month = date.getUTCMonth();
      switch (token) {
        case 'M':
        case 'MM':
          return formatters$5.M(date, token);
        // 1st, 2nd, ..., 12th

        case 'Mo':
          return localize.ordinalNumber(month + 1, {
            unit: 'month'
          });
        // Jan, Feb, ..., Dec

        case 'MMM':
          return localize.month(month, {
            width: 'abbreviated',
            context: 'formatting'
          });
        // J, F, ..., D

        case 'MMMMM':
          return localize.month(month, {
            width: 'narrow',
            context: 'formatting'
          });
        // January, February, ..., December

        case 'MMMM':
        default:
          return localize.month(month, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // Stand-alone month
    L: function L(date, token, localize) {
      var month = date.getUTCMonth();
      switch (token) {
        // 1, 2, ..., 12
        case 'L':
          return String(month + 1);
        // 01, 02, ..., 12

        case 'LL':
          return addLeadingZeros$1(month + 1, 2);
        // 1st, 2nd, ..., 12th

        case 'Lo':
          return localize.ordinalNumber(month + 1, {
            unit: 'month'
          });
        // Jan, Feb, ..., Dec

        case 'LLL':
          return localize.month(month, {
            width: 'abbreviated',
            context: 'standalone'
          });
        // J, F, ..., D

        case 'LLLLL':
          return localize.month(month, {
            width: 'narrow',
            context: 'standalone'
          });
        // January, February, ..., December

        case 'LLLL':
        default:
          return localize.month(month, {
            width: 'wide',
            context: 'standalone'
          });
      }
    },
    // Local week of year
    w: function w(date, token, localize, options) {
      var week = getUTCWeek(date, options);
      if (token === 'wo') {
        return localize.ordinalNumber(week, {
          unit: 'week'
        });
      }
      return addLeadingZeros$1(week, token.length);
    },
    // ISO week of year
    I: function I(date, token, localize) {
      var isoWeek = getUTCISOWeek(date);
      if (token === 'Io') {
        return localize.ordinalNumber(isoWeek, {
          unit: 'week'
        });
      }
      return addLeadingZeros$1(isoWeek, token.length);
    },
    // Day of the month
    d: function d(date, token, localize) {
      if (token === 'do') {
        return localize.ordinalNumber(date.getUTCDate(), {
          unit: 'date'
        });
      }
      return formatters$5.d(date, token);
    },
    // Day of year
    D: function D(date, token, localize) {
      var dayOfYear = getUTCDayOfYear(date);
      if (token === 'Do') {
        return localize.ordinalNumber(dayOfYear, {
          unit: 'dayOfYear'
        });
      }
      return addLeadingZeros$1(dayOfYear, token.length);
    },
    // Day of week
    E: function E(date, token, localize) {
      var dayOfWeek = date.getUTCDay();
      switch (token) {
        // Tue
        case 'E':
        case 'EE':
        case 'EEE':
          return localize.day(dayOfWeek, {
            width: 'abbreviated',
            context: 'formatting'
          });
        // T

        case 'EEEEE':
          return localize.day(dayOfWeek, {
            width: 'narrow',
            context: 'formatting'
          });
        // Tu

        case 'EEEEEE':
          return localize.day(dayOfWeek, {
            width: 'short',
            context: 'formatting'
          });
        // Tuesday

        case 'EEEE':
        default:
          return localize.day(dayOfWeek, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // Local day of week
    e: function e(date, token, localize, options) {
      var dayOfWeek = date.getUTCDay();
      var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;
      switch (token) {
        // Numerical value (Nth day of week with current locale or weekStartsOn)
        case 'e':
          return String(localDayOfWeek);
        // Padded numerical value

        case 'ee':
          return addLeadingZeros$1(localDayOfWeek, 2);
        // 1st, 2nd, ..., 7th

        case 'eo':
          return localize.ordinalNumber(localDayOfWeek, {
            unit: 'day'
          });
        case 'eee':
          return localize.day(dayOfWeek, {
            width: 'abbreviated',
            context: 'formatting'
          });
        // T

        case 'eeeee':
          return localize.day(dayOfWeek, {
            width: 'narrow',
            context: 'formatting'
          });
        // Tu

        case 'eeeeee':
          return localize.day(dayOfWeek, {
            width: 'short',
            context: 'formatting'
          });
        // Tuesday

        case 'eeee':
        default:
          return localize.day(dayOfWeek, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // Stand-alone local day of week
    c: function c(date, token, localize, options) {
      var dayOfWeek = date.getUTCDay();
      var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;
      switch (token) {
        // Numerical value (same as in `e`)
        case 'c':
          return String(localDayOfWeek);
        // Padded numerical value

        case 'cc':
          return addLeadingZeros$1(localDayOfWeek, token.length);
        // 1st, 2nd, ..., 7th

        case 'co':
          return localize.ordinalNumber(localDayOfWeek, {
            unit: 'day'
          });
        case 'ccc':
          return localize.day(dayOfWeek, {
            width: 'abbreviated',
            context: 'standalone'
          });
        // T

        case 'ccccc':
          return localize.day(dayOfWeek, {
            width: 'narrow',
            context: 'standalone'
          });
        // Tu

        case 'cccccc':
          return localize.day(dayOfWeek, {
            width: 'short',
            context: 'standalone'
          });
        // Tuesday

        case 'cccc':
        default:
          return localize.day(dayOfWeek, {
            width: 'wide',
            context: 'standalone'
          });
      }
    },
    // ISO day of week
    i: function i(date, token, localize) {
      var dayOfWeek = date.getUTCDay();
      var isoDayOfWeek = dayOfWeek === 0 ? 7 : dayOfWeek;
      switch (token) {
        // 2
        case 'i':
          return String(isoDayOfWeek);
        // 02

        case 'ii':
          return addLeadingZeros$1(isoDayOfWeek, token.length);
        // 2nd

        case 'io':
          return localize.ordinalNumber(isoDayOfWeek, {
            unit: 'day'
          });
        // Tue

        case 'iii':
          return localize.day(dayOfWeek, {
            width: 'abbreviated',
            context: 'formatting'
          });
        // T

        case 'iiiii':
          return localize.day(dayOfWeek, {
            width: 'narrow',
            context: 'formatting'
          });
        // Tu

        case 'iiiiii':
          return localize.day(dayOfWeek, {
            width: 'short',
            context: 'formatting'
          });
        // Tuesday

        case 'iiii':
        default:
          return localize.day(dayOfWeek, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // AM or PM
    a: function a(date, token, localize) {
      var hours = date.getUTCHours();
      var dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';
      switch (token) {
        case 'a':
        case 'aa':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'abbreviated',
            context: 'formatting'
          });
        case 'aaa':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'abbreviated',
            context: 'formatting'
          }).toLowerCase();
        case 'aaaaa':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'narrow',
            context: 'formatting'
          });
        case 'aaaa':
        default:
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // AM, PM, midnight, noon
    b: function b(date, token, localize) {
      var hours = date.getUTCHours();
      var dayPeriodEnumValue;
      if (hours === 12) {
        dayPeriodEnumValue = dayPeriodEnum.noon;
      } else if (hours === 0) {
        dayPeriodEnumValue = dayPeriodEnum.midnight;
      } else {
        dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';
      }
      switch (token) {
        case 'b':
        case 'bb':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'abbreviated',
            context: 'formatting'
          });
        case 'bbb':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'abbreviated',
            context: 'formatting'
          }).toLowerCase();
        case 'bbbbb':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'narrow',
            context: 'formatting'
          });
        case 'bbbb':
        default:
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // in the morning, in the afternoon, in the evening, at night
    B: function B(date, token, localize) {
      var hours = date.getUTCHours();
      var dayPeriodEnumValue;
      if (hours >= 17) {
        dayPeriodEnumValue = dayPeriodEnum.evening;
      } else if (hours >= 12) {
        dayPeriodEnumValue = dayPeriodEnum.afternoon;
      } else if (hours >= 4) {
        dayPeriodEnumValue = dayPeriodEnum.morning;
      } else {
        dayPeriodEnumValue = dayPeriodEnum.night;
      }
      switch (token) {
        case 'B':
        case 'BB':
        case 'BBB':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'abbreviated',
            context: 'formatting'
          });
        case 'BBBBB':
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'narrow',
            context: 'formatting'
          });
        case 'BBBB':
        default:
          return localize.dayPeriod(dayPeriodEnumValue, {
            width: 'wide',
            context: 'formatting'
          });
      }
    },
    // Hour [1-12]
    h: function h(date, token, localize) {
      if (token === 'ho') {
        var hours = date.getUTCHours() % 12;
        if (hours === 0) hours = 12;
        return localize.ordinalNumber(hours, {
          unit: 'hour'
        });
      }
      return formatters$5.h(date, token);
    },
    // Hour [0-23]
    H: function H(date, token, localize) {
      if (token === 'Ho') {
        return localize.ordinalNumber(date.getUTCHours(), {
          unit: 'hour'
        });
      }
      return formatters$5.H(date, token);
    },
    // Hour [0-11]
    K: function K(date, token, localize) {
      var hours = date.getUTCHours() % 12;
      if (token === 'Ko') {
        return localize.ordinalNumber(hours, {
          unit: 'hour'
        });
      }
      return addLeadingZeros$1(hours, token.length);
    },
    // Hour [1-24]
    k: function k(date, token, localize) {
      var hours = date.getUTCHours();
      if (hours === 0) hours = 24;
      if (token === 'ko') {
        return localize.ordinalNumber(hours, {
          unit: 'hour'
        });
      }
      return addLeadingZeros$1(hours, token.length);
    },
    // Minute
    m: function m(date, token, localize) {
      if (token === 'mo') {
        return localize.ordinalNumber(date.getUTCMinutes(), {
          unit: 'minute'
        });
      }
      return formatters$5.m(date, token);
    },
    // Second
    s: function s(date, token, localize) {
      if (token === 'so') {
        return localize.ordinalNumber(date.getUTCSeconds(), {
          unit: 'second'
        });
      }
      return formatters$5.s(date, token);
    },
    // Fraction of second
    S: function S(date, token) {
      return formatters$5.S(date, token);
    },
    // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
    X: function X(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timezoneOffset = originalDate.getTimezoneOffset();
      if (timezoneOffset === 0) {
        return 'Z';
      }
      switch (token) {
        // Hours and optional minutes
        case 'X':
          return formatTimezoneWithOptionalMinutes$1(timezoneOffset);
        // Hours, minutes and optional seconds without `:` delimiter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `XX`

        case 'XXXX':
        case 'XX':
          // Hours and minutes without `:` delimiter
          return formatTimezone$1(timezoneOffset);
        // Hours, minutes and optional seconds with `:` delimiter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `XXX`

        case 'XXXXX':
        case 'XXX': // Hours and minutes with `:` delimiter

        default:
          return formatTimezone$1(timezoneOffset, ':');
      }
    },
    // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
    x: function x(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timezoneOffset = originalDate.getTimezoneOffset();
      switch (token) {
        // Hours and optional minutes
        case 'x':
          return formatTimezoneWithOptionalMinutes$1(timezoneOffset);
        // Hours, minutes and optional seconds without `:` delimiter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `xx`

        case 'xxxx':
        case 'xx':
          // Hours and minutes without `:` delimiter
          return formatTimezone$1(timezoneOffset);
        // Hours, minutes and optional seconds with `:` delimiter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `xxx`

        case 'xxxxx':
        case 'xxx': // Hours and minutes with `:` delimiter

        default:
          return formatTimezone$1(timezoneOffset, ':');
      }
    },
    // Timezone (GMT)
    O: function O(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timezoneOffset = originalDate.getTimezoneOffset();
      switch (token) {
        // Short
        case 'O':
        case 'OO':
        case 'OOO':
          return 'GMT' + formatTimezoneShort$1(timezoneOffset, ':');
        // Long

        case 'OOOO':
        default:
          return 'GMT' + formatTimezone$1(timezoneOffset, ':');
      }
    },
    // Timezone (specific non-location)
    z: function z(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timezoneOffset = originalDate.getTimezoneOffset();
      switch (token) {
        // Short
        case 'z':
        case 'zz':
        case 'zzz':
          return 'GMT' + formatTimezoneShort$1(timezoneOffset, ':');
        // Long

        case 'zzzz':
        default:
          return 'GMT' + formatTimezone$1(timezoneOffset, ':');
      }
    },
    // Seconds timestamp
    t: function t(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timestamp = Math.floor(originalDate.getTime() / 1000);
      return addLeadingZeros$1(timestamp, token.length);
    },
    // Milliseconds timestamp
    T: function T(date, token, _localize, options) {
      var originalDate = options._originalDate || date;
      var timestamp = originalDate.getTime();
      return addLeadingZeros$1(timestamp, token.length);
    }
  };
  function formatTimezoneShort$1(offset, dirtyDelimiter) {
    var sign = offset > 0 ? '-' : '+';
    var absOffset = Math.abs(offset);
    var hours = Math.floor(absOffset / 60);
    var minutes = absOffset % 60;
    if (minutes === 0) {
      return sign + String(hours);
    }
    var delimiter = dirtyDelimiter || '';
    return sign + String(hours) + delimiter + addLeadingZeros$1(minutes, 2);
  }
  function formatTimezoneWithOptionalMinutes$1(offset, dirtyDelimiter) {
    if (offset % 60 === 0) {
      var sign = offset > 0 ? '-' : '+';
      return sign + addLeadingZeros$1(Math.abs(offset) / 60, 2);
    }
    return formatTimezone$1(offset, dirtyDelimiter);
  }
  function formatTimezone$1(offset, dirtyDelimiter) {
    var delimiter = dirtyDelimiter || '';
    var sign = offset > 0 ? '-' : '+';
    var absOffset = Math.abs(offset);
    var hours = addLeadingZeros$1(Math.floor(absOffset / 60), 2);
    var minutes = addLeadingZeros$1(absOffset % 60, 2);
    return sign + hours + delimiter + minutes;
  }
  var formatters$3 = formatters$2;

  function dateLongFormatter(pattern, formatLong) {
    switch (pattern) {
      case 'P':
        return formatLong.date({
          width: 'short'
        });
      case 'PP':
        return formatLong.date({
          width: 'medium'
        });
      case 'PPP':
        return formatLong.date({
          width: 'long'
        });
      case 'PPPP':
      default:
        return formatLong.date({
          width: 'full'
        });
    }
  }
  function timeLongFormatter(pattern, formatLong) {
    switch (pattern) {
      case 'p':
        return formatLong.time({
          width: 'short'
        });
      case 'pp':
        return formatLong.time({
          width: 'medium'
        });
      case 'ppp':
        return formatLong.time({
          width: 'long'
        });
      case 'pppp':
      default:
        return formatLong.time({
          width: 'full'
        });
    }
  }
  function dateTimeLongFormatter(pattern, formatLong) {
    var matchResult = pattern.match(/(P+)(p+)?/) || [];
    var datePattern = matchResult[1];
    var timePattern = matchResult[2];
    if (!timePattern) {
      return dateLongFormatter(pattern, formatLong);
    }
    var dateTimeFormat;
    switch (datePattern) {
      case 'P':
        dateTimeFormat = formatLong.dateTime({
          width: 'short'
        });
        break;
      case 'PP':
        dateTimeFormat = formatLong.dateTime({
          width: 'medium'
        });
        break;
      case 'PPP':
        dateTimeFormat = formatLong.dateTime({
          width: 'long'
        });
        break;
      case 'PPPP':
      default:
        dateTimeFormat = formatLong.dateTime({
          width: 'full'
        });
        break;
    }
    return dateTimeFormat.replace('{{date}}', dateLongFormatter(datePattern, formatLong)).replace('{{time}}', timeLongFormatter(timePattern, formatLong));
  }
  var longFormatters = {
    p: timeLongFormatter,
    P: dateTimeLongFormatter
  };
  var longFormatters$1 = longFormatters;

  var protectedDayOfYearTokens = ['D', 'DD'];
  var protectedWeekYearTokens = ['YY', 'YYYY'];
  function isProtectedDayOfYearToken(token) {
    return protectedDayOfYearTokens.indexOf(token) !== -1;
  }
  function isProtectedWeekYearToken(token) {
    return protectedWeekYearTokens.indexOf(token) !== -1;
  }
  function throwProtectedError(token, format, input) {
    if (token === 'YYYY') {
      throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://git.io/fxCyr"));
    } else if (token === 'YY') {
      throw new RangeError("Use `yy` instead of `YY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://git.io/fxCyr"));
    } else if (token === 'D') {
      throw new RangeError("Use `d` instead of `D` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://git.io/fxCyr"));
    } else if (token === 'DD') {
      throw new RangeError("Use `dd` instead of `DD` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://git.io/fxCyr"));
    }
  }

  // - [yYQqMLwIdDecihHKkms]o matches any available ordinal number token
  //   (one of the certain letters followed by `o`)
  // - (\w)\1* matches any sequences of the same letter
  // - '' matches two quote characters in a row
  // - '(''|[^'])+('|$) matches anything surrounded by two quote characters ('),
  //   except a single quote symbol, which ends the sequence.
  //   Two quote characters do not end the sequence.
  //   If there is no matching single quote
  //   then the sequence will continue until the end of the string.
  // - . matches any single character unmatched by previous parts of the RegExps

  var formattingTokensRegExp = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g; // This RegExp catches symbols escaped by quotes, and also
  // sequences of symbols P, p, and the combinations like `PPPPPPPppppp`

  var longFormattingTokensRegExp = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g;
  var escapedStringRegExp = /^'([^]*?)'?$/;
  var doubleQuoteRegExp = /''/g;
  var unescapedLatinCharacterRegExp = /[a-zA-Z]/;
  /**
   * @name format
   * @category Common Helpers
   * @summary Format the date.
   *
   * @description
   * Return the formatted date string in the given format. The result may vary by locale.
   *
   * > ⚠️ Please note that the `format` tokens differ from Moment.js and other libraries.
   * > See: https://git.io/fxCyr
   *
   * The characters wrapped between two single quotes characters (') are escaped.
   * Two single quotes in a row, whether inside or outside a quoted sequence, represent a 'real' single quote.
   * (see the last example)
   *
   * Format of the string is based on Unicode Technical Standard #35:
   * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
   * with a few additions (see note 7 below the table).
   *
   * Accepted patterns:
   * | Unit                            | Pattern | Result examples                   | Notes |
   * |---------------------------------|---------|-----------------------------------|-------|
   * | Era                             | G..GGG  | AD, BC                            |       |
   * |                                 | GGGG    | Anno Domini, Before Christ        | 2     |
   * |                                 | GGGGG   | A, B                              |       |
   * | Calendar year                   | y       | 44, 1, 1900, 2017                 | 5     |
   * |                                 | yo      | 44th, 1st, 0th, 17th              | 5,7   |
   * |                                 | yy      | 44, 01, 00, 17                    | 5     |
   * |                                 | yyy     | 044, 001, 1900, 2017              | 5     |
   * |                                 | yyyy    | 0044, 0001, 1900, 2017            | 5     |
   * |                                 | yyyyy   | ...                               | 3,5   |
   * | Local week-numbering year       | Y       | 44, 1, 1900, 2017                 | 5     |
   * |                                 | Yo      | 44th, 1st, 1900th, 2017th         | 5,7   |
   * |                                 | YY      | 44, 01, 00, 17                    | 5,8   |
   * |                                 | YYY     | 044, 001, 1900, 2017              | 5     |
   * |                                 | YYYY    | 0044, 0001, 1900, 2017            | 5,8   |
   * |                                 | YYYYY   | ...                               | 3,5   |
   * | ISO week-numbering year         | R       | -43, 0, 1, 1900, 2017             | 5,7   |
   * |                                 | RR      | -43, 00, 01, 1900, 2017           | 5,7   |
   * |                                 | RRR     | -043, 000, 001, 1900, 2017        | 5,7   |
   * |                                 | RRRR    | -0043, 0000, 0001, 1900, 2017     | 5,7   |
   * |                                 | RRRRR   | ...                               | 3,5,7 |
   * | Extended year                   | u       | -43, 0, 1, 1900, 2017             | 5     |
   * |                                 | uu      | -43, 01, 1900, 2017               | 5     |
   * |                                 | uuu     | -043, 001, 1900, 2017             | 5     |
   * |                                 | uuuu    | -0043, 0001, 1900, 2017           | 5     |
   * |                                 | uuuuu   | ...                               | 3,5   |
   * | Quarter (formatting)            | Q       | 1, 2, 3, 4                        |       |
   * |                                 | Qo      | 1st, 2nd, 3rd, 4th                | 7     |
   * |                                 | QQ      | 01, 02, 03, 04                    |       |
   * |                                 | QQQ     | Q1, Q2, Q3, Q4                    |       |
   * |                                 | QQQQ    | 1st quarter, 2nd quarter, ...     | 2     |
   * |                                 | QQQQQ   | 1, 2, 3, 4                        | 4     |
   * | Quarter (stand-alone)           | q       | 1, 2, 3, 4                        |       |
   * |                                 | qo      | 1st, 2nd, 3rd, 4th                | 7     |
   * |                                 | qq      | 01, 02, 03, 04                    |       |
   * |                                 | qqq     | Q1, Q2, Q3, Q4                    |       |
   * |                                 | qqqq    | 1st quarter, 2nd quarter, ...     | 2     |
   * |                                 | qqqqq   | 1, 2, 3, 4                        | 4     |
   * | Month (formatting)              | M       | 1, 2, ..., 12                     |       |
   * |                                 | Mo      | 1st, 2nd, ..., 12th               | 7     |
   * |                                 | MM      | 01, 02, ..., 12                   |       |
   * |                                 | MMM     | Jan, Feb, ..., Dec                |       |
   * |                                 | MMMM    | January, February, ..., December  | 2     |
   * |                                 | MMMMM   | J, F, ..., D                      |       |
   * | Month (stand-alone)             | L       | 1, 2, ..., 12                     |       |
   * |                                 | Lo      | 1st, 2nd, ..., 12th               | 7     |
   * |                                 | LL      | 01, 02, ..., 12                   |       |
   * |                                 | LLL     | Jan, Feb, ..., Dec                |       |
   * |                                 | LLLL    | January, February, ..., December  | 2     |
   * |                                 | LLLLL   | J, F, ..., D                      |       |
   * | Local week of year              | w       | 1, 2, ..., 53                     |       |
   * |                                 | wo      | 1st, 2nd, ..., 53th               | 7     |
   * |                                 | ww      | 01, 02, ..., 53                   |       |
   * | ISO week of year                | I       | 1, 2, ..., 53                     | 7     |
   * |                                 | Io      | 1st, 2nd, ..., 53th               | 7     |
   * |                                 | II      | 01, 02, ..., 53                   | 7     |
   * | Day of month                    | d       | 1, 2, ..., 31                     |       |
   * |                                 | do      | 1st, 2nd, ..., 31st               | 7     |
   * |                                 | dd      | 01, 02, ..., 31                   |       |
   * | Day of year                     | D       | 1, 2, ..., 365, 366               | 9     |
   * |                                 | Do      | 1st, 2nd, ..., 365th, 366th       | 7     |
   * |                                 | DD      | 01, 02, ..., 365, 366             | 9     |
   * |                                 | DDD     | 001, 002, ..., 365, 366           |       |
   * |                                 | DDDD    | ...                               | 3     |
   * | Day of week (formatting)        | E..EEE  | Mon, Tue, Wed, ..., Sun           |       |
   * |                                 | EEEE    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | EEEEE   | M, T, W, T, F, S, S               |       |
   * |                                 | EEEEEE  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
   * | ISO day of week (formatting)    | i       | 1, 2, 3, ..., 7                   | 7     |
   * |                                 | io      | 1st, 2nd, ..., 7th                | 7     |
   * |                                 | ii      | 01, 02, ..., 07                   | 7     |
   * |                                 | iii     | Mon, Tue, Wed, ..., Sun           | 7     |
   * |                                 | iiii    | Monday, Tuesday, ..., Sunday      | 2,7   |
   * |                                 | iiiii   | M, T, W, T, F, S, S               | 7     |
   * |                                 | iiiiii  | Mo, Tu, We, Th, Fr, Sa, Su        | 7     |
   * | Local day of week (formatting)  | e       | 2, 3, 4, ..., 1                   |       |
   * |                                 | eo      | 2nd, 3rd, ..., 1st                | 7     |
   * |                                 | ee      | 02, 03, ..., 01                   |       |
   * |                                 | eee     | Mon, Tue, Wed, ..., Sun           |       |
   * |                                 | eeee    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | eeeee   | M, T, W, T, F, S, S               |       |
   * |                                 | eeeeee  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
   * | Local day of week (stand-alone) | c       | 2, 3, 4, ..., 1                   |       |
   * |                                 | co      | 2nd, 3rd, ..., 1st                | 7     |
   * |                                 | cc      | 02, 03, ..., 01                   |       |
   * |                                 | ccc     | Mon, Tue, Wed, ..., Sun           |       |
   * |                                 | cccc    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | ccccc   | M, T, W, T, F, S, S               |       |
   * |                                 | cccccc  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
   * | AM, PM                          | a..aa   | AM, PM                            |       |
   * |                                 | aaa     | am, pm                            |       |
   * |                                 | aaaa    | a.m., p.m.                        | 2     |
   * |                                 | aaaaa   | a, p                              |       |
   * | AM, PM, noon, midnight          | b..bb   | AM, PM, noon, midnight            |       |
   * |                                 | bbb     | am, pm, noon, midnight            |       |
   * |                                 | bbbb    | a.m., p.m., noon, midnight        | 2     |
   * |                                 | bbbbb   | a, p, n, mi                       |       |
   * | Flexible day period             | B..BBB  | at night, in the morning, ...     |       |
   * |                                 | BBBB    | at night, in the morning, ...     | 2     |
   * |                                 | BBBBB   | at night, in the morning, ...     |       |
   * | Hour [1-12]                     | h       | 1, 2, ..., 11, 12                 |       |
   * |                                 | ho      | 1st, 2nd, ..., 11th, 12th         | 7     |
   * |                                 | hh      | 01, 02, ..., 11, 12               |       |
   * | Hour [0-23]                     | H       | 0, 1, 2, ..., 23                  |       |
   * |                                 | Ho      | 0th, 1st, 2nd, ..., 23rd          | 7     |
   * |                                 | HH      | 00, 01, 02, ..., 23               |       |
   * | Hour [0-11]                     | K       | 1, 2, ..., 11, 0                  |       |
   * |                                 | Ko      | 1st, 2nd, ..., 11th, 0th          | 7     |
   * |                                 | KK      | 01, 02, ..., 11, 00               |       |
   * | Hour [1-24]                     | k       | 24, 1, 2, ..., 23                 |       |
   * |                                 | ko      | 24th, 1st, 2nd, ..., 23rd         | 7     |
   * |                                 | kk      | 24, 01, 02, ..., 23               |       |
   * | Minute                          | m       | 0, 1, ..., 59                     |       |
   * |                                 | mo      | 0th, 1st, ..., 59th               | 7     |
   * |                                 | mm      | 00, 01, ..., 59                   |       |
   * | Second                          | s       | 0, 1, ..., 59                     |       |
   * |                                 | so      | 0th, 1st, ..., 59th               | 7     |
   * |                                 | ss      | 00, 01, ..., 59                   |       |
   * | Fraction of second              | S       | 0, 1, ..., 9                      |       |
   * |                                 | SS      | 00, 01, ..., 99                   |       |
   * |                                 | SSS     | 000, 001, ..., 999                |       |
   * |                                 | SSSS    | ...                               | 3     |
   * | Timezone (ISO-8601 w/ Z)        | X       | -08, +0530, Z                     |       |
   * |                                 | XX      | -0800, +0530, Z                   |       |
   * |                                 | XXX     | -08:00, +05:30, Z                 |       |
   * |                                 | XXXX    | -0800, +0530, Z, +123456          | 2     |
   * |                                 | XXXXX   | -08:00, +05:30, Z, +12:34:56      |       |
   * | Timezone (ISO-8601 w/o Z)       | x       | -08, +0530, +00                   |       |
   * |                                 | xx      | -0800, +0530, +0000               |       |
   * |                                 | xxx     | -08:00, +05:30, +00:00            | 2     |
   * |                                 | xxxx    | -0800, +0530, +0000, +123456      |       |
   * |                                 | xxxxx   | -08:00, +05:30, +00:00, +12:34:56 |       |
   * | Timezone (GMT)                  | O...OOO | GMT-8, GMT+5:30, GMT+0            |       |
   * |                                 | OOOO    | GMT-08:00, GMT+05:30, GMT+00:00   | 2     |
   * | Timezone (specific non-locat.)  | z...zzz | GMT-8, GMT+5:30, GMT+0            | 6     |
   * |                                 | zzzz    | GMT-08:00, GMT+05:30, GMT+00:00   | 2,6   |
   * | Seconds timestamp               | t       | 512969520                         | 7     |
   * |                                 | tt      | ...                               | 3,7   |
   * | Milliseconds timestamp          | T       | 512969520900                      | 7     |
   * |                                 | TT      | ...                               | 3,7   |
   * | Long localized date             | P       | 04/29/1453                        | 7     |
   * |                                 | PP      | Apr 29, 1453                      | 7     |
   * |                                 | PPP     | April 29th, 1453                  | 7     |
   * |                                 | PPPP    | Friday, April 29th, 1453          | 2,7   |
   * | Long localized time             | p       | 12:00 AM                          | 7     |
   * |                                 | pp      | 12:00:00 AM                       | 7     |
   * |                                 | ppp     | 12:00:00 AM GMT+2                 | 7     |
   * |                                 | pppp    | 12:00:00 AM GMT+02:00             | 2,7   |
   * | Combination of date and time    | Pp      | 04/29/1453, 12:00 AM              | 7     |
   * |                                 | PPpp    | Apr 29, 1453, 12:00:00 AM         | 7     |
   * |                                 | PPPppp  | April 29th, 1453 at ...           | 7     |
   * |                                 | PPPPpppp| Friday, April 29th, 1453 at ...   | 2,7   |
   * Notes:
   * 1. "Formatting" units (e.g. formatting quarter) in the default en-US locale
   *    are the same as "stand-alone" units, but are different in some languages.
   *    "Formatting" units are declined according to the rules of the language
   *    in the context of a date. "Stand-alone" units are always nominative singular:
   *
   *    `format(new Date(2017, 10, 6), 'do LLLL', {locale: cs}) //=> '6. listopad'`
   *
   *    `format(new Date(2017, 10, 6), 'do MMMM', {locale: cs}) //=> '6. listopadu'`
   *
   * 2. Any sequence of the identical letters is a pattern, unless it is escaped by
   *    the single quote characters (see below).
   *    If the sequence is longer than listed in table (e.g. `EEEEEEEEEEE`)
   *    the output will be the same as default pattern for this unit, usually
   *    the longest one (in case of ISO weekdays, `EEEE`). Default patterns for units
   *    are marked with "2" in the last column of the table.
   *
   *    `format(new Date(2017, 10, 6), 'MMM') //=> 'Nov'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMM') //=> 'November'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMM') //=> 'N'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMMM') //=> 'November'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMMMM') //=> 'November'`
   *
   * 3. Some patterns could be unlimited length (such as `yyyyyyyy`).
   *    The output will be padded with zeros to match the length of the pattern.
   *
   *    `format(new Date(2017, 10, 6), 'yyyyyyyy') //=> '00002017'`
   *
   * 4. `QQQQQ` and `qqqqq` could be not strictly numerical in some locales.
   *    These tokens represent the shortest form of the quarter.
   *
   * 5. The main difference between `y` and `u` patterns are B.C. years:
   *
   *    | Year | `y` | `u` |
   *    |------|-----|-----|
   *    | AC 1 |   1 |   1 |
   *    | BC 1 |   1 |   0 |
   *    | BC 2 |   2 |  -1 |
   *
   *    Also `yy` always returns the last two digits of a year,
   *    while `uu` pads single digit years to 2 characters and returns other years unchanged:
   *
   *    | Year | `yy` | `uu` |
   *    |------|------|------|
   *    | 1    |   01 |   01 |
   *    | 14   |   14 |   14 |
   *    | 376  |   76 |  376 |
   *    | 1453 |   53 | 1453 |
   *
   *    The same difference is true for local and ISO week-numbering years (`Y` and `R`),
   *    except local week-numbering years are dependent on `options.weekStartsOn`
   *    and `options.firstWeekContainsDate` (compare [getISOWeekYear]{@link https://date-fns.org/docs/getISOWeekYear}
   *    and [getWeekYear]{@link https://date-fns.org/docs/getWeekYear}).
   *
   * 6. Specific non-location timezones are currently unavailable in `date-fns`,
   *    so right now these tokens fall back to GMT timezones.
   *
   * 7. These patterns are not in the Unicode Technical Standard #35:
   *    - `i`: ISO day of week
   *    - `I`: ISO week of year
   *    - `R`: ISO week-numbering year
   *    - `t`: seconds timestamp
   *    - `T`: milliseconds timestamp
   *    - `o`: ordinal number modifier
   *    - `P`: long localized date
   *    - `p`: long localized time
   *
   * 8. `YY` and `YYYY` tokens represent week-numbering years but they are often confused with years.
   *    You should enable `options.useAdditionalWeekYearTokens` to use them. See: https://git.io/fxCyr
   *
   * 9. `D` and `DD` tokens represent days of the year but they are often confused with days of the month.
   *    You should enable `options.useAdditionalDayOfYearTokens` to use them. See: https://git.io/fxCyr
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * - The second argument is now required for the sake of explicitness.
   *
   *   ```javascript
   *   // Before v2.0.0
   *   format(new Date(2016, 0, 1))
   *
   *   // v2.0.0 onward
   *   format(new Date(2016, 0, 1), "yyyy-MM-dd'T'HH:mm:ss.SSSxxx")
   *   ```
   *
   * - New format string API for `format` function
   *   which is based on [Unicode Technical Standard #35](https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table).
   *   See [this post](https://blog.date-fns.org/post/unicode-tokens-in-date-fns-v2-sreatyki91jg) for more details.
   *
   * - Characters are now escaped using single quote symbols (`'`) instead of square brackets.
   *
   * @param {Date|Number} date - the original date
   * @param {String} format - the string of tokens
   * @param {Object} [options] - an object with options.
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @param {Number} [options.firstWeekContainsDate=1] - the day of January, which is
   * @param {Boolean} [options.useAdditionalWeekYearTokens=false] - if true, allows usage of the week-numbering year tokens `YY` and `YYYY`;
   *   see: https://git.io/fxCyr
   * @param {Boolean} [options.useAdditionalDayOfYearTokens=false] - if true, allows usage of the day of year tokens `D` and `DD`;
   *   see: https://git.io/fxCyr
   * @returns {String} the formatted date string
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `date` must not be Invalid Date
   * @throws {RangeError} `options.locale` must contain `localize` property
   * @throws {RangeError} `options.locale` must contain `formatLong` property
   * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
   * @throws {RangeError} `options.firstWeekContainsDate` must be between 1 and 7
   * @throws {RangeError} use `yyyy` instead of `YYYY` for formatting years using [format provided] to the input [input provided]; see: https://git.io/fxCyr
   * @throws {RangeError} use `yy` instead of `YY` for formatting years using [format provided] to the input [input provided]; see: https://git.io/fxCyr
   * @throws {RangeError} use `d` instead of `D` for formatting days of the month using [format provided] to the input [input provided]; see: https://git.io/fxCyr
   * @throws {RangeError} use `dd` instead of `DD` for formatting days of the month using [format provided] to the input [input provided]; see: https://git.io/fxCyr
   * @throws {RangeError} format string contains an unescaped latin alphabet character
   *
   * @example
   * // Represent 11 February 2014 in middle-endian format:
   * var result = format(new Date(2014, 1, 11), 'MM/dd/yyyy')
   * //=> '02/11/2014'
   *
   * @example
   * // Represent 2 July 2014 in Esperanto:
   * import { eoLocale } from 'date-fns/locale/eo'
   * var result = format(new Date(2014, 6, 2), "do 'de' MMMM yyyy", {
   *   locale: eoLocale
   * })
   * //=> '2-a de julio 2014'
   *
   * @example
   * // Escape string by single quote characters:
   * var result = format(new Date(2014, 6, 2, 15), "h 'o''clock'")
   * //=> "3 o'clock"
   */

  function format$1(dirtyDate, dirtyFormatStr, dirtyOptions) {
    requiredArgs(2, arguments);
    var formatStr = String(dirtyFormatStr);
    var options = dirtyOptions || {};
    var locale = options.locale || defaultLocale;
    var localeFirstWeekContainsDate = locale.options && locale.options.firstWeekContainsDate;
    var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : toInteger$1(localeFirstWeekContainsDate);
    var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : toInteger$1(options.firstWeekContainsDate); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

    if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
      throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
    }
    var localeWeekStartsOn = locale.options && locale.options.weekStartsOn;
    var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : toInteger$1(localeWeekStartsOn);
    var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : toInteger$1(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

    if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
      throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
    }
    if (!locale.localize) {
      throw new RangeError('locale must contain localize property');
    }
    if (!locale.formatLong) {
      throw new RangeError('locale must contain formatLong property');
    }
    var originalDate = toDate$1(dirtyDate);
    if (!isValid(originalDate)) {
      throw new RangeError('Invalid time value');
    } // Convert the date in system timezone to the same date in UTC+00:00 timezone.
    // This ensures that when UTC functions will be implemented, locales will be compatible with them.
    // See an issue about UTC functions: https://github.com/date-fns/date-fns/issues/376

    var timezoneOffset = getTimezoneOffsetInMilliseconds$1(originalDate);
    var utcDate = subMilliseconds(originalDate, timezoneOffset);
    var formatterOptions = {
      firstWeekContainsDate: firstWeekContainsDate,
      weekStartsOn: weekStartsOn,
      locale: locale,
      _originalDate: originalDate
    };
    var result = formatStr.match(longFormattingTokensRegExp).map(function (substring) {
      var firstCharacter = substring[0];
      if (firstCharacter === 'p' || firstCharacter === 'P') {
        var longFormatter = longFormatters$1[firstCharacter];
        return longFormatter(substring, locale.formatLong, formatterOptions);
      }
      return substring;
    }).join('').match(formattingTokensRegExp).map(function (substring) {
      // Replace two single quote characters with one single quote character
      if (substring === "''") {
        return "'";
      }
      var firstCharacter = substring[0];
      if (firstCharacter === "'") {
        return cleanEscapedString(substring);
      }
      var formatter = formatters$3[firstCharacter];
      if (formatter) {
        if (!options.useAdditionalWeekYearTokens && isProtectedWeekYearToken(substring)) {
          throwProtectedError(substring, dirtyFormatStr, dirtyDate);
        }
        if (!options.useAdditionalDayOfYearTokens && isProtectedDayOfYearToken(substring)) {
          throwProtectedError(substring, dirtyFormatStr, dirtyDate);
        }
        return formatter(utcDate, substring, locale.localize, formatterOptions);
      }
      if (firstCharacter.match(unescapedLatinCharacterRegExp)) {
        throw new RangeError('Format string contains an unescaped latin alphabet character `' + firstCharacter + '`');
      }
      return substring;
    }).join('');
    return result;
  }
  function cleanEscapedString(input) {
    return input.match(escapedStringRegExp)[1].replace(doubleQuoteRegExp, "'");
  }

  /**
   * @name getDaysInMonth
   * @category Month Helpers
   * @summary Get the number of days in a month of the given date.
   *
   * @description
   * Get the number of days in a month of the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the given date
   * @returns {Number} the number of days in a month
   * @throws {TypeError} 1 argument required
   *
   * @example
   * // How many days are in February 2000?
   * const result = getDaysInMonth(new Date(2000, 1))
   * //=> 29
   */

  function getDaysInMonth(dirtyDate) {
    requiredArgs(1, arguments);
    var date = toDate$1(dirtyDate);
    var year = date.getFullYear();
    var monthIndex = date.getMonth();
    var lastDayOfMonth = new Date(0);
    lastDayOfMonth.setFullYear(year, monthIndex + 1, 0);
    lastDayOfMonth.setHours(0, 0, 0, 0);
    return lastDayOfMonth.getDate();
  }

  /**
   * @name subDays
   * @category Day Helpers
   * @summary Subtract the specified number of days from the given date.
   *
   * @description
   * Subtract the specified number of days from the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of days to be subtracted. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} the new date with the days subtracted
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Subtract 10 days from 1 September 2014:
   * const result = subDays(new Date(2014, 8, 1), 10)
   * //=> Fri Aug 22 2014 00:00:00
   */

  function subDays(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var amount = toInteger$1(dirtyAmount);
    return addDays(dirtyDate, -amount);
  }

  /**
   * @name subMonths
   * @category Month Helpers
   * @summary Subtract the specified number of months from the given date.
   *
   * @description
   * Subtract the specified number of months from the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} amount - the amount of months to be subtracted. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
   * @returns {Date} the new date with the months subtracted
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Subtract 5 months from 1 February 2015:
   * const result = subMonths(new Date(2015, 1, 1), 5)
   * //=> Mon Sep 01 2014 00:00:00
   */

  function subMonths(dirtyDate, dirtyAmount) {
    requiredArgs(2, arguments);
    var amount = toInteger$1(dirtyAmount);
    return addMonths(dirtyDate, -amount);
  }

  /**
   * @name sub
   * @category Common Helpers
   * @summary Subtract the specified years, months, weeks, days, hours, minutes and seconds from the given date.
   *
   * @description
   * Subtract the specified years, months, weeks, days, hours, minutes and seconds from the given date.
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Duration} duration - the object with years, months, weeks, days, hours, minutes and seconds to be subtracted
   *
   * | Key     | Description                        |
   * |---------|------------------------------------|
   * | years   | Amount of years to be subtracted   |
   * | months  | Amount of months to be subtracted  |
   * | weeks   | Amount of weeks to be subtracted   |
   * | days    | Amount of days to be subtracted    |
   * | hours   | Amount of hours to be subtracted   |
   * | minutes | Amount of minutes to be subtracted |
   * | seconds | Amount of seconds to be subtracted |
   *
   * All values default to 0
   *
   * @returns {Date} the new date with the seconds subtracted
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Subtract the following duration from 15 June 2017 15:29:20
   * const result = sub(new Date(2017, 5, 15, 15, 29, 20), {
   *   years: 2,
   *   months: 9,
   *   weeks: 1,
   *   days: 7,
   *   hours: 5,
   *   minutes: 9,
   *   seconds: 30
   * })
   * //=> Mon Sep 1 2014 10:19:50
   */

  function sub(date, duration) {
    requiredArgs(2, arguments);
    if (!duration || typeof duration !== 'object') return new Date(NaN);
    var years = duration.years ? toInteger$1(duration.years) : 0;
    var months = duration.months ? toInteger$1(duration.months) : 0;
    var weeks = duration.weeks ? toInteger$1(duration.weeks) : 0;
    var days = duration.days ? toInteger$1(duration.days) : 0;
    var hours = duration.hours ? toInteger$1(duration.hours) : 0;
    var minutes = duration.minutes ? toInteger$1(duration.minutes) : 0;
    var seconds = duration.seconds ? toInteger$1(duration.seconds) : 0; // Subtract years and months

    var dateWithoutMonths = subMonths(date, months + years * 12); // Subtract weeks and days

    var dateWithoutDays = subDays(dateWithoutMonths, days + weeks * 7); // Subtract hours, minutes and seconds

    var minutestoSub = minutes + hours * 60;
    var secondstoSub = seconds + minutestoSub * 60;
    var mstoSub = secondstoSub * 1000;
    var finalDate = new Date(dateWithoutDays.getTime() - mstoSub);
    return finalDate;
  }

  /**
   * @name isAfter
   * @category Common Helpers
   * @summary Is the first date after the second one?
   *
   * @description
   * Is the first date after the second one?
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date that should be after the other one to return true
   * @param {Date|Number} dateToCompare - the date to compare with
   * @returns {Boolean} the first date is after the second date
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Is 10 July 1989 after 11 February 1987?
   * var result = isAfter(new Date(1989, 6, 10), new Date(1987, 1, 11))
   * //=> true
   */

  function isAfter(dirtyDate, dirtyDateToCompare) {
    requiredArgs(2, arguments);
    var date = toDate$1(dirtyDate);
    var dateToCompare = toDate$1(dirtyDateToCompare);
    return date.getTime() > dateToCompare.getTime();
  }

  /**
   * @name isBefore
   * @category Common Helpers
   * @summary Is the first date before the second one?
   *
   * @description
   * Is the first date before the second one?
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date that should be before the other one to return true
   * @param {Date|Number} dateToCompare - the date to compare with
   * @returns {Boolean} the first date is before the second date
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Is 10 July 1989 before 11 February 1987?
   * var result = isBefore(new Date(1989, 6, 10), new Date(1987, 1, 11))
   * //=> false
   */

  function isBefore(dirtyDate, dirtyDateToCompare) {
    requiredArgs(2, arguments);
    var date = toDate$1(dirtyDate);
    var dateToCompare = toDate$1(dirtyDateToCompare);
    return date.getTime() < dateToCompare.getTime();
  }

  /**
   * @name isSameMonth
   * @category Month Helpers
   * @summary Are the given dates in the same month (and year)?
   *
   * @description
   * Are the given dates in the same month (and year)?
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} dateLeft - the first date to check
   * @param {Date|Number} dateRight - the second date to check
   * @returns {Boolean} the dates are in the same month (and year)
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Are 2 September 2014 and 25 September 2014 in the same month?
   * var result = isSameMonth(new Date(2014, 8, 2), new Date(2014, 8, 25))
   * //=> true
   *
   * @example
   * // Are 2 September 2014 and 25 September 2015 in the same month?
   * var result = isSameMonth(new Date(2014, 8, 2), new Date(2015, 8, 25))
   * //=> false
   */

  function isSameMonth(dirtyDateLeft, dirtyDateRight) {
    requiredArgs(2, arguments);
    var dateLeft = toDate$1(dirtyDateLeft);
    var dateRight = toDate$1(dirtyDateRight);
    return dateLeft.getFullYear() === dateRight.getFullYear() && dateLeft.getMonth() === dateRight.getMonth();
  }

  /**
   * @name isToday
   * @category Day Helpers
   * @summary Is the given date today?
   * @pure false
   *
   * @description
   * Is the given date today?
   *
   * > ⚠️ Please note that this function is not present in the FP submodule as
   * > it uses `Date.now()` internally hence impure and can't be safely curried.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to check
   * @returns {Boolean} the date is today
   * @throws {TypeError} 1 argument required
   *
   * @example
   * // If today is 6 October 2014, is 6 October 14:00:00 today?
   * var result = isToday(new Date(2014, 9, 6, 14, 0))
   * //=> true
   */

  function isToday(dirtyDate) {
    requiredArgs(1, arguments);
    return isSameDay(dirtyDate, Date.now());
  }

  /**
   * @name setMonth
   * @category Month Helpers
   * @summary Set the month to the given date.
   *
   * @description
   * Set the month to the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} month - the month of the new date
   * @returns {Date} the new date with the month set
   * @throws {TypeError} 2 arguments required
   *
   * @example
   * // Set February to 1 September 2014:
   * const result = setMonth(new Date(2014, 8, 1), 1)
   * //=> Sat Feb 01 2014 00:00:00
   */

  function setMonth(dirtyDate, dirtyMonth) {
    requiredArgs(2, arguments);
    var date = toDate$1(dirtyDate);
    var month = toInteger$1(dirtyMonth);
    var year = date.getFullYear();
    var day = date.getDate();
    var dateWithDesiredMonth = new Date(0);
    dateWithDesiredMonth.setFullYear(year, month, 15);
    dateWithDesiredMonth.setHours(0, 0, 0, 0);
    var daysInMonth = getDaysInMonth(dateWithDesiredMonth); // Set the last day of the new month
    // if the original date was the last day of the longer month

    date.setMonth(month, Math.min(day, daysInMonth));
    return date;
  }

  /**
   * @name set
   * @category Common Helpers
   * @summary Set date values to a given date.
   *
   * @description
   * Set date values to a given date.
   *
   * Sets time values to date from object `values`.
   * A value is not set if it is undefined or null or doesn't exist in `values`.
   *
   * Note about bundle size: `set` does not internally use `setX` functions from date-fns but instead opts
   * to use native `Date#setX` methods. If you use this function, you may not want to include the
   * other `setX` functions that date-fns provides if you are concerned about the bundle size.
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Object} values - an object with options
   * @param {Number} [values.year] - the number of years to be set
   * @param {Number} [values.month] - the number of months to be set
   * @param {Number} [values.date] - the number of days to be set
   * @param {Number} [values.hours] - the number of hours to be set
   * @param {Number} [values.minutes] - the number of minutes to be set
   * @param {Number} [values.seconds] - the number of seconds to be set
   * @param {Number} [values.milliseconds] - the number of milliseconds to be set
   * @returns {Date} the new date with options set
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `values` must be an object
   *
   * @example
   * // Transform 1 September 2014 into 20 October 2015 in a single line:
   * var result = set(new Date(2014, 8, 20), { year: 2015, month: 9, date: 20 })
   * //=> Tue Oct 20 2015 00:00:00
   *
   * @example
   * // Set 12 PM to 1 September 2014 01:23:45 to 1 September 2014 12:00:00:
   * var result = set(new Date(2014, 8, 1, 1, 23, 45), { hours: 12 })
   * //=> Mon Sep 01 2014 12:23:45
   */
  function set(dirtyDate, values) {
    requiredArgs(2, arguments);
    if (typeof values !== 'object' || values === null) {
      throw new RangeError('values parameter must be an object');
    }
    var date = toDate$1(dirtyDate); // Check if date is Invalid Date because Date.prototype.setFullYear ignores the value of Invalid Date

    if (isNaN(date.getTime())) {
      return new Date(NaN);
    }
    if (values.year != null) {
      date.setFullYear(values.year);
    }
    if (values.month != null) {
      date = setMonth(date, values.month);
    }
    if (values.date != null) {
      date.setDate(toInteger$1(values.date));
    }
    if (values.hours != null) {
      date.setHours(toInteger$1(values.hours));
    }
    if (values.minutes != null) {
      date.setMinutes(toInteger$1(values.minutes));
    }
    if (values.seconds != null) {
      date.setSeconds(toInteger$1(values.seconds));
    }
    if (values.milliseconds != null) {
      date.setMilliseconds(toInteger$1(values.milliseconds));
    }
    return date;
  }

  /**
   * @name setDay
   * @category Weekday Helpers
   * @summary Set the day of the week to the given date.
   *
   * @description
   * Set the day of the week to the given date.
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * @param {Date|Number} date - the date to be changed
   * @param {Number} day - the day of the week of the new date
   * @param {Object} [options] - an object with options.
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @returns {Date} the new date with the day of the week set
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
   *
   * @example
   * // Set week day to Sunday, with the default weekStartsOn of Sunday:
   * var result = setDay(new Date(2014, 8, 1), 0)
   * //=> Sun Aug 31 2014 00:00:00
   *
   * @example
   * // Set week day to Sunday, with a weekStartsOn of Monday:
   * var result = setDay(new Date(2014, 8, 1), 0, { weekStartsOn: 1 })
   * //=> Sun Sep 07 2014 00:00:00
   */
  function setDay(dirtyDate, dirtyDay, dirtyOptions) {
    requiredArgs(2, arguments);
    var options = dirtyOptions || {};
    var locale = options.locale;
    var localeWeekStartsOn = locale && locale.options && locale.options.weekStartsOn;
    var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : toInteger$1(localeWeekStartsOn);
    var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : toInteger$1(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

    if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
      throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
    }
    var date = toDate$1(dirtyDate);
    var day = toInteger$1(dirtyDay);
    var currentDay = date.getDay();
    var remainder = day % 7;
    var dayIndex = (remainder + 7) % 7;
    var delta = 7 - weekStartsOn;
    var diff = day < 0 || day > 6 ? day - (currentDay + delta) % 7 : (dayIndex + delta) % 7 - (currentDay + delta) % 7;
    return addDays(date, diff);
  }

  var script$s = {
    name: 'Time',
    props: {
      value: {
        type: Date,
        required: true
      },
      small: {
        type: Boolean
      }
    },
    methods: {
      sub: sub,
      add: add,
      set: set,
      format: format$1,
      range: _range
    }
  };

  /* script */
  var __vue_script__$s = script$s;

  /* template */
  var __vue_render__$r = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-flex uk-flex-between"
    }, [_c('div', [_c('a', {
      staticClass: "uk-icon-link",
      "class": _vm.small ? 'uk-margin-small-right' : 'uk-margin-right',
      attrs: {
        "href": "",
        "uk-icon": "chevron-left"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.$emit('input', _vm.sub(_vm.value, {
            hours: 1
          }));
        }
      }
    })]), _vm._v(" "), _c('div', {
      attrs: {
        "uk-form-custom": ""
      }
    }, [_c('select', {
      domProps: {
        "value": _vm.format(_vm.value, 'H')
      },
      on: {
        "change": function change($event) {
          _vm.$emit('input', _vm.set(_vm.value, {
            hours: $event.target.value
          }));
        }
      }
    }, _vm._l(_vm.range(24), function (h) {
      return _c('option', {
        key: h,
        domProps: {
          "value": h,
          "textContent": _vm._s(h)
        }
      });
    }), 0), _vm._v(" "), _c('span', {
      staticClass: "uk-text-lead uk-text-background uk-text-primary"
    }, [_vm._v(_vm._s(_vm.format(_vm.value, 'HH')) + "h")])]), _vm._v(" "), _c('div', [_c('a', {
      staticClass: "uk-icon-link",
      "class": _vm.small ? 'uk-margin-small-left' : 'uk-margin-left',
      attrs: {
        "href": "",
        "uk-icon": "chevron-right"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.$emit('input', _vm.add(_vm.value, {
            hours: 1
          }));
        }
      }
    })]), _vm._v("\n\n    :\n\n    "), _c('div', [_c('a', {
      staticClass: "uk-icon-link",
      "class": _vm.small ? 'uk-margin-small-right' : 'uk-margin-right',
      attrs: {
        "href": "",
        "uk-icon": "chevron-left"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.$emit('input', _vm.sub(_vm.value, {
            minutes: 1
          }));
        }
      }
    })]), _vm._v(" "), _c('div', {
      attrs: {
        "uk-form-custom": ""
      }
    }, [_c('select', {
      domProps: {
        "value": _vm.format(_vm.value, 'm')
      },
      on: {
        "change": function change($event) {
          _vm.$emit('input', _vm.set(_vm.value, {
            minutes: $event.target.value
          }));
        }
      }
    }, _vm._l(_vm.range(0, 60, 5), function (h) {
      return _c('option', {
        key: h,
        domProps: {
          "value": h,
          "textContent": _vm._s(h)
        }
      });
    }), 0), _vm._v(" "), _c('span', {
      staticClass: "uk-text-lead uk-text-background uk-text-primary"
    }, [_vm._v(_vm._s(_vm.format(_vm.value, 'mm')) + "m")])]), _vm._v(" "), _c('div', [_c('a', {
      staticClass: "uk-icon-link",
      "class": _vm.small ? 'uk-margin-small-left' : 'uk-margin-left',
      attrs: {
        "href": "",
        "uk-icon": "chevron-right"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.$emit('input', _vm.add(_vm.value, {
            minutes: 1
          }));
        }
      }
    })])]);
  };
  var __vue_staticRenderFns__$r = [];

  /* style */
  var __vue_inject_styles__$s = undefined;
  /* scoped */
  var __vue_scope_id__$s = undefined;
  /* module identifier */
  var __vue_module_identifier__$s = undefined;
  /* functional template */
  var __vue_is_functional_template__$s = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$s = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$r,
    staticRenderFns: __vue_staticRenderFns__$r
  }, __vue_inject_styles__$s, __vue_script__$s, __vue_scope_id__$s, __vue_is_functional_template__$s, __vue_module_identifier__$s, false, undefined, undefined, undefined);

  //
  var script$r = {
    name: 'TimePicker',
    components: {
      Time: __vue_component__$s
    },
    props: {
      value: {
        type: Date
      },
      small: {
        type: Boolean
      }
    },
    data: function data() {
      return {
        selection: null
      };
    },
    created: function created() {
      this.selection = this.value ? this.value : new Date();
    }
  };

  /* script */
  var __vue_script__$r = script$r;

  /* template */
  var __vue_render__$q = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      staticClass: "uk-padding"
    }, [_c('Time', {
      staticClass: "uk-margin-top",
      model: {
        value: _vm.selection,
        callback: function callback($$v) {
          _vm.selection = $$v;
        },
        expression: "selection"
      }
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-margin-large-top uk-flex uk-flex-around"
    }, [_c('button', {
      staticClass: "uk-button",
      "class": {
        'uk-button-small': _vm.small
      },
      on: {
        "click": function click($event) {
          return _vm.$emit('resolve');
        }
      }
    }, [_vm._v(_vm._s(_vm.$t('Cancel')))]), _vm._v(" "), _c('button', {
      staticClass: "uk-button",
      "class": {
        'uk-button-small': _vm.small
      },
      on: {
        "click": function click($event) {
          return _vm.$emit('resolve', _vm.selection);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t('Confirm')))])])], 1);
  };
  var __vue_staticRenderFns__$q = [];

  /* style */
  var __vue_inject_styles__$r = undefined;
  /* scoped */
  var __vue_scope_id__$r = undefined;
  /* module identifier */
  var __vue_module_identifier__$r = undefined;
  /* functional template */
  var __vue_is_functional_template__$r = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$r = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$q,
    staticRenderFns: __vue_staticRenderFns__$q
  }, __vue_inject_styles__$r, __vue_script__$r, __vue_scope_id__$r, __vue_is_functional_template__$r, __vue_module_identifier__$r, false, undefined, undefined, undefined);

  var script$q = {
    name: 'Calendar',
    props: {
      value: {
        type: Date
      },
      min: {
        type: Date
      },
      max: {
        type: Date
      },
      small: {
        type: Boolean
      }
    },
    data: function data() {
      return {
        date: null
      };
    },
    computed: {
      year: function year() {
        var _this$date;
        return (_this$date = this.date) == null ? void 0 : _this$date.getFullYear();
      },
      month: function month() {
        var _this$date2;
        return (_this$date2 = this.date) == null ? void 0 : _this$date2.getMonth();
      },
      dateStyle: function dateStyle() {
        return {
          width: 'calc(100% * 1 / 7.001)',
          margin: this.small ? '2px 0' : 'inherit'
        };
      },
      calendar: function calendar() {
        var start = startOfWeek(new Date(this.year, this.month, 1), {
          weekStartsOn: 1
        });
        var end = endOfWeek(new Date(this.year, this.month + 1, 1), {
          weekStartsOn: 1
        });
        return eachDayOfInterval({
          start: start,
          end: end
        });
      },
      weekDays: function weekDays() {
        var _this = this;
        return _range(1, 8).map(function (day) {
          return format$1(setDay(new Date(), day), _this.small ? 'EEEEEE' : 'E');
        });
      },
      monthsInterval: function monthsInterval() {
        var _this2 = this;
        return _range(12).map(function (month) {
          return new Date(_this2.year, month);
        });
      },
      yearsInterval: function yearsInterval() {
        return [].concat(_range(60).reduce(function (carry) {
          return [carry[0] - 1].concat(carry);
        }, [this.year - 1]), [this.year], _range(20).reduce(function (carry) {
          return [].concat(carry, [carry[carry.length - 1] + 1]);
        }, [this.year + 1]));
      }
    },
    created: function created() {
      this.date = this.value ? this.value : new Date();
    },
    methods: {
      isToday: isToday,
      format: format$1,
      isSameDay: isSameDay,
      add: add,
      sub: sub,
      set: set,
      isWithinCalendarMonth: function isWithinCalendarMonth(date) {
        return isSameMonth(date, this.date);
      },
      isWithinInterval: function isWithinInterval(date) {
        if (this.min && isBefore(date, this.min)) {
          return false;
        }
        if (this.max && isAfter(date, this.max)) {
          return false;
        }
        return true;
      },
      select: function select(date) {
        var _this$value, _this$value2;
        this.$emit('input', set(date, {
          hours: (_this$value = this.value) == null ? void 0 : _this$value.getHours(),
          minutes: (_this$value2 = this.value) == null ? void 0 : _this$value2.getMinutes()
        }));
      }
    }
  };

  /* script */
  var __vue_script__$q = script$q;

  /* template */
  var __vue_render__$p = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "uk-flex uk-flex-between uk-margin"
    }, [_c('div', [_c('a', {
      staticClass: "uk-icon-link uk-margin-right",
      attrs: {
        "href": "",
        "uk-icon": "chevron-left"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.date = _vm.sub(_vm.date, {
            months: 1
          });
        }
      }
    })]), _vm._v(" "), _c('div', {
      staticClass: "uk-flex"
    }, [_c('div', {
      staticClass: "uk-margin-small-right",
      attrs: {
        "uk-form-custom": ""
      }
    }, [_c('select', {
      domProps: {
        "value": _vm.month
      },
      on: {
        "change": function change($event) {
          _vm.date = _vm.set(_vm.date, {
            month: $event.target.value
          });
        }
      }
    }, _vm._l(_vm.monthsInterval, function (m) {
      return _c('option', {
        key: m.getMonth(),
        domProps: {
          "value": m.getMonth(),
          "textContent": _vm._s(_vm.format(m, 'MMMM'))
        }
      });
    }), 0), _vm._v(" "), _c('span', {
      staticClass: "uk-text-lead"
    }, [_vm._v(_vm._s(_vm.format(_vm.date, _vm.small ? 'MMM' : 'MMMM')))])]), _vm._v(" "), _c('div', {
      attrs: {
        "uk-form-custom": ""
      }
    }, [_c('select', {
      domProps: {
        "value": _vm.year
      },
      on: {
        "change": function change($event) {
          _vm.date = _vm.set(_vm.date, {
            year: $event.target.value
          });
        }
      }
    }, _vm._l(_vm.yearsInterval, function (y) {
      return _c('option', {
        key: y,
        domProps: {
          "value": y,
          "textContent": _vm._s(y)
        }
      });
    }), 0), _vm._v(" "), _c('span', {
      staticClass: "uk-text-lead"
    }, [_vm._v(_vm._s(_vm.year))])])]), _vm._v(" "), _c('div', [_c('a', {
      staticClass: "uk-icon-link uk-margin-left",
      attrs: {
        "href": "",
        "uk-icon": "chevron-right"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          _vm.date = _vm.add(_vm.date, {
            months: 1
          });
        }
      }
    })])]), _vm._v(" "), _c('div', {
      staticClass: "uk-grid-collapse uk-child-width-1-7",
      attrs: {
        "uk-grid": ""
      }
    }, [_vm._l(_vm.weekDays, function (day) {
      return _c('div', {
        key: day,
        staticClass: "uk-text-lead uk-text-center",
        "class": {
          'uk-margin-bottom': !_vm.small,
          'uk-margin-small-bottom': _vm.small
        },
        style: _vm.dateStyle,
        domProps: {
          "textContent": _vm._s(day)
        }
      });
    }), _vm._v(" "), _vm._l(_vm.calendar, function (day) {
      return _c('div', {
        key: day.toString(),
        "class": ['uk-card uk-card-body uk-card-hover uk-flex uk-flex-center uk-flex-middle uk-link', {
          'uk-padding-small': !_vm.small,
          'uk-padding-remove': _vm.small,
          'uk-card-primary': _vm.isSameDay(day, _vm.value),
          'uk-card-default': _vm.isToday(day),
          'uk-disabled uk-text-meta': !_vm.isWithinInterval(day),
          'uk-text-meta': !_vm.isWithinCalendarMonth(day)
        }],
        style: _vm.dateStyle,
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.select(day);
          }
        }
      }, [_c('div', {
        "class": ['uk-align-vertical', {}],
        domProps: {
          "textContent": _vm._s(day.getDate())
        }
      })]);
    })], 2)]);
  };
  var __vue_staticRenderFns__$p = [];

  /* style */
  var __vue_inject_styles__$q = undefined;
  /* scoped */
  var __vue_scope_id__$q = undefined;
  /* module identifier */
  var __vue_module_identifier__$q = undefined;
  /* functional template */
  var __vue_is_functional_template__$q = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$q = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$p,
    staticRenderFns: __vue_staticRenderFns__$p
  }, __vue_inject_styles__$q, __vue_script__$q, __vue_scope_id__$q, __vue_is_functional_template__$q, __vue_module_identifier__$q, false, undefined, undefined, undefined);

  //
  var script$p = {
    name: 'DatePicker',
    components: {
      Calendar: __vue_component__$q
    },
    props: {
      value: {
        type: Date
      },
      min: {
        type: Date
      },
      max: {
        type: Date
      },
      small: {
        type: Boolean
      }
    }
  };

  /* script */
  var __vue_script__$p = script$p;

  /* template */
  var __vue_render__$o = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      "class": ['uk-padding', {
        'uk-padding-small': _vm.small
      }]
    }, [_c('Calendar', {
      attrs: {
        "value": _vm.value,
        "min": _vm.min,
        "max": _vm.max,
        "small": _vm.small
      },
      on: {
        "input": function input(v) {
          return _vm.$emit('resolve', v);
        }
      }
    })], 1);
  };
  var __vue_staticRenderFns__$o = [];

  /* style */
  var __vue_inject_styles__$p = undefined;
  /* scoped */
  var __vue_scope_id__$p = undefined;
  /* module identifier */
  var __vue_module_identifier__$p = undefined;
  /* functional template */
  var __vue_is_functional_template__$p = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$p = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$o,
    staticRenderFns: __vue_staticRenderFns__$o
  }, __vue_inject_styles__$p, __vue_script__$p, __vue_scope_id__$p, __vue_is_functional_template__$p, __vue_module_identifier__$p, false, undefined, undefined, undefined);

  //
  var script$o = {
    name: 'DatetimePicker',
    components: {
      Time: __vue_component__$s,
      Calendar: __vue_component__$q
    },
    props: {
      value: {
        type: Date
      },
      min: {
        type: Date
      },
      max: {
        type: Date
      },
      small: {
        type: Boolean
      }
    },
    data: function data() {
      return {
        selection: null
      };
    },
    created: function created() {
      this.selection = this.value ? this.value : new Date();
    }
  };

  /* script */
  var __vue_script__$o = script$o;

  /* template */
  var __vue_render__$n = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', {
      "class": ['uk-padding', {
        'uk-padding-small': _vm.small
      }]
    }, [_c('Calendar', {
      attrs: {
        "min": _vm.min,
        "max": _vm.max,
        "small": _vm.small
      },
      model: {
        value: _vm.selection,
        callback: function callback($$v) {
          _vm.selection = $$v;
        },
        expression: "selection"
      }
    }), _vm._v(" "), _c('Time', {
      staticClass: "uk-margin-top",
      attrs: {
        "small": _vm.small
      },
      model: {
        value: _vm.selection,
        callback: function callback($$v) {
          _vm.selection = $$v;
        },
        expression: "selection"
      }
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-margin-large-top uk-flex uk-flex-around"
    }, [_c('button', {
      staticClass: "uk-button",
      "class": {
        'uk-button-small': _vm.small
      },
      on: {
        "click": function click($event) {
          return _vm.$emit('resolve');
        }
      }
    }, [_vm._v(_vm._s(_vm.$t('Cancel')))]), _vm._v(" "), _c('button', {
      staticClass: "uk-button",
      "class": {
        'uk-button-small': _vm.small
      },
      on: {
        "click": function click($event) {
          return _vm.$emit('resolve', _vm.selection);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t('Confirm')))])])], 1);
  };
  var __vue_staticRenderFns__$n = [];

  /* style */
  var __vue_inject_styles__$o = undefined;
  /* scoped */
  var __vue_scope_id__$o = undefined;
  /* module identifier */
  var __vue_module_identifier__$o = undefined;
  /* functional template */
  var __vue_is_functional_template__$o = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$o = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$n,
    staticRenderFns: __vue_staticRenderFns__$n
  }, __vue_inject_styles__$o, __vue_script__$o, __vue_scope_id__$o, __vue_is_functional_template__$o, __vue_module_identifier__$o, false, undefined, undefined, undefined);

  var components = /*#__PURE__*/Object.freeze({
    __proto__: null,
    Item: __vue_component__$P,
    ResourceListItem: __vue_component__$O,
    ResourcePicker: __vue_component__$K,
    Finder: __vue_component__$M,
    Switcher: __vue_component__$J,
    ModalForm: __vue_component__$E,
    ModalTabs: __vue_component__$D,
    PanelNode: __vue_component__$C,
    FieldsPanel: __vue_component__$F,
    DynamicPanel: __vue_component__$B,
    BuilderPanel: __vue_component__$A,
    NodeStatusError: __vue_component__$z,
    ItemsFinderModal: __vue_component__$y,
    DropdownList: __vue_component__$w,
    DropdownListView: __vue_component__$x,
    OptionsDropdown: __vue_component__$u,
    OptionsDropdownAsync: __vue_component__$t,
    TimePicker: __vue_component__$r,
    DatePicker: __vue_component__$p,
    DatetimePicker: __vue_component__$o
  });

  var script$n = {
    name: 'ContentItem',
    components: {
      Item: __vue_component__$P
    },
    "extends": $fields__default["default"].FieldContentItems.components.ContentItem,
    computed: {
      icon: function icon() {
        return this.field.icon ? this.type.iconSmall : '';
      },
      title: function title() {
        var _this = this;
        var title = this.field.title ? this.field.title.split('||') : ['title'];
        for (var _iterator = _createForOfIteratorHelperLoose(title), _step; !(_step = _iterator()).done;) {
          var _this$type$fields$_ti;
          var _title = _step.value;
          _title = _title.trim();

          // if select field, evaluate selection
          if (((_this$type$fields$_ti = this.type.fields[_title]) == null ? void 0 : _this$type$fields$_ti.type) === 'select') {
            var _ret = function () {
              var titleValue = _this.node.props[_title];
              var options = _this.type.fields[_title].options;
              return {
                v: Object.keys(options).filter(function (key) {
                  return options[key] === titleValue;
                })[0]
              };
            }();
            if (typeof _ret === "object") return _ret.v;
          }
          if (this.node.props[_title]) {
            return stripTags(this.node.props[_title]);
          }
        }
        return this.type.title;
      }
    }
  };
  function stripTags(html) {
    var _fragment;
    return (_fragment = uikitUtil.fragment(html)) == null ? void 0 : _fragment.textContent;
  }

  /* script */
  var __vue_script__$n = script$n;

  /* template */
  var __vue_render__$m = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('Item', {
      attrs: {
        "status-icons": _vm.statusIcons,
        "title": _vm.title,
        "icon": _vm.icon
      },
      on: {
        "edit": function edit($event) {
          return _vm.Builder.edit(_vm.node);
        },
        "copy": function copy($event) {
          return _vm.Builder.copy(_vm.node);
        },
        "remove": function remove($event) {
          return _vm.Builder.remove(_vm.node);
        }
      }
    });
  };
  var __vue_staticRenderFns__$m = [];

  /* style */
  var __vue_inject_styles__$n = undefined;
  /* scoped */
  var __vue_scope_id__$n = undefined;
  /* module identifier */
  var __vue_module_identifier__$n = undefined;
  /* functional template */
  var __vue_is_functional_template__$n = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$n = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$m,
    staticRenderFns: __vue_staticRenderFns__$m
  }, __vue_inject_styles__$n, __vue_script__$n, __vue_scope_id__$n, __vue_is_functional_template__$n, __vue_module_identifier__$n, false, undefined, undefined, undefined);

  //
  var script$m = {
    name: 'ContenItems',
    components: {
      ContentItem: __vue_component__$n
    },
    "extends": $fields__default["default"].FieldContentItems,
    methods: {
      addFromLibrary: function addFromLibrary() {
        var _this = this;
        var filter = this.field.filter;
        var elements = Object.values(this.Builder.types);
        if (filter != null && filter.group) {
          elements = elements.filter(function (el) {
            return el.group === filter.group;
          });
        }
        if (filter != null && filter.name) {
          elements = elements.filter(function (el) {
            return el.name.match(new RegExp(filter.name));
          });
        }
        if (elements.length === 1) {
          this.addItem(elements[0].name);
          return;
        }
        this.$dropdown(__vue_component__$u, {
          items: elements.map(function (type) {
            return {
              id: type.name,
              name: type.title,
              icon: type.iconSmall
            };
          })
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (name) {
          name && _this.addItem(name);
        });
      },
      addItem: function addItem(name) {
        var _this2 = this;
        this.Builder.add(this.$node, name, this.Builder.append).then(function (item) {
          return _this2.Builder.edit(item);
        });
      }
    }
  };

  /* script */
  var __vue_script__$m = script$m;

  /* template */
  var __vue_render__$l = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_vm.isEmpty(_vm.$node.children) ? _c('p', {
      staticClass: "uk-text-muted"
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtEmpty || 'No items yet.')))]) : _c('ul', {
      directives: [{
        name: "sortable",
        rawName: "v-sortable",
        value: {
          group: 'content-items'
        },
        expression: "{group: 'content-items'}"
      }],
      staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-sortable yo-nav-iconnav uk-margin",
      attrs: {
        "cls-custom": "yo-nav-sortable-drag"
      }
    }, _vm._l(_vm.$node.children, function (child) {
      return _c('ContentItem', {
        key: _vm.Builder.key(child),
        ref: "items",
        refInFor: true,
        attrs: {
          "node": child,
          "field": _vm.field
        }
      });
    }), 1), _vm._v(" "), _c('div', {
      staticClass: "uk-grid uk-grid-small uk-child-width-auto"
    }, [_c('div', [_vm.field.item ? _c('button', {
      staticClass: "uk-button uk-button-default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          return _vm.add(_vm.field.item);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.button || 'Add Item')))]) : _c('button', {
      staticClass: "uk-button uk-button-default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.addFromLibrary
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.button || 'Add Item')))])])])]);
  };
  var __vue_staticRenderFns__$l = [];

  /* style */
  var __vue_inject_styles__$m = undefined;
  /* scoped */
  var __vue_scope_id__$m = undefined;
  /* module identifier */
  var __vue_module_identifier__$m = undefined;
  /* functional template */
  var __vue_is_functional_template__$m = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$m = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$l,
    staticRenderFns: __vue_staticRenderFns__$l
  }, __vue_inject_styles__$m, __vue_script__$m, __vue_scope_id__$m, __vue_is_functional_template__$m, __vue_module_identifier__$m, false, undefined, undefined, undefined);

  //
  var errors = {
    'unknown-condition': 'Unknown condition stated',
    'missing-condition': 'Not all conditions stated',
    'invalid-syntax': 'Invalid Syntax'
  };
  var script$l = {
    "extends": $fields__default["default"].FieldText,
    data: function data() {
      return {
        draft: ''
      };
    },
    computed: {
      input: {
        set: function set(val) {
          this.draft = val;
          if (!this.error) {
            this.value = val;
          }
        },
        get: function get() {
          return this.draft;
        }
      },
      validation: function validation() {
        return this.validate(this.draft);
      },
      error: function error() {
        if (this.validation !== true) {
          return errors[this.validation];
        }
        return '';
      },
      id: function id() {
        return "simple-query-field-" + this.name;
      },
      $connection: function $connection() {
        var _this$values, _this$field;
        return (_this$values = this.values) == null ? void 0 : _this$values[(_this$field = this.field) == null ? void 0 : _this$field.connection];
      },
      conditions: function conditions() {
        return (this.$connection || []).map(function (c, i) {
          return (i + 1).toString();
        });
      },
      totalConditions: function totalConditions() {
        return this.conditions.length;
      },
      defaultQuery: function defaultQuery() {
        return this.conditions.map(function (q) {
          return "(" + q + ")";
        }).join(' AND ');
      }
    },
    created: function created() {
      this.draft = this.value;
    },
    methods: {
      createQuery: function createQuery(operator) {
        if (operator === void 0) {
          operator = 'AND';
        }
        return this.conditions.map(function (q) {
          return "{" + q + "}";
        }).join(" " + operator + " ");
      },
      createGroupedQuery: function createGroupedQuery(operator) {
        if (operator === void 0) {
          operator = 'AND';
        }
        var inverse = operator === 'AND' ? 'OR' : 'AND';
        var query = this.createQuery(inverse).replace(/(\{\d\} (OR|AND) \{\d\})/g, '($1)');
        if (operator === 'AND') {
          return query.replace(/\) (OR) (\{|\()/g, ') AND $2');
        } else {
          return query.replace(/\) (AND) (\{|\()/g, ') OR $2');
        }
      },
      validate: function validate(value) {
        var _this = this;
        if (!value) {
          return true;
        }
        var operatorRegex = /[})]([^{}()]*)[{(]/g;
        var conditionRegex = /\{([\w ]*)\}/g;
        var openingParenthesis = value.match(/\(/g);
        var closingParenthesis = value.match(/\)/g);
        var openingBrackets = value.match(/\{/g);
        var closingBrackets = value.match(/\}/g);
        var operators = Array.from(value.matchAll(operatorRegex)).map(function (g) {
          return g[1];
        }).filter(Boolean);
        var conditions = Array.from(value.matchAll(conditionRegex)).map(function (g) {
          return g[1];
        }).filter(Boolean);
        if (value.match(/[^0-9{}()ANDOR ]/)) {
          return 'invalid-syntax';
        }
        if (value.match(/(^[^{(])|[^})]$/)) {
          return 'invalid-syntax';
        }
        if (value.match(/{}|\(\)/)) {
          return 'invalid-syntax';
        }
        if ((openingParenthesis == null ? void 0 : openingParenthesis.length) !== (closingParenthesis == null ? void 0 : closingParenthesis.length)) {
          return 'invalid-syntax';
        }
        if ((openingBrackets == null ? void 0 : openingBrackets.length) !== (closingBrackets == null ? void 0 : closingBrackets.length)) {
          return 'invalid-syntax';
        }
        if (!operators.every(function (o) {
          return o.trim().match(/^(AND|OR)$/);
        })) {
          return 'invalid-syntax';
        }
        if (!conditions.every(function (name) {
          return _this.conditions.includes(name);
        })) {
          return 'unknown-condition';
        }

        // if (!this.conditions.every(name => conditions.includes(name))) {
        //     return 'missing-condition';
        // }

        return true;
      }
    }
  };

  /* script */
  var __vue_script__$l = script$l;

  /* template */
  var __vue_render__$k = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return !_vm.$connection ? _c('div', [_vm._v("\n    Failed to connect to conditions.\n")]) : _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      },
      domProps: {
        "value": _vm.input
      }
    }) : _c('div', [_c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model.trim",
        value: _vm.input,
        expression: "input",
        modifiers: {
          "trim": true
        }
      }],
      staticClass: "uk-input",
      "class": {
        'uk-text-danger': _vm.error
      },
      attrs: {
        "list": _vm.id,
        "type": "text",
        "placeholder": _vm.createQuery('AND')
      },
      domProps: {
        "value": _vm.input
      },
      on: {
        "input": function input($event) {
          if ($event.target.composing) {
            return;
          }
          _vm.input = $event.target.value.trim();
        },
        "blur": function blur($event) {
          return _vm.$forceUpdate();
        }
      }
    }, 'input', _vm.attributes, false)), _vm._v(" "), _vm.error ? _c('div', {
      staticClass: "uk-text-danger uk-text-small"
    }, [_vm._v(_vm._s(_vm.error))]) : _vm._e(), _vm._v(" "), _c('datalist', {
      attrs: {
        "id": _vm.id
      }
    }, [_vm.conditions.length === 2 ? _c('option', {
      domProps: {
        "value": _vm.createQuery('AND')
      }
    }, [_vm._v("AND")]) : _vm._e(), _vm._v(" "), _vm.conditions.length === 2 ? _c('option', {
      domProps: {
        "value": _vm.createQuery('OR')
      }
    }, [_vm._v("OR")]) : _vm._e(), _vm._v(" "), _vm.conditions.length > 2 ? _c('option', {
      domProps: {
        "value": _vm.createGroupedQuery('AND')
      }
    }, [_vm._v("AND")]) : _vm._e(), _vm._v(" "), _vm.conditions.length > 2 ? _c('option', {
      domProps: {
        "value": _vm.createGroupedQuery('OR')
      }
    }, [_vm._v("OR")]) : _vm._e()])]);
  };
  var __vue_staticRenderFns__$k = [];

  /* style */
  var __vue_inject_styles__$l = undefined;
  /* scoped */
  var __vue_scope_id__$l = undefined;
  /* module identifier */
  var __vue_module_identifier__$l = undefined;
  /* functional template */
  var __vue_is_functional_template__$l = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$l = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$k,
    staticRenderFns: __vue_staticRenderFns__$k
  }, __vue_inject_styles__$l, __vue_script__$l, __vue_scope_id__$l, __vue_is_functional_template__$l, __vue_module_identifier__$l, false, undefined, undefined, undefined);

  var script$k = {
    name: 'SubNodes',
    components: {
      Item: __vue_component__$P
    },
    directives: {
      Sortable: $fields__default["default"].FieldContentItems.directives.Sortable
    },
    "extends": $fields__default["default"].FieldContentItems["extends"],
    inject: {
      Sidebar: {},
      Builder: {
        "default": undefined
      },
      $node: {
        "default": undefined
      }
    },
    created: function created() {
      if (!uikitUtil.isArray(this.value)) {
        this.value = [];
      }
    },
    methods: {
      isEmpty: uikitUtil.isEmpty,
      add: function add() {
        this.push({
          props: {}
        });
        this.edit(this.value.length - 1);
      },
      edit: function edit(index) {
        var node = this.value[index];
        if (!(node != null && node.props)) {
          return;
        }
        if (this.Builder) {
          var _this$field;
          this.Builder.adjacentOf = (_this$field = this.field) != null && _this$field.adjacent ? this.$node : null;
        }
        this.$trigger('openPanel', _extends({}, this.getPanel(this.field.panel), {
          props: {
            node: node,
            builder: this.Builder,
            values: node.props,
            rootPanelValues: this.values
          }
        }));
      },
      push: function push(value) {
        this.value = [].concat(this.value, [value]);
      },
      remove: function remove(index) {
        this.value.splice(index, 1);
      },
      copy: function copy(index) {
        this.value.splice(index, 0, deepCopy(this.value[index]));
      },
      move: function move(child, parent, toIndex) {
        var fromIndex = uikitUtil.findIndex(parent.$children, function (c) {
          return c === child;
        });
        reindex(this.value, fromIndex, toIndex);
      },
      getPanel: function getPanel(panel) {
        if (!panel) {
          throw new Error('Invalid Panel');
        }
        if (uikitUtil.isString(panel)) {
          var _this$Sidebar, _this$Sidebar$panel, _this$Sidebar$panel$p, _this$Sidebar2, _this$Sidebar2$panels;
          panel = _extends({
            name: panel
          }, ((_this$Sidebar = this.Sidebar) == null ? void 0 : (_this$Sidebar$panel = _this$Sidebar.panel) == null ? void 0 : (_this$Sidebar$panel$p = _this$Sidebar$panel.panels) == null ? void 0 : _this$Sidebar$panel$p[panel]) || ((_this$Sidebar2 = this.Sidebar) == null ? void 0 : (_this$Sidebar2$panels = _this$Sidebar2.panels) == null ? void 0 : _this$Sidebar2$panels[panel]));
        }
        panel = _extends({}, panel, {
          component: panelComponent$1
        });
        if (!panel.name) {
          throw new Error('Panel is missing name');
        }
        return panel;
      }
    }
  };
  var panelComponent$1 = {
    name: 'BuilderPanel',
    // required for source builder

    "extends": __vue_component__$A,
    events: {
      'yooessentials-prerequest': function yooessentialsPrerequest(e) {
        var _e$params$0$form;
        e.params[0]['form'] = _extends({}, (_e$params$0$form = e.params[0]['form']) != null ? _e$params$0$form : {}, this.values);
      }
    }
  };

  /* script */
  var __vue_script__$k = script$k;

  /* template */
  var __vue_render__$j = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return !_vm.field.panel ? _c('div', {
      staticClass: "uk-text-danger"
    }, [_vm._v("\n    Panel not specified\n")]) : _vm.isEmpty(_vm.value) ? _c('button', {
      staticClass: "uk-button yo-button-panel yooessentials-button-plus uk-width-1-1",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtEmpty || 'Add')))]) : _c('div', [_c('ul', {
      directives: [{
        name: "sortable",
        rawName: "v-sortable",
        value: {
          group: 'settings-items'
        },
        expression: "{group: 'settings-items'}"
      }],
      staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-sortable yo-nav-iconnav uk-margin uk-margin-remove-bottom",
      attrs: {
        "cls-custom": "yo-nav-sortable-drag"
      }
    }, _vm._l(_vm.value, function (item, i) {
      return _c('Item', {
        key: i,
        attrs: {
          "title": item.title
        },
        on: {
          "edit": function edit($event) {
            return _vm.edit(i);
          },
          "copy": function copy($event) {
            return _vm.copy(i);
          },
          "remove": function remove($event) {
            return _vm.remove(i);
          }
        }
      });
    }), 1), _vm._v(" "), _c('div', [_c('hr', {
      staticClass: "uk-margin-small-bottom"
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-flex uk-flex-right"
    }, [_c('a', {
      staticClass: "ye-builder-icon-add",
      attrs: {
        "href": "",
        "title": _vm.$t(_vm.field.txtEmpty || 'Add'),
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    })])])]);
  };
  var __vue_staticRenderFns__$j = [];

  /* style */
  var __vue_inject_styles__$k = undefined;
  /* scoped */
  var __vue_scope_id__$k = undefined;
  /* module identifier */
  var __vue_module_identifier__$k = undefined;
  /* functional template */
  var __vue_is_functional_template__$k = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$k = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$j,
    staticRenderFns: __vue_staticRenderFns__$j
  }, __vue_inject_styles__$k, __vue_script__$k, __vue_scope_id__$k, __vue_is_functional_template__$k, __vue_module_identifier__$k, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script$j = {
    name: 'RepeatableItem',
    props: {
      total: {
        type: Number,
        required: true
      },
      values: {
        type: Object,
        required: true
      },
      orderable: {
        type: Boolean,
        "default": true
      },
      separator: {
        type: Boolean,
        "default": false
      },
      txtAdd: {
        type: String,
        "default": 'Add'
      }
    },
    computed: {
      index: function index() {
        return this.$vnode.key;
      }
    }
  };

  /* script */
  var __vue_script__$j = script$j;

  /* template */
  var __vue_render__$i = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('li', {
      staticClass: "uk-visible-toggle",
      attrs: {
        "tabindex": "-1"
      }
    }, [_c('div', [_vm._t("default", null, {
      "values": _vm.values
    })], 2), _vm._v(" "), _vm.separator ? _c('hr', {
      staticClass: "uk-margin-small-bottom"
    }) : _vm._e(), _vm._v(" "), _c('div', {
      staticClass: "uk-flex uk-flex-between",
      "class": {
        'uk-margin-small-top': !_vm.separator
      }
    }, [_c('div', [_vm.index + 1 === _vm.total ? _c('button', {
      staticClass: "uk-button uk-button-small uk-button-default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('add');
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.txtAdd)))]) : _vm._e()]), _vm._v(" "), _c('ul', {
      staticClass: "uk-grid uk-grid-collapse uk-invisible-hover"
    }, [_c('li', {
      key: "delete"
    }, [_c('a', {
      staticClass: "yo-builder-icon-delete",
      attrs: {
        "href": "",
        "title": _vm.$t('Delete'),
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('remove');
        }
      }
    })]), _vm._v(" "), _vm.orderable && _vm.index !== 0 ? _c('li', {
      key: "moveup"
    }, [_c('a', {
      staticClass: "uk-icon-link",
      attrs: {
        "href": "",
        "title": _vm.$t('Move Up'),
        "uk-tooltip": "delay: 500",
        "uk-icon": "arrow-up"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('move', -1);
        }
      }
    })]) : _vm._e(), _vm._v(" "), _vm.orderable && _vm.index + 1 !== _vm.total ? _c('li', {
      key: "movedown"
    }, [_c('a', {
      staticClass: "uk-icon-link",
      attrs: {
        "href": "",
        "title": _vm.$t('Move Down'),
        "uk-tooltip": "delay: 500",
        "uk-icon": "arrow-down"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.$emit('move', 1);
        }
      }
    })]) : _vm._e()])])]);
  };
  var __vue_staticRenderFns__$i = [];

  /* style */
  var __vue_inject_styles__$j = undefined;
  /* scoped */
  var __vue_scope_id__$j = undefined;
  /* module identifier */
  var __vue_module_identifier__$j = undefined;
  /* functional template */
  var __vue_is_functional_template__$j = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$j = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$i,
    staticRenderFns: __vue_staticRenderFns__$i
  }, __vue_inject_styles__$j, __vue_script__$j, __vue_scope_id__$j, __vue_is_functional_template__$j, __vue_module_identifier__$j, false, undefined, undefined, undefined);

  //
  var script$i = {
    name: 'RepeatableField',
    components: {
      RepeatableItem: __vue_component__$j
    },
    "extends": $fields__default["default"].FieldText["extends"],
    computed: {
      repeatableField: function repeatableField() {
        return $fields__default["default"][uikitUtil.camelize("Field-" + (this.repeat || 'text'))];
      }
    },
    watch: {
      value: function value() {
        this.init();
      }
    },
    created: function created() {
      this.init();
    },
    methods: {
      init: function init() {
        if (!uikitUtil.isArray(this.value) || this.value.length === 0) {
          this.value = [null];
        }
      },
      add: function add() {
        this.push(null);
      },
      set: function set(index, value) {
        this.value[index] = value;
        this.value = [].concat(this.value);
      },
      remove: function remove(index) {
        this.value.splice(index, 1);
        this.value = [].concat(this.value);
      },
      push: function push(value) {
        this.value = [].concat(this.value, [value]);
      },
      copy: function copy(index) {
        this.push(this.value[index]);
      },
      move: function move(index, position) {
        reindex(this.value, index, index + position);
      }
    }
  };

  /* script */
  var __vue_script__$i = script$i;

  /* template */
  var __vue_render__$h = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('ul', {
      staticClass: "uk-list uk-margin-remove"
    }, _vm._l(_vm.value, function (v, i) {
      var _obj;
      return _c('RepeatableItem', {
        key: i,
        attrs: {
          "total": _vm.value.length,
          "values": (_obj = {}, _obj[i] = v, _obj)
        },
        on: {
          "copy": function copy($event) {
            return _vm.copy(i);
          },
          "move": function move(pos) {
            return _vm.move(i, pos);
          },
          "remove": function remove($event) {
            return _vm.remove(i);
          },
          "add": function add($event) {
            return _vm.add(i + 1);
          }
        },
        scopedSlots: _vm._u([{
          key: "default",
          fn: function fn(ref) {
            var values = ref.values;
            return [_c(_vm.repeatableField, {
              tag: "component",
              attrs: {
                "values": values,
                "field": Object.assign({}, _vm.field, {
                  name: [i]
                })
              },
              on: {
                "change": function change(v) {
                  return _vm.set(i, v);
                }
              }
            })];
          }
        }], null, true)
      });
    }), 1);
  };
  var __vue_staticRenderFns__$h = [];

  /* style */
  var __vue_inject_styles__$i = undefined;
  /* scoped */
  var __vue_scope_id__$i = undefined;
  /* module identifier */
  var __vue_module_identifier__$i = undefined;
  /* functional template */
  var __vue_is_functional_template__$i = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$i = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$h,
    staticRenderFns: __vue_staticRenderFns__$h
  }, __vue_inject_styles__$i, __vue_script__$i, __vue_scope_id__$i, __vue_is_functional_template__$i, __vue_module_identifier__$i, false, undefined, undefined, undefined);

  //
  var script$h = {
    name: 'RepeatableMulti',
    components: {
      FieldsPanel: __vue_component__$F
    },
    "extends": __vue_component__$i,
    events: {
      'yooessentials-resolve-field-argument': function yooessentialsResolveFieldArgument(e, params) {
        var repeatableItem = vueClosestParent(e.origin, function (instance) {
          return get$1(instance, '$options._componentTag') === 'RepeatableItem';
        });
        if (!repeatableItem) {
          return;
        }
        for (var key in params) {
          params[key] = params[key].replace(/#__{repeatable_index}/, this.$children.indexOf(repeatableItem));
        }
      }
    },
    methods: {
      isEmpty: uikitUtil.isEmpty,
      init: function init() {
        if (!uikitUtil.isArray(this.value)) {
          this.value = [];
        }
      },
      add: function add(index) {
        this.value.splice(index, 0, {});
      },
      set: function set(index, name, v) {
        if (!this.value[index]) {
          this.$set(this.value, index, {});
        }
        this.$set(this.value[index], name, v);
      },
      copy: function copy(index) {
        this.value.splice(index, 0, deepCopy(this.value[index]));
      }
    }
  };

  /* script */
  var __vue_script__$h = script$h;

  /* template */
  var __vue_render__$g = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.isEmpty(_vm.value) ? _c('div', [_c('button', {
      staticClass: "uk-button uk-button-default uk-margin-small-top uk-width-1-1",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtAdd || 'Add')))])]) : _c('ul', {
      staticClass: "uk-list"
    }, _vm._l(_vm.value, function (v, i) {
      return _c('RepeatableItem', {
        key: i,
        attrs: {
          "values": v,
          "total": _vm.value.length,
          "orderable": _vm.field.orderable,
          "separator": true,
          "txt-add": _vm.field.txtAdd
        },
        on: {
          "copy": function copy($event) {
            return _vm.copy(i);
          },
          "move": function move(pos) {
            return _vm.move(i, pos);
          },
          "remove": function remove($event) {
            return _vm.remove(i);
          },
          "add": function add($event) {
            return _vm.add(i + 1);
          }
        },
        scopedSlots: _vm._u([{
          key: "default",
          fn: function fn(ref) {
            var values = ref.values;
            return [_c('FieldsPanel', {
              attrs: {
                "panel": {
                  fields: _vm.field.fields
                },
                "values": values
              }
            })];
          }
        }], null, true)
      });
    }), 1);
  };
  var __vue_staticRenderFns__$g = [];

  /* style */
  var __vue_inject_styles__$h = undefined;
  /* scoped */
  var __vue_scope_id__$h = undefined;
  /* module identifier */
  var __vue_module_identifier__$h = undefined;
  /* functional template */
  var __vue_is_functional_template__$h = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$h = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$g,
    staticRenderFns: __vue_staticRenderFns__$g
  }, __vue_inject_styles__$h, __vue_script__$h, __vue_scope_id__$h, __vue_is_functional_template__$h, __vue_module_identifier__$h, false, undefined, undefined, undefined);

  var script$g = {
    name: 'SettingsPanel',
    components: {
      Item: __vue_component__$P
    },
    directives: {
      Sortable: $fields__default["default"].FieldContentItems.directives.Sortable
    },
    "extends": $fields__default["default"].FieldContentItems["extends"],
    inject: {
      Sidebar: {},
      Builder: {
        "default": undefined
      },
      $node: {
        "default": undefined
      }
    },
    created: function created() {
      if (!uikitUtil.isArray(this.value)) {
        this.value = [];
      }
    },
    methods: {
      isEmpty: uikitUtil.isEmpty,
      add: function add() {
        this.push({});
        this.edit(this.value.length - 1);
      },
      edit: function edit(index) {
        var node = this.value[index];
        if (this.Builder) {
          var _this$field;
          this.Builder.adjacentOf = (_this$field = this.field) != null && _this$field.adjacent ? this.$node : null;
        }
        this.$trigger('openPanel', _extends({}, this.getPanel(this.field.panel), {
          props: {
            node: node,
            values: node,
            builder: this.Builder,
            rootPanelValues: this.values
          }
        }));
      },
      push: function push(value) {
        this.value = [].concat(this.value, [value]);
      },
      remove: function remove(index) {
        this.value.splice(index, 1);
      },
      copy: function copy(index) {
        this.value.splice(index, 0, deepCopy(this.value[index]));
      },
      move: function move(child, parent, toIndex) {
        var fromIndex = uikitUtil.findIndex(parent.$children, function (c) {
          return c === child;
        });
        reindex(this.value, fromIndex, toIndex);
      },
      getPanel: function getPanel(panel) {
        if (!panel) {
          throw new Error('Invalid Panel');
        }
        if (uikitUtil.isString(panel)) {
          var _this$Sidebar, _this$Sidebar$panel, _this$Sidebar$panel$p, _this$Sidebar2, _this$Sidebar2$panels;
          panel = _extends({
            name: panel
          }, ((_this$Sidebar = this.Sidebar) == null ? void 0 : (_this$Sidebar$panel = _this$Sidebar.panel) == null ? void 0 : (_this$Sidebar$panel$p = _this$Sidebar$panel.panels) == null ? void 0 : _this$Sidebar$panel$p[panel]) || ((_this$Sidebar2 = this.Sidebar) == null ? void 0 : (_this$Sidebar2$panels = _this$Sidebar2.panels) == null ? void 0 : _this$Sidebar2$panels[panel]));
        }
        panel = _extends({}, panel, {
          component: panelComponent
        });
        if (!panel.name) {
          throw new Error('Panel is missing name');
        }
        return panel;
      },
      getItemTitle: function getItemTitle(item) {
        var _this$field2, _this$field$title, _this$field3;
        if (uikitUtil.isString((_this$field2 = this.field) == null ? void 0 : _this$field2.title)) {
          this.field.title = {
            prop: this.field.title
          };
        }
        var title = _extends({
          prop: 'title',
          "default": 'Item'
        }, (_this$field$title = (_this$field3 = this.field) == null ? void 0 : _this$field3.title) != null ? _this$field$title : {});
        return this.stripTags(item[title.prop]) || title["default"];
      },
      stripTags: function stripTags(html) {
        var _fragment;
        return (_fragment = uikitUtil.fragment(html)) == null ? void 0 : _fragment.textContent;
      }
    }
  };
  var panelComponent = {
    name: 'BuilderPanel',
    // required for source builder

    "extends": __vue_component__$A,
    events: {
      'yooessentials-prerequest': function yooessentialsPrerequest(e) {
        var _e$params$0$form;
        e.params[0]['form'] = _extends({}, (_e$params$0$form = e.params[0]['form']) != null ? _e$params$0$form : {}, this.values);
      }
    }
  };

  /* script */
  var __vue_script__$g = script$g;

  /* template */
  var __vue_render__$f = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return !_vm.field.panel ? _c('div', {
      staticClass: "uk-text-danger"
    }, [_vm._v("\n    Panel not specified\n")]) : _vm.isEmpty(_vm.value) ? _c('button', {
      staticClass: "uk-button yo-button-panel yooessentials-button-plus uk-width-1-1",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtEmpty || 'Add')))]) : _c('div', [_c('ul', {
      directives: [{
        name: "sortable",
        rawName: "v-sortable",
        value: {
          group: 'settings-items'
        },
        expression: "{group: 'settings-items'}"
      }],
      staticClass: "uk-nav uk-nav-default yo-sidebar-marginless yo-nav-sortable yo-nav-iconnav uk-margin uk-margin-remove-bottom",
      attrs: {
        "cls-custom": "yo-nav-sortable-drag"
      }
    }, _vm._l(_vm.value, function (item, i) {
      return _c('Item', {
        key: i,
        attrs: {
          "title": _vm.getItemTitle(item)
        },
        on: {
          "edit": function edit($event) {
            return _vm.edit(i);
          },
          "copy": function copy($event) {
            return _vm.copy(i);
          },
          "remove": function remove($event) {
            return _vm.remove(i);
          }
        }
      });
    }), 1), _vm._v(" "), _c('div', [_c('hr', {
      staticClass: "uk-margin-small-bottom"
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-flex uk-flex-right"
    }, [_c('a', {
      staticClass: "ye-builder-icon-add",
      attrs: {
        "href": "",
        "title": _vm.$t(_vm.field.txtEmpty || 'Add'),
        "uk-tooltip": "delay: 1000"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    })])])]);
  };
  var __vue_staticRenderFns__$f = [];

  /* style */
  var __vue_inject_styles__$g = undefined;
  /* scoped */
  var __vue_scope_id__$g = undefined;
  /* module identifier */
  var __vue_module_identifier__$g = undefined;
  /* functional template */
  var __vue_is_functional_template__$g = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$g = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$f,
    staticRenderFns: __vue_staticRenderFns__$f
  }, __vue_inject_styles__$g, __vue_script__$g, __vue_scope_id__$g, __vue_is_functional_template__$g, __vue_module_identifier__$g, false, undefined, undefined, undefined);

  var script$f = {
    name: 'InputDrop',
    "extends": $fields__default["default"].FieldText,
    inject: {
      Sidebar: {
        "default": {}
      }
    },
    data: function data() {
      return {
        items: []
      };
    },
    created: function created() {
      if (this.field.items) {
        this.items = this.field.items;
      }
    },
    methods: {
      open: function open() {
        var _this = this;
        var params = _extends({}, this.field.params);
        this.$trigger('yooessentials-resolve-field-argument', params);
        this.$dropdown(this.field.endpoint ? __vue_component__$t : __vue_component__$u, {
          params: params,
          items: this.items,
          map: this.field.map,
          endpoint: this.field.endpoint,
          dropMaxSize: this.field.dropMaxSize
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (item) {
          uikitUtil.isUndefined(item) || (_this.value = item);
        })["catch"](function () {});
      }
    }
  };

  /* script */
  var __vue_script__$f = script$f;

  /* template */
  var __vue_render__$e = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      }
    }) : _c('div', [_c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [_c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Pick'),
        "uk-icon": "album",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    })])])]), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model",
        value: _vm.value,
        expression: "value"
      }],
      staticClass: "uk-input yo-input-iconnav-right",
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.value
      },
      on: {
        "input": function input($event) {
          if ($event.target.composing) {
            return;
          }
          _vm.value = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))])]);
  };
  var __vue_staticRenderFns__$e = [];

  /* style */
  var __vue_inject_styles__$f = undefined;
  /* scoped */
  var __vue_scope_id__$f = undefined;
  /* module identifier */
  var __vue_module_identifier__$f = undefined;
  /* functional template */
  var __vue_is_functional_template__$f = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$f = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$e,
    staticRenderFns: __vue_staticRenderFns__$e
  }, __vue_inject_styles__$f, __vue_script__$f, __vue_scope_id__$f, __vue_is_functional_template__$f, __vue_module_identifier__$f, false, undefined, undefined, undefined);

  //
  var script$e = {
    name: 'SelectDrop',
    "extends": __vue_component__$f
  };

  /* script */
  var __vue_script__$e = script$e;

  /* template */
  var __vue_render__$d = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('a', _vm._b({
      staticClass: "uk-select",
      attrs: {
        "href": ""
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        },
        "keydown": function keydown($event) {
          if (!$event.type.indexOf('key') && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
            return null;
          }
          return _vm.open.apply(null, arguments);
        }
      }
    }, 'a', _vm.attributes, false), [_vm._v("\n    " + _vm._s(_vm.value) + "\n")]);
  };
  var __vue_staticRenderFns__$d = [];

  /* style */
  var __vue_inject_styles__$e = undefined;
  /* scoped */
  var __vue_scope_id__$e = undefined;
  /* module identifier */
  var __vue_module_identifier__$e = undefined;
  /* functional template */
  var __vue_is_functional_template__$e = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$e = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$d,
    staticRenderFns: __vue_staticRenderFns__$d
  }, __vue_inject_styles__$e, __vue_script__$e, __vue_scope_id__$e, __vue_is_functional_template__$e, __vue_module_identifier__$e, false, undefined, undefined, undefined);

  //
  var script$d = {
    name: 'SelectDropdown',
    "extends": $fields__default["default"].FieldText,
    computed: {
      entries: function entries() {
        return this.flattenOptions(this.options);
      },
      selected: {
        get: function get() {
          if (!uikitUtil.isUndefined(this.value)) {
            return this.value;
          }
          return this.attributes.multiple ? [] : '';
        },
        set: function set(value) {
          this.value = value;
        }
      },
      selectedText: function selectedText() {
        var _keyBy, _keyBy$this$selected;
        return ((_keyBy = keyBy(this.entries, 'value')) == null ? void 0 : (_keyBy$this$selected = _keyBy[this.selected]) == null ? void 0 : _keyBy$this$selected.text) || this.field.placeholder || '';
      },
      optionValues: function optionValues() {
        return this.entries.map(function (_ref) {
          var value = _ref.value;
          return value;
        });
      },
      invalid: function invalid() {
        var _this = this;
        return !uikitUtil.isUndefined(this.value) && [].concat(this.selected).some(function (value) {
          return !_this.optionValues.includes(value);
        });
      }
    },
    created: function created() {
      if (uikitUtil.isUndefined(this.value) && !uikitUtil.isUndefined(this.defaultIndex)) {
        this.value = this.optionValues[this.defaultIndex];
      }
    },
    methods: {
      open: function open() {
        var _this2 = this;
        this.$dropdown(__vue_component__$w, {
          entries: this.entries,
          current: this.selected
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (selection) {
          !uikitUtil.isUndefined(selection == null ? void 0 : selection.value) && (_this2.selected = selection.value);
        })["catch"](function () {});
      },
      flattenOptions: function flattenOptions(options, group) {
        var _this3 = this;
        if (options === void 0) {
          options = {};
        }
        if (group === void 0) {
          group = '';
        }
        return Object.keys(options).reduce(function (carry, key) {
          var option = options[key];
          return [].concat(carry, uikitUtil.isObject(option) ? _this3.flattenOptions(option, key) : [{
            text: key,
            value: option,
            group: group
          }]);
        }, []);
      }
    }
  };

  /* script */
  var __vue_script__$d = script$d;

  /* template */
  var __vue_render__$c = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-select",
      attrs: {
        "disabled": ""
      },
      domProps: {
        "value": _vm.selectedText
      }
    }) : _c('div', {
      "class": ['uk-select uk-cursor-default', _vm.attributes["class"], {
        'uk-form-danger': _vm.invalid
      }],
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        },
        "keydown": function keydown($event) {
          if (!$event.type.indexOf('key') && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
            return null;
          }
          return _vm.open.apply(null, arguments);
        }
      }
    }, [_c('span', {
      staticClass: "uk-disabled"
    }, [_vm._v(_vm._s(_vm.$t(_vm.selectedText)))])]);
  };
  var __vue_staticRenderFns__$c = [];

  /* style */
  var __vue_inject_styles__$d = undefined;
  /* scoped */
  var __vue_scope_id__$d = undefined;
  /* module identifier */
  var __vue_module_identifier__$d = undefined;
  /* functional template */
  var __vue_is_functional_template__$d = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$d = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$c,
    staticRenderFns: __vue_staticRenderFns__$c
  }, __vue_inject_styles__$d, __vue_script__$d, __vue_scope_id__$d, __vue_is_functional_template__$d, __vue_module_identifier__$d, false, undefined, undefined, undefined);

  var script$c = {
    name: 'SelectDropdownAsync',
    "extends": __vue_component__$d,
    inject: ['Fields'],
    data: function data() {
      return {
        options: [],
        cachedOptions: [],
        fetching: false,
        lastFetched: 0,
        error: ''
      };
    },
    computed: {
      selectedText: {
        get: function get() {
          return this.values[this.field.name + "_meta:selection_text"] || this.values[this.field.name];
        },
        set: function set(value) {
          this.$set(this.values, this.field.name + "_meta:selection_text", value);
        }
      },
      watchedValue: function watchedValue() {
        return this.values[this.watch];
      },
      watchedField: function watchedField() {
        return keyBy(this.Fields.fieldlist, 'name')[this.watch];
      }
    },
    watch: {
      options: function options(_options) {
        var _this = this;
        var option = _options.find(function (o) {
          return o.value === _this.selected;
        });
        if (option) {
          this.selectedText = option.text;
        }
      }
    },
    mounted: function mounted() {
      var _this$attributes,
        _this2 = this;
      if ((_this$attributes = this.attributes) != null && _this$attributes.disabled) {
        this.$watch('attributes.disabled', function (disabled) {
          disabled || _this2.fetch();
        });
      }
      if (this.field.watch) {
        this.field.watch.split(',').forEach(function (watch) {
          _this2.$watch("values." + watch, debounce(function () {
            _this2.fetch({}, true);
          }, 100));
        });
      }
      if (!this.selected && this.field.autoSelect && !this.watch) {
        this.fetch().then(function () {
          if (_this2.entries.length === 1) {
            _this2.selected = _this2.entries[0].value;
            _this2.selectedText = _this2.entries[0].text;
          }
        });
      }
    },
    methods: {
      prefetch: function prefetch() {
        if (this.watch && !this.watchedValue) {
          return;
        }
        this.fetch();
      },
      open: function open() {
        var _this3 = this;
        if (this.fetching || this.lastFetched === 0) {
          this.fetching = true;
          var stop = this.$watch('fetching', function () {
            _this3.open();
            stop();
          });
          return;
        }
        if (this.watch && !this.watchedValue) {
          var _this$watchedField;
          this.error = ((_this$watchedField = this.watchedField) == null ? void 0 : _this$watchedField.label) + " must be specified";
          return;
        }
        var field = this;
        var drop = this.$dropdown({
          "extends": __vue_component__$w,
          data: function data() {
            return {
              search: _this3.search
            };
          },
          created: function created() {
            this.$on('search', function (val) {
              return field.fetch({
                query: val
              }, true);
            });
          }
        }, {
          entries: this.entries,
          selected: this.selected,
          maxHeight: this.field.dropsize
        });
        drop.show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (selection) {
          if (selection != null && selection.value) {
            _this3.selected = selection.value;
            _this3.selectedText = selection.text;
          }
          drop.hide();
        });
      },
      fetch: function fetch(params, force) {
        var _this4 = this;
        if (params === void 0) {
          params = {};
        }
        if (force === void 0) {
          force = false;
        }
        var msSinceLastFetch = Date.now() - this.lastFetched;
        if (!force && msSinceLastFetch < 20000) {
          return;
        }
        params = _extends({}, params, this.field.params || {});
        this.$trigger('yooessentials-resolve-field-argument', params);
        this.error = false;
        var fetchIndicationId = setTimeout(function () {
          _this4.fetching = true;
        }, 1000);
        return yooessRequest(this.field.endpoint, params).then(function (_ref) {
          var options = _ref.body;
          if (uikitUtil.isArray(options)) {
            _this4.options = options;
            _this4.cachedOptions = [].concat(_this4.cachedOptions, options);
            _this4.lastFetched = Date.now();
          } else {
            _this4.error = uikitUtil.isString(options) ? options : 'Invalid Options';
          }
          clearTimeout(fetchIndicationId);
          _this4.fetching = false;
          return options;
        })["catch"](function (res) {
          _this4.error = res.statusText;
          _this4.fetching = false;
        });
      },
      flattenOptions: function flattenOptions(options, group) {
        var _this5 = this;
        if (options === void 0) {
          options = [];
        }
        if (group === void 0) {
          group = '';
        }
        return options.reduce(function (carry, option) {
          return [].concat(carry, option.group ? _this5.flattenOptions(option.group, option.text) : [_extends({}, option, {
            group: group
          })]);
        }, []);
      }
    }
  };

  /* script */
  var __vue_script__$c = script$c;

  /* template */
  var __vue_render__$b = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-select",
      attrs: {
        "disabled": ""
      },
      domProps: {
        "value": _vm.selectedText
      }
    }) : _c('div', {
      "class": ['uk-select uk-cursor-default', _vm.attributes["class"], {
        'uk-form-danger': _vm.error
      }],
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        },
        "mouseover": _vm.prefetch,
        "keydown": function keydown($event) {
          if (!$event.type.indexOf('key') && _vm._k($event.keyCode, "down", 40, $event.key, ["Down", "ArrowDown"])) {
            return null;
          }
          return _vm.open.apply(null, arguments);
        }
      }
    }, [_vm.error ? _c('span', {
      staticClass: "uk-disabled uk-text-danger"
    }, [_vm._v(_vm._s(_vm.error))]) : _c('span', {
      staticClass: "uk-disabled"
    }, [_vm._v(_vm._s(_vm.selectedText || _vm.field.placeholder || ''))]), _vm._v(" "), _vm.fetching ? _c('span', {
      staticClass: "uk-disabled"
    }, [_vm._v("...")]) : _vm._e()]);
  };
  var __vue_staticRenderFns__$b = [];

  /* style */
  var __vue_inject_styles__$c = undefined;
  /* scoped */
  var __vue_scope_id__$c = undefined;
  /* module identifier */
  var __vue_module_identifier__$c = undefined;
  /* functional template */
  var __vue_is_functional_template__$c = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$c = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$b,
    staticRenderFns: __vue_staticRenderFns__$b
  }, __vue_inject_styles__$c, __vue_script__$c, __vue_scope_id__$c, __vue_is_functional_template__$c, __vue_module_identifier__$c, false, undefined, undefined, undefined);

  var script$b = {
    "extends": $fields__default["default"].FieldText,
    inject: {
      Sidebar: {
        "default": {}
      },
      Builder: {
        "default": undefined
      },
      $node: {
        "default": undefined
      }
    },
    methods: {
      open: function open() {
        this.$trigger('openPanel', _extends({}, this.getPanel(), {
          props: {
            node: this.$node,
            builder: this.Builder,
            values: this.values
          }
        }));
      },
      getPanel: function getPanel() {
        var _this$Sidebar3, _this$Sidebar3$panel;
        var panel = this.field.panel;
        if (!panel) {
          throw new Error('Invalid Panel');
        }
        if (uikitUtil.isString(panel)) {
          var _this$Sidebar, _this$Sidebar$panel, _this$Sidebar$panel$p, _this$Sidebar2, _this$Sidebar2$panels;
          // get panel from current panel, fallback to global panels
          panel = ((_this$Sidebar = this.Sidebar) == null ? void 0 : (_this$Sidebar$panel = _this$Sidebar.panel) == null ? void 0 : (_this$Sidebar$panel$p = _this$Sidebar$panel.panels) == null ? void 0 : _this$Sidebar$panel$p[panel]) || ((_this$Sidebar2 = this.Sidebar) == null ? void 0 : (_this$Sidebar2$panels = _this$Sidebar2.panels) == null ? void 0 : _this$Sidebar2$panels[panel]);
        }
        panel = _extends({}, panel, {
          component: (_this$Sidebar3 = this.Sidebar) == null ? void 0 : (_this$Sidebar3$panel = _this$Sidebar3.panel) == null ? void 0 : _this$Sidebar3$panel.component
        });
        if (!panel.name) {
          throw new Error('Missing Panel Name');
        }
        if (!panel.title) {
          throw new Error('Missing Panel Title');
        }
        return panel;
      }
    }
  };

  /* script */
  var __vue_script__$b = script$b;

  /* template */
  var __vue_render__$a = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('button', _vm._b({
      staticClass: "uk-button yo-button-panel uk-width-1-1",
      "class": {
        'yo-button-medium': _vm.attributes["class"] === 'yo-form-medium'
      },
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    }, 'button', _vm.attributes, false), [_vm._v(_vm._s(_vm.$t(_vm.field.text || 'Open')))]);
  };
  var __vue_staticRenderFns__$a = [];

  /* style */
  var __vue_inject_styles__$b = undefined;
  /* scoped */
  var __vue_scope_id__$b = undefined;
  /* module identifier */
  var __vue_module_identifier__$b = undefined;
  /* functional template */
  var __vue_is_functional_template__$b = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$b = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$a,
    staticRenderFns: __vue_staticRenderFns__$a
  }, __vue_inject_styles__$b, __vue_script__$b, __vue_scope_id__$b, __vue_is_functional_template__$b, __vue_module_identifier__$b, false, undefined, undefined, undefined);

  //
  var script$a = {
    "extends": __vue_component__$b,
    inject: {
      Sidebar: {
        "default": {}
      }
    },
    methods: {
      open: function open() {
        var _this = this;
        return this.$modal(__vue_component__$E, {
          panel: this.getPanel(),
          values: this.values
        }).show().then(function (values) {
          if (!values) {
            return;
          }
          for (var key in values) {
            _this.$set(_this.values, key, values[key]);
          }
        });
      }
    }
  };

  /* script */
  var __vue_script__$a = script$a;

  /* template */
  var __vue_render__$9 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('button', _vm._b({
      staticClass: "uk-button yo-button-panel uk-width-1-1",
      "class": {
        'yo-button-medium': _vm.attributes["class"] === 'yo-form-medium'
      },
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    }, 'button', _vm.attributes, false), [_vm._v(_vm._s(_vm.$t(_vm.field.text || 'Open')))]);
  };
  var __vue_staticRenderFns__$9 = [];

  /* style */
  var __vue_inject_styles__$a = undefined;
  /* scoped */
  var __vue_scope_id__$a = undefined;
  /* module identifier */
  var __vue_module_identifier__$a = undefined;
  /* functional template */
  var __vue_is_functional_template__$a = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$a = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$9,
    staticRenderFns: __vue_staticRenderFns__$9
  }, __vue_inject_styles__$a, __vue_script__$a, __vue_scope_id__$a, __vue_is_functional_template__$a, __vue_module_identifier__$a, false, undefined, undefined, undefined);

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
  }

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  	  path: basedir,
  	  exports: {},
  	  require: function (path, base) {
        return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
      }
  	}, fn(module, module.exports), module.exports;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var requiredArgs_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = requiredArgs;
    function requiredArgs(required, args) {
      if (args.length < required) {
        throw new TypeError(required + ' argument' + (required > 1 ? 's' : '') + ' required, but only ' + args.length + ' present');
      }
    }
    module.exports = exports["default"];
  });
  unwrapExports(requiredArgs_1);

  var require$$8 = requiredArgs_1;

  var isDate_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = isDate;
    var _index = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @name isDate
     * @category Common Helpers
     * @summary Is the given value a date?
     *
     * @description
     * Returns true if the given value is an instance of Date. The function works for dates transferred across iframes.
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * @param {*} value - the value to check
     * @returns {boolean} true if the given value is a date
     * @throws {TypeError} 1 arguments required
     *
     * @example
     * // For a valid date:
     * const result = isDate(new Date())
     * //=> true
     *
     * @example
     * // For an invalid date:
     * const result = isDate(new Date(NaN))
     * //=> true
     *
     * @example
     * // For some value:
     * const result = isDate('2014-02-31')
     * //=> false
     *
     * @example
     * // For an object:
     * const result = isDate({})
     * //=> false
     */
    function isDate(value) {
      (0, _index["default"])(1, arguments);
      return value instanceof Date || typeof value === 'object' && Object.prototype.toString.call(value) === '[object Date]';
    }
    module.exports = exports["default"];
  });
  unwrapExports(isDate_1);

  var toDate_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = toDate;
    var _index = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @name toDate
     * @category Common Helpers
     * @summary Convert the given argument to an instance of Date.
     *
     * @description
     * Convert the given argument to an instance of Date.
     *
     * If the argument is an instance of Date, the function returns its clone.
     *
     * If the argument is a number, it is treated as a timestamp.
     *
     * If the argument is none of the above, the function returns Invalid Date.
     *
     * **Note**: *all* Date arguments passed to any *date-fns* function is processed by `toDate`.
     *
     * @param {Date|Number} argument - the value to convert
     * @returns {Date} the parsed date in the local time zone
     * @throws {TypeError} 1 argument required
     *
     * @example
     * // Clone the date:
     * const result = toDate(new Date(2014, 1, 11, 11, 30, 30))
     * //=> Tue Feb 11 2014 11:30:30
     *
     * @example
     * // Convert the timestamp to date:
     * const result = toDate(1392098430000)
     * //=> Tue Feb 11 2014 11:30:30
     */
    function toDate(argument) {
      (0, _index["default"])(1, arguments);
      var argStr = Object.prototype.toString.call(argument); // Clone the date

      if (argument instanceof Date || typeof argument === 'object' && argStr === '[object Date]') {
        // Prevent the date to lose the milliseconds when passed to new Date() in IE10
        return new Date(argument.getTime());
      } else if (typeof argument === 'number' || argStr === '[object Number]') {
        return new Date(argument);
      } else {
        if ((typeof argument === 'string' || argStr === '[object String]') && typeof console !== 'undefined') {
          // eslint-disable-next-line no-console
          console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://git.io/fjule"); // eslint-disable-next-line no-console

          console.warn(new Error().stack);
        }
        return new Date(NaN);
      }
    }
    module.exports = exports["default"];
  });
  unwrapExports(toDate_1);

  var require$$0$7 = isDate_1;

  var require$$3$2 = toDate_1;

  var isValid_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = isValid;
    var _index = _interopRequireDefault(require$$0$7);
    var _index2 = _interopRequireDefault(require$$3$2);
    var _index3 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @name isValid
     * @category Common Helpers
     * @summary Is the given date valid?
     *
     * @description
     * Returns false if argument is Invalid Date and true otherwise.
     * Argument is converted to Date using `toDate`. See [toDate]{@link https://date-fns.org/docs/toDate}
     * Invalid Date is a Date, whose time value is NaN.
     *
     * Time value of Date: http://es5.github.io/#x15.9.1.1
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * - Now `isValid` doesn't throw an exception
     *   if the first argument is not an instance of Date.
     *   Instead, argument is converted beforehand using `toDate`.
     *
     *   Examples:
     *
     *   | `isValid` argument        | Before v2.0.0 | v2.0.0 onward |
     *   |---------------------------|---------------|---------------|
     *   | `new Date()`              | `true`        | `true`        |
     *   | `new Date('2016-01-01')`  | `true`        | `true`        |
     *   | `new Date('')`            | `false`       | `false`       |
     *   | `new Date(1488370835081)` | `true`        | `true`        |
     *   | `new Date(NaN)`           | `false`       | `false`       |
     *   | `'2016-01-01'`            | `TypeError`   | `false`       |
     *   | `''`                      | `TypeError`   | `false`       |
     *   | `1488370835081`           | `TypeError`   | `true`        |
     *   | `NaN`                     | `TypeError`   | `false`       |
     *
     *   We introduce this change to make *date-fns* consistent with ECMAScript behavior
     *   that try to coerce arguments to the expected type
     *   (which is also the case with other *date-fns* functions).
     *
     * @param {*} date - the date to check
     * @returns {Boolean} the date is valid
     * @throws {TypeError} 1 argument required
     *
     * @example
     * // For the valid date:
     * const result = isValid(new Date(2014, 1, 31))
     * //=> true
     *
     * @example
     * // For the value, convertable into a date:
     * const result = isValid(1393804800000)
     * //=> true
     *
     * @example
     * // For the invalid date:
     * const result = isValid(new Date(''))
     * //=> false
     */
    function isValid(dirtyDate) {
      (0, _index3["default"])(1, arguments);
      if (!(0, _index["default"])(dirtyDate) && typeof dirtyDate !== 'number') {
        return false;
      }
      var date = (0, _index2["default"])(dirtyDate);
      return !isNaN(Number(date));
    }
    module.exports = exports["default"];
  });
  unwrapExports(isValid_1);

  var formatDistance_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var formatDistanceLocale = {
      lessThanXSeconds: {
        one: 'less than a second',
        other: 'less than {{count}} seconds'
      },
      xSeconds: {
        one: '1 second',
        other: '{{count}} seconds'
      },
      halfAMinute: 'half a minute',
      lessThanXMinutes: {
        one: 'less than a minute',
        other: 'less than {{count}} minutes'
      },
      xMinutes: {
        one: '1 minute',
        other: '{{count}} minutes'
      },
      aboutXHours: {
        one: 'about 1 hour',
        other: 'about {{count}} hours'
      },
      xHours: {
        one: '1 hour',
        other: '{{count}} hours'
      },
      xDays: {
        one: '1 day',
        other: '{{count}} days'
      },
      aboutXWeeks: {
        one: 'about 1 week',
        other: 'about {{count}} weeks'
      },
      xWeeks: {
        one: '1 week',
        other: '{{count}} weeks'
      },
      aboutXMonths: {
        one: 'about 1 month',
        other: 'about {{count}} months'
      },
      xMonths: {
        one: '1 month',
        other: '{{count}} months'
      },
      aboutXYears: {
        one: 'about 1 year',
        other: 'about {{count}} years'
      },
      xYears: {
        one: '1 year',
        other: '{{count}} years'
      },
      overXYears: {
        one: 'over 1 year',
        other: 'over {{count}} years'
      },
      almostXYears: {
        one: 'almost 1 year',
        other: 'almost {{count}} years'
      }
    };
    var formatDistance = function formatDistance(token, count, options) {
      var result;
      var tokenValue = formatDistanceLocale[token];
      if (typeof tokenValue === 'string') {
        result = tokenValue;
      } else if (count === 1) {
        result = tokenValue.one;
      } else {
        result = tokenValue.other.replace('{{count}}', count.toString());
      }
      if (options !== null && options !== void 0 && options.addSuffix) {
        if (options.comparison && options.comparison > 0) {
          return 'in ' + result;
        } else {
          return result + ' ago';
        }
      }
      return result;
    };
    var _default = formatDistance;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(formatDistance_1);

  var buildFormatLongFn_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = buildFormatLongFn;
    function buildFormatLongFn(args) {
      return function () {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        // TODO: Remove String()
        var width = options.width ? String(options.width) : args.defaultWidth;
        var format = args.formats[width] || args.formats[args.defaultWidth];
        return format;
      };
    }
    module.exports = exports["default"];
  });
  unwrapExports(buildFormatLongFn_1);

  var require$$0$6 = buildFormatLongFn_1;

  var formatLong_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$0$6);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var dateFormats = {
      full: 'EEEE, MMMM do, y',
      "long": 'MMMM do, y',
      medium: 'MMM d, y',
      "short": 'MM/dd/yyyy'
    };
    var timeFormats = {
      full: 'h:mm:ss a zzzz',
      "long": 'h:mm:ss a z',
      medium: 'h:mm:ss a',
      "short": 'h:mm a'
    };
    var dateTimeFormats = {
      full: "{{date}} 'at' {{time}}",
      "long": "{{date}} 'at' {{time}}",
      medium: '{{date}}, {{time}}',
      "short": '{{date}}, {{time}}'
    };
    var formatLong = {
      date: (0, _index["default"])({
        formats: dateFormats,
        defaultWidth: 'full'
      }),
      time: (0, _index["default"])({
        formats: timeFormats,
        defaultWidth: 'full'
      }),
      dateTime: (0, _index["default"])({
        formats: dateTimeFormats,
        defaultWidth: 'full'
      })
    };
    var _default = formatLong;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(formatLong_1);

  var formatRelative_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var formatRelativeLocale = {
      lastWeek: "'last' eeee 'at' p",
      yesterday: "'yesterday at' p",
      today: "'today at' p",
      tomorrow: "'tomorrow at' p",
      nextWeek: "eeee 'at' p",
      other: 'P'
    };
    var formatRelative = function formatRelative(token, _date, _baseDate, _options) {
      return formatRelativeLocale[token];
    };
    var _default = formatRelative;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(formatRelative_1);

  var buildLocalizeFn_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = buildLocalizeFn;
    function buildLocalizeFn(args) {
      return function (dirtyIndex, dirtyOptions) {
        var options = dirtyOptions || {};
        var context = options.context ? String(options.context) : 'standalone';
        var valuesArray;
        if (context === 'formatting' && args.formattingValues) {
          var defaultWidth = args.defaultFormattingWidth || args.defaultWidth;
          var width = options.width ? String(options.width) : defaultWidth;
          valuesArray = args.formattingValues[width] || args.formattingValues[defaultWidth];
        } else {
          var _defaultWidth = args.defaultWidth;
          var _width = options.width ? String(options.width) : args.defaultWidth;
          valuesArray = args.values[_width] || args.values[_defaultWidth];
        }
        var index = args.argumentCallback ? args.argumentCallback(dirtyIndex) : dirtyIndex; // @ts-ignore: For some reason TypeScript just don't want to match it, no matter how hard we try. I challenge you to try to remove it!

        return valuesArray[index];
      };
    }
    module.exports = exports["default"];
  });
  unwrapExports(buildLocalizeFn_1);

  var require$$0$5 = buildLocalizeFn_1;

  var localize_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$0$5);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var eraValues = {
      narrow: ['B', 'A'],
      abbreviated: ['BC', 'AD'],
      wide: ['Before Christ', 'Anno Domini']
    };
    var quarterValues = {
      narrow: ['1', '2', '3', '4'],
      abbreviated: ['Q1', 'Q2', 'Q3', 'Q4'],
      wide: ['1st quarter', '2nd quarter', '3rd quarter', '4th quarter']
    }; // Note: in English, the names of days of the week and months are capitalized.
    // If you are making a new locale based on this one, check if the same is true for the language you're working on.
    // Generally, formatted dates should look like they are in the middle of a sentence,
    // e.g. in Spanish language the weekdays and months should be in the lowercase.

    var monthValues = {
      narrow: ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'],
      abbreviated: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
      wide: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    };
    var dayValues = {
      narrow: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
      "short": ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
      abbreviated: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
      wide: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
    };
    var dayPeriodValues = {
      narrow: {
        am: 'a',
        pm: 'p',
        midnight: 'mi',
        noon: 'n',
        morning: 'morning',
        afternoon: 'afternoon',
        evening: 'evening',
        night: 'night'
      },
      abbreviated: {
        am: 'AM',
        pm: 'PM',
        midnight: 'midnight',
        noon: 'noon',
        morning: 'morning',
        afternoon: 'afternoon',
        evening: 'evening',
        night: 'night'
      },
      wide: {
        am: 'a.m.',
        pm: 'p.m.',
        midnight: 'midnight',
        noon: 'noon',
        morning: 'morning',
        afternoon: 'afternoon',
        evening: 'evening',
        night: 'night'
      }
    };
    var formattingDayPeriodValues = {
      narrow: {
        am: 'a',
        pm: 'p',
        midnight: 'mi',
        noon: 'n',
        morning: 'in the morning',
        afternoon: 'in the afternoon',
        evening: 'in the evening',
        night: 'at night'
      },
      abbreviated: {
        am: 'AM',
        pm: 'PM',
        midnight: 'midnight',
        noon: 'noon',
        morning: 'in the morning',
        afternoon: 'in the afternoon',
        evening: 'in the evening',
        night: 'at night'
      },
      wide: {
        am: 'a.m.',
        pm: 'p.m.',
        midnight: 'midnight',
        noon: 'noon',
        morning: 'in the morning',
        afternoon: 'in the afternoon',
        evening: 'in the evening',
        night: 'at night'
      }
    };
    var ordinalNumber = function ordinalNumber(dirtyNumber, _options) {
      var number = Number(dirtyNumber); // If ordinal numbers depend on context, for example,
      // if they are different for different grammatical genders,
      // use `options.unit`.
      //
      // `unit` can be 'year', 'quarter', 'month', 'week', 'date', 'dayOfYear',
      // 'day', 'hour', 'minute', 'second'.

      var rem100 = number % 100;
      if (rem100 > 20 || rem100 < 10) {
        switch (rem100 % 10) {
          case 1:
            return number + 'st';
          case 2:
            return number + 'nd';
          case 3:
            return number + 'rd';
        }
      }
      return number + 'th';
    };
    var localize = {
      ordinalNumber: ordinalNumber,
      era: (0, _index["default"])({
        values: eraValues,
        defaultWidth: 'wide'
      }),
      quarter: (0, _index["default"])({
        values: quarterValues,
        defaultWidth: 'wide',
        argumentCallback: function argumentCallback(quarter) {
          return quarter - 1;
        }
      }),
      month: (0, _index["default"])({
        values: monthValues,
        defaultWidth: 'wide'
      }),
      day: (0, _index["default"])({
        values: dayValues,
        defaultWidth: 'wide'
      }),
      dayPeriod: (0, _index["default"])({
        values: dayPeriodValues,
        defaultWidth: 'wide',
        formattingValues: formattingDayPeriodValues,
        defaultFormattingWidth: 'wide'
      })
    };
    var _default = localize;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(localize_1);

  var buildMatchFn_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = buildMatchFn;
    function buildMatchFn(args) {
      return function (string) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var width = options.width;
        var matchPattern = width && args.matchPatterns[width] || args.matchPatterns[args.defaultMatchWidth];
        var matchResult = string.match(matchPattern);
        if (!matchResult) {
          return null;
        }
        var matchedString = matchResult[0];
        var parsePatterns = width && args.parsePatterns[width] || args.parsePatterns[args.defaultParseWidth];
        var key = Array.isArray(parsePatterns) ? findIndex(parsePatterns, function (pattern) {
          return pattern.test(matchedString);
        }) : findKey(parsePatterns, function (pattern) {
          return pattern.test(matchedString);
        });
        var value;
        value = args.valueCallback ? args.valueCallback(key) : key;
        value = options.valueCallback ? options.valueCallback(value) : value;
        var rest = string.slice(matchedString.length);
        return {
          value: value,
          rest: rest
        };
      };
    }
    function findKey(object, predicate) {
      for (var key in object) {
        if (object.hasOwnProperty(key) && predicate(object[key])) {
          return key;
        }
      }
      return undefined;
    }
    function findIndex(array, predicate) {
      for (var key = 0; key < array.length; key++) {
        if (predicate(array[key])) {
          return key;
        }
      }
      return undefined;
    }
    module.exports = exports["default"];
  });
  unwrapExports(buildMatchFn_1);

  var buildMatchPatternFn_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = buildMatchPatternFn;
    function buildMatchPatternFn(args) {
      return function (string) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var matchResult = string.match(args.matchPattern);
        if (!matchResult) return null;
        var matchedString = matchResult[0];
        var parseResult = string.match(args.parsePattern);
        if (!parseResult) return null;
        var value = args.valueCallback ? args.valueCallback(parseResult[0]) : parseResult[0];
        value = options.valueCallback ? options.valueCallback(value) : value;
        var rest = string.slice(matchedString.length);
        return {
          value: value,
          rest: rest
        };
      };
    }
    module.exports = exports["default"];
  });
  unwrapExports(buildMatchPatternFn_1);

  var require$$0$4 = buildMatchFn_1;

  var require$$1$6 = buildMatchPatternFn_1;

  var match_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$0$4);
    var _index2 = _interopRequireDefault(require$$1$6);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var matchOrdinalNumberPattern = /^(\d+)(th|st|nd|rd)?/i;
    var parseOrdinalNumberPattern = /\d+/i;
    var matchEraPatterns = {
      narrow: /^(b|a)/i,
      abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
      wide: /^(before christ|before common era|anno domini|common era)/i
    };
    var parseEraPatterns = {
      any: [/^b/i, /^(a|c)/i]
    };
    var matchQuarterPatterns = {
      narrow: /^[1234]/i,
      abbreviated: /^q[1234]/i,
      wide: /^[1234](th|st|nd|rd)? quarter/i
    };
    var parseQuarterPatterns = {
      any: [/1/i, /2/i, /3/i, /4/i]
    };
    var matchMonthPatterns = {
      narrow: /^[jfmasond]/i,
      abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
      wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
    };
    var parseMonthPatterns = {
      narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
      any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
    };
    var matchDayPatterns = {
      narrow: /^[smtwf]/i,
      "short": /^(su|mo|tu|we|th|fr|sa)/i,
      abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
      wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
    };
    var parseDayPatterns = {
      narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
      any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
    };
    var matchDayPeriodPatterns = {
      narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
      any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
    };
    var parseDayPeriodPatterns = {
      any: {
        am: /^a/i,
        pm: /^p/i,
        midnight: /^mi/i,
        noon: /^no/i,
        morning: /morning/i,
        afternoon: /afternoon/i,
        evening: /evening/i,
        night: /night/i
      }
    };
    var match = {
      ordinalNumber: (0, _index2["default"])({
        matchPattern: matchOrdinalNumberPattern,
        parsePattern: parseOrdinalNumberPattern,
        valueCallback: function valueCallback(value) {
          return parseInt(value, 10);
        }
      }),
      era: (0, _index["default"])({
        matchPatterns: matchEraPatterns,
        defaultMatchWidth: 'wide',
        parsePatterns: parseEraPatterns,
        defaultParseWidth: 'any'
      }),
      quarter: (0, _index["default"])({
        matchPatterns: matchQuarterPatterns,
        defaultMatchWidth: 'wide',
        parsePatterns: parseQuarterPatterns,
        defaultParseWidth: 'any',
        valueCallback: function valueCallback(index) {
          return index + 1;
        }
      }),
      month: (0, _index["default"])({
        matchPatterns: matchMonthPatterns,
        defaultMatchWidth: 'wide',
        parsePatterns: parseMonthPatterns,
        defaultParseWidth: 'any'
      }),
      day: (0, _index["default"])({
        matchPatterns: matchDayPatterns,
        defaultMatchWidth: 'wide',
        parsePatterns: parseDayPatterns,
        defaultParseWidth: 'any'
      }),
      dayPeriod: (0, _index["default"])({
        matchPatterns: matchDayPeriodPatterns,
        defaultMatchWidth: 'any',
        parsePatterns: parseDayPeriodPatterns,
        defaultParseWidth: 'any'
      })
    };
    var _default = match;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(match_1);

  var require$$0$3 = formatDistance_1;

  var require$$1$5 = formatLong_1;

  var require$$2$4 = formatRelative_1;

  var require$$3$1 = localize_1;

  var require$$4$2 = match_1;

  var enUS = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$0$3);
    var _index2 = _interopRequireDefault(require$$1$5);
    var _index3 = _interopRequireDefault(require$$2$4);
    var _index4 = _interopRequireDefault(require$$3$1);
    var _index5 = _interopRequireDefault(require$$4$2);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @type {Locale}
     * @category Locales
     * @summary English locale (United States).
     * @language English
     * @iso-639-2 eng
     * @author Sasha Koss [@kossnocorp]{@link https://github.com/kossnocorp}
     * @author Lesha Koss [@leshakoss]{@link https://github.com/leshakoss}
     */
    var locale = {
      code: 'en-US',
      formatDistance: _index["default"],
      formatLong: _index2["default"],
      formatRelative: _index3["default"],
      localize: _index4["default"],
      match: _index5["default"],
      options: {
        weekStartsOn: 0
        /* Sunday */,

        firstWeekContainsDate: 1
      }
    };
    var _default = locale;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(enUS);

  var toInteger_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = toInteger;
    function toInteger(dirtyNumber) {
      if (dirtyNumber === null || dirtyNumber === true || dirtyNumber === false) {
        return NaN;
      }
      var number = Number(dirtyNumber);
      if (isNaN(number)) {
        return number;
      }
      return number < 0 ? Math.ceil(number) : Math.floor(number);
    }
    module.exports = exports["default"];
  });
  var toInteger = unwrapExports(toInteger_1);

  var addMilliseconds_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = addMilliseconds;
    var _index = _interopRequireDefault(toInteger_1);
    var _index2 = _interopRequireDefault(require$$3$2);
    var _index3 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @name addMilliseconds
     * @category Millisecond Helpers
     * @summary Add the specified number of milliseconds to the given date.
     *
     * @description
     * Add the specified number of milliseconds to the given date.
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * @param {Date|Number} date - the date to be changed
     * @param {Number} amount - the amount of milliseconds to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
     * @returns {Date} the new date with the milliseconds added
     * @throws {TypeError} 2 arguments required
     *
     * @example
     * // Add 750 milliseconds to 10 July 2014 12:45:30.000:
     * const result = addMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
     * //=> Thu Jul 10 2014 12:45:30.750
     */
    function addMilliseconds(dirtyDate, dirtyAmount) {
      (0, _index3["default"])(2, arguments);
      var timestamp = (0, _index2["default"])(dirtyDate).getTime();
      var amount = (0, _index["default"])(dirtyAmount);
      return new Date(timestamp + amount);
    }
    module.exports = exports["default"];
  });
  unwrapExports(addMilliseconds_1);

  var require$$1$4 = addMilliseconds_1;

  var subMilliseconds_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = subMilliseconds;
    var _index = _interopRequireDefault(toInteger_1);
    var _index2 = _interopRequireDefault(require$$1$4);
    var _index3 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /**
     * @name subMilliseconds
     * @category Millisecond Helpers
     * @summary Subtract the specified number of milliseconds from the given date.
     *
     * @description
     * Subtract the specified number of milliseconds from the given date.
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * @param {Date|Number} date - the date to be changed
     * @param {Number} amount - the amount of milliseconds to be subtracted. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
     * @returns {Date} the new date with the milliseconds subtracted
     * @throws {TypeError} 2 arguments required
     *
     * @example
     * // Subtract 750 milliseconds from 10 July 2014 12:45:30.000:
     * const result = subMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
     * //=> Thu Jul 10 2014 12:45:29.250
     */
    function subMilliseconds(dirtyDate, dirtyAmount) {
      (0, _index3["default"])(2, arguments);
      var amount = (0, _index["default"])(dirtyAmount);
      return (0, _index2["default"])(dirtyDate, -amount);
    }
    module.exports = exports["default"];
  });
  unwrapExports(subMilliseconds_1);

  var getUTCDayOfYear_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getUTCDayOfYear;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var MILLISECONDS_IN_DAY = 86400000; // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376

    function getUTCDayOfYear(dirtyDate) {
      (0, _index2["default"])(1, arguments);
      var date = (0, _index["default"])(dirtyDate);
      var timestamp = date.getTime();
      date.setUTCMonth(0, 1);
      date.setUTCHours(0, 0, 0, 0);
      var startOfYearTimestamp = date.getTime();
      var difference = timestamp - startOfYearTimestamp;
      return Math.floor(difference / MILLISECONDS_IN_DAY) + 1;
    }
    module.exports = exports["default"];
  });
  unwrapExports(getUTCDayOfYear_1);

  var startOfUTCISOWeek_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = startOfUTCISOWeek;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function startOfUTCISOWeek(dirtyDate) {
      (0, _index2["default"])(1, arguments);
      var weekStartsOn = 1;
      var date = (0, _index["default"])(dirtyDate);
      var day = date.getUTCDay();
      var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
      date.setUTCDate(date.getUTCDate() - diff);
      date.setUTCHours(0, 0, 0, 0);
      return date;
    }
    module.exports = exports["default"];
  });
  unwrapExports(startOfUTCISOWeek_1);

  var require$$1$3 = startOfUTCISOWeek_1;

  var getUTCISOWeekYear_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getUTCISOWeekYear;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$8);
    var _index3 = _interopRequireDefault(require$$1$3);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function getUTCISOWeekYear(dirtyDate) {
      (0, _index2["default"])(1, arguments);
      var date = (0, _index["default"])(dirtyDate);
      var year = date.getUTCFullYear();
      var fourthOfJanuaryOfNextYear = new Date(0);
      fourthOfJanuaryOfNextYear.setUTCFullYear(year + 1, 0, 4);
      fourthOfJanuaryOfNextYear.setUTCHours(0, 0, 0, 0);
      var startOfNextYear = (0, _index3["default"])(fourthOfJanuaryOfNextYear);
      var fourthOfJanuaryOfThisYear = new Date(0);
      fourthOfJanuaryOfThisYear.setUTCFullYear(year, 0, 4);
      fourthOfJanuaryOfThisYear.setUTCHours(0, 0, 0, 0);
      var startOfThisYear = (0, _index3["default"])(fourthOfJanuaryOfThisYear);
      if (date.getTime() >= startOfNextYear.getTime()) {
        return year + 1;
      } else if (date.getTime() >= startOfThisYear.getTime()) {
        return year;
      } else {
        return year - 1;
      }
    }
    module.exports = exports["default"];
  });
  unwrapExports(getUTCISOWeekYear_1);

  var require$$2$3 = getUTCISOWeekYear_1;

  var startOfUTCISOWeekYear_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = startOfUTCISOWeekYear;
    var _index = _interopRequireDefault(require$$2$3);
    var _index2 = _interopRequireDefault(require$$1$3);
    var _index3 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function startOfUTCISOWeekYear(dirtyDate) {
      (0, _index3["default"])(1, arguments);
      var year = (0, _index["default"])(dirtyDate);
      var fourthOfJanuary = new Date(0);
      fourthOfJanuary.setUTCFullYear(year, 0, 4);
      fourthOfJanuary.setUTCHours(0, 0, 0, 0);
      var date = (0, _index2["default"])(fourthOfJanuary);
      return date;
    }
    module.exports = exports["default"];
  });
  unwrapExports(startOfUTCISOWeekYear_1);

  var require$$2$2 = startOfUTCISOWeekYear_1;

  var getUTCISOWeek_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getUTCISOWeek;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$1$3);
    var _index3 = _interopRequireDefault(require$$2$2);
    var _index4 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var MILLISECONDS_IN_WEEK = 604800000; // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376

    function getUTCISOWeek(dirtyDate) {
      (0, _index4["default"])(1, arguments);
      var date = (0, _index["default"])(dirtyDate);
      var diff = (0, _index2["default"])(date).getTime() - (0, _index3["default"])(date).getTime(); // Round the number of days to the nearest integer
      // because the number of milliseconds in a week is not constant
      // (e.g. it's different in the week of the daylight saving time clock shift)

      return Math.round(diff / MILLISECONDS_IN_WEEK) + 1;
    }
    module.exports = exports["default"];
  });
  unwrapExports(getUTCISOWeek_1);

  var startOfUTCWeek_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = startOfUTCWeek;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$8);
    var _index3 = _interopRequireDefault(toInteger_1);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function startOfUTCWeek(dirtyDate, dirtyOptions) {
      (0, _index2["default"])(1, arguments);
      var options = dirtyOptions || {};
      var locale = options.locale;
      var localeWeekStartsOn = locale && locale.options && locale.options.weekStartsOn;
      var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : (0, _index3["default"])(localeWeekStartsOn);
      var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : (0, _index3["default"])(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

      if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
        throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
      }
      var date = (0, _index["default"])(dirtyDate);
      var day = date.getUTCDay();
      var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
      date.setUTCDate(date.getUTCDate() - diff);
      date.setUTCHours(0, 0, 0, 0);
      return date;
    }
    module.exports = exports["default"];
  });
  unwrapExports(startOfUTCWeek_1);

  var require$$1$2 = startOfUTCWeek_1;

  var getUTCWeekYear_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getUTCWeekYear;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$8);
    var _index3 = _interopRequireDefault(require$$1$2);
    var _index4 = _interopRequireDefault(toInteger_1);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function getUTCWeekYear(dirtyDate, dirtyOptions) {
      (0, _index2["default"])(1, arguments);
      var date = (0, _index["default"])(dirtyDate);
      var year = date.getUTCFullYear();
      var options = dirtyOptions || {};
      var locale = options.locale;
      var localeFirstWeekContainsDate = locale && locale.options && locale.options.firstWeekContainsDate;
      var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : (0, _index4["default"])(localeFirstWeekContainsDate);
      var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : (0, _index4["default"])(options.firstWeekContainsDate); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

      if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
        throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
      }
      var firstWeekOfNextYear = new Date(0);
      firstWeekOfNextYear.setUTCFullYear(year + 1, 0, firstWeekContainsDate);
      firstWeekOfNextYear.setUTCHours(0, 0, 0, 0);
      var startOfNextYear = (0, _index3["default"])(firstWeekOfNextYear, dirtyOptions);
      var firstWeekOfThisYear = new Date(0);
      firstWeekOfThisYear.setUTCFullYear(year, 0, firstWeekContainsDate);
      firstWeekOfThisYear.setUTCHours(0, 0, 0, 0);
      var startOfThisYear = (0, _index3["default"])(firstWeekOfThisYear, dirtyOptions);
      if (date.getTime() >= startOfNextYear.getTime()) {
        return year + 1;
      } else if (date.getTime() >= startOfThisYear.getTime()) {
        return year;
      } else {
        return year - 1;
      }
    }
    module.exports = exports["default"];
  });
  unwrapExports(getUTCWeekYear_1);

  var require$$4$1 = getUTCWeekYear_1;

  var startOfUTCWeekYear_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = startOfUTCWeekYear;
    var _index = _interopRequireDefault(require$$4$1);
    var _index2 = _interopRequireDefault(require$$8);
    var _index3 = _interopRequireDefault(require$$1$2);
    var _index4 = _interopRequireDefault(toInteger_1);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376
    function startOfUTCWeekYear(dirtyDate, dirtyOptions) {
      (0, _index2["default"])(1, arguments);
      var options = dirtyOptions || {};
      var locale = options.locale;
      var localeFirstWeekContainsDate = locale && locale.options && locale.options.firstWeekContainsDate;
      var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : (0, _index4["default"])(localeFirstWeekContainsDate);
      var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : (0, _index4["default"])(options.firstWeekContainsDate);
      var year = (0, _index["default"])(dirtyDate, dirtyOptions);
      var firstWeek = new Date(0);
      firstWeek.setUTCFullYear(year, 0, firstWeekContainsDate);
      firstWeek.setUTCHours(0, 0, 0, 0);
      var date = (0, _index3["default"])(firstWeek, dirtyOptions);
      return date;
    }
    module.exports = exports["default"];
  });
  unwrapExports(startOfUTCWeekYear_1);

  var require$$2$1 = startOfUTCWeekYear_1;

  var getUTCWeek_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getUTCWeek;
    var _index = _interopRequireDefault(require$$3$2);
    var _index2 = _interopRequireDefault(require$$1$2);
    var _index3 = _interopRequireDefault(require$$2$1);
    var _index4 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var MILLISECONDS_IN_WEEK = 604800000; // This function will be a part of public API when UTC function will be implemented.
    // See issue: https://github.com/date-fns/date-fns/issues/376

    function getUTCWeek(dirtyDate, options) {
      (0, _index4["default"])(1, arguments);
      var date = (0, _index["default"])(dirtyDate);
      var diff = (0, _index2["default"])(date, options).getTime() - (0, _index3["default"])(date, options).getTime(); // Round the number of days to the nearest integer
      // because the number of milliseconds in a week is not constant
      // (e.g. it's different in the week of the daylight saving time clock shift)

      return Math.round(diff / MILLISECONDS_IN_WEEK) + 1;
    }
    module.exports = exports["default"];
  });
  unwrapExports(getUTCWeek_1);

  var addLeadingZeros_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = addLeadingZeros;
    function addLeadingZeros(number, targetLength) {
      var sign = number < 0 ? '-' : '';
      var output = Math.abs(number).toString();
      while (output.length < targetLength) {
        output = '0' + output;
      }
      return sign + output;
    }
    module.exports = exports["default"];
  });
  unwrapExports(addLeadingZeros_1);

  var require$$5$1 = addLeadingZeros_1;

  var lightFormatters = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$5$1);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    /*
     * |     | Unit                           |     | Unit                           |
     * |-----|--------------------------------|-----|--------------------------------|
     * |  a  | AM, PM                         |  A* |                                |
     * |  d  | Day of month                   |  D  |                                |
     * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
     * |  m  | Minute                         |  M  | Month                          |
     * |  s  | Second                         |  S  | Fraction of second             |
     * |  y  | Year (abs)                     |  Y  |                                |
     *
     * Letters marked by * are not implemented but reserved by Unicode standard.
     */
    var formatters = {
      // Year
      y: function y(date, token) {
        // From http://www.unicode.org/reports/tr35/tr35-31/tr35-dates.html#Date_Format_tokens
        // | Year     |     y | yy |   yyy |  yyyy | yyyyy |
        // |----------|-------|----|-------|-------|-------|
        // | AD 1     |     1 | 01 |   001 |  0001 | 00001 |
        // | AD 12    |    12 | 12 |   012 |  0012 | 00012 |
        // | AD 123   |   123 | 23 |   123 |  0123 | 00123 |
        // | AD 1234  |  1234 | 34 |  1234 |  1234 | 01234 |
        // | AD 12345 | 12345 | 45 | 12345 | 12345 | 12345 |
        var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

        var year = signedYear > 0 ? signedYear : 1 - signedYear;
        return (0, _index["default"])(token === 'yy' ? year % 100 : year, token.length);
      },
      // Month
      M: function M(date, token) {
        var month = date.getUTCMonth();
        return token === 'M' ? String(month + 1) : (0, _index["default"])(month + 1, 2);
      },
      // Day of the month
      d: function d(date, token) {
        return (0, _index["default"])(date.getUTCDate(), token.length);
      },
      // AM or PM
      a: function a(date, token) {
        var dayPeriodEnumValue = date.getUTCHours() / 12 >= 1 ? 'pm' : 'am';
        switch (token) {
          case 'a':
          case 'aa':
            return dayPeriodEnumValue.toUpperCase();
          case 'aaa':
            return dayPeriodEnumValue;
          case 'aaaaa':
            return dayPeriodEnumValue[0];
          case 'aaaa':
          default:
            return dayPeriodEnumValue === 'am' ? 'a.m.' : 'p.m.';
        }
      },
      // Hour [1-12]
      h: function h(date, token) {
        return (0, _index["default"])(date.getUTCHours() % 12 || 12, token.length);
      },
      // Hour [0-23]
      H: function H(date, token) {
        return (0, _index["default"])(date.getUTCHours(), token.length);
      },
      // Minute
      m: function m(date, token) {
        return (0, _index["default"])(date.getUTCMinutes(), token.length);
      },
      // Second
      s: function s(date, token) {
        return (0, _index["default"])(date.getUTCSeconds(), token.length);
      },
      // Fraction of second
      S: function S(date, token) {
        var numberOfDigits = token.length;
        var milliseconds = date.getUTCMilliseconds();
        var fractionalSeconds = Math.floor(milliseconds * Math.pow(10, numberOfDigits - 3));
        return (0, _index["default"])(fractionalSeconds, token.length);
      }
    };
    var _default = formatters;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(lightFormatters);

  var require$$0$2 = getUTCDayOfYear_1;

  var require$$1$1 = getUTCISOWeek_1;

  var require$$3 = getUTCWeek_1;

  var require$$6 = lightFormatters;

  var formatters_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _index = _interopRequireDefault(require$$0$2);
    var _index2 = _interopRequireDefault(require$$1$1);
    var _index3 = _interopRequireDefault(require$$2$3);
    var _index4 = _interopRequireDefault(require$$3);
    var _index5 = _interopRequireDefault(require$$4$1);
    var _index6 = _interopRequireDefault(require$$5$1);
    var _index7 = _interopRequireDefault(require$$6);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    var dayPeriodEnum = {
      am: 'am',
      pm: 'pm',
      midnight: 'midnight',
      noon: 'noon',
      morning: 'morning',
      afternoon: 'afternoon',
      evening: 'evening',
      night: 'night'
    };
    /*
     * |     | Unit                           |     | Unit                           |
     * |-----|--------------------------------|-----|--------------------------------|
     * |  a  | AM, PM                         |  A* | Milliseconds in day            |
     * |  b  | AM, PM, noon, midnight         |  B  | Flexible day period            |
     * |  c  | Stand-alone local day of week  |  C* | Localized hour w/ day period   |
     * |  d  | Day of month                   |  D  | Day of year                    |
     * |  e  | Local day of week              |  E  | Day of week                    |
     * |  f  |                                |  F* | Day of week in month           |
     * |  g* | Modified Julian day            |  G  | Era                            |
     * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
     * |  i! | ISO day of week                |  I! | ISO week of year               |
     * |  j* | Localized hour w/ day period   |  J* | Localized hour w/o day period  |
     * |  k  | Hour [1-24]                    |  K  | Hour [0-11]                    |
     * |  l* | (deprecated)                   |  L  | Stand-alone month              |
     * |  m  | Minute                         |  M  | Month                          |
     * |  n  |                                |  N  |                                |
     * |  o! | Ordinal number modifier        |  O  | Timezone (GMT)                 |
     * |  p! | Long localized time            |  P! | Long localized date            |
     * |  q  | Stand-alone quarter            |  Q  | Quarter                        |
     * |  r* | Related Gregorian year         |  R! | ISO week-numbering year        |
     * |  s  | Second                         |  S  | Fraction of second             |
     * |  t! | Seconds timestamp              |  T! | Milliseconds timestamp         |
     * |  u  | Extended year                  |  U* | Cyclic year                    |
     * |  v* | Timezone (generic non-locat.)  |  V* | Timezone (location)            |
     * |  w  | Local week of year             |  W* | Week of month                  |
     * |  x  | Timezone (ISO-8601 w/o Z)      |  X  | Timezone (ISO-8601)            |
     * |  y  | Year (abs)                     |  Y  | Local week-numbering year      |
     * |  z  | Timezone (specific non-locat.) |  Z* | Timezone (aliases)             |
     *
     * Letters marked by * are not implemented but reserved by Unicode standard.
     *
     * Letters marked by ! are non-standard, but implemented by date-fns:
     * - `o` modifies the previous token to turn it into an ordinal (see `format` docs)
     * - `i` is ISO day of week. For `i` and `ii` is returns numeric ISO week days,
     *   i.e. 7 for Sunday, 1 for Monday, etc.
     * - `I` is ISO week of year, as opposed to `w` which is local week of year.
     * - `R` is ISO week-numbering year, as opposed to `Y` which is local week-numbering year.
     *   `R` is supposed to be used in conjunction with `I` and `i`
     *   for universal ISO week-numbering date, whereas
     *   `Y` is supposed to be used in conjunction with `w` and `e`
     *   for week-numbering date specific to the locale.
     * - `P` is long localized date format
     * - `p` is long localized time format
     */

    var formatters = {
      // Era
      G: function G(date, token, localize) {
        var era = date.getUTCFullYear() > 0 ? 1 : 0;
        switch (token) {
          // AD, BC
          case 'G':
          case 'GG':
          case 'GGG':
            return localize.era(era, {
              width: 'abbreviated'
            });
          // A, B

          case 'GGGGG':
            return localize.era(era, {
              width: 'narrow'
            });
          // Anno Domini, Before Christ

          case 'GGGG':
          default:
            return localize.era(era, {
              width: 'wide'
            });
        }
      },
      // Year
      y: function y(date, token, localize) {
        // Ordinal number
        if (token === 'yo') {
          var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

          var year = signedYear > 0 ? signedYear : 1 - signedYear;
          return localize.ordinalNumber(year, {
            unit: 'year'
          });
        }
        return _index7["default"].y(date, token);
      },
      // Local week-numbering year
      Y: function Y(date, token, localize, options) {
        var signedWeekYear = (0, _index5["default"])(date, options); // Returns 1 for 1 BC (which is year 0 in JavaScript)

        var weekYear = signedWeekYear > 0 ? signedWeekYear : 1 - signedWeekYear; // Two digit year

        if (token === 'YY') {
          var twoDigitYear = weekYear % 100;
          return (0, _index6["default"])(twoDigitYear, 2);
        } // Ordinal number

        if (token === 'Yo') {
          return localize.ordinalNumber(weekYear, {
            unit: 'year'
          });
        } // Padding

        return (0, _index6["default"])(weekYear, token.length);
      },
      // ISO week-numbering year
      R: function R(date, token) {
        var isoWeekYear = (0, _index3["default"])(date); // Padding

        return (0, _index6["default"])(isoWeekYear, token.length);
      },
      // Extended year. This is a single number designating the year of this calendar system.
      // The main difference between `y` and `u` localizers are B.C. years:
      // | Year | `y` | `u` |
      // |------|-----|-----|
      // | AC 1 |   1 |   1 |
      // | BC 1 |   1 |   0 |
      // | BC 2 |   2 |  -1 |
      // Also `yy` always returns the last two digits of a year,
      // while `uu` pads single digit years to 2 characters and returns other years unchanged.
      u: function u(date, token) {
        var year = date.getUTCFullYear();
        return (0, _index6["default"])(year, token.length);
      },
      // Quarter
      Q: function Q(date, token, localize) {
        var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);
        switch (token) {
          // 1, 2, 3, 4
          case 'Q':
            return String(quarter);
          // 01, 02, 03, 04

          case 'QQ':
            return (0, _index6["default"])(quarter, 2);
          // 1st, 2nd, 3rd, 4th

          case 'Qo':
            return localize.ordinalNumber(quarter, {
              unit: 'quarter'
            });
          // Q1, Q2, Q3, Q4

          case 'QQQ':
            return localize.quarter(quarter, {
              width: 'abbreviated',
              context: 'formatting'
            });
          // 1, 2, 3, 4 (narrow quarter; could be not numerical)

          case 'QQQQQ':
            return localize.quarter(quarter, {
              width: 'narrow',
              context: 'formatting'
            });
          // 1st quarter, 2nd quarter, ...

          case 'QQQQ':
          default:
            return localize.quarter(quarter, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // Stand-alone quarter
      q: function q(date, token, localize) {
        var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);
        switch (token) {
          // 1, 2, 3, 4
          case 'q':
            return String(quarter);
          // 01, 02, 03, 04

          case 'qq':
            return (0, _index6["default"])(quarter, 2);
          // 1st, 2nd, 3rd, 4th

          case 'qo':
            return localize.ordinalNumber(quarter, {
              unit: 'quarter'
            });
          // Q1, Q2, Q3, Q4

          case 'qqq':
            return localize.quarter(quarter, {
              width: 'abbreviated',
              context: 'standalone'
            });
          // 1, 2, 3, 4 (narrow quarter; could be not numerical)

          case 'qqqqq':
            return localize.quarter(quarter, {
              width: 'narrow',
              context: 'standalone'
            });
          // 1st quarter, 2nd quarter, ...

          case 'qqqq':
          default:
            return localize.quarter(quarter, {
              width: 'wide',
              context: 'standalone'
            });
        }
      },
      // Month
      M: function M(date, token, localize) {
        var month = date.getUTCMonth();
        switch (token) {
          case 'M':
          case 'MM':
            return _index7["default"].M(date, token);
          // 1st, 2nd, ..., 12th

          case 'Mo':
            return localize.ordinalNumber(month + 1, {
              unit: 'month'
            });
          // Jan, Feb, ..., Dec

          case 'MMM':
            return localize.month(month, {
              width: 'abbreviated',
              context: 'formatting'
            });
          // J, F, ..., D

          case 'MMMMM':
            return localize.month(month, {
              width: 'narrow',
              context: 'formatting'
            });
          // January, February, ..., December

          case 'MMMM':
          default:
            return localize.month(month, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // Stand-alone month
      L: function L(date, token, localize) {
        var month = date.getUTCMonth();
        switch (token) {
          // 1, 2, ..., 12
          case 'L':
            return String(month + 1);
          // 01, 02, ..., 12

          case 'LL':
            return (0, _index6["default"])(month + 1, 2);
          // 1st, 2nd, ..., 12th

          case 'Lo':
            return localize.ordinalNumber(month + 1, {
              unit: 'month'
            });
          // Jan, Feb, ..., Dec

          case 'LLL':
            return localize.month(month, {
              width: 'abbreviated',
              context: 'standalone'
            });
          // J, F, ..., D

          case 'LLLLL':
            return localize.month(month, {
              width: 'narrow',
              context: 'standalone'
            });
          // January, February, ..., December

          case 'LLLL':
          default:
            return localize.month(month, {
              width: 'wide',
              context: 'standalone'
            });
        }
      },
      // Local week of year
      w: function w(date, token, localize, options) {
        var week = (0, _index4["default"])(date, options);
        if (token === 'wo') {
          return localize.ordinalNumber(week, {
            unit: 'week'
          });
        }
        return (0, _index6["default"])(week, token.length);
      },
      // ISO week of year
      I: function I(date, token, localize) {
        var isoWeek = (0, _index2["default"])(date);
        if (token === 'Io') {
          return localize.ordinalNumber(isoWeek, {
            unit: 'week'
          });
        }
        return (0, _index6["default"])(isoWeek, token.length);
      },
      // Day of the month
      d: function d(date, token, localize) {
        if (token === 'do') {
          return localize.ordinalNumber(date.getUTCDate(), {
            unit: 'date'
          });
        }
        return _index7["default"].d(date, token);
      },
      // Day of year
      D: function D(date, token, localize) {
        var dayOfYear = (0, _index["default"])(date);
        if (token === 'Do') {
          return localize.ordinalNumber(dayOfYear, {
            unit: 'dayOfYear'
          });
        }
        return (0, _index6["default"])(dayOfYear, token.length);
      },
      // Day of week
      E: function E(date, token, localize) {
        var dayOfWeek = date.getUTCDay();
        switch (token) {
          // Tue
          case 'E':
          case 'EE':
          case 'EEE':
            return localize.day(dayOfWeek, {
              width: 'abbreviated',
              context: 'formatting'
            });
          // T

          case 'EEEEE':
            return localize.day(dayOfWeek, {
              width: 'narrow',
              context: 'formatting'
            });
          // Tu

          case 'EEEEEE':
            return localize.day(dayOfWeek, {
              width: 'short',
              context: 'formatting'
            });
          // Tuesday

          case 'EEEE':
          default:
            return localize.day(dayOfWeek, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // Local day of week
      e: function e(date, token, localize, options) {
        var dayOfWeek = date.getUTCDay();
        var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;
        switch (token) {
          // Numerical value (Nth day of week with current locale or weekStartsOn)
          case 'e':
            return String(localDayOfWeek);
          // Padded numerical value

          case 'ee':
            return (0, _index6["default"])(localDayOfWeek, 2);
          // 1st, 2nd, ..., 7th

          case 'eo':
            return localize.ordinalNumber(localDayOfWeek, {
              unit: 'day'
            });
          case 'eee':
            return localize.day(dayOfWeek, {
              width: 'abbreviated',
              context: 'formatting'
            });
          // T

          case 'eeeee':
            return localize.day(dayOfWeek, {
              width: 'narrow',
              context: 'formatting'
            });
          // Tu

          case 'eeeeee':
            return localize.day(dayOfWeek, {
              width: 'short',
              context: 'formatting'
            });
          // Tuesday

          case 'eeee':
          default:
            return localize.day(dayOfWeek, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // Stand-alone local day of week
      c: function c(date, token, localize, options) {
        var dayOfWeek = date.getUTCDay();
        var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;
        switch (token) {
          // Numerical value (same as in `e`)
          case 'c':
            return String(localDayOfWeek);
          // Padded numerical value

          case 'cc':
            return (0, _index6["default"])(localDayOfWeek, token.length);
          // 1st, 2nd, ..., 7th

          case 'co':
            return localize.ordinalNumber(localDayOfWeek, {
              unit: 'day'
            });
          case 'ccc':
            return localize.day(dayOfWeek, {
              width: 'abbreviated',
              context: 'standalone'
            });
          // T

          case 'ccccc':
            return localize.day(dayOfWeek, {
              width: 'narrow',
              context: 'standalone'
            });
          // Tu

          case 'cccccc':
            return localize.day(dayOfWeek, {
              width: 'short',
              context: 'standalone'
            });
          // Tuesday

          case 'cccc':
          default:
            return localize.day(dayOfWeek, {
              width: 'wide',
              context: 'standalone'
            });
        }
      },
      // ISO day of week
      i: function i(date, token, localize) {
        var dayOfWeek = date.getUTCDay();
        var isoDayOfWeek = dayOfWeek === 0 ? 7 : dayOfWeek;
        switch (token) {
          // 2
          case 'i':
            return String(isoDayOfWeek);
          // 02

          case 'ii':
            return (0, _index6["default"])(isoDayOfWeek, token.length);
          // 2nd

          case 'io':
            return localize.ordinalNumber(isoDayOfWeek, {
              unit: 'day'
            });
          // Tue

          case 'iii':
            return localize.day(dayOfWeek, {
              width: 'abbreviated',
              context: 'formatting'
            });
          // T

          case 'iiiii':
            return localize.day(dayOfWeek, {
              width: 'narrow',
              context: 'formatting'
            });
          // Tu

          case 'iiiiii':
            return localize.day(dayOfWeek, {
              width: 'short',
              context: 'formatting'
            });
          // Tuesday

          case 'iiii':
          default:
            return localize.day(dayOfWeek, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // AM or PM
      a: function a(date, token, localize) {
        var hours = date.getUTCHours();
        var dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';
        switch (token) {
          case 'a':
          case 'aa':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'abbreviated',
              context: 'formatting'
            });
          case 'aaa':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'abbreviated',
              context: 'formatting'
            }).toLowerCase();
          case 'aaaaa':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'narrow',
              context: 'formatting'
            });
          case 'aaaa':
          default:
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // AM, PM, midnight, noon
      b: function b(date, token, localize) {
        var hours = date.getUTCHours();
        var dayPeriodEnumValue;
        if (hours === 12) {
          dayPeriodEnumValue = dayPeriodEnum.noon;
        } else if (hours === 0) {
          dayPeriodEnumValue = dayPeriodEnum.midnight;
        } else {
          dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';
        }
        switch (token) {
          case 'b':
          case 'bb':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'abbreviated',
              context: 'formatting'
            });
          case 'bbb':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'abbreviated',
              context: 'formatting'
            }).toLowerCase();
          case 'bbbbb':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'narrow',
              context: 'formatting'
            });
          case 'bbbb':
          default:
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // in the morning, in the afternoon, in the evening, at night
      B: function B(date, token, localize) {
        var hours = date.getUTCHours();
        var dayPeriodEnumValue;
        if (hours >= 17) {
          dayPeriodEnumValue = dayPeriodEnum.evening;
        } else if (hours >= 12) {
          dayPeriodEnumValue = dayPeriodEnum.afternoon;
        } else if (hours >= 4) {
          dayPeriodEnumValue = dayPeriodEnum.morning;
        } else {
          dayPeriodEnumValue = dayPeriodEnum.night;
        }
        switch (token) {
          case 'B':
          case 'BB':
          case 'BBB':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'abbreviated',
              context: 'formatting'
            });
          case 'BBBBB':
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'narrow',
              context: 'formatting'
            });
          case 'BBBB':
          default:
            return localize.dayPeriod(dayPeriodEnumValue, {
              width: 'wide',
              context: 'formatting'
            });
        }
      },
      // Hour [1-12]
      h: function h(date, token, localize) {
        if (token === 'ho') {
          var hours = date.getUTCHours() % 12;
          if (hours === 0) hours = 12;
          return localize.ordinalNumber(hours, {
            unit: 'hour'
          });
        }
        return _index7["default"].h(date, token);
      },
      // Hour [0-23]
      H: function H(date, token, localize) {
        if (token === 'Ho') {
          return localize.ordinalNumber(date.getUTCHours(), {
            unit: 'hour'
          });
        }
        return _index7["default"].H(date, token);
      },
      // Hour [0-11]
      K: function K(date, token, localize) {
        var hours = date.getUTCHours() % 12;
        if (token === 'Ko') {
          return localize.ordinalNumber(hours, {
            unit: 'hour'
          });
        }
        return (0, _index6["default"])(hours, token.length);
      },
      // Hour [1-24]
      k: function k(date, token, localize) {
        var hours = date.getUTCHours();
        if (hours === 0) hours = 24;
        if (token === 'ko') {
          return localize.ordinalNumber(hours, {
            unit: 'hour'
          });
        }
        return (0, _index6["default"])(hours, token.length);
      },
      // Minute
      m: function m(date, token, localize) {
        if (token === 'mo') {
          return localize.ordinalNumber(date.getUTCMinutes(), {
            unit: 'minute'
          });
        }
        return _index7["default"].m(date, token);
      },
      // Second
      s: function s(date, token, localize) {
        if (token === 'so') {
          return localize.ordinalNumber(date.getUTCSeconds(), {
            unit: 'second'
          });
        }
        return _index7["default"].s(date, token);
      },
      // Fraction of second
      S: function S(date, token) {
        return _index7["default"].S(date, token);
      },
      // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
      X: function X(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timezoneOffset = originalDate.getTimezoneOffset();
        if (timezoneOffset === 0) {
          return 'Z';
        }
        switch (token) {
          // Hours and optional minutes
          case 'X':
            return formatTimezoneWithOptionalMinutes(timezoneOffset);
          // Hours, minutes and optional seconds without `:` delimiter
          // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
          // so this token always has the same output as `XX`

          case 'XXXX':
          case 'XX':
            // Hours and minutes without `:` delimiter
            return formatTimezone(timezoneOffset);
          // Hours, minutes and optional seconds with `:` delimiter
          // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
          // so this token always has the same output as `XXX`

          case 'XXXXX':
          case 'XXX': // Hours and minutes with `:` delimiter

          default:
            return formatTimezone(timezoneOffset, ':');
        }
      },
      // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
      x: function x(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timezoneOffset = originalDate.getTimezoneOffset();
        switch (token) {
          // Hours and optional minutes
          case 'x':
            return formatTimezoneWithOptionalMinutes(timezoneOffset);
          // Hours, minutes and optional seconds without `:` delimiter
          // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
          // so this token always has the same output as `xx`

          case 'xxxx':
          case 'xx':
            // Hours and minutes without `:` delimiter
            return formatTimezone(timezoneOffset);
          // Hours, minutes and optional seconds with `:` delimiter
          // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
          // so this token always has the same output as `xxx`

          case 'xxxxx':
          case 'xxx': // Hours and minutes with `:` delimiter

          default:
            return formatTimezone(timezoneOffset, ':');
        }
      },
      // Timezone (GMT)
      O: function O(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timezoneOffset = originalDate.getTimezoneOffset();
        switch (token) {
          // Short
          case 'O':
          case 'OO':
          case 'OOO':
            return 'GMT' + formatTimezoneShort(timezoneOffset, ':');
          // Long

          case 'OOOO':
          default:
            return 'GMT' + formatTimezone(timezoneOffset, ':');
        }
      },
      // Timezone (specific non-location)
      z: function z(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timezoneOffset = originalDate.getTimezoneOffset();
        switch (token) {
          // Short
          case 'z':
          case 'zz':
          case 'zzz':
            return 'GMT' + formatTimezoneShort(timezoneOffset, ':');
          // Long

          case 'zzzz':
          default:
            return 'GMT' + formatTimezone(timezoneOffset, ':');
        }
      },
      // Seconds timestamp
      t: function t(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timestamp = Math.floor(originalDate.getTime() / 1000);
        return (0, _index6["default"])(timestamp, token.length);
      },
      // Milliseconds timestamp
      T: function T(date, token, _localize, options) {
        var originalDate = options._originalDate || date;
        var timestamp = originalDate.getTime();
        return (0, _index6["default"])(timestamp, token.length);
      }
    };
    function formatTimezoneShort(offset, dirtyDelimiter) {
      var sign = offset > 0 ? '-' : '+';
      var absOffset = Math.abs(offset);
      var hours = Math.floor(absOffset / 60);
      var minutes = absOffset % 60;
      if (minutes === 0) {
        return sign + String(hours);
      }
      var delimiter = dirtyDelimiter || '';
      return sign + String(hours) + delimiter + (0, _index6["default"])(minutes, 2);
    }
    function formatTimezoneWithOptionalMinutes(offset, dirtyDelimiter) {
      if (offset % 60 === 0) {
        var sign = offset > 0 ? '-' : '+';
        return sign + (0, _index6["default"])(Math.abs(offset) / 60, 2);
      }
      return formatTimezone(offset, dirtyDelimiter);
    }
    function formatTimezone(offset, dirtyDelimiter) {
      var delimiter = dirtyDelimiter || '';
      var sign = offset > 0 ? '-' : '+';
      var absOffset = Math.abs(offset);
      var hours = (0, _index6["default"])(Math.floor(absOffset / 60), 2);
      var minutes = (0, _index6["default"])(absOffset % 60, 2);
      return sign + hours + delimiter + minutes;
    }
    var _default = formatters;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(formatters_1);

  var longFormatters_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    function dateLongFormatter(pattern, formatLong) {
      switch (pattern) {
        case 'P':
          return formatLong.date({
            width: 'short'
          });
        case 'PP':
          return formatLong.date({
            width: 'medium'
          });
        case 'PPP':
          return formatLong.date({
            width: 'long'
          });
        case 'PPPP':
        default:
          return formatLong.date({
            width: 'full'
          });
      }
    }
    function timeLongFormatter(pattern, formatLong) {
      switch (pattern) {
        case 'p':
          return formatLong.time({
            width: 'short'
          });
        case 'pp':
          return formatLong.time({
            width: 'medium'
          });
        case 'ppp':
          return formatLong.time({
            width: 'long'
          });
        case 'pppp':
        default:
          return formatLong.time({
            width: 'full'
          });
      }
    }
    function dateTimeLongFormatter(pattern, formatLong) {
      var matchResult = pattern.match(/(P+)(p+)?/) || [];
      var datePattern = matchResult[1];
      var timePattern = matchResult[2];
      if (!timePattern) {
        return dateLongFormatter(pattern, formatLong);
      }
      var dateTimeFormat;
      switch (datePattern) {
        case 'P':
          dateTimeFormat = formatLong.dateTime({
            width: 'short'
          });
          break;
        case 'PP':
          dateTimeFormat = formatLong.dateTime({
            width: 'medium'
          });
          break;
        case 'PPP':
          dateTimeFormat = formatLong.dateTime({
            width: 'long'
          });
          break;
        case 'PPPP':
        default:
          dateTimeFormat = formatLong.dateTime({
            width: 'full'
          });
          break;
      }
      return dateTimeFormat.replace('{{date}}', dateLongFormatter(datePattern, formatLong)).replace('{{time}}', timeLongFormatter(timePattern, formatLong));
    }
    var longFormatters = {
      p: timeLongFormatter,
      P: dateTimeLongFormatter
    };
    var _default = longFormatters;
    exports["default"] = _default;
    module.exports = exports["default"];
  });
  unwrapExports(longFormatters_1);

  var getTimezoneOffsetInMilliseconds_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = getTimezoneOffsetInMilliseconds;

    /**
     * Google Chrome as of 67.0.3396.87 introduced timezones with offset that includes seconds.
     * They usually appear for dates that denote time before the timezones were introduced
     * (e.g. for 'Europe/Prague' timezone the offset is GMT+00:57:44 before 1 October 1891
     * and GMT+01:00:00 after that date)
     *
     * Date#getTimezoneOffset returns the offset in minutes and would return 57 for the example above,
     * which would lead to incorrect calculations.
     *
     * This function returns the timezone offset in milliseconds that takes seconds in account.
     */
    function getTimezoneOffsetInMilliseconds(date) {
      var utcDate = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()));
      utcDate.setUTCFullYear(date.getFullYear());
      return date.getTime() - utcDate.getTime();
    }
    module.exports = exports["default"];
  });
  var getTimezoneOffsetInMilliseconds = unwrapExports(getTimezoneOffsetInMilliseconds_1);

  var protectedTokens = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.isProtectedDayOfYearToken = isProtectedDayOfYearToken;
    exports.isProtectedWeekYearToken = isProtectedWeekYearToken;
    exports.throwProtectedError = throwProtectedError;
    var protectedDayOfYearTokens = ['D', 'DD'];
    var protectedWeekYearTokens = ['YY', 'YYYY'];
    function isProtectedDayOfYearToken(token) {
      return protectedDayOfYearTokens.indexOf(token) !== -1;
    }
    function isProtectedWeekYearToken(token) {
      return protectedWeekYearTokens.indexOf(token) !== -1;
    }
    function throwProtectedError(token, format, input) {
      if (token === 'YYYY') {
        throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://git.io/fxCyr"));
      } else if (token === 'YY') {
        throw new RangeError("Use `yy` instead of `YY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://git.io/fxCyr"));
      } else if (token === 'D') {
        throw new RangeError("Use `d` instead of `D` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://git.io/fxCyr"));
      } else if (token === 'DD') {
        throw new RangeError("Use `dd` instead of `DD` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://git.io/fxCyr"));
      }
    }
  });
  unwrapExports(protectedTokens);
  protectedTokens.isProtectedDayOfYearToken;
  protectedTokens.isProtectedWeekYearToken;
  protectedTokens.throwProtectedError;

  var require$$0$1 = isValid_1;

  var require$$1 = enUS;

  var require$$2 = subMilliseconds_1;

  var require$$4 = formatters_1;

  var require$$5 = longFormatters_1;

  var _index8 = protectedTokens;

  var format_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = format;
    var _index = _interopRequireDefault(require$$0$1);
    var _index2 = _interopRequireDefault(require$$1);
    var _index3 = _interopRequireDefault(require$$2);
    var _index4 = _interopRequireDefault(require$$3$2);
    var _index5 = _interopRequireDefault(require$$4);
    var _index6 = _interopRequireDefault(require$$5);
    var _index7 = _interopRequireDefault(getTimezoneOffsetInMilliseconds_1);
    var _index9 = _interopRequireDefault(toInteger_1);
    var _index10 = _interopRequireDefault(require$$8);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }

    // This RegExp consists of three parts separated by `|`:
    // - [yYQqMLwIdDecihHKkms]o matches any available ordinal number token
    //   (one of the certain letters followed by `o`)
    // - (\w)\1* matches any sequences of the same letter
    // - '' matches two quote characters in a row
    // - '(''|[^'])+('|$) matches anything surrounded by two quote characters ('),
    //   except a single quote symbol, which ends the sequence.
    //   Two quote characters do not end the sequence.
    //   If there is no matching single quote
    //   then the sequence will continue until the end of the string.
    // - . matches any single character unmatched by previous parts of the RegExps
    var formattingTokensRegExp = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g; // This RegExp catches symbols escaped by quotes, and also
    // sequences of symbols P, p, and the combinations like `PPPPPPPppppp`

    var longFormattingTokensRegExp = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g;
    var escapedStringRegExp = /^'([^]*?)'?$/;
    var doubleQuoteRegExp = /''/g;
    var unescapedLatinCharacterRegExp = /[a-zA-Z]/;
    /**
     * @name format
     * @category Common Helpers
     * @summary Format the date.
     *
     * @description
     * Return the formatted date string in the given format. The result may vary by locale.
     *
     * > ⚠️ Please note that the `format` tokens differ from Moment.js and other libraries.
     * > See: https://git.io/fxCyr
     *
     * The characters wrapped between two single quotes characters (') are escaped.
     * Two single quotes in a row, whether inside or outside a quoted sequence, represent a 'real' single quote.
     * (see the last example)
     *
     * Format of the string is based on Unicode Technical Standard #35:
     * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
     * with a few additions (see note 7 below the table).
     *
     * Accepted patterns:
     * | Unit                            | Pattern | Result examples                   | Notes |
     * |---------------------------------|---------|-----------------------------------|-------|
     * | Era                             | G..GGG  | AD, BC                            |       |
     * |                                 | GGGG    | Anno Domini, Before Christ        | 2     |
     * |                                 | GGGGG   | A, B                              |       |
     * | Calendar year                   | y       | 44, 1, 1900, 2017                 | 5     |
     * |                                 | yo      | 44th, 1st, 0th, 17th              | 5,7   |
     * |                                 | yy      | 44, 01, 00, 17                    | 5     |
     * |                                 | yyy     | 044, 001, 1900, 2017              | 5     |
     * |                                 | yyyy    | 0044, 0001, 1900, 2017            | 5     |
     * |                                 | yyyyy   | ...                               | 3,5   |
     * | Local week-numbering year       | Y       | 44, 1, 1900, 2017                 | 5     |
     * |                                 | Yo      | 44th, 1st, 1900th, 2017th         | 5,7   |
     * |                                 | YY      | 44, 01, 00, 17                    | 5,8   |
     * |                                 | YYY     | 044, 001, 1900, 2017              | 5     |
     * |                                 | YYYY    | 0044, 0001, 1900, 2017            | 5,8   |
     * |                                 | YYYYY   | ...                               | 3,5   |
     * | ISO week-numbering year         | R       | -43, 0, 1, 1900, 2017             | 5,7   |
     * |                                 | RR      | -43, 00, 01, 1900, 2017           | 5,7   |
     * |                                 | RRR     | -043, 000, 001, 1900, 2017        | 5,7   |
     * |                                 | RRRR    | -0043, 0000, 0001, 1900, 2017     | 5,7   |
     * |                                 | RRRRR   | ...                               | 3,5,7 |
     * | Extended year                   | u       | -43, 0, 1, 1900, 2017             | 5     |
     * |                                 | uu      | -43, 01, 1900, 2017               | 5     |
     * |                                 | uuu     | -043, 001, 1900, 2017             | 5     |
     * |                                 | uuuu    | -0043, 0001, 1900, 2017           | 5     |
     * |                                 | uuuuu   | ...                               | 3,5   |
     * | Quarter (formatting)            | Q       | 1, 2, 3, 4                        |       |
     * |                                 | Qo      | 1st, 2nd, 3rd, 4th                | 7     |
     * |                                 | QQ      | 01, 02, 03, 04                    |       |
     * |                                 | QQQ     | Q1, Q2, Q3, Q4                    |       |
     * |                                 | QQQQ    | 1st quarter, 2nd quarter, ...     | 2     |
     * |                                 | QQQQQ   | 1, 2, 3, 4                        | 4     |
     * | Quarter (stand-alone)           | q       | 1, 2, 3, 4                        |       |
     * |                                 | qo      | 1st, 2nd, 3rd, 4th                | 7     |
     * |                                 | qq      | 01, 02, 03, 04                    |       |
     * |                                 | qqq     | Q1, Q2, Q3, Q4                    |       |
     * |                                 | qqqq    | 1st quarter, 2nd quarter, ...     | 2     |
     * |                                 | qqqqq   | 1, 2, 3, 4                        | 4     |
     * | Month (formatting)              | M       | 1, 2, ..., 12                     |       |
     * |                                 | Mo      | 1st, 2nd, ..., 12th               | 7     |
     * |                                 | MM      | 01, 02, ..., 12                   |       |
     * |                                 | MMM     | Jan, Feb, ..., Dec                |       |
     * |                                 | MMMM    | January, February, ..., December  | 2     |
     * |                                 | MMMMM   | J, F, ..., D                      |       |
     * | Month (stand-alone)             | L       | 1, 2, ..., 12                     |       |
     * |                                 | Lo      | 1st, 2nd, ..., 12th               | 7     |
     * |                                 | LL      | 01, 02, ..., 12                   |       |
     * |                                 | LLL     | Jan, Feb, ..., Dec                |       |
     * |                                 | LLLL    | January, February, ..., December  | 2     |
     * |                                 | LLLLL   | J, F, ..., D                      |       |
     * | Local week of year              | w       | 1, 2, ..., 53                     |       |
     * |                                 | wo      | 1st, 2nd, ..., 53th               | 7     |
     * |                                 | ww      | 01, 02, ..., 53                   |       |
     * | ISO week of year                | I       | 1, 2, ..., 53                     | 7     |
     * |                                 | Io      | 1st, 2nd, ..., 53th               | 7     |
     * |                                 | II      | 01, 02, ..., 53                   | 7     |
     * | Day of month                    | d       | 1, 2, ..., 31                     |       |
     * |                                 | do      | 1st, 2nd, ..., 31st               | 7     |
     * |                                 | dd      | 01, 02, ..., 31                   |       |
     * | Day of year                     | D       | 1, 2, ..., 365, 366               | 9     |
     * |                                 | Do      | 1st, 2nd, ..., 365th, 366th       | 7     |
     * |                                 | DD      | 01, 02, ..., 365, 366             | 9     |
     * |                                 | DDD     | 001, 002, ..., 365, 366           |       |
     * |                                 | DDDD    | ...                               | 3     |
     * | Day of week (formatting)        | E..EEE  | Mon, Tue, Wed, ..., Sun           |       |
     * |                                 | EEEE    | Monday, Tuesday, ..., Sunday      | 2     |
     * |                                 | EEEEE   | M, T, W, T, F, S, S               |       |
     * |                                 | EEEEEE  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
     * | ISO day of week (formatting)    | i       | 1, 2, 3, ..., 7                   | 7     |
     * |                                 | io      | 1st, 2nd, ..., 7th                | 7     |
     * |                                 | ii      | 01, 02, ..., 07                   | 7     |
     * |                                 | iii     | Mon, Tue, Wed, ..., Sun           | 7     |
     * |                                 | iiii    | Monday, Tuesday, ..., Sunday      | 2,7   |
     * |                                 | iiiii   | M, T, W, T, F, S, S               | 7     |
     * |                                 | iiiiii  | Mo, Tu, We, Th, Fr, Sa, Su        | 7     |
     * | Local day of week (formatting)  | e       | 2, 3, 4, ..., 1                   |       |
     * |                                 | eo      | 2nd, 3rd, ..., 1st                | 7     |
     * |                                 | ee      | 02, 03, ..., 01                   |       |
     * |                                 | eee     | Mon, Tue, Wed, ..., Sun           |       |
     * |                                 | eeee    | Monday, Tuesday, ..., Sunday      | 2     |
     * |                                 | eeeee   | M, T, W, T, F, S, S               |       |
     * |                                 | eeeeee  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
     * | Local day of week (stand-alone) | c       | 2, 3, 4, ..., 1                   |       |
     * |                                 | co      | 2nd, 3rd, ..., 1st                | 7     |
     * |                                 | cc      | 02, 03, ..., 01                   |       |
     * |                                 | ccc     | Mon, Tue, Wed, ..., Sun           |       |
     * |                                 | cccc    | Monday, Tuesday, ..., Sunday      | 2     |
     * |                                 | ccccc   | M, T, W, T, F, S, S               |       |
     * |                                 | cccccc  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
     * | AM, PM                          | a..aa   | AM, PM                            |       |
     * |                                 | aaa     | am, pm                            |       |
     * |                                 | aaaa    | a.m., p.m.                        | 2     |
     * |                                 | aaaaa   | a, p                              |       |
     * | AM, PM, noon, midnight          | b..bb   | AM, PM, noon, midnight            |       |
     * |                                 | bbb     | am, pm, noon, midnight            |       |
     * |                                 | bbbb    | a.m., p.m., noon, midnight        | 2     |
     * |                                 | bbbbb   | a, p, n, mi                       |       |
     * | Flexible day period             | B..BBB  | at night, in the morning, ...     |       |
     * |                                 | BBBB    | at night, in the morning, ...     | 2     |
     * |                                 | BBBBB   | at night, in the morning, ...     |       |
     * | Hour [1-12]                     | h       | 1, 2, ..., 11, 12                 |       |
     * |                                 | ho      | 1st, 2nd, ..., 11th, 12th         | 7     |
     * |                                 | hh      | 01, 02, ..., 11, 12               |       |
     * | Hour [0-23]                     | H       | 0, 1, 2, ..., 23                  |       |
     * |                                 | Ho      | 0th, 1st, 2nd, ..., 23rd          | 7     |
     * |                                 | HH      | 00, 01, 02, ..., 23               |       |
     * | Hour [0-11]                     | K       | 1, 2, ..., 11, 0                  |       |
     * |                                 | Ko      | 1st, 2nd, ..., 11th, 0th          | 7     |
     * |                                 | KK      | 01, 02, ..., 11, 00               |       |
     * | Hour [1-24]                     | k       | 24, 1, 2, ..., 23                 |       |
     * |                                 | ko      | 24th, 1st, 2nd, ..., 23rd         | 7     |
     * |                                 | kk      | 24, 01, 02, ..., 23               |       |
     * | Minute                          | m       | 0, 1, ..., 59                     |       |
     * |                                 | mo      | 0th, 1st, ..., 59th               | 7     |
     * |                                 | mm      | 00, 01, ..., 59                   |       |
     * | Second                          | s       | 0, 1, ..., 59                     |       |
     * |                                 | so      | 0th, 1st, ..., 59th               | 7     |
     * |                                 | ss      | 00, 01, ..., 59                   |       |
     * | Fraction of second              | S       | 0, 1, ..., 9                      |       |
     * |                                 | SS      | 00, 01, ..., 99                   |       |
     * |                                 | SSS     | 000, 001, ..., 999                |       |
     * |                                 | SSSS    | ...                               | 3     |
     * | Timezone (ISO-8601 w/ Z)        | X       | -08, +0530, Z                     |       |
     * |                                 | XX      | -0800, +0530, Z                   |       |
     * |                                 | XXX     | -08:00, +05:30, Z                 |       |
     * |                                 | XXXX    | -0800, +0530, Z, +123456          | 2     |
     * |                                 | XXXXX   | -08:00, +05:30, Z, +12:34:56      |       |
     * | Timezone (ISO-8601 w/o Z)       | x       | -08, +0530, +00                   |       |
     * |                                 | xx      | -0800, +0530, +0000               |       |
     * |                                 | xxx     | -08:00, +05:30, +00:00            | 2     |
     * |                                 | xxxx    | -0800, +0530, +0000, +123456      |       |
     * |                                 | xxxxx   | -08:00, +05:30, +00:00, +12:34:56 |       |
     * | Timezone (GMT)                  | O...OOO | GMT-8, GMT+5:30, GMT+0            |       |
     * |                                 | OOOO    | GMT-08:00, GMT+05:30, GMT+00:00   | 2     |
     * | Timezone (specific non-locat.)  | z...zzz | GMT-8, GMT+5:30, GMT+0            | 6     |
     * |                                 | zzzz    | GMT-08:00, GMT+05:30, GMT+00:00   | 2,6   |
     * | Seconds timestamp               | t       | 512969520                         | 7     |
     * |                                 | tt      | ...                               | 3,7   |
     * | Milliseconds timestamp          | T       | 512969520900                      | 7     |
     * |                                 | TT      | ...                               | 3,7   |
     * | Long localized date             | P       | 04/29/1453                        | 7     |
     * |                                 | PP      | Apr 29, 1453                      | 7     |
     * |                                 | PPP     | April 29th, 1453                  | 7     |
     * |                                 | PPPP    | Friday, April 29th, 1453          | 2,7   |
     * | Long localized time             | p       | 12:00 AM                          | 7     |
     * |                                 | pp      | 12:00:00 AM                       | 7     |
     * |                                 | ppp     | 12:00:00 AM GMT+2                 | 7     |
     * |                                 | pppp    | 12:00:00 AM GMT+02:00             | 2,7   |
     * | Combination of date and time    | Pp      | 04/29/1453, 12:00 AM              | 7     |
     * |                                 | PPpp    | Apr 29, 1453, 12:00:00 AM         | 7     |
     * |                                 | PPPppp  | April 29th, 1453 at ...           | 7     |
     * |                                 | PPPPpppp| Friday, April 29th, 1453 at ...   | 2,7   |
     * Notes:
     * 1. "Formatting" units (e.g. formatting quarter) in the default en-US locale
     *    are the same as "stand-alone" units, but are different in some languages.
     *    "Formatting" units are declined according to the rules of the language
     *    in the context of a date. "Stand-alone" units are always nominative singular:
     *
     *    `format(new Date(2017, 10, 6), 'do LLLL', {locale: cs}) //=> '6. listopad'`
     *
     *    `format(new Date(2017, 10, 6), 'do MMMM', {locale: cs}) //=> '6. listopadu'`
     *
     * 2. Any sequence of the identical letters is a pattern, unless it is escaped by
     *    the single quote characters (see below).
     *    If the sequence is longer than listed in table (e.g. `EEEEEEEEEEE`)
     *    the output will be the same as default pattern for this unit, usually
     *    the longest one (in case of ISO weekdays, `EEEE`). Default patterns for units
     *    are marked with "2" in the last column of the table.
     *
     *    `format(new Date(2017, 10, 6), 'MMM') //=> 'Nov'`
     *
     *    `format(new Date(2017, 10, 6), 'MMMM') //=> 'November'`
     *
     *    `format(new Date(2017, 10, 6), 'MMMMM') //=> 'N'`
     *
     *    `format(new Date(2017, 10, 6), 'MMMMMM') //=> 'November'`
     *
     *    `format(new Date(2017, 10, 6), 'MMMMMMM') //=> 'November'`
     *
     * 3. Some patterns could be unlimited length (such as `yyyyyyyy`).
     *    The output will be padded with zeros to match the length of the pattern.
     *
     *    `format(new Date(2017, 10, 6), 'yyyyyyyy') //=> '00002017'`
     *
     * 4. `QQQQQ` and `qqqqq` could be not strictly numerical in some locales.
     *    These tokens represent the shortest form of the quarter.
     *
     * 5. The main difference between `y` and `u` patterns are B.C. years:
     *
     *    | Year | `y` | `u` |
     *    |------|-----|-----|
     *    | AC 1 |   1 |   1 |
     *    | BC 1 |   1 |   0 |
     *    | BC 2 |   2 |  -1 |
     *
     *    Also `yy` always returns the last two digits of a year,
     *    while `uu` pads single digit years to 2 characters and returns other years unchanged:
     *
     *    | Year | `yy` | `uu` |
     *    |------|------|------|
     *    | 1    |   01 |   01 |
     *    | 14   |   14 |   14 |
     *    | 376  |   76 |  376 |
     *    | 1453 |   53 | 1453 |
     *
     *    The same difference is true for local and ISO week-numbering years (`Y` and `R`),
     *    except local week-numbering years are dependent on `options.weekStartsOn`
     *    and `options.firstWeekContainsDate` (compare [getISOWeekYear]{@link https://date-fns.org/docs/getISOWeekYear}
     *    and [getWeekYear]{@link https://date-fns.org/docs/getWeekYear}).
     *
     * 6. Specific non-location timezones are currently unavailable in `date-fns`,
     *    so right now these tokens fall back to GMT timezones.
     *
     * 7. These patterns are not in the Unicode Technical Standard #35:
     *    - `i`: ISO day of week
     *    - `I`: ISO week of year
     *    - `R`: ISO week-numbering year
     *    - `t`: seconds timestamp
     *    - `T`: milliseconds timestamp
     *    - `o`: ordinal number modifier
     *    - `P`: long localized date
     *    - `p`: long localized time
     *
     * 8. `YY` and `YYYY` tokens represent week-numbering years but they are often confused with years.
     *    You should enable `options.useAdditionalWeekYearTokens` to use them. See: https://git.io/fxCyr
     *
     * 9. `D` and `DD` tokens represent days of the year but they are often confused with days of the month.
     *    You should enable `options.useAdditionalDayOfYearTokens` to use them. See: https://git.io/fxCyr
     *
     * ### v2.0.0 breaking changes:
     *
     * - [Changes that are common for the whole library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
     *
     * - The second argument is now required for the sake of explicitness.
     *
     *   ```javascript
     *   // Before v2.0.0
     *   format(new Date(2016, 0, 1))
     *
     *   // v2.0.0 onward
     *   format(new Date(2016, 0, 1), "yyyy-MM-dd'T'HH:mm:ss.SSSxxx")
     *   ```
     *
     * - New format string API for `format` function
     *   which is based on [Unicode Technical Standard #35](https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table).
     *   See [this post](https://blog.date-fns.org/post/unicode-tokens-in-date-fns-v2-sreatyki91jg) for more details.
     *
     * - Characters are now escaped using single quote symbols (`'`) instead of square brackets.
     *
     * @param {Date|Number} date - the original date
     * @param {String} format - the string of tokens
     * @param {Object} [options] - an object with options.
     * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
     * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
     * @param {Number} [options.firstWeekContainsDate=1] - the day of January, which is
     * @param {Boolean} [options.useAdditionalWeekYearTokens=false] - if true, allows usage of the week-numbering year tokens `YY` and `YYYY`;
     *   see: https://git.io/fxCyr
     * @param {Boolean} [options.useAdditionalDayOfYearTokens=false] - if true, allows usage of the day of year tokens `D` and `DD`;
     *   see: https://git.io/fxCyr
     * @returns {String} the formatted date string
     * @throws {TypeError} 2 arguments required
     * @throws {RangeError} `date` must not be Invalid Date
     * @throws {RangeError} `options.locale` must contain `localize` property
     * @throws {RangeError} `options.locale` must contain `formatLong` property
     * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
     * @throws {RangeError} `options.firstWeekContainsDate` must be between 1 and 7
     * @throws {RangeError} use `yyyy` instead of `YYYY` for formatting years using [format provided] to the input [input provided]; see: https://git.io/fxCyr
     * @throws {RangeError} use `yy` instead of `YY` for formatting years using [format provided] to the input [input provided]; see: https://git.io/fxCyr
     * @throws {RangeError} use `d` instead of `D` for formatting days of the month using [format provided] to the input [input provided]; see: https://git.io/fxCyr
     * @throws {RangeError} use `dd` instead of `DD` for formatting days of the month using [format provided] to the input [input provided]; see: https://git.io/fxCyr
     * @throws {RangeError} format string contains an unescaped latin alphabet character
     *
     * @example
     * // Represent 11 February 2014 in middle-endian format:
     * var result = format(new Date(2014, 1, 11), 'MM/dd/yyyy')
     * //=> '02/11/2014'
     *
     * @example
     * // Represent 2 July 2014 in Esperanto:
     * import { eoLocale } from 'date-fns/locale/eo'
     * var result = format(new Date(2014, 6, 2), "do 'de' MMMM yyyy", {
     *   locale: eoLocale
     * })
     * //=> '2-a de julio 2014'
     *
     * @example
     * // Escape string by single quote characters:
     * var result = format(new Date(2014, 6, 2, 15), "h 'o''clock'")
     * //=> "3 o'clock"
     */

    function format(dirtyDate, dirtyFormatStr, dirtyOptions) {
      (0, _index10["default"])(2, arguments);
      var formatStr = String(dirtyFormatStr);
      var options = dirtyOptions || {};
      var locale = options.locale || _index2["default"];
      var localeFirstWeekContainsDate = locale.options && locale.options.firstWeekContainsDate;
      var defaultFirstWeekContainsDate = localeFirstWeekContainsDate == null ? 1 : (0, _index9["default"])(localeFirstWeekContainsDate);
      var firstWeekContainsDate = options.firstWeekContainsDate == null ? defaultFirstWeekContainsDate : (0, _index9["default"])(options.firstWeekContainsDate); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

      if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
        throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
      }
      var localeWeekStartsOn = locale.options && locale.options.weekStartsOn;
      var defaultWeekStartsOn = localeWeekStartsOn == null ? 0 : (0, _index9["default"])(localeWeekStartsOn);
      var weekStartsOn = options.weekStartsOn == null ? defaultWeekStartsOn : (0, _index9["default"])(options.weekStartsOn); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

      if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
        throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
      }
      if (!locale.localize) {
        throw new RangeError('locale must contain localize property');
      }
      if (!locale.formatLong) {
        throw new RangeError('locale must contain formatLong property');
      }
      var originalDate = (0, _index4["default"])(dirtyDate);
      if (!(0, _index["default"])(originalDate)) {
        throw new RangeError('Invalid time value');
      } // Convert the date in system timezone to the same date in UTC+00:00 timezone.
      // This ensures that when UTC functions will be implemented, locales will be compatible with them.
      // See an issue about UTC functions: https://github.com/date-fns/date-fns/issues/376

      var timezoneOffset = (0, _index7["default"])(originalDate);
      var utcDate = (0, _index3["default"])(originalDate, timezoneOffset);
      var formatterOptions = {
        firstWeekContainsDate: firstWeekContainsDate,
        weekStartsOn: weekStartsOn,
        locale: locale,
        _originalDate: originalDate
      };
      var result = formatStr.match(longFormattingTokensRegExp).map(function (substring) {
        var firstCharacter = substring[0];
        if (firstCharacter === 'p' || firstCharacter === 'P') {
          var longFormatter = _index6["default"][firstCharacter];
          return longFormatter(substring, locale.formatLong, formatterOptions);
        }
        return substring;
      }).join('').match(formattingTokensRegExp).map(function (substring) {
        // Replace two single quote characters with one single quote character
        if (substring === "''") {
          return "'";
        }
        var firstCharacter = substring[0];
        if (firstCharacter === "'") {
          return cleanEscapedString(substring);
        }
        var formatter = _index5["default"][firstCharacter];
        if (formatter) {
          if (!options.useAdditionalWeekYearTokens && (0, _index8.isProtectedWeekYearToken)(substring)) {
            (0, _index8.throwProtectedError)(substring, dirtyFormatStr, dirtyDate);
          }
          if (!options.useAdditionalDayOfYearTokens && (0, _index8.isProtectedDayOfYearToken)(substring)) {
            (0, _index8.throwProtectedError)(substring, dirtyFormatStr, dirtyDate);
          }
          return formatter(utcDate, substring, locale.localize, formatterOptions);
        }
        if (firstCharacter.match(unescapedLatinCharacterRegExp)) {
          throw new RangeError('Format string contains an unescaped latin alphabet character `' + firstCharacter + '`');
        }
        return substring;
      }).join('');
      return result;
    }
    function cleanEscapedString(input) {
      return input.match(escapedStringRegExp)[1].replace(doubleQuoteRegExp, "'");
    }
    module.exports = exports["default"];
  });
  var dateFnsFormat = unwrapExports(format_1);

  /**
   * Returns the formatted time zone name of the provided `timeZone` or the current
   * system time zone if omitted, accounting for DST according to the UTC value of
   * the date.
   */
  function tzIntlTimeZoneName(length, date, options) {
    var dtf = getDTF(length, options.timeZone, options.locale);
    return dtf.formatToParts ? partsTimeZone(dtf, date) : hackyTimeZone(dtf, date);
  }
  function partsTimeZone(dtf, date) {
    var formatted = dtf.formatToParts(date);
    return formatted[formatted.length - 1].value;
  }
  function hackyTimeZone(dtf, date) {
    var formatted = dtf.format(date).replace(/\u200E/g, '');
    var tzNameMatch = / [\w-+ ]+$/.exec(formatted);
    return tzNameMatch ? tzNameMatch[0].substr(1) : '';
  }

  // If a locale has been provided `en-US` is used as a fallback in case it is an
  // invalid locale, otherwise the locale is left undefined to use the system locale.
  function getDTF(length, timeZone, locale) {
    if (locale && !locale.code) {
      throw new Error("date-fns-tz error: Please set a language code on the locale object imported from date-fns, e.g. `locale.code = 'en-US'`");
    }
    return new Intl.DateTimeFormat(locale ? [locale.code, 'en-US'] : undefined, {
      timeZone: timeZone,
      timeZoneName: length
    });
  }

  /**
   * Returns the [year, month, day, hour, minute, seconds] tokens of the provided
   * `date` as it will be rendered in the `timeZone`.
   */
  function tzTokenizeDate(date, timeZone) {
    var dtf = getDateTimeFormat(timeZone);
    return dtf.formatToParts ? partsOffset(dtf, date) : hackyOffset(dtf, date);
  }
  var typeToPos = {
    year: 0,
    month: 1,
    day: 2,
    hour: 3,
    minute: 4,
    second: 5
  };
  function partsOffset(dtf, date) {
    try {
      var formatted = dtf.formatToParts(date);
      var filled = [];
      for (var i = 0; i < formatted.length; i++) {
        var pos = typeToPos[formatted[i].type];
        if (pos >= 0) {
          filled[pos] = parseInt(formatted[i].value, 10);
        }
      }
      return filled;
    } catch (error) {
      if (error instanceof RangeError) {
        return [NaN];
      }
      throw error;
    }
  }
  function hackyOffset(dtf, date) {
    var formatted = dtf.format(date).replace(/\u200E/g, '');
    var parsed = /(\d+)\/(\d+)\/(\d+),? (\d+):(\d+):(\d+)/.exec(formatted);
    // var [, fMonth, fDay, fYear, fHour, fMinute, fSecond] = parsed
    // return [fYear, fMonth, fDay, fHour, fMinute, fSecond]
    return [parsed[3], parsed[1], parsed[2], parsed[4], parsed[5], parsed[6]];
  }

  // Get a cached Intl.DateTimeFormat instance for the IANA `timeZone`. This can be used
  // to get deterministic local date/time output according to the `en-US` locale which
  // can be used to extract local time parts as necessary.
  var dtfCache = {};
  function getDateTimeFormat(timeZone) {
    if (!dtfCache[timeZone]) {
      // New browsers use `hourCycle`, IE and Chrome <73 does not support it and uses `hour12`
      var testDateFormatted = new Intl.DateTimeFormat('en-US', {
        hour12: false,
        timeZone: 'America/New_York',
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
        hour: '2-digit',
        minute: '2-digit',
        second: '2-digit'
      }).format(new Date('2014-06-25T04:00:00.123Z'));
      var hourCycleSupported = testDateFormatted === '06/25/2014, 00:00:00' || testDateFormatted === '‎06‎/‎25‎/‎2014‎ ‎00‎:‎00‎:‎00';
      dtfCache[timeZone] = hourCycleSupported ? new Intl.DateTimeFormat('en-US', {
        hour12: false,
        timeZone: timeZone,
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
        hour: '2-digit',
        minute: '2-digit',
        second: '2-digit'
      }) : new Intl.DateTimeFormat('en-US', {
        hourCycle: 'h23',
        timeZone: timeZone,
        year: 'numeric',
        month: '2-digit',
        day: '2-digit',
        hour: '2-digit',
        minute: '2-digit',
        second: '2-digit'
      });
    }
    return dtfCache[timeZone];
  }

  /**
   * Use instead of `new Date(Date.UTC(...))` to support years below 100 which doesn't work
   * otherwise due to the nature of the
   * [`Date` constructor](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date#interpretation_of_two-digit_years.
   *
   * For `Date.UTC(...)`, use `newDateUTC(...).getTime()`.
   */
  function newDateUTC(fullYear, month, day, hour, minute, second, millisecond) {
    var utcDate = new Date(0);
    utcDate.setUTCFullYear(fullYear, month, day);
    utcDate.setUTCHours(hour, minute, second, millisecond);
    return utcDate;
  }

  var MILLISECONDS_IN_HOUR$1 = 3600000;
  var MILLISECONDS_IN_MINUTE$2 = 60000;
  var patterns$1 = {
    timezone: /([Z+-].*)$/,
    timezoneZ: /^(Z)$/,
    timezoneHH: /^([+-]\d{2})$/,
    timezoneHHMM: /^([+-]\d{2}):?(\d{2})$/
  };

  // Parse various time zone offset formats to an offset in milliseconds
  function tzParseTimezone(timezoneString, date, isUtcDate) {
    var token;
    var absoluteOffset;

    // Empty string
    if (timezoneString === '') {
      return 0;
    }

    // Z
    token = patterns$1.timezoneZ.exec(timezoneString);
    if (token) {
      return 0;
    }
    var hours;

    // ±hh
    token = patterns$1.timezoneHH.exec(timezoneString);
    if (token) {
      hours = parseInt(token[1], 10);
      if (!validateTimezone(hours)) {
        return NaN;
      }
      return -(hours * MILLISECONDS_IN_HOUR$1);
    }

    // ±hh:mm or ±hhmm
    token = patterns$1.timezoneHHMM.exec(timezoneString);
    if (token) {
      hours = parseInt(token[1], 10);
      var minutes = parseInt(token[2], 10);
      if (!validateTimezone(hours, minutes)) {
        return NaN;
      }
      absoluteOffset = Math.abs(hours) * MILLISECONDS_IN_HOUR$1 + minutes * MILLISECONDS_IN_MINUTE$2;
      return hours > 0 ? -absoluteOffset : absoluteOffset;
    }

    // IANA time zone
    if (isValidTimezoneIANAString(timezoneString)) {
      date = new Date(date || Date.now());
      var utcDate = isUtcDate ? date : toUtcDate(date);
      var offset = calcOffset(utcDate, timezoneString);
      var fixedOffset = isUtcDate ? offset : fixOffset(date, offset, timezoneString);
      return -fixedOffset;
    }
    return NaN;
  }
  function toUtcDate(date) {
    return newDateUTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds());
  }
  function calcOffset(date, timezoneString) {
    var tokens = tzTokenizeDate(date, timezoneString);

    // ms dropped because it's not provided by tzTokenizeDate
    var asUTC = newDateUTC(tokens[0], tokens[1] - 1, tokens[2], tokens[3] % 24, tokens[4], tokens[5], 0).getTime();
    var asTS = date.getTime();
    var over = asTS % 1000;
    asTS -= over >= 0 ? over : 1000 + over;
    return asUTC - asTS;
  }
  function fixOffset(date, offset, timezoneString) {
    var localTS = date.getTime();

    // Our UTC time is just a guess because our offset is just a guess
    var utcGuess = localTS - offset;

    // Test whether the zone matches the offset for this ts
    var o2 = calcOffset(new Date(utcGuess), timezoneString);

    // If so, offset didn't change, and we're done
    if (offset === o2) {
      return offset;
    }

    // If not, change the ts by the difference in the offset
    utcGuess -= o2 - offset;

    // If that gives us the local time we want, we're done
    var o3 = calcOffset(new Date(utcGuess), timezoneString);
    if (o2 === o3) {
      return o2;
    }

    // If it's different, we're in a hole time. The offset has changed, but we don't adjust the time
    return Math.max(o2, o3);
  }
  function validateTimezone(hours, minutes) {
    return -23 <= hours && hours <= 23 && (minutes == null || 0 <= minutes && minutes <= 59);
  }
  var validIANATimezoneCache = {};
  function isValidTimezoneIANAString(timeZoneString) {
    if (validIANATimezoneCache[timeZoneString]) return true;
    try {
      new Intl.DateTimeFormat(undefined, {
        timeZone: timeZoneString
      });
      validIANATimezoneCache[timeZoneString] = true;
      return true;
    } catch (error) {
      return false;
    }
  }

  var MILLISECONDS_IN_MINUTE$1 = 60 * 1000;
  var formatters = {
    // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
    X: function X(date, token, localize, options) {
      var timezoneOffset = getTimeZoneOffset(options.timeZone, options._originalDate || date);
      if (timezoneOffset === 0) {
        return 'Z';
      }
      switch (token) {
        // Hours and optional minutes
        case 'X':
          return formatTimezoneWithOptionalMinutes(timezoneOffset);

        // Hours, minutes and optional seconds without `:` delimeter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `XX`
        case 'XXXX':
        case 'XX':
          // Hours and minutes without `:` delimeter
          return formatTimezone(timezoneOffset);

        // Hours, minutes and optional seconds with `:` delimeter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `XXX`
        case 'XXXXX':
        case 'XXX': // Hours and minutes with `:` delimeter
        default:
          return formatTimezone(timezoneOffset, ':');
      }
    },
    // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
    x: function x(date, token, localize, options) {
      var timezoneOffset = getTimeZoneOffset(options.timeZone, options._originalDate || date);
      switch (token) {
        // Hours and optional minutes
        case 'x':
          return formatTimezoneWithOptionalMinutes(timezoneOffset);

        // Hours, minutes and optional seconds without `:` delimeter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `xx`
        case 'xxxx':
        case 'xx':
          // Hours and minutes without `:` delimeter
          return formatTimezone(timezoneOffset);

        // Hours, minutes and optional seconds with `:` delimeter
        // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
        // so this token always has the same output as `xxx`
        case 'xxxxx':
        case 'xxx': // Hours and minutes with `:` delimeter
        default:
          return formatTimezone(timezoneOffset, ':');
      }
    },
    // Timezone (GMT)
    O: function O(date, token, localize, options) {
      var timezoneOffset = getTimeZoneOffset(options.timeZone, options._originalDate || date);
      switch (token) {
        // Short
        case 'O':
        case 'OO':
        case 'OOO':
          return 'GMT' + formatTimezoneShort(timezoneOffset, ':');
        // Long
        case 'OOOO':
        default:
          return 'GMT' + formatTimezone(timezoneOffset, ':');
      }
    },
    // Timezone (specific non-location)
    z: function z(date, token, localize, options) {
      var originalDate = options._originalDate || date;
      switch (token) {
        // Short
        case 'z':
        case 'zz':
        case 'zzz':
          return tzIntlTimeZoneName('short', originalDate, options);
        // Long
        case 'zzzz':
        default:
          return tzIntlTimeZoneName('long', originalDate, options);
      }
    }
  };
  function getTimeZoneOffset(timeZone, originalDate) {
    var timeZoneOffset = timeZone ? tzParseTimezone(timeZone, originalDate, true) / MILLISECONDS_IN_MINUTE$1 : originalDate.getTimezoneOffset();
    if (Number.isNaN(timeZoneOffset)) {
      throw new RangeError('Invalid time zone specified: ' + timeZone);
    }
    return timeZoneOffset;
  }
  function addLeadingZeros(number, targetLength) {
    var sign = number < 0 ? '-' : '';
    var output = Math.abs(number).toString();
    while (output.length < targetLength) {
      output = '0' + output;
    }
    return sign + output;
  }
  function formatTimezone(offset, dirtyDelimeter) {
    var delimeter = dirtyDelimeter || '';
    var sign = offset > 0 ? '-' : '+';
    var absOffset = Math.abs(offset);
    var hours = addLeadingZeros(Math.floor(absOffset / 60), 2);
    var minutes = addLeadingZeros(Math.floor(absOffset % 60), 2);
    return sign + hours + delimeter + minutes;
  }
  function formatTimezoneWithOptionalMinutes(offset, dirtyDelimeter) {
    if (offset % 60 === 0) {
      var sign = offset > 0 ? '-' : '+';
      return sign + addLeadingZeros(Math.abs(offset) / 60, 2);
    }
    return formatTimezone(offset, dirtyDelimeter);
  }
  function formatTimezoneShort(offset, dirtyDelimeter) {
    var sign = offset > 0 ? '-' : '+';
    var absOffset = Math.abs(offset);
    var hours = Math.floor(absOffset / 60);
    var minutes = absOffset % 60;
    if (minutes === 0) {
      return sign + String(hours);
    }
    var delimeter = dirtyDelimeter || '';
    return sign + String(hours) + delimeter + addLeadingZeros(minutes, 2);
  }
  var formatters$1 = formatters;

  /** Regex to identify the presence of a time zone specifier in a date string */
  var tzPattern = /(Z|[+-]\d{2}(?::?\d{2})?| UTC| [a-zA-Z]+\/[a-zA-Z_]+(?:\/[a-zA-Z_]+)?)$/;
  var tzPattern$1 = tzPattern;

  var MILLISECONDS_IN_HOUR = 3600000;
  var MILLISECONDS_IN_MINUTE = 60000;
  var DEFAULT_ADDITIONAL_DIGITS = 2;
  var patterns = {
    dateTimePattern: /^([0-9W+-]+)(T| )(.*)/,
    datePattern: /^([0-9W+-]+)(.*)/,
    plainTime: /:/,
    // year tokens
    YY: /^(\d{2})$/,
    YYY: [/^([+-]\d{2})$/,
    // 0 additional digits
    /^([+-]\d{3})$/,
    // 1 additional digit
    /^([+-]\d{4})$/ // 2 additional digits
    ],

    YYYY: /^(\d{4})/,
    YYYYY: [/^([+-]\d{4})/,
    // 0 additional digits
    /^([+-]\d{5})/,
    // 1 additional digit
    /^([+-]\d{6})/ // 2 additional digits
    ],

    // date tokens
    MM: /^-(\d{2})$/,
    DDD: /^-?(\d{3})$/,
    MMDD: /^-?(\d{2})-?(\d{2})$/,
    Www: /^-?W(\d{2})$/,
    WwwD: /^-?W(\d{2})-?(\d{1})$/,
    HH: /^(\d{2}([.,]\d*)?)$/,
    HHMM: /^(\d{2}):?(\d{2}([.,]\d*)?)$/,
    HHMMSS: /^(\d{2}):?(\d{2}):?(\d{2}([.,]\d*)?)$/,
    // time zone tokens (to identify the presence of a tz)
    timeZone: tzPattern$1
  };

  /**
   * @name toDate
   * @category Common Helpers
   * @summary Convert the given argument to an instance of Date.
   *
   * @description
   * Convert the given argument to an instance of Date.
   *
   * If the argument is an instance of Date, the function returns its clone.
   *
   * If the argument is a number, it is treated as a timestamp.
   *
   * If an argument is a string, the function tries to parse it.
   * Function accepts complete ISO 8601 formats as well as partial implementations.
   * ISO 8601: http://en.wikipedia.org/wiki/ISO_8601
   * If the function cannot parse the string or the values are invalid, it returns Invalid Date.
   *
   * If the argument is none of the above, the function returns Invalid Date.
   *
   * **Note**: *all* Date arguments passed to any *date-fns* function is processed by `toDate`.
   * All *date-fns* functions will throw `RangeError` if `options.additionalDigits` is not 0, 1, 2 or undefined.
   *
   * @param {Date|String|Number} argument - the value to convert
   * @param {OptionsWithTZ} [options] - the object with options. See [Options]{@link https://date-fns.org/docs/Options}
   * @param {0|1|2} [options.additionalDigits=2] - the additional number of digits in the extended year format
   * @param {String} [options.timeZone=''] - used to specify the IANA time zone offset of a date String.
   * @returns {Date} the parsed date in the local time zone
   * @throws {TypeError} 1 argument required
   * @throws {RangeError} `options.additionalDigits` must be 0, 1 or 2
   *
   * @example
   * // Convert string '2014-02-11T11:30:30' to date:
   * var result = toDate('2014-02-11T11:30:30')
   * //=> Tue Feb 11 2014 11:30:30
   *
   * @example
   * // Convert string '+02014101' to date,
   * // if the additional number of digits in the extended year format is 1:
   * var result = toDate('+02014101', {additionalDigits: 1})
   * //=> Fri Apr 11 2014 00:00:00
   */
  function toDate(argument, dirtyOptions) {
    if (arguments.length < 1) {
      throw new TypeError('1 argument required, but only ' + arguments.length + ' present');
    }
    if (argument === null) {
      return new Date(NaN);
    }
    var options = dirtyOptions || {};
    var additionalDigits = options.additionalDigits == null ? DEFAULT_ADDITIONAL_DIGITS : toInteger(options.additionalDigits);
    if (additionalDigits !== 2 && additionalDigits !== 1 && additionalDigits !== 0) {
      throw new RangeError('additionalDigits must be 0, 1 or 2');
    }

    // Clone the date
    if (argument instanceof Date || typeof argument === 'object' && Object.prototype.toString.call(argument) === '[object Date]') {
      // Prevent the date to lose the milliseconds when passed to new Date() in IE10
      return new Date(argument.getTime());
    } else if (typeof argument === 'number' || Object.prototype.toString.call(argument) === '[object Number]') {
      return new Date(argument);
    } else if (!(typeof argument === 'string' || Object.prototype.toString.call(argument) === '[object String]')) {
      return new Date(NaN);
    }
    var dateStrings = splitDateString(argument);
    var parseYearResult = parseYear(dateStrings.date, additionalDigits);
    var year = parseYearResult.year;
    var restDateString = parseYearResult.restDateString;
    var date = parseDate(restDateString, year);
    if (isNaN(date)) {
      return new Date(NaN);
    }
    if (date) {
      var timestamp = date.getTime();
      var time = 0;
      var offset;
      if (dateStrings.time) {
        time = parseTime(dateStrings.time);
        if (isNaN(time)) {
          return new Date(NaN);
        }
      }
      if (dateStrings.timeZone || options.timeZone) {
        offset = tzParseTimezone(dateStrings.timeZone || options.timeZone, new Date(timestamp + time));
        if (isNaN(offset)) {
          return new Date(NaN);
        }
      } else {
        // get offset accurate to hour in time zones that change offset
        offset = getTimezoneOffsetInMilliseconds(new Date(timestamp + time));
        offset = getTimezoneOffsetInMilliseconds(new Date(timestamp + time + offset));
      }
      return new Date(timestamp + time + offset);
    } else {
      return new Date(NaN);
    }
  }
  function splitDateString(dateString) {
    var dateStrings = {};
    var parts = patterns.dateTimePattern.exec(dateString);
    var timeString;
    if (!parts) {
      parts = patterns.datePattern.exec(dateString);
      if (parts) {
        dateStrings.date = parts[1];
        timeString = parts[2];
      } else {
        dateStrings.date = null;
        timeString = dateString;
      }
    } else {
      dateStrings.date = parts[1];
      timeString = parts[3];
    }
    if (timeString) {
      var token = patterns.timeZone.exec(timeString);
      if (token) {
        dateStrings.time = timeString.replace(token[1], '');
        dateStrings.timeZone = token[1].trim();
      } else {
        dateStrings.time = timeString;
      }
    }
    return dateStrings;
  }
  function parseYear(dateString, additionalDigits) {
    var patternYYY = patterns.YYY[additionalDigits];
    var patternYYYYY = patterns.YYYYY[additionalDigits];
    var token;

    // YYYY or ±YYYYY
    token = patterns.YYYY.exec(dateString) || patternYYYYY.exec(dateString);
    if (token) {
      var yearString = token[1];
      return {
        year: parseInt(yearString, 10),
        restDateString: dateString.slice(yearString.length)
      };
    }

    // YY or ±YYY
    token = patterns.YY.exec(dateString) || patternYYY.exec(dateString);
    if (token) {
      var centuryString = token[1];
      return {
        year: parseInt(centuryString, 10) * 100,
        restDateString: dateString.slice(centuryString.length)
      };
    }

    // Invalid ISO-formatted year
    return {
      year: null
    };
  }
  function parseDate(dateString, year) {
    // Invalid ISO-formatted year
    if (year === null) {
      return null;
    }
    var token;
    var date;
    var month;
    var week;

    // YYYY
    if (dateString.length === 0) {
      date = new Date(0);
      date.setUTCFullYear(year);
      return date;
    }

    // YYYY-MM
    token = patterns.MM.exec(dateString);
    if (token) {
      date = new Date(0);
      month = parseInt(token[1], 10) - 1;
      if (!validateDate(year, month)) {
        return new Date(NaN);
      }
      date.setUTCFullYear(year, month);
      return date;
    }

    // YYYY-DDD or YYYYDDD
    token = patterns.DDD.exec(dateString);
    if (token) {
      date = new Date(0);
      var dayOfYear = parseInt(token[1], 10);
      if (!validateDayOfYearDate(year, dayOfYear)) {
        return new Date(NaN);
      }
      date.setUTCFullYear(year, 0, dayOfYear);
      return date;
    }

    // yyyy-MM-dd or YYYYMMDD
    token = patterns.MMDD.exec(dateString);
    if (token) {
      date = new Date(0);
      month = parseInt(token[1], 10) - 1;
      var day = parseInt(token[2], 10);
      if (!validateDate(year, month, day)) {
        return new Date(NaN);
      }
      date.setUTCFullYear(year, month, day);
      return date;
    }

    // YYYY-Www or YYYYWww
    token = patterns.Www.exec(dateString);
    if (token) {
      week = parseInt(token[1], 10) - 1;
      if (!validateWeekDate(year, week)) {
        return new Date(NaN);
      }
      return dayOfISOWeekYear(year, week);
    }

    // YYYY-Www-D or YYYYWwwD
    token = patterns.WwwD.exec(dateString);
    if (token) {
      week = parseInt(token[1], 10) - 1;
      var dayOfWeek = parseInt(token[2], 10) - 1;
      if (!validateWeekDate(year, week, dayOfWeek)) {
        return new Date(NaN);
      }
      return dayOfISOWeekYear(year, week, dayOfWeek);
    }

    // Invalid ISO-formatted date
    return null;
  }
  function parseTime(timeString) {
    var token;
    var hours;
    var minutes;

    // hh
    token = patterns.HH.exec(timeString);
    if (token) {
      hours = parseFloat(token[1].replace(',', '.'));
      if (!validateTime(hours)) {
        return NaN;
      }
      return hours % 24 * MILLISECONDS_IN_HOUR;
    }

    // hh:mm or hhmm
    token = patterns.HHMM.exec(timeString);
    if (token) {
      hours = parseInt(token[1], 10);
      minutes = parseFloat(token[2].replace(',', '.'));
      if (!validateTime(hours, minutes)) {
        return NaN;
      }
      return hours % 24 * MILLISECONDS_IN_HOUR + minutes * MILLISECONDS_IN_MINUTE;
    }

    // hh:mm:ss or hhmmss
    token = patterns.HHMMSS.exec(timeString);
    if (token) {
      hours = parseInt(token[1], 10);
      minutes = parseInt(token[2], 10);
      var seconds = parseFloat(token[3].replace(',', '.'));
      if (!validateTime(hours, minutes, seconds)) {
        return NaN;
      }
      return hours % 24 * MILLISECONDS_IN_HOUR + minutes * MILLISECONDS_IN_MINUTE + seconds * 1000;
    }

    // Invalid ISO-formatted time
    return null;
  }
  function dayOfISOWeekYear(isoWeekYear, week, day) {
    week = week || 0;
    day = day || 0;
    var date = new Date(0);
    date.setUTCFullYear(isoWeekYear, 0, 4);
    var fourthOfJanuaryDay = date.getUTCDay() || 7;
    var diff = week * 7 + day + 1 - fourthOfJanuaryDay;
    date.setUTCDate(date.getUTCDate() + diff);
    return date;
  }

  // Validation functions

  var DAYS_IN_MONTH = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  var DAYS_IN_MONTH_LEAP_YEAR = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  function isLeapYearIndex(year) {
    return year % 400 === 0 || year % 4 === 0 && year % 100 !== 0;
  }
  function validateDate(year, month, date) {
    if (month < 0 || month > 11) {
      return false;
    }
    if (date != null) {
      if (date < 1) {
        return false;
      }
      var isLeapYear = isLeapYearIndex(year);
      if (isLeapYear && date > DAYS_IN_MONTH_LEAP_YEAR[month]) {
        return false;
      }
      if (!isLeapYear && date > DAYS_IN_MONTH[month]) {
        return false;
      }
    }
    return true;
  }
  function validateDayOfYearDate(year, dayOfYear) {
    if (dayOfYear < 1) {
      return false;
    }
    var isLeapYear = isLeapYearIndex(year);
    if (isLeapYear && dayOfYear > 366) {
      return false;
    }
    if (!isLeapYear && dayOfYear > 365) {
      return false;
    }
    return true;
  }
  function validateWeekDate(year, week, day) {
    if (week < 0 || week > 52) {
      return false;
    }
    if (day != null && (day < 0 || day > 6)) {
      return false;
    }
    return true;
  }
  function validateTime(hours, minutes, seconds) {
    if (hours != null && (hours < 0 || hours >= 25)) {
      return false;
    }
    if (minutes != null && (minutes < 0 || minutes >= 60)) {
      return false;
    }
    if (seconds != null && (seconds < 0 || seconds >= 60)) {
      return false;
    }
    return true;
  }

  var tzFormattingTokensRegExp = /([xXOz]+)|''|'(''|[^'])+('|$)/g;

  /**
   * @name format
   * @category Common Helpers
   * @summary Format the date.
   *
   * @description
   * Return the formatted date string in the given format. The result may vary by locale.
   *
   * > ⚠️ Please note that the `format` tokens differ from Moment.js and other libraries.
   * > See: https://git.io/fxCyr
   *
   * The characters wrapped between two single quotes characters (') are escaped.
   * Two single quotes in a row, whether inside or outside a quoted sequence, represent a 'real' single quote.
   * (see the last example)
   *
   * Format of the string is based on Unicode Technical Standard #35:
   * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
   * with a few additions (see note 7 below the table).
   *
   * Accepted patterns:
   * | Unit                            | Pattern | Result examples                   | Notes |
   * |---------------------------------|---------|-----------------------------------|-------|
   * | Era                             | G..GGG  | AD, BC                            |       |
   * |                                 | GGGG    | Anno Domini, Before Christ        | 2     |
   * |                                 | GGGGG   | A, B                              |       |
   * | Calendar year                   | y       | 44, 1, 1900, 2017                 | 5     |
   * |                                 | yo      | 44th, 1st, 0th, 17th              | 5,7   |
   * |                                 | yy      | 44, 01, 00, 17                    | 5     |
   * |                                 | yyy     | 044, 001, 1900, 2017              | 5     |
   * |                                 | yyyy    | 0044, 0001, 1900, 2017            | 5     |
   * |                                 | yyyyy   | ...                               | 3,5   |
   * | Local week-numbering year       | Y       | 44, 1, 1900, 2017                 | 5     |
   * |                                 | Yo      | 44th, 1st, 1900th, 2017th         | 5,7   |
   * |                                 | YY      | 44, 01, 00, 17                    | 5,8   |
   * |                                 | YYY     | 044, 001, 1900, 2017              | 5     |
   * |                                 | YYYY    | 0044, 0001, 1900, 2017            | 5,8   |
   * |                                 | YYYYY   | ...                               | 3,5   |
   * | ISO week-numbering year         | R       | -43, 0, 1, 1900, 2017             | 5,7   |
   * |                                 | RR      | -43, 00, 01, 1900, 2017           | 5,7   |
   * |                                 | RRR     | -043, 000, 001, 1900, 2017        | 5,7   |
   * |                                 | RRRR    | -0043, 0000, 0001, 1900, 2017     | 5,7   |
   * |                                 | RRRRR   | ...                               | 3,5,7 |
   * | Extended year                   | u       | -43, 0, 1, 1900, 2017             | 5     |
   * |                                 | uu      | -43, 01, 1900, 2017               | 5     |
   * |                                 | uuu     | -043, 001, 1900, 2017             | 5     |
   * |                                 | uuuu    | -0043, 0001, 1900, 2017           | 5     |
   * |                                 | uuuuu   | ...                               | 3,5   |
   * | Quarter (formatting)            | Q       | 1, 2, 3, 4                        |       |
   * |                                 | Qo      | 1st, 2nd, 3rd, 4th                | 7     |
   * |                                 | QQ      | 01, 02, 03, 04                    |       |
   * |                                 | QQQ     | Q1, Q2, Q3, Q4                    |       |
   * |                                 | QQQQ    | 1st quarter, 2nd quarter, ...     | 2     |
   * |                                 | QQQQQ   | 1, 2, 3, 4                        | 4     |
   * | Quarter (stand-alone)           | q       | 1, 2, 3, 4                        |       |
   * |                                 | qo      | 1st, 2nd, 3rd, 4th                | 7     |
   * |                                 | qq      | 01, 02, 03, 04                    |       |
   * |                                 | qqq     | Q1, Q2, Q3, Q4                    |       |
   * |                                 | qqqq    | 1st quarter, 2nd quarter, ...     | 2     |
   * |                                 | qqqqq   | 1, 2, 3, 4                        | 4     |
   * | Month (formatting)              | M       | 1, 2, ..., 12                     |       |
   * |                                 | Mo      | 1st, 2nd, ..., 12th               | 7     |
   * |                                 | MM      | 01, 02, ..., 12                   |       |
   * |                                 | MMM     | Jan, Feb, ..., Dec                |       |
   * |                                 | MMMM    | January, February, ..., December  | 2     |
   * |                                 | MMMMM   | J, F, ..., D                      |       |
   * | Month (stand-alone)             | L       | 1, 2, ..., 12                     |       |
   * |                                 | Lo      | 1st, 2nd, ..., 12th               | 7     |
   * |                                 | LL      | 01, 02, ..., 12                   |       |
   * |                                 | LLL     | Jan, Feb, ..., Dec                |       |
   * |                                 | LLLL    | January, February, ..., December  | 2     |
   * |                                 | LLLLL   | J, F, ..., D                      |       |
   * | Local week of year              | w       | 1, 2, ..., 53                     |       |
   * |                                 | wo      | 1st, 2nd, ..., 53th               | 7     |
   * |                                 | ww      | 01, 02, ..., 53                   |       |
   * | ISO week of year                | I       | 1, 2, ..., 53                     | 7     |
   * |                                 | Io      | 1st, 2nd, ..., 53th               | 7     |
   * |                                 | II      | 01, 02, ..., 53                   | 7     |
   * | Day of month                    | d       | 1, 2, ..., 31                     |       |
   * |                                 | do      | 1st, 2nd, ..., 31st               | 7     |
   * |                                 | dd      | 01, 02, ..., 31                   |       |
   * | Day of year                     | D       | 1, 2, ..., 365, 366               | 8     |
   * |                                 | Do      | 1st, 2nd, ..., 365th, 366th       | 7     |
   * |                                 | DD      | 01, 02, ..., 365, 366             | 8     |
   * |                                 | DDD     | 001, 002, ..., 365, 366           |       |
   * |                                 | DDDD    | ...                               | 3     |
   * | Day of week (formatting)        | E..EEE  | Mon, Tue, Wed, ..., Su            |       |
   * |                                 | EEEE    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | EEEEE   | M, T, W, T, F, S, S               |       |
   * |                                 | EEEEEE  | Mo, Tu, We, Th, Fr, Su, Sa        |       |
   * | ISO day of week (formatting)    | i       | 1, 2, 3, ..., 7                   | 7     |
   * |                                 | io      | 1st, 2nd, ..., 7th                | 7     |
   * |                                 | ii      | 01, 02, ..., 07                   | 7     |
   * |                                 | iii     | Mon, Tue, Wed, ..., Su            | 7     |
   * |                                 | iiii    | Monday, Tuesday, ..., Sunday      | 2,7   |
   * |                                 | iiiii   | M, T, W, T, F, S, S               | 7     |
   * |                                 | iiiiii  | Mo, Tu, We, Th, Fr, Su, Sa        | 7     |
   * | Local day of week (formatting)  | e       | 2, 3, 4, ..., 1                   |       |
   * |                                 | eo      | 2nd, 3rd, ..., 1st                | 7     |
   * |                                 | ee      | 02, 03, ..., 01                   |       |
   * |                                 | eee     | Mon, Tue, Wed, ..., Su            |       |
   * |                                 | eeee    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | eeeee   | M, T, W, T, F, S, S               |       |
   * |                                 | eeeeee  | Mo, Tu, We, Th, Fr, Su, Sa        |       |
   * | Local day of week (stand-alone) | c       | 2, 3, 4, ..., 1                   |       |
   * |                                 | co      | 2nd, 3rd, ..., 1st                | 7     |
   * |                                 | cc      | 02, 03, ..., 01                   |       |
   * |                                 | ccc     | Mon, Tue, Wed, ..., Su            |       |
   * |                                 | cccc    | Monday, Tuesday, ..., Sunday      | 2     |
   * |                                 | ccccc   | M, T, W, T, F, S, S               |       |
   * |                                 | cccccc  | Mo, Tu, We, Th, Fr, Su, Sa        |       |
   * | AM, PM                          | a..aaa  | AM, PM                            |       |
   * |                                 | aaaa    | a.m., p.m.                        | 2     |
   * |                                 | aaaaa   | a, p                              |       |
   * | AM, PM, noon, midnight          | b..bbb  | AM, PM, noon, midnight            |       |
   * |                                 | bbbb    | a.m., p.m., noon, midnight        | 2     |
   * |                                 | bbbbb   | a, p, n, mi                       |       |
   * | Flexible day period             | B..BBB  | at night, in the morning, ...     |       |
   * |                                 | BBBB    | at night, in the morning, ...     | 2     |
   * |                                 | BBBBB   | at night, in the morning, ...     |       |
   * | Hour [1-12]                     | h       | 1, 2, ..., 11, 12                 |       |
   * |                                 | ho      | 1st, 2nd, ..., 11th, 12th         | 7     |
   * |                                 | hh      | 01, 02, ..., 11, 12               |       |
   * | Hour [0-23]                     | H       | 0, 1, 2, ..., 23                  |       |
   * |                                 | Ho      | 0th, 1st, 2nd, ..., 23rd          | 7     |
   * |                                 | HH      | 00, 01, 02, ..., 23               |       |
   * | Hour [0-11]                     | K       | 1, 2, ..., 11, 0                  |       |
   * |                                 | Ko      | 1st, 2nd, ..., 11th, 0th          | 7     |
   * |                                 | KK      | 1, 2, ..., 11, 0                  |       |
   * | Hour [1-24]                     | k       | 24, 1, 2, ..., 23                 |       |
   * |                                 | ko      | 24th, 1st, 2nd, ..., 23rd         | 7     |
   * |                                 | kk      | 24, 01, 02, ..., 23               |       |
   * | Minute                          | m       | 0, 1, ..., 59                     |       |
   * |                                 | mo      | 0th, 1st, ..., 59th               | 7     |
   * |                                 | mm      | 00, 01, ..., 59                   |       |
   * | Second                          | s       | 0, 1, ..., 59                     |       |
   * |                                 | so      | 0th, 1st, ..., 59th               | 7     |
   * |                                 | ss      | 00, 01, ..., 59                   |       |
   * | Fraction of second              | S       | 0, 1, ..., 9                      |       |
   * |                                 | SS      | 00, 01, ..., 99                   |       |
   * |                                 | SSS     | 000, 0001, ..., 999               |       |
   * |                                 | SSSS    | ...                               | 3     |
   * | Timezone (ISO-8601 w/ Z)        | X       | -08, +0530, Z                     |       |
   * |                                 | XX      | -0800, +0530, Z                   |       |
   * |                                 | XXX     | -08:00, +05:30, Z                 |       |
   * |                                 | XXXX    | -0800, +0530, Z, +123456          | 2     |
   * |                                 | XXXXX   | -08:00, +05:30, Z, +12:34:56      |       |
   * | Timezone (ISO-8601 w/o Z)       | x       | -08, +0530, +00                   |       |
   * |                                 | xx      | -0800, +0530, +0000               |       |
   * |                                 | xxx     | -08:00, +05:30, +00:00            | 2     |
   * |                                 | xxxx    | -0800, +0530, +0000, +123456      |       |
   * |                                 | xxxxx   | -08:00, +05:30, +00:00, +12:34:56 |       |
   * | Timezone (GMT)                  | O...OOO | GMT-8, GMT+5:30, GMT+0            |       |
   * |                                 | OOOO    | GMT-08:00, GMT+05:30, GMT+00:00   | 2     |
   * | Timezone (specific non-locat.)  | z...zzz | PDT, EST, CEST                    | 6     |
   * |                                 | zzzz    | Pacific Daylight Time             | 2,6   |
   * | Seconds timestamp               | t       | 512969520                         | 7     |
   * |                                 | tt      | ...                               | 3,7   |
   * | Milliseconds timestamp          | T       | 512969520900                      | 7     |
   * |                                 | TT      | ...                               | 3,7   |
   * | Long localized date             | P       | 05/29/1453                        | 7     |
   * |                                 | PP      | May 29, 1453                      | 7     |
   * |                                 | PPP     | May 29th, 1453                    | 7     |
   * |                                 | PPPP    | Sunday, May 29th, 1453            | 2,7   |
   * | Long localized time             | p       | 12:00 AM                          | 7     |
   * |                                 | pp      | 12:00:00 AM                       | 7     |
   * |                                 | ppp     | 12:00:00 AM GMT+2                 | 7     |
   * |                                 | pppp    | 12:00:00 AM GMT+02:00             | 2,7   |
   * | Combination of date and time    | Pp      | 05/29/1453, 12:00 AM              | 7     |
   * |                                 | PPpp    | May 29, 1453, 12:00:00 AM         | 7     |
   * |                                 | PPPppp  | May 29th, 1453 at ...             | 7     |
   * |                                 | PPPPpppp| Sunday, May 29th, 1453 at ...     | 2,7   |
   * Notes:
   * 1. "Formatting" units (e.g. formatting quarter) in the default en-US locale
   *    are the same as "stand-alone" units, but are different in some languages.
   *    "Formatting" units are declined according to the rules of the language
   *    in the context of a date. "Stand-alone" units are always nominative singular:
   *
   *    `format(new Date(2017, 10, 6), 'do LLLL', {locale: cs}) //=> '6. listopad'`
   *
   *    `format(new Date(2017, 10, 6), 'do MMMM', {locale: cs}) //=> '6. listopadu'`
   *
   * 2. Any sequence of the identical letters is a pattern, unless it is escaped by
   *    the single quote characters (see below).
   *    If the sequence is longer than listed in table (e.g. `EEEEEEEEEEE`)
   *    the output will be the same as default pattern for this unit, usually
   *    the longest one (in case of ISO weekdays, `EEEE`). Default patterns for units
   *    are marked with "2" in the last column of the table.
   *
   *    `format(new Date(2017, 10, 6), 'MMM') //=> 'Nov'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMM') //=> 'November'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMM') //=> 'N'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMMM') //=> 'November'`
   *
   *    `format(new Date(2017, 10, 6), 'MMMMMMM') //=> 'November'`
   *
   * 3. Some patterns could be unlimited length (such as `yyyyyyyy`).
   *    The output will be padded with zeros to match the length of the pattern.
   *
   *    `format(new Date(2017, 10, 6), 'yyyyyyyy') //=> '00002017'`
   *
   * 4. `QQQQQ` and `qqqqq` could be not strictly numerical in some locales.
   *    These tokens represent the shortest form of the quarter.
   *
   * 5. The main difference between `y` and `u` patterns are B.C. years:
   *
   *    | Year | `y` | `u` |
   *    |------|-----|-----|
   *    | AC 1 |   1 |   1 |
   *    | BC 1 |   1 |   0 |
   *    | BC 2 |   2 |  -1 |
   *
   *    Also `yy` always returns the last two digits of a year,
   *    while `uu` pads single digit years to 2 characters and returns other years unchanged:
   *
   *    | Year | `yy` | `uu` |
   *    |------|------|------|
   *    | 1    |   01 |   01 |
   *    | 14   |   14 |   14 |
   *    | 376  |   76 |  376 |
   *    | 1453 |   53 | 1453 |
   *
   *    The same difference is true for local and ISO week-numbering years (`Y` and `R`),
   *    except local week-numbering years are dependent on `options.weekStartsOn`
   *    and `options.firstWeekContainsDate` (compare [getISOWeekYear]{@link https://date-fns.org/docs/getISOWeekYear}
   *    and [getWeekYear]{@link https://date-fns.org/docs/getWeekYear}).
   *
   * 6. Specific non-location timezones are created using the Intl browser API. The output is determined by the
   *    preferred standard of the current locale (en-US by default) which may not always give the expected result.
   *    For this reason it is recommended to supply a `locale` in the format options when formatting a time zone name.
   *
   * 7. These patterns are not in the Unicode Technical Standard #35:
   *    - `i`: ISO day of week
   *    - `I`: ISO week of year
   *    - `R`: ISO week-numbering year
   *    - `t`: seconds timestamp
   *    - `T`: milliseconds timestamp
   *    - `o`: ordinal number modifier
   *    - `P`: long localized date
   *    - `p`: long localized time
   *
   * 8. These tokens are often confused with others. See: https://git.io/fxCyr
   *
   *
   * ### v2.0.0 breaking changes:
   *
   * - [Changes that are common for the whole
   *   library](https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#Common-Changes).
   *
   * - The second argument is now required for the sake of explicitness.
   *
   *   ```javascript
   *   // Before v2.0.0
   *   format(new Date(2016, 0, 1))
   *
   *   // v2.0.0 onward
   *   format(new Date(2016, 0, 1), "yyyy-MM-dd'T'HH:mm:ss.SSSxxx")
   *   ```
   *
   * - New format string API for `format` function
   *   which is based on [Unicode Technical Standard
   *   #35](https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table). See [this
   *   post](https://blog.date-fns.org/post/unicode-tokens-in-date-fns-v2-sreatyki91jg) for more details.
   *
   * - Characters are now escaped using single quote symbols (`'`) instead of square brackets.
   *
   * @param {Date|String|Number} date - the original date
   * @param {String} format - the string of tokens
   * @param {OptionsWithTZ} [options] - the object with options. See [Options]{@link https://date-fns.org/docs/Options}
   * @param {0|1|2} [options.additionalDigits=2] - passed to `toDate`. See [toDate]{@link
   *   https://date-fns.org/docs/toDate}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @param {Number} [options.firstWeekContainsDate=1] - the day of January, which is
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See
   *   [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {Boolean} [options.awareOfUnicodeTokens=false] - if true, allows usage of Unicode tokens causes confusion:
   *   - Some of the day of year tokens (`D`, `DD`) that are confused with the day of month tokens (`d`, `dd`).
   *   - Some of the local week-numbering year tokens (`YY`, `YYYY`) that are confused with the calendar year tokens
   *   (`yy`, `yyyy`). See: https://git.io/fxCyr
   * @param {String} [options.timeZone=''] - used to specify the IANA time zone offset of a date String.
   * @returns {String} the formatted date string
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `options.additionalDigits` must be 0, 1 or 2
   * @throws {RangeError} `options.locale` must contain `localize` property
   * @throws {RangeError} `options.locale` must contain `formatLong` property
   * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
   * @throws {RangeError} `options.firstWeekContainsDate` must be between 1 and 7
   * @throws {RangeError} `options.awareOfUnicodeTokens` must be set to `true` to use `XX` token; see:
   *   https://git.io/fxCyr
   *
   * @example
   * // Represent 11 February 2014 in middle-endian format:
   * var result = format(new Date(2014, 1, 11), 'MM/dd/yyyy')
   * //=> '02/11/2014'
   *
   * @example
   * // Represent 2 July 2014 in Esperanto:
   * import { eoLocale } from 'date-fns/locale/eo'
   * var result = format(new Date(2014, 6, 2), "do 'de' MMMM yyyy", {
   *   locale: eoLocale
   * })
   * //=> '2-a de julio 2014'
   *
   * @example
   * // Escape string by single quote characters:
   * var result = format(new Date(2014, 6, 2, 15), "h 'o''clock'")
   * //=> "3 o'clock"
   */
  function format(dirtyDate, dirtyFormatStr, dirtyOptions) {
    var formatStr = String(dirtyFormatStr);
    var options = dirtyOptions || {};
    var matches = formatStr.match(tzFormattingTokensRegExp);
    if (matches) {
      var date = toDate(dirtyDate, options);
      // Work through each match and replace the tz token in the format string with the quoted
      // formatted time zone so the remaining tokens can be filled in by date-fns#format.
      formatStr = matches.reduce(function (result, token) {
        if (token[0] === "'") {
          return result; // This is a quoted portion, matched only to ensure we don't match inside it
        }

        var pos = result.indexOf(token);
        var precededByQuotedSection = result[pos - 1] === "'";
        var replaced = result.replace(token, "'" + formatters$1[token[0]](date, token, null, options) + "'");
        // If the replacement results in two adjoining quoted strings, the back to back quotes
        // are removed so it doesn't look like an escaped quote.
        return precededByQuotedSection ? replaced.substring(0, pos - 1) + replaced.substring(pos + 1) : replaced;
      }, formatStr);
    }
    return dateFnsFormat(dirtyDate, formatStr, options);
  }

  var assign_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = assign;
    function assign(target, dirtyObject) {
      if (target == null) {
        throw new TypeError('assign requires that input parameter not be null or undefined');
      }
      dirtyObject = dirtyObject || {};
      for (var property in dirtyObject) {
        if (Object.prototype.hasOwnProperty.call(dirtyObject, property)) {
          target[property] = dirtyObject[property];
        }
      }
      return target;
    }
    module.exports = exports["default"];
  });
  unwrapExports(assign_1);

  var require$$0 = assign_1;

  var cloneObject_1 = createCommonjsModule(function (module, exports) {

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = cloneObject;
    var _index = _interopRequireDefault(require$$0);
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    function cloneObject(dirtyObject) {
      return (0, _index["default"])({}, dirtyObject);
    }
    module.exports = exports["default"];
  });
  var cloneObject = unwrapExports(cloneObject_1);

  /**
   * @name utcToZonedTime
   * @category Time Zone Helpers
   * @summary Get a date/time representing local time in a given time zone from the UTC date
   *
   * @description
   * Returns a date instance with values representing the local time in the time zone
   * specified of the UTC time from the date provided. In other words, when the new date
   * is formatted it will show the equivalent hours in the target time zone regardless
   * of the current system time zone.
   *
   * @param {Date|String|Number} date - the date with the relevant UTC time
   * @param {String} timeZone - the time zone to get local time for, can be an offset or IANA time zone
   * @param {OptionsWithTZ} [options] - the object with options. See [Options]{@link https://date-fns.org/docs/Options}
   * @param {0|1|2} [options.additionalDigits=2] - passed to `toDate`. See [toDate]{@link https://date-fns.org/docs/toDate}
   * @returns {Date} the new date with the equivalent time in the time zone
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `options.additionalDigits` must be 0, 1 or 2
   *
   * @example
   * // In June 10am UTC is 6am in New York (-04:00)
   * const result = utcToZonedTime('2014-06-25T10:00:00.000Z', 'America/New_York')
   * //=> Jun 25 2014 06:00:00
   */
  function utcToZonedTime(dirtyDate, timeZone, options) {
    var date = toDate(dirtyDate, options);
    var offsetMilliseconds = tzParseTimezone(timeZone, date, true);
    var d = new Date(date.getTime() - offsetMilliseconds);
    var resultDate = new Date(0);
    resultDate.setFullYear(d.getUTCFullYear(), d.getUTCMonth(), d.getUTCDate());
    resultDate.setHours(d.getUTCHours(), d.getUTCMinutes(), d.getUTCSeconds(), d.getUTCMilliseconds());
    return resultDate;
  }

  /**
   * @name formatInTimeZone
   * @category Time Zone Helpers
   * @summary Gets the offset in milliseconds between the time zone and Universal Coordinated Time (UTC)
   *
   * @param {Date|String|Number} date - the date representing the local time / real UTC time
   * @param {String} timeZone - the time zone this date should be formatted for; can be an offset or IANA time zone
   * @param {String} formatStr - the string of tokens
   * @param {OptionsWithTZ} [options] - the object with options. See [Options]{@link https://date-fns.org/docs/Options}
   * @param {0|1|2} [options.additionalDigits=2] - passed to `toDate`. See [toDate]{@link
   *   https://date-fns.org/docs/toDate}
   * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
   * @param {Number} [options.firstWeekContainsDate=1] - the day of January, which is
   * @param {Locale} [options.locale=defaultLocale] - the locale object. See
   *   [Locale]{@link https://date-fns.org/docs/Locale}
   * @param {Boolean} [options.awareOfUnicodeTokens=false] - if true, allows usage of Unicode tokens causes confusion:
   *   - Some of the day of year tokens (`D`, `DD`) that are confused with the day of month tokens (`d`, `dd`).
   *   - Some of the local week-numbering year tokens (`YY`, `YYYY`) that are confused with the calendar year tokens
   *   (`yy`, `yyyy`). See: https://git.io/fxCyr
   * @param {String} [options.timeZone=''] - used to specify the IANA time zone offset of a date String.
   * @returns {String} the formatted date string
   */
  function formatInTimeZone(date, timeZone, formatStr, options) {
    var extendedOptions = cloneObject(options);
    extendedOptions.timeZone = timeZone;
    return format(utcToZonedTime(date, timeZone), formatStr, extendedOptions);
  }

  /**
   * @name getTimezoneOffset
   * @category Time Zone Helpers
   * @summary Gets the offset in milliseconds between the time zone and Universal Coordinated Time (UTC)
   *
   * @description
   * Returns the time zone offset from UTC time in milliseconds for IANA time zones as well
   * as other time zone offset string formats.
   *
   * For time zones where daylight savings time is applicable a `Date` should be passed on
   * the second parameter to ensure the offset correctly accounts for DST at that time of
   * year. When omitted, the current date is used.
   *
   * @param {String} timeZone - the time zone of this local time, can be an offset or IANA time zone
   * @param {Date|Number} [date] - the date with values representing the local time
   * @returns {Number} the time zone offset in milliseconds
   *
   * @example
   * const result = getTimezoneOffset('-07:00')
   *   //=> -18000000 (-7 * 60 * 60 * 1000)
   * const result = getTimezoneOffset('Africa/Johannesburg')
   *   //=> 7200000 (2 * 60 * 60 * 1000)
   * const result = getTimezoneOffset('America/New_York', new Date(2016, 0, 1))
   *   //=> -18000000 (-5 * 60 * 60 * 1000)
   * const result = getTimezoneOffset('America/New_York', new Date(2016, 6, 1))
   *   //=> -14400000 (-4 * 60 * 60 * 1000)
   */
  function getTimezoneOffset(timeZone, date) {
    return -tzParseTimezone(timeZone, date);
  }

  /**
   * @name zonedTimeToUtc
   * @category Time Zone Helpers
   * @summary Get the UTC date/time from a date representing local time in a given time zone
   *
   * @description
   * Returns a date instance with the UTC time of the provided date of which the values
   * represented the local time in the time zone specified. In other words, if the input
   * date represented local time in time time zone, the timestamp of the output date will
   * give the equivalent UTC of that local time regardless of the current system time zone.
   *
   * @param {Date|String|Number} date - the date with values representing the local time
   * @param {String} timeZone - the time zone of this local time, can be an offset or IANA time zone
   * @param {OptionsWithTZ} [options] - the object with options. See [Options]{@link https://date-fns.org/docs/Options}
   * @param {0|1|2} [options.additionalDigits=2] - passed to `toDate`. See [toDate]{@link https://date-fns.org/docs/toDate}
   * @returns {Date} the new date with the equivalent time in the time zone
   * @throws {TypeError} 2 arguments required
   * @throws {RangeError} `options.additionalDigits` must be 0, 1 or 2
   *
   * @example
   * // In June 10am in Los Angeles is 5pm UTC
   * const result = zonedTimeToUtc(new Date(2014, 5, 25, 10, 0, 0), 'America/Los_Angeles')
   * //=> 2014-06-25T17:00:00.000Z
   */
  function zonedTimeToUtc(date, timeZone, options) {
    if (typeof date === 'string' && !date.match(tzPattern$1)) {
      var extendedOptions = cloneObject(options);
      extendedOptions.timeZone = timeZone;
      return toDate(date, extendedOptions);
    }
    var d = toDate(date, options);
    var utc = newDateUTC(d.getFullYear(), d.getMonth(), d.getDate(), d.getHours(), d.getMinutes(), d.getSeconds(), d.getMilliseconds()).getTime();
    var offsetMilliseconds = tzParseTimezone(timeZone, new Date(utc));
    return new Date(utc + offsetMilliseconds);
  }

  //
  var script$9 = {
    name: 'TimeField',
    "extends": $fields__default["default"].FieldText,
    format: 'HH:mm',
    computed: {
      timezone: function timezone() {
        return Intl.DateTimeFormat().resolvedOptions().timeZone;
      },
      $displayFormat: function $displayFormat() {
        return this.field.displayFormat || this.$options.format;
      },
      $valueFormat: function $valueFormat() {
        return this.field.valueFormat || this.$options.format;
      },
      inputValue: {
        get: function get() {
          if (!this.val) {
            return '';
          }
          return format$1(this.val, this.$displayFormat);
        },
        set: function set$1(value) {
          if (!value) {
            this.val = null;
            return;
          }
          var _value$split = value.split(':'),
            hours = _value$split[0],
            _value$split$ = _value$split[1],
            minutes = _value$split$ === void 0 ? 0 : _value$split$;
          var date = set(new Date(), {
            hours: hours,
            minutes: minutes
          });
          if (value && !isValid(date)) {
            this.$forceUpdate();
            return;
          }
          this.val = date;
          this.$forceUpdate();
        }
      },
      val: {
        get: function get() {
          var _this$value;
          var _ref = ((_this$value = this.value) == null ? void 0 : _this$value.split(':')) || [],
            hours = _ref[0],
            minutes = _ref[1];
          if (!hours || !minutes) {
            return undefined;
          }
          var value = set(new Date(), {
            hours: hours,
            minutes: minutes
          });
          if (!isValid(value)) {
            return undefined;
          }
          var offset = getTimezoneOffset(this.timezone, value) / 1000;
          return add(value, {
            seconds: offset
          });
        },
        set: function set(value) {
          if (!value) {
            this.value = undefined;
            return;
          }
          this.value = formatInTimeZone(zonedTimeToUtc(value, this.timezone), '', this.$valueFormat);
        }
      }
    },
    methods: {
      open: function open() {
        var _this = this;
        this.$dropdown(__vue_component__$r, {
          value: this.val,
          small: Boolean(this.field.small)
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (date) {
          if (uikitUtil.isUndefined(date)) {
            return;
          }
          _this.val = date;
        })["catch"](function () {});
      }
    }
  };

  /* script */
  var __vue_script__$9 = script$9;

  /* template */
  var __vue_render__$8 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      }
    }) : _c('div', [_c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [_c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Pick'),
        "uk-icon": "clock",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    })])])]), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model.lazy",
        value: _vm.inputValue,
        expression: "inputValue",
        modifiers: {
          "lazy": true
        }
      }],
      staticClass: "uk-input yo-input-iconnav-right",
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.inputValue
      },
      on: {
        "change": function change($event) {
          _vm.inputValue = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))])]);
  };
  var __vue_staticRenderFns__$8 = [];

  /* style */
  var __vue_inject_styles__$9 = undefined;
  /* scoped */
  var __vue_scope_id__$9 = undefined;
  /* module identifier */
  var __vue_module_identifier__$9 = undefined;
  /* functional template */
  var __vue_is_functional_template__$9 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$9 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$8,
    staticRenderFns: __vue_staticRenderFns__$8
  }, __vue_inject_styles__$9, __vue_script__$9, __vue_scope_id__$9, __vue_is_functional_template__$9, __vue_module_identifier__$9, false, undefined, undefined, undefined);

  //
  var script$8 = {
    name: 'DateField',
    "extends": __vue_component__$9,
    format: 'yyyy-MM-dd',
    computed: {
      inputValue: {
        get: function get() {
          if (!this.val) {
            return '';
          }
          return format$1(this.val, this.$displayFormat);
        },
        set: function set(value) {
          if (!value) {
            this.val = null;
            return;
          }
          var date = new Date(value);
          if (value && !isValid(date)) {
            this.$forceUpdate();
            return;
          }
          this.val = date;
          this.$forceUpdate();
        }
      },
      val: {
        get: function get() {
          var value = new Date(this.value);
          if (!this.value || !isValid(value)) {
            return undefined;
          }
          return value;
        },
        set: function set(value) {
          if (!value) {
            this.value = undefined;
            return;
          }
          this.value = format$1(value, this.$valueFormat);
        }
      }
    },
    methods: {
      open: function open() {
        var _this$field,
          _this$field2,
          _this = this;
        this.$dropdown(__vue_component__$p, {
          value: this.val,
          min: (_this$field = this.field) != null && _this$field.min ? new Date(this.field.min) : null,
          max: (_this$field2 = this.field) != null && _this$field2.max ? new Date(this.field.max) : null,
          small: Boolean(this.field.small)
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (date) {
          if (uikitUtil.isUndefined(date)) {
            return;
          }
          _this.val = date;
        })["catch"](function () {});
      }
    }
  };

  /* script */
  var __vue_script__$8 = script$8;

  /* template */
  var __vue_render__$7 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      }
    }) : _c('div', [_c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [_c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Pick'),
        "uk-icon": "calendar",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    })])])]), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model.lazy",
        value: _vm.inputValue,
        expression: "inputValue",
        modifiers: {
          "lazy": true
        }
      }],
      staticClass: "uk-input yo-input-iconnav-right",
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.inputValue
      },
      on: {
        "change": function change($event) {
          _vm.inputValue = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))])]);
  };
  var __vue_staticRenderFns__$7 = [];

  /* style */
  var __vue_inject_styles__$8 = undefined;
  /* scoped */
  var __vue_scope_id__$8 = undefined;
  /* module identifier */
  var __vue_module_identifier__$8 = undefined;
  /* functional template */
  var __vue_is_functional_template__$8 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$8 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$7,
    staticRenderFns: __vue_staticRenderFns__$7
  }, __vue_inject_styles__$8, __vue_script__$8, __vue_scope_id__$8, __vue_is_functional_template__$8, __vue_module_identifier__$8, false, undefined, undefined, undefined);

  //
  var script$7 = {
    name: 'DatetimeField',
    "extends": __vue_component__$8,
    format: 'yyyy-MM-dd HH:mm:ss',
    computed: {
      val: {
        get: function get() {
          var value = new Date(this.value);
          if (!this.value || !isValid(value)) {
            return undefined;
          }
          var offset = getTimezoneOffset(this.timezone, value) / 1000;
          return add(value, {
            seconds: offset
          });
        },
        set: function set(value) {
          if (!value) {
            this.value = undefined;
            return;
          }
          this.value = formatInTimeZone(zonedTimeToUtc(value, this.timezone), '', this.$valueFormat);
        }
      }
    },
    methods: {
      open: function open() {
        var _this$field,
          _this$field2,
          _this = this;
        this.$dropdown(__vue_component__$o, {
          value: this.val,
          min: (_this$field = this.field) != null && _this$field.min ? new Date(this.field.min) : null,
          max: (_this$field2 = this.field) != null && _this$field2.max ? new Date(this.field.max) : null,
          small: Boolean(this.field.small)
        }).show(this.$el, {
          classes: 'yo-dropdown'
        }).then(function (date) {
          if (uikitUtil.isUndefined(date)) {
            return;
          }
          _this.val = date;
        })["catch"](function () {});
      }
    }
  };

  /* script */
  var __vue_script__$7 = script$7;

  /* template */
  var __vue_render__$6 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.attributes.disabled ? _c('input', {
      staticClass: "uk-input",
      attrs: {
        "disabled": ""
      }
    }) : _c('div', [_c('div', {
      staticClass: "uk-inline uk-width-1-1"
    }, [_c('div', {
      staticClass: "uk-position-center-right uk-position-small"
    }, [_c('ul', {
      staticClass: "uk-iconnav uk-flex-nowrap"
    }, [_c('li', [_c('a', {
      staticClass: "uk-icon-link uk-preserve-width",
      attrs: {
        "tabindex": "-1",
        "title": _vm.$t('Pick'),
        "uk-icon": "calendar",
        "uk-tooltip": "delay: 500"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.open.apply(null, arguments);
        }
      }
    })])])]), _vm._v(" "), _c('input', _vm._b({
      directives: [{
        name: "model",
        rawName: "v-model.lazy",
        value: _vm.inputValue,
        expression: "inputValue",
        modifiers: {
          "lazy": true
        }
      }],
      staticClass: "uk-input yo-input-iconnav-right",
      attrs: {
        "type": "text"
      },
      domProps: {
        "value": _vm.inputValue
      },
      on: {
        "change": function change($event) {
          _vm.inputValue = $event.target.value;
        }
      }
    }, 'input', _vm.attributes, false))])]);
  };
  var __vue_staticRenderFns__$6 = [];

  /* style */
  var __vue_inject_styles__$7 = undefined;
  /* scoped */
  var __vue_scope_id__$7 = undefined;
  /* module identifier */
  var __vue_module_identifier__$7 = undefined;
  /* functional template */
  var __vue_is_functional_template__$7 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$7 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$6,
    staticRenderFns: __vue_staticRenderFns__$6
  }, __vue_inject_styles__$7, __vue_script__$7, __vue_scope_id__$7, __vue_is_functional_template__$7, __vue_module_identifier__$7, false, undefined, undefined, undefined);

  var Confirm = {
    bind: attach,
    update: attach
  };
  function attach(el, _ref, _ref2) {
    var value = _ref.value;
    var on = _ref2.data.on;
    Object.values(on).forEach(function (invoker) {
      var fns = invoker.fns;
      invoker.fns = (uikitUtil.isArray(fns) ? fns : [fns]).map(function (fn) {
        return function () {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          return UIkit.modal.confirm(value, {
            stack: true
          }).then(function () {
            fn.apply(void 0, args);
          }, function () {});
        };
      });
    });
  }

  var Sortable = {
    bind: function bind(el, _ref, _ref2) {
      var value = _ref.value;
      var context = _ref2.context;
      if (value.enabled === false) {
        return;
      }
      if (!uikitUtil.isFunction(context.move)) {
        throw 'Sortable directive needs to implement function move(child, parent, index).';
      }
      UIkit.sortable(el, _extends({}, value, {
        animation: false
      }));
      el._off = uikitUtil.on(el, 'moved added removed', function (_ref3, sortable, item) {
        var type = _ref3.type;
        if (type !== 'removed') {
          context.move(item.__vue__, context, uikitUtil.index(item));
        }
        if (type !== 'added') {
          insertAt(el, item, sortable.origin.index);
        }
      }, {
        self: true
      });
    },
    componentUpdated: function componentUpdated(el, _ref4) {
      var value = _ref4.value;
      if (value.enabled === false) {
        return;
      }

      // Fix Vue stealing uk-sortable classes
      if (!el.classList.contains('uk-sortable')) {
        UIkit.sortable(el).$reset();
      }
    },
    unbind: function unbind(_ref5) {
      var _ref5$_off = _ref5._off,
        _off = _ref5$_off === void 0 ? function () {} : _ref5$_off;
      _off();
    }
  };
  function insertAt(el, item, index) {
    item.remove();
    if (el.children[index]) {
      el.children[index].before(item);
    } else {
      el.appendChild(item);
    }
  }

  var directives = /*#__PURE__*/Object.freeze({
    __proto__: null,
    ConfirmDirective: Confirm,
    SortableDirective: Sortable
  });

  var ResourcesMixin = {
    components: {
      ResourceListItem: __vue_component__$O
    },
    directives: {
      Sortable: Sortable
    },
    idPrefix: '',
    created: function created() {
      var _this = this;
      if (!uikitUtil.isArray(this.value)) {
        this.value = [];
      }
      this.value.forEach(function (val, i) {
        if (!val.id) {
          // workaround for resources created before the id concept
          _this.$set(_this.value, i, _extends({
            id: _this.getId()
          }, val));
        }
      });
    },
    methods: {
      getId: function getId() {
        return "" + this.$options.idPrefix + uuid();
      },
      push: function push(value) {
        if (this.$options.idPrefix) {
          value.id = this.getId();
        }
        this.value = [].concat(this.value, [value]);
      },
      remove: function remove(item) {
        this.value.splice(this.value.indexOf(item), 1);
      },
      copy: function copy(item) {
        var newItem = deepCopy(item);
        if (this.$options.idPrefix) {
          newItem.id = this.getId();
        }
        this.value.splice(this.value.indexOf(item), 0, newItem);
      },
      move: function move(child, parent, toIndex) {
        var fromIndex = parent.$children.indexOf(child);
        reindex(this.value, fromIndex, toIndex);
      }
    }
  };

  var script$6 = {
    name: 'DatasetField',
    "extends": $fields__default["default"].FieldText,
    mixins: [ResourcesMixin],
    inject: {
      Sidebar: {
        "default": function _default() {
          return {};
        }
      },
      Builder: {
        "default": undefined
      },
      $node: {
        "default": undefined
      }
    },
    computed: {
      items: function items() {
        var _this = this;
        return this.value.map(function (item) {
          return {
            item: item,
            id: uuid(),
            title: _this.getTitle(item),
            actions: [_this.isCopyable ? 'copy' : null, _this.isDeletable ? 'delete' : null]
          };
        });
      },
      isSortable: function isSortable() {
        return uikitUtil.isUndefined(this.field.sortable) || this.field.sortable;
      },
      isCopyable: function isCopyable() {
        return uikitUtil.isUndefined(this.field.copyable) || this.field.copyable;
      },
      isDeletable: function isDeletable() {
        return uikitUtil.isUndefined(this.field.deletable) || this.field.deletable;
      }
    },
    methods: {
      isEmpty: uikitUtil.isEmpty,
      add: function add() {
        this.push({});
        this.edit(this.value[this.value.length - 1]);
      },
      edit: function edit(item) {
        if (!item.props) {
          this.$set(item, 'props', {});
        }
        this.openPanel(_extends({
          title: this.getTitle(item),
          name: 'dataset-panel'
        }, this.getPanel(this.field.panel), {
          props: {
            node: item,
            values: item.props
          }
        }));
      },
      openPanel: function openPanel(panel) {
        if (this.Builder) {
          var _this$field;
          this.Builder.adjacentOf = (_this$field = this.field) != null && _this$field.adjacent ? this.$node : null;
        }
        this.$trigger('openPanel', _extends({}, panel, {
          component: __vue_component__$B
        }));
      },
      getTitle: function getTitle(item) {
        var _this$field2;
        var prop = ((_this$field2 = this.field) == null ? void 0 : _this$field2.titleMap) || 'name';
        return get$1(item.props, prop) || get$1(item, prop) || this.field.titleFallback || 'Item';
      },
      getPanel: function getPanel(panel) {
        if (uikitUtil.isString(panel)) {
          var _this$Sidebar, _this$Sidebar$panel, _this$Sidebar$panel$p, _this$Sidebar2, _this$Sidebar2$panels;
          return ((_this$Sidebar = this.Sidebar) == null ? void 0 : (_this$Sidebar$panel = _this$Sidebar.panel) == null ? void 0 : (_this$Sidebar$panel$p = _this$Sidebar$panel.panels) == null ? void 0 : _this$Sidebar$panel$p[panel]) || ((_this$Sidebar2 = this.Sidebar) == null ? void 0 : (_this$Sidebar2$panels = _this$Sidebar2.panels) == null ? void 0 : _this$Sidebar2$panels[panel]);
        }
        return panel;
      }
    }
  };

  /* script */
  var __vue_script__$6 = script$6;

  /* template */
  function objectWithoutProperties(obj, exclude) {
    var target = {};
    for (var k in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) target[k] = obj[k];
    }
    return target;
  }
  var __vue_render__$5 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.isEmpty(_vm.value) ? _c('div', {
      staticClass: "uk-margin"
    }, [_c('div', [_vm._v(_vm._s(_vm.$t(_vm.field.txtEmpty || 'No items yet.')))]), _vm._v(" "), _c('button', {
      staticClass: "uk-button uk-button-default uk-margin-top",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtAdd || 'Add')))])]) : _c('div', [_c('ul', {
      directives: [{
        name: "sortable",
        rawName: "v-sortable",
        value: {
          group: 'dataset-items',
          enabled: _vm.isSortable
        },
        expression: "{group: 'dataset-items', enabled: isSortable}"
      }],
      "class": ['uk-nav uk-nav-default yo-sidebar-marginless yo-nav-sortable uk-margin uk-margin-remove-bottom', {
        'yo-nav-iconnav': !_vm.attributes.disabled
      }],
      attrs: {
        "cls-custom": "yo-nav-sortable-drag"
      }
    }, _vm._l(_vm.items, function (ref) {
      var item = ref.item;
      var id = ref.id;
      var disabled = ref.disabled;
      var rest = objectWithoutProperties(ref, ["item", "id", "disabled"]);
      var props = rest;
      return _c('ResourceListItem', _vm._b({
        key: id,
        attrs: {
          "disabled": Boolean(_vm.attributes.disabled || disabled)
        },
        on: {
          "edit": function edit($event) {
            return _vm.edit(item);
          },
          "copy": function copy($event) {
            return _vm.copy(item);
          },
          "delete": function _delete($event) {
            return _vm.remove(item);
          }
        }
      }, 'ResourceListItem', props, false));
    }), 1), _vm._v(" "), _c('hr', {
      staticClass: "uk-margin-remove"
    }), _vm._v(" "), _c('div', {
      staticClass: "uk-flex uk-flex-left uk-margin-small-top"
    }, [_c('button', {
      staticClass: "uk-button uk-button-small uk-button-default",
      attrs: {
        "type": "button"
      },
      on: {
        "click": function click($event) {
          $event.preventDefault();
          return _vm.add.apply(null, arguments);
        }
      }
    }, [_vm._v(_vm._s(_vm.$t(_vm.field.txtAdd || 'Add')))])])]);
  };
  var __vue_staticRenderFns__$5 = [];

  /* style */
  var __vue_inject_styles__$6 = undefined;
  /* scoped */
  var __vue_scope_id__$6 = undefined;
  /* module identifier */
  var __vue_module_identifier__$6 = undefined;
  /* functional template */
  var __vue_is_functional_template__$6 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$6 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$5,
    staticRenderFns: __vue_staticRenderFns__$5
  }, __vue_inject_styles__$6, __vue_script__$6, __vue_scope_id__$6, __vue_is_functional_template__$6, __vue_module_identifier__$6, false, undefined, undefined, undefined);

  var _excluded = ["id", "required"];
  var script$5 = {
    name: 'DatasetMappingField',
    "extends": __vue_component__$6,
    data: function data() {
      return {
        fetched: [],
        fetchError: false
      };
    },
    computed: {
      items: function items() {
        var _this = this;
        return this.value.map(function (item) {
          var _item$props, _item$source, _item$source_extended, _item$props2;
          var fetched = _this.fetched.find(function (_ref) {
            var id = _ref.id;
            return id === item.id;
          });
          var isMapped = Boolean(((_item$props = item.props) == null ? void 0 : _item$props.value) || ((_item$source = item.source) == null ? void 0 : _item$source.props) || ((_item$source_extended = item.source_extended) == null ? void 0 : _item$source_extended.props));
          var isDisabled = ((_item$props2 = item.props) == null ? void 0 : _item$props2.status) === 'disabled';
          var isRequired = Boolean(fetched.required);
          return {
            item: item,
            title: _this.getTitle(item),
            icon: get$1(fetched, _this.field.iconMap || 'icon'),
            meta: get$1(fetched, _this.field.metaMap || 'meta'),
            disabled: isDisabled,
            indications: [!isDisabled && {
              title: 'Mapping Status',
              icon: "ye--" + (isMapped ? 'check-circle' : 'circle-dashed')
            }].filter(Boolean),
            actions: [!isRequired && {
              title: 'Toggle Mapping',
              emit: 'toggle',
              icon: "ye--toggle-" + (isDisabled ? 'off' : 'on'),
              stack: true
            }].filter(Boolean)
          };
        });
      }
    },
    watch: {
      fetched: function fetched(_fetched) {
        var _this2 = this;
        this.value = [].concat(_fetched).sort(function (a, b) {
          return a.required === b.required ? 0 : a.required ? -1 : 1;
        }).map(function (_ref2) {
          var id = _ref2.id,
            required = _ref2.required;
            _objectWithoutPropertiesLoose(_ref2, _excluded);
          var item = _this2.value.find(function (v) {
            return v.id === id;
          }) || {
            props: {
              status: !required ? 'disabled' : ''
            }
          };
          return _extends({
            id: id
          }, item);
        });
      }
    },
    mounted: function mounted() {
      var _this3 = this;
      // this.$watch('attributes.disabled', disabled => {
      //     disabled || this.fetch();
      // }, {immediate: true});

      if (this.field.watch) {
        this.field.watch.split(',').forEach(function (watch) {
          _this3.$watch("values." + watch, debounce(function () {
            _this3.fetch();
          }, 100));
        });
      }
      if (!this.attributes.disabled) {
        this.fetch();
      }
    },
    methods: {
      isEmpty: uikitUtil.isEmpty,
      fetch: function fetch() {
        var _this4 = this;
        yooessRequest(this.field.endpoint).then(function (_ref3) {
          var body = _ref3.body;
          if (uikitUtil.isArray(body)) {
            _this4.fetched = body;
            _this4.fetchError = body.length === 0 ? 'No Mapping Fields' : false;
          } else {
            _this4.fetched = [];
            _this4.fetchError = uikitUtil.isString(body) ? body : 'Error';
          }
        })["catch"](function (e) {
          _this4.fetched = [];
          _this4.fetchError = (e == null ? void 0 : e.statusText) || 'Error';
        });
      },
      toggle: function toggle(item) {
        if (!item.props) {
          this.$set(item, 'props', {});
        }
        var isDisabled = item.props.status === 'disabled';
        this.$set(item.props, 'status', isDisabled ? '' : 'disabled');
      },
      edit: function edit(item) {
        if (!item.props) {
          this.$set(item, 'props', {});
        }
        var title = this.getTitle(item);
        var meta = this.getMeta(item);
        this.openPanel(_extends({}, this.getPanel(item), {
          name: 'dataset-panel',
          title: title + ": " + meta,
          props: {
            node: item,
            values: item.props
          }
        }));
      },
      getTitle: function getTitle(item) {
        var fetched = this.fetched.find(function (_ref4) {
          var id = _ref4.id;
          return id === item.id;
        });
        var map = this.field.titleMap || 'title';
        return get$1(fetched, map) || get$1(item, map) || this.field.titleFallback || 'Item';
      },
      getMeta: function getMeta(item) {
        var fetched = this.fetched.find(function (_ref5) {
          var id = _ref5.id;
          return id === item.id;
        });
        return get$1(fetched, this.field.metaMap || 'meta');
      },
      getPanel: function getPanel(item) {
        var _this5 = this;
        var panel = this.field.panel;
        if (!panel) {
          return {
            title: 'Content',
            fields: {
              value: {
                label: 'Value',
                source: true,
                description: 'The value for this data entry.'
              }
            }
          };
        }
        var getPanel = function getPanel(panel) {
          var _this5$Sidebar, _this5$Sidebar$panel, _this5$Sidebar$panel$, _this5$Sidebar2, _this5$Sidebar2$panel;
          return ((_this5$Sidebar = _this5.Sidebar) == null ? void 0 : (_this5$Sidebar$panel = _this5$Sidebar.panel) == null ? void 0 : (_this5$Sidebar$panel$ = _this5$Sidebar$panel.panels) == null ? void 0 : _this5$Sidebar$panel$[panel]) || ((_this5$Sidebar2 = _this5.Sidebar) == null ? void 0 : (_this5$Sidebar2$panel = _this5$Sidebar2.panels) == null ? void 0 : _this5$Sidebar2$panel[panel]);
        };
        if (uikitUtil.isString(panel)) {
          var panelName = panel;
          panel = this.resolvePanelName(panelName, item);
          if (!getPanel(panel)) {
            panel = this.resolvePanelName(panelName);
          }
          panel = getPanel(panel);
        }
        return panel;
      },
      resolvePanelName: function resolvePanelName(panel, item) {
        var _this6 = this;
        if (item === void 0) {
          item = {};
        }
        var matches = Array.from(panel.matchAll(/\{(.*?[a-zA-Z]+.*?)\}/g));
        matches.forEach(function (match) {
          var fetched = _this6.fetched.find(function (_ref6) {
            var id = _ref6.id;
            return id === item.id;
          });
          var path = match[1];
          panel = panel.replace(match[0], get$1(fetched, path) || get$1(item, path) || '');
        });
        return panel;
      }
    }
  };

  /* script */
  var __vue_script__$5 = script$5;

  /* template */
  var __vue_render__$4 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _vm.fetchError && !_vm.attributes.disabled ? _c('div', {
      staticClass: "uk-text-danger"
    }, [_vm._v("\n    " + _vm._s(_vm.fetchError) + "\n")]) : !_vm.isEmpty(_vm.fetched) ? _c('ul', {
      "class": ['uk-nav uk-nav-default yo-sidebar-marginless uk-margin uk-margin-remove-bottom', {
        'yo-nav-iconnav': !_vm.attributes.disabled
      }]
    }, _vm._l(_vm.items, function (ref, i) {
      var item = ref.item;
      var title = ref.title;
      var icon = ref.icon;
      var meta = ref.meta;
      var error = ref.error;
      var disabled = ref.disabled;
      var actions = ref.actions;
      var indications = ref.indications;
      return _c('ResourceListItem', {
        key: i,
        attrs: {
          "title": title,
          "icon": icon,
          "meta": meta,
          "error": error,
          "actions": actions,
          "indications": indications,
          "disabled": Boolean(_vm.attributes.disabled || disabled)
        },
        on: {
          "edit": function edit($event) {
            return _vm.edit(item);
          },
          "copy": function copy($event) {
            return _vm.copy(item);
          },
          "delete": function _delete($event) {
            return _vm.remove(item);
          },
          "toggle": function toggle($event) {
            return _vm.toggle(item);
          }
        }
      });
    }), 1) : _vm._e();
  };
  var __vue_staticRenderFns__$4 = [];

  /* style */
  var __vue_inject_styles__$5 = undefined;
  /* scoped */
  var __vue_scope_id__$5 = undefined;
  /* module identifier */
  var __vue_module_identifier__$5 = undefined;
  /* functional template */
  var __vue_is_functional_template__$5 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$5 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$4,
    staticRenderFns: __vue_staticRenderFns__$4
  }, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);

  var script$4 = {
    name: 'DatasetMultiField',
    "extends": __vue_component__$6,
    computed: {
      items: function items() {
        var _this = this;
        return this.value.map(function (item) {
          var option = _this.field.options.find(function (o) {
            return o.name === item.type;
          });
          return {
            item: item,
            id: uuid(),
            title: _this.getTitle(item, option),
            meta: _this.getMeta(item, option),
            error: !option ? "Unknown Type: " + item.type : '',
            disabled: !option,
            icon: option == null ? void 0 : option.icon,
            description: option == null ? void 0 : option.description,
            actions: [_this.isCopyable && option ? 'copy' : null, _this.isDeletale !== false ? 'delete' : null]
          };
        });
      }
    },
    methods: {
      add: function add() {
        var _this2 = this;
        this.$modal(__vue_component__$K, {
          items: this.field.options || []
        }).show({
          container: true
        }).then(function (option) {
          if (!option) {
            return;
          }
          var item = _extends({
            type: option.name
          }, option.defaults || {});
          _this2.push(item);
          _this2.edit(item);
        });
      },
      edit: function edit(item) {
        if (!item.props) {
          this.$set(item, 'props', {});
        }
        var option = this.field.options.find(function (o) {
          return o.name === item.type;
        });
        var panel = this.getPanel(option.panel);
        this.openPanel(_extends({
          title: this.getTitle(item, option),
          name: 'dataset-panel'
        }, this.getPanel(panel, item), {
          props: {
            node: item,
            values: item.props
          }
        }));
      },
      getTitle: function getTitle(item, option) {
        return get$1(item, (option == null ? void 0 : option.titleMap) || 'props.name') || (option == null ? void 0 : option.titleFallback);
      },
      getMeta: function getMeta(item, option) {
        return get$1(item, (option == null ? void 0 : option.metaMap) || 'meta') || (option == null ? void 0 : option.metaFallback);
      }
    }
  };

  /* script */
  var __vue_script__$4 = script$4;

  /* template */

  /* style */
  var __vue_inject_styles__$4 = undefined;
  /* scoped */
  var __vue_scope_id__$4 = undefined;
  /* module identifier */
  var __vue_module_identifier__$4 = undefined;
  /* functional template */
  var __vue_is_functional_template__$4 = undefined;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$4 = /*#__PURE__*/normalizeComponent({}, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);

  var SourceTypeSelect = {
    name: 'YooessentialsSourceTypeSelect',
    "extends": $fields__default["default"].FieldSelect,
    methods: {
      filterOptions: function filterOptions() {
        var _window$$yooess, _window$$yooess$yoocu, _window$$yooess$yoocu2, _this$field;
        var types = (_window$$yooess = window.$yooess) == null ? void 0 : (_window$$yooess$yoocu = _window$$yooess.yoocustomizer) == null ? void 0 : (_window$$yooess$yoocu2 = _window$$yooess$yoocu.schema) == null ? void 0 : _window$$yooess$yoocu2.types;
        return [{
          text: this.$t(((_this$field = this.field) == null ? void 0 : _this$field.placeholder) || 'None'),
          value: ''
        }].concat(types.filter(function (type) {
          return type.kind === 'OBJECT' && type.name !== 'Query' && !type.name.startsWith('__');
        }).map(function (type) {
          return {
            value: type.name,
            text: type.name
          };
        }));
      }
    }
  };

  var fields = /*#__PURE__*/Object.freeze({
    __proto__: null,
    FieldYooessentialsCheckbox: __vue_component__$U,
    FieldYooessentialsInfo: __vue_component__$T,
    FieldYooessentialsFile: __vue_component__$S,
    FieldYooessentialsNumber: __vue_component__$R,
    FieldYooessentialsPassword: __vue_component__$Q,
    FieldYooessentialsContentItems: __vue_component__$m,
    FieldYooessentialsSimpleQuery: __vue_component__$l,
    FieldYooessentialsSubNodes: __vue_component__$k,
    FieldYooessentialsRepeatable: __vue_component__$i,
    FieldYooessentialsRepeatableMulti: __vue_component__$h,
    FieldYooessentialsSettingsPanel: __vue_component__$g,
    FieldYooessentialsInputDrop: __vue_component__$f,
    FieldYooessentialsSelectDrop: __vue_component__$e,
    FieldYooessentialsSelectDropdown: __vue_component__$d,
    FieldYooessentialsSelectDropdownAsync: __vue_component__$c,
    FieldYooessentialsButtonPanel: __vue_component__$b,
    FieldYooessentialsButtonPanelModal: __vue_component__$a,
    FieldYooessentialsTime: __vue_component__$9,
    FieldYooessentialsDate: __vue_component__$8,
    FieldYooessentialsDatetime: __vue_component__$7,
    FieldYooessentialsDataset: __vue_component__$6,
    FieldYooessentialsDatasetMapping: __vue_component__$5,
    FieldYooessentialsDatasetMulti: __vue_component__$4,
    FieldYooessentialsSourceTypeSelect: SourceTypeSelect
  });

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  /* global marked */

  var script$3 = {
    name: 'Changelog',
    inject: ['Config'],
    data: function data() {
      return {
        changelog: ''
      };
    },
    created: function created() {
      var _this = this;
      this.$http.get('yooessentials/changelog').then(function (_ref) {
        var body = _ref.body;
        return _this.$asset({
          js: 'https://cdn.jsdelivr.net/npm/marked@2.0.3/lib/marked.min.js'
        }).then(function () {
          return _this.changelog = _this.parse(body);
        });
      });
    },
    methods: {
      parse: function parse(markdown) {
        var section;
        var renderer = new marked.Renderer();
        renderer.list = function (text) {
          var list = "<ul class=\"uk-list\">" + text + "</ul>";
          if (section) {
            return "<h4>" + section + "</h4>" + list;
          }
          return list;
        };
        renderer.listitem = function (text) {
          var labelClass = '';
          var labelText = '';
          switch (text.match(/^\w*/)[0]) {
            case 'Add':
              labelText = 'Added';
              labelClass = 'success';
              break;
            case 'Change':
              labelText = 'Changed';
              labelClass = 'warning';
              break;
            case 'Remove':
              labelText = 'Removed';
              labelClass = 'warning';
              break;
            case 'Fix':
              labelText = 'Fixed';
              labelClass = 'danger';
          }
          if (labelText) {
            return "<li class=\"uk-flex uk-flex-top\">\n                        <span class=\"uk-label uk-margin-right uk-text-center uk-flex-none uk-label-" + labelClass + "\" style=\"width: 100px\">" + labelText + "</span>\n                        <div>" + text + "</div>\n                    </li>";
          }
          return "<li>" + text + "</li>";
        };
        renderer.heading = function (text, level) {
          section = null;
          text = text.replace(/(\(.*?\))/, '<span class="uk-text-muted">$1</span>');
          if (level === 2) {
            return "<h" + level + ">" + text + "</h" + level + ">";
          }
          if (level === 3) {
            section = text;
          }
          return '';
        };
        return marked(markdown, {
          renderer: renderer
        });
      }
    }
  };

  /* script */
  var __vue_script__$3 = script$3;

  /* template */
  var __vue_render__$3 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('div', {
      staticClass: "uk-modal-header"
    }, [_c('h3', {
      staticClass: "uk-modal-title"
    }, [_vm._v(_vm._s(_vm.$t('Changelog')))])]), _vm._v(" "), _c('div', {
      staticClass: "uk-modal-body",
      attrs: {
        "uk-overflow-auto": ""
      },
      domProps: {
        "innerHTML": _vm._s(_vm.changelog)
      }
    })]);
  };
  var __vue_staticRenderFns__$3 = [];

  /* style */
  var __vue_inject_styles__$3 = undefined;
  /* scoped */
  var __vue_scope_id__$3 = undefined;
  /* module identifier */
  var __vue_module_identifier__$3 = undefined;
  /* functional template */
  var __vue_is_functional_template__$3 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$3,
    staticRenderFns: __vue_staticRenderFns__$3
  }, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, undefined, undefined, undefined);

  //
  var script$2 = {
    name: 'About',
    props: {
      panel: {
        type: Object
      }
    },
    computed: {
      version: function version() {
        var _window$$customizer, _window$$customizer$y;
        return (_window$$customizer = window.$customizer) == null ? void 0 : (_window$$customizer$y = _window$$customizer.yooessentials) == null ? void 0 : _window$$customizer$y.version;
      }
    },
    methods: {
      openChangelog: function openChangelog() {
        this.$modal(__vue_component__$3).show({
          width: 'xlarge'
        });
      }
    }
  };

  /* script */
  var __vue_script__$2 = script$2;

  /* template */
  var __vue_render__$2 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('p', [_vm._v("\n        Essential Addons for YOOtheme Pro"), _c('br'), _vm._v("\n        v" + _vm._s(_vm.version) + " by "), _c('a', {
      attrs: {
        "href": "https://zoolanders.com/essentials-for-yootheme-pro",
        "target": "_blank"
      }
    }, [_vm._v("zoolanders.com")]), _vm._v(".\n    ")]), _vm._v(" "), _c('button', {
      staticClass: "uk-button uk-button-default uk-width-1-1 uk-text-nowrap uk-margin-top",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.openChangelog
      }
    }, [_vm._v(_vm._s(_vm.$t('Changelog')))])]);
  };
  var __vue_staticRenderFns__$2 = [];

  /* style */
  var __vue_inject_styles__$2 = undefined;
  /* scoped */
  var __vue_scope_id__$2 = undefined;
  /* module identifier */
  var __vue_module_identifier__$2 = undefined;
  /* functional template */
  var __vue_is_functional_template__$2 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$2,
    staticRenderFns: __vue_staticRenderFns__$2
  }, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, undefined, undefined, undefined);

  //
  var hostname = window.location.hostname;
  var script$1 = {
    name: 'AdvancedPanel',
    components: {
      FieldsPanel: __vue_component__$F
    },
    props: {
      panel: Object
    },
    computed: {
      values: function values() {
        return Config.values;
      }
    },
    events: {
      openPanel: {
        handler: function handler(_ref, panel) {
          var params = _ref.params;
          if (panel.fields) {
            set$2(panel, 'props.values', this.values);
            panel.component = __vue_component__$F;
          }
          params[0] = panel;
        },
        priority: -500
      }
    },
    methods: {
      importConfig: function importConfig(config) {
        this.$http.post('yooessentials/config/import', {
          config: config
        }).then(function (_ref2) {
          var data = _ref2.data;
          Config.replace(data);
        });
      },
      exportConfig: function exportConfig() {
        download("yooessentials-" + hostname + ".json", JSON.stringify(Config.values) + '\n');
      },
      uploadFile: function uploadFile(_ref3) {
        var _this = this;
        var currentTarget = _ref3.currentTarget,
          dataTransfer = _ref3.dataTransfer;
        var _ref4 = currentTarget.files || (dataTransfer == null ? void 0 : dataTransfer.files) || [],
          file = _ref4[0];
        if (file) {
          readFile(file).then(function (_ref5) {
            var target = _ref5.target;
            return _this.importConfig(JSON.parse(target.result));
          })["catch"](function () {
            return _this.$notify("Error loading '" + file.name + "'", 'danger');
          });
        }
      },
      downloadDebugData: function downloadDebugData() {
        var _yoocustomizer$yooess;
        var yoocustomizer = window.$yooessentials.yoocustomizer;
        var url = yoocustomizer == null ? void 0 : (_yoocustomizer$yooess = yoocustomizer.yooessentials) == null ? void 0 : _yoocustomizer$yooess.requestUrl.replace('route', encodeURIComponent('yooessentials/debug/data'));
        window.open(url);
      }
    }
  };

  /* script */
  var __vue_script__$1 = script$1;

  /* template */
  var __vue_render__$1 = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('FieldsPanel', {
      attrs: {
        "panel": _vm.panel,
        "values": _vm.values
      }
    }), _vm._v(" "), _c('h3', {
      staticClass: "yo-sidebar-subheading"
    }, [_vm._v(_vm._s(_vm.$t('Settings')))]), _vm._v(" "), _c('div', [_c('button', {
      staticClass: "uk-button uk-button-default uk-width-1-1",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.exportConfig
      }
    }, [_vm._v(_vm._s(_vm.$t('Export Settings')))]), _vm._v(" "), _c('div', {
      staticClass: "uk-margin-small-top uk-display-block",
      attrs: {
        "uk-form-custom": ""
      }
    }, [_c('input', {
      ref: "input",
      attrs: {
        "accept": "application/json",
        "type": "file",
        "name": "files[]"
      },
      on: {
        "change": _vm.uploadFile
      }
    }), _vm._v(" "), _c('button', {
      staticClass: "uk-button uk-button-default uk-width-1-1",
      attrs: {
        "type": "button"
      }
    }, [_vm._v(_vm._s(_vm.$t('Import Settings')))])])]), _vm._v(" "), _c('p', [_vm._v(_vm._s(_vm.$t('Export Essentials settings and/or import them deleting any previous configuration.')))]), _vm._v(" "), _c('h3', {
      staticClass: "yo-sidebar-subheading"
    }, [_vm._v(_vm._s(_vm.$t('Debug Data')))]), _vm._v(" "), _c('div', [_c('button', {
      staticClass: "uk-button uk-button-default uk-width-1-1",
      attrs: {
        "type": "button"
      },
      on: {
        "click": _vm.downloadDebugData
      }
    }, [_vm._v(_vm._s(_vm.$t('Download Data')))])]), _vm._v(" "), _c('p', [_vm._v(_vm._s(_vm.$t('Generates a ZIP with information about the site and theme configuration. Sensitive data might be included, be carefull who you share this with.')))])], 1);
  };
  var __vue_staticRenderFns__$1 = [];

  /* style */
  var __vue_inject_styles__$1 = undefined;
  /* scoped */
  var __vue_scope_id__$1 = undefined;
  /* module identifier */
  var __vue_module_identifier__$1 = undefined;
  /* functional template */
  var __vue_is_functional_template__$1 = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
    render: __vue_render__$1,
    staticRenderFns: __vue_staticRenderFns__$1
  }, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //
  //

  var script = {
    name: 'EssentialsPanel',
    inject: ['Sidebar', 'Config'],
    props: {
      panel: Object
    },
    computed: {
      items: function items() {
        var _this$panel$items,
          _this$panel,
          _this = this;
        var items = Object.keys((_this$panel$items = (_this$panel = this.panel) == null ? void 0 : _this$panel.items) != null ? _this$panel$items : {});
        return items.map(function (name) {
          var _this$Sidebar, _this$Sidebar$panels, _this$Sidebar$panels$;
          return {
            name: name,
            title: _this.panel.items[name],
            priority: (_this$Sidebar = _this.Sidebar) == null ? void 0 : (_this$Sidebar$panels = _this$Sidebar.panels) == null ? void 0 : (_this$Sidebar$panels$ = _this$Sidebar$panels[name]) == null ? void 0 : _this$Sidebar$panels$.priority
          };
        }).sort(function (a, b) {
          var _a$priority, _b$priority;
          return ((_a$priority = a.priority) != null ? _a$priority : 0) - ((_b$priority = b.priority) != null ? _b$priority : 0);
        });
      }
    }
  };

  /* script */
  var __vue_script__ = script;

  /* template */
  var __vue_render__ = function __vue_render__() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c('div', [_c('ul', {
      staticClass: "uk-nav uk-nav-default yo-sidebar-marginless"
    }, _vm._l(_vm.items, function (item) {
      return _c('li', {
        key: item.name
      }, [_c('a', {
        attrs: {
          "href": ""
        },
        on: {
          "click": function click($event) {
            $event.preventDefault();
            return _vm.$trigger('openPanel', item.name);
          }
        }
      }, [_vm._v(_vm._s(_vm.$t(item.title || item.name)))])]);
    }), 0)]);
  };
  var __vue_staticRenderFns__ = [];

  /* style */
  var __vue_inject_styles__ = undefined;
  /* scoped */
  var __vue_scope_id__ = undefined;
  /* module identifier */
  var __vue_module_identifier__ = undefined;
  /* functional template */
  var __vue_is_functional_template__ = false;
  /* style inject */

  /* style inject SSR */

  /* style inject shadow dom */

  var __vue_component__ = /*#__PURE__*/normalizeComponent({
    render: __vue_render__,
    staticRenderFns: __vue_staticRenderFns__
  }, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

  var panels = /*#__PURE__*/Object.freeze({
    __proto__: null,
    AboutPanel: __vue_component__$2,
    AdvancedPanel: __vue_component__$1,
    EssentialsPanel: __vue_component__
  });

  Vue__default["default"].events.on('initBuilder', function (e) {
    var Builder = e.origin;
    if (!Builder.id) {
      // extends builder with missing functionality in ytp 2.x
      Builder.id = getBuilderNodeId.bind(Builder);
      Builder.index = getBuilderNodeIndex.bind(Builder);
    }
  });
  function getBuilderNodeId(node) {
    var parent = this.parent(node);
    if (!parent) {
      return '';
    }
    var id = this.id(parent);
    return "" + (id ? id + "-" : this.prefix) + this.index(node);
  }
  function getBuilderNodeIndex(node) {
    var _this$parent;
    return (((_this$parent = this.parent(node)) == null ? void 0 : _this$parent.children) || []).indexOf(node);
  }

  var UIkitCustomIcons = {
    'ye--check-circle': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><circle cx="9.5" cy="9.5" r="9" fill="none" stroke="#444" stroke-width="1.32" transform="matrix(.80783 0 0 .80783 .326 2.887)"/><path d="m4.365 10.841 2.237 2.797 5.033-6.152" fill="none" stroke="#444" stroke-width="1.0682057"/></svg>',
    'ye--circle-dashed': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><circle cx="9.5" cy="9.5" r="9" fill="none" stroke="#444" stroke-width="1.32" stroke-dasharray="2.64,1.32,0,0" transform="matrix(.80783 0 0 .80783 .326 2.887)"/></svg>',
    'ye--toggle-on': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path fill="#444" d="M7.933 2.559h2.566v1H7.933zM11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path fill="#444" d="M5.501 2.559h2.435v1H5.5zM1.5 19.05v-2.435h1v2.434zM1.5 15.634V13.2h1v2.434zM1.5 12.218V9.653h1v2.565zM1.5 8.672V6.106h1v2.566zM1.5 5.125V2.559h1v2.566z"/><g><path fill="#444" d="M13.499 19.05v-2.435h1v2.434zM13.499 15.634V13.2h1v2.434zM13.499 12.218V9.653h1v2.565zM13.499 8.672V6.106h1v2.566zM13.499 5.125V2.559h1v2.566z"/></g><g><path fill="#444" d="M7.93 18.05h2.567v1H7.93zM11.93 18.05h2.567v1H11.93zM1.5 18.05h2.433v1H1.5z"/><path fill="#444" d="M5.5 18.05h2.433v1H5.5z"/></g><g><path d="M8 1.559v1" fill="none" stroke="#444"/></g><g><path d="M8 19.025v1" fill="none" stroke="#444"/></g><g><path fill="#444" d="M7.502 2.559h6.995v16.49H7.502z"/></g></svg>',
    'ye--toggle-off': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path fill="#444" d="M7.933 2.559h2.566v1H7.933zM11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path fill="#444" d="M5.501 2.559h2.435v1H5.5zM1.5 19.05v-2.435h1v2.434zM1.5 15.634V13.2h1v2.434zM1.5 12.218V9.653h1v2.565zM1.5 8.672V6.106h1v2.566zM1.5 5.125V2.559h1v2.566z"/><g><path fill="#444" d="M13.499 19.05v-2.435h1v2.434zM13.499 15.634V13.2h1v2.434zM13.499 12.218V9.653h1v2.565zM13.499 8.672V6.106h1v2.566zM13.499 5.125V2.559h1v2.566z"/></g><g><path fill="#444" d="M7.93 18.05h2.567v1H7.93zM11.93 18.05h2.567v1H11.93zM1.5 18.05h2.433v1H1.5z"/><path fill="#444" d="M5.5 18.05h2.433v1H5.5z"/></g><g><path d="M8 1.559v1" fill="none" stroke="#444"/></g><g><path d="M8 19.025v1" fill="none" stroke="#444"/></g><g><path fill="#444" d="M1.501 2.559h6v1h-6zM1.999 18.05h6v1H2z"/><path fill="#444" d="M1.5 2.597h1v16.452h-1zM7.502 2.335h1v16.452h-1z"/></g></svg>',
    'ye--report': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path d="M3.5 2.5v16h12v-16" fill="none" stroke="#444" stroke-width="1.03" transform="matrix(1 0 0 .93688 -1.502 1.217)"/><path fill="#444" d="M11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path d="M4.436 3.059v-1.5h7v1.5M4.436 3.059v1.5h7v-1.5" fill="none" stroke="#444"/></svg>',
    'ye--report-check': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path d="M3.5 2.5v16h12v-16" fill="none" stroke="#444" stroke-width="1.03" transform="matrix(1 0 0 .93688 -1.502 1.217)"/><path fill="#444" d="M11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path d="M4.436 3.059v-1.5h7v1.5M4.436 3.059v1.5h7v-1.5" fill="none" stroke="#444"/><g><path d="m10.638 9.393-3.303 5.121-1.977-1.997" fill="none" stroke="#444" stroke-width=".9846536000000001"/></g></svg>',
    'ye--report-ban': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path d="M3.5 2.5v16h12v-16" fill="none" stroke="#444" stroke-width="1.03" transform="matrix(1 0 0 .93688 -1.502 1.217)"/><path fill="#444" d="M11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path d="M4.436 3.059v-1.5h7v1.5M4.436 3.059v1.5h7v-1.5" fill="none" stroke="#444"/><g><circle cx="10" cy="10" r="9" fill="none" stroke="#444" stroke-width="3.17" transform="matrix(.29444 0 0 .29444 5.056 9.079)"/><path d="m6.233 10.11 3.534 3.827" fill="none" stroke="#444" stroke-width=".9333748"/></g></svg>',
    'ye--report-x': '<svg viewBox="0 0 16 21" xmlns="http://www.w3.org/2000/svg" xml:space="preserve" fill-rule="evenodd" clip-rule="evenodd"><path d="M3.5 2.5v16h12v-16" fill="none" stroke="#444" stroke-width="1.03" transform="matrix(1 0 0 .93688 -1.502 1.217)"/><path fill="#444" d="M11.933 2.559h2.566v1h-2.566zM1.501 2.559h2.435v1H1.5z"/><path d="M4.436 3.059v-1.5h7v1.5M4.436 3.059v1.5h7v-1.5" fill="none" stroke="#444"/><g><path d="m5.358 9.393 5.28 5.28M10.638 9.393l-5.28 5.28" fill="none" stroke="#444" stroke-width=".9306563999999999"/></g></svg>'
  };

  var _window$$customizer;
  UIkit__default["default"].icon.add(UIkitCustomIcons);
  var ytpVer = (_window$$customizer = window.$customizer) == null ? void 0 : _window$$customizer.version;
  Util$1(Vue__default["default"]);
  uikitUtil.assign(window.$fields, fields);
  Vue__default["default"].component('yooessentials', __vue_component__);
  Vue__default["default"].component('yooessentials-about', __vue_component__$2);
  Vue__default["default"].component('yooessentials-advanced', __vue_component__$1);
  window.$yooessentials = window.$yooess = _extends({
    yooconfig: null,
    yoocustomizer: null,
    yoobuilder: null,
    ytpVer: ytpVer,
    Config: Config,
    yooessRequest: yooessRequest
  }, fields, panels, util, components, directives);

  // origin.$root.$config -> Customizer
  // origin.$root.Config -> yooconfig
  Vue__default["default"].events.on('initBuilder', function (e) {
    var _e$origin$$root = e.origin.$root,
      Config = _e$origin$$root.Config,
      $config = _e$origin$$root.$config;
    if (Config) {
      window.$yooess.yooconfig = Config;
    }
    if ($config) {
      window.$yooess.yoocustomizer = $config;
    }
    window.$yooess.yoobuilder = e.origin;
    Vue__default["default"].events.trigger('initYooess', window.$yooess);
  });

})(Vue, UIkit, UIkit.util, $fields);
